<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Traduction 23/12/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  -->
<!--  MJ 30/07/2003 coreutils-4.5.3 -->
<br/><h1>EXPR</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">exemples</a>
<br /><a class="summaryIndent0" href="#L4">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
expr - valuer des expressions.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>expr</b> <b></b>  expression...
<br/>
<b>expr</b> <b></b>  {--help,--version}
<br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette page de manuel dcrit la version GNU de
<b>expr .<br/><br/></b>
<b>expr</b> <b></b>  value une expression, et imprime le rsultat sur la sortie standard.<br/><br/>
Chaque lment minimal de l'expression doit tre fourni comme argument
indpendant. Les oprandes peuvent tre des nombres ou des chanes de
caractres. Les chanes n'ont pas besoin d'tre encadres pour <b>expr</b>,
mais il est gnralement ncessaire de le faire pour les protger du shell.<br/><br/>
<b>expr</b> <b></b>  transforme tout argument apparaissant en position d'oprande en un entier,
ou en une chane suivant le type d'opration  appliquer.<br/><br/>
Les oprateurs sont (par ordre dcroissant de priorit)&nbsp;:
.IP "<i>|</i>"
Renvoie son premier argument s'il n'est pas nul, et si sa valeur n'est pas
zro, sinon il renvoie son second argument. Il s'agit de l'opration 'OU'
habituelle.
.IP "<i>&</i>"
Si aucun des deux arguments n'est nul, et si aucune valeur n'est 0, renvoie
son premier argument. Sinon il renvoie 0.
</div><div class="paragraph"><i>&lt;</i>\0 <i>&lt;=</i>\0 <i>=</i>\0 <i>==</i>\0 <i>!=</i>\0 <i>&gt;=</i>\0<br/>
Compare les arguments et renvoie 1 si la relation est vraie, 0 sinon.
(<i>==</i> est un synonyme de <i>=</i>.)
<b>expr</b> transforme les deux arguments en nombres. La comparaison est
numrique. Si la transformation en nombre choue, une comparaison de type
lexicographique est choisie.
</div><div class="paragraph"><i>+</i>\0<br/>
Effectuent une opration arithmtique. Les deux arguments sont transforms
en nombres et une erreur se produit si c'est impossible.
</div><div class="paragraph"><i>*</i>\0 <i>/</i>\0<br/>
Effectuent une opration arithmtique (le `%' est l'opration `modulo' comme
en C). Les deux arguments sont transforms en nombres et une erreur se produit
si c'est impossible.
.IP "<i>:</i>"
Effectue une recherche de sous-chane. Les arguments sont considrs comme
des chanes. Le second est une expression rationnelle avec un `^' ajout
implicitement au dbut. Le premier argument est compar  ce motif.
Si la correspondance russit, et si une partie de la chane est
encadre par `\e(' et `\e)', cette partie sera renvoye comme valeur
de l'expression <i>:</i>. Sinon l'opration renvoie un entier reprsentant
le nombre de caractres mis en correspondance. Si la comparaison choue,
l'oprateur <i>:</i> renvoie une chane nulle si l'encadrement `\e(' et `\e)'
est utilis, et renvoie 0 sinon. On ne peut utiliser qu'un seul encadrement
`\e(' et `\e)'.
<br/><br/>

De plus, les mots-cls suivants sont valides :
<br/><br/>

match <b> chane exp_rationnelle</b>
Une autre manire de faire une mise en correspondance. Le rsultat est
le mme que ``<i>chane</i>&nbsp;<b>:</b> <i>exp_rationnelle</i>''.
<br/><br/>

substr <b> chane pos lg</b>
Renvoie la partie de <i>chane</i> commenant  la position <i>pos</i> et
de longueur maximale <i>lg</i>.  Si <i>pos</i> ou <i>lg</i> est ngatif, ou
non-numrique, <i>substr</i> renvoie une chane nulle.
<br/><br/>

index <b> chane classe_caractres</b>
Renvoie la position de la premire occurrence du premier caractre appartenant
 <i>classe_caractres</i> dans la <i>chane</i>. Si aucun caractre de la
<i>classe_caractres</i> n'est trouv dans <i>chane</i>, 0 est renvoy.
<br/><br/>

length <b> chane</b>
Renvoie la longueur de la <i>chane</i>.<br/><br/>
Les parenthses servent  grouper les oprations comme d'habitude. Les mots-cls
ne peuvent pas tre utiliss comme chanes.
</div><br/><h2 class="TitreSection1" id="L6">OPTIONS</h2>
<div class="paragraph">
Quand la version GNU de
<b>expr</b> <b></b>  est invoque avec un unique argument, les options suivantes sont reconnues :
<br/><br/>

<i>--help</i> Afficher un message d'aide sur la sortie standard, et se terminer normalement.
<br/><br/>

<i>--version</i> Afficher un numro de version sur la sortie standard, et se terminer normalement.
</div><br/><br /><h1 class="TitreSection0" id="L4">exemples</h1>
<div class="paragraph"><br/><br/>
Pour ajouter 1  la variable shell
<i>a </i> :<i></i>
.IP
a=\`expr $a + 1\`<br/><br/>
On peut utiliser l'expression suivante pour imprimer la partie sans rpertoire d'un nom
de fichier situ dans la variable
<i>a</i>
(La valeur de
<i>a</i>
n'a pas besoin de contenir de `/'):
.IP
expr $a : '.*/\e(\^.*\e)' '\^|' $a<br/><br/>
Remarquez la protection des mta-caractres du shell.<br/><br/>
<b>expr</b> <b></b>  renvoie les codes de retour suivants :<br/><br/>
0 si l'expression n'est ni nulle ni 0,
<br/>
1 si l'expression est nulle ou 0,
<br/>
2 si l'expression est invalide.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1997.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
