.\" Traduction 21/08/2000 par Frdric Delanoy (delanoy_f@yahoo.com)
.\" (passwd 0.??)
.\" Mise  jour 17/07/2002 (passwd 0.67)
.\" 
.\" Copyright Red Hat Software, Inc., 1998, 1999.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, and the entire permission notice in its entirety,
.\"    including the disclaimer of warranties.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. The name of the author may not be used to endorse or promote
.\"    products derived from this software without specific prior
.\"    written permission.
.\"
.\" ALTERNATIVELY, this product may be distributed under the terms of
.\" the GNU Public License, in which case the provisions of the GPL are
.\" required INSTEAD OF the above restrictions.  (This clause is
.\" necessary due to a potential bad interaction between the GPL and
.\" the restrictions contained in a BSD-style copyright.)
.\"
.\"  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
.\" WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
.\" DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
.\" INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
.\" (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
.\" SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
.\" STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
.\" OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" Copyright (c) Cristian Gafton, 1998, <gafton@redhat.com>
.\" MJ 30/07/2003 passwd-0.68
.TH PASSWD 1 "30 juillet 2003" PAM "Manuel de l'utilisateur Linux"
.SH NOM

passwd \- mettre  jour les marques d'authentification d'un utilisateur.

.SH SYNOPSIS
.B passwd [-k] [-l] [-u [-f]] [-d] [-S] [nom_utilisateur]
.sp 2
.SH DESCRIPTION
Passwd est utilis pour mettre  jour la ou les marques
d'authentification d'un utilisateur. Passwd est configur pour
travailler grce 
.RB "l'" "API Linux-PAM" ". "
Il s'initialise en tant que service \ passwd\  avec
.I Linux-PAM
et utilise les modules
.I "password"
(mot de passe) configurs pour authentifier et ensuite mettre  jour
le mot de passe d'un utilisateur.

.sp
Une entre du fichier de configuration de
.I Linux-PAM
pour ce service pourrait tre\ :
.br
  
.br
 #
.br
 # entre de service passwd effectuant une 
.br
 # vrification de force d'un mot de passe
.br
 # propos avant de le mettre  jour.
.br
 #
.br
 passwd password requisite \\
.br
             /usr/lib/security/pam_cracklib<?php include ("../retry=3.php"); ?>.br
 passwd password required \\
.br
             /usr/lib/security/pam_pwdb<?php include ("../use_authtok.php"); ?>.br
 #

.sp
Notez qu'aucun autre type de module n'est requis pour le
fonctionnement correct de cette application.

.SH OPTIONS

.IP \fB-k\fR
L'option,
.BR -k ", "
est utilise pour indiquer que la mise  jour ne devrait tre
effectue que pour les marques d'authentification (mots de passe)\ ;
l'utilisateur conserve ses marques non expirs.

.IP \fB-l\fR
Cette option est utilis pour verrouiller le compte spcifi, et n'est
disponible que pour root. Le verrouillage est effectu en rendant le
mot de passe crypt invalide (en le prfixant par un !).

.IP \fB--stdin\fR
Cette option est utilise pour indiquer que \fBpasswd\fR doit lire le
nouveau mot de passe depuis l'entre standard, qui peut tre un
tube.

.IP \fB-u\fR
L'inverse de l'option -l - dverrouille le mot de passe du compte en
supprimant le prfixe \ !\ . Cette option n'est disponible que pour
root. Par dfaut, \fBpasswd\fR refusera de crer un compte sans mot de
passe associ (il ne dverrouillera pas un compte contenant uniquement
! pour mot de passe). L'option \fB-f\fR contourne cette protection.

.IP \fB-d\fR
C'est un moyen rapide de dsactivation du mot de passe d'un compte. Il
rendra inutile la saisie d'un mot de passe pour un compte
donn. Disponible uniquement pour root.

.IP \fB-n\fR
Ceci fixera la dure de vie minimale du mot de passe, en jours, si le
compte de l'utilisateur supporte les dures de vie pour les mots de
passe. Disponible uniquement pour root.

.IP \fB-x\fR
Ceci fixe la dure de vie maximale du mot de passe, en jours, si le
compte de l'utilisateur supporte les dures de vie pour les mots de
passe. Disponible uniquement pour root.

.IP \fB-w\fR
Ceci fixe le nombre de jours  l'avance pendant lesquels
l'utilisateur recevra des avertissements l'informant que son mot de
passe va expirer, si le compte de l'utilisateur supporte les dures de
vie pour les mots de passe. Disponible uniquement pour root.

.IP \fB-i\fR
Ceci fixe le nombre de jours qui s'couleront avant qu'un mot de
passe expir pour ce compte indique qu'il est inactif et devrait tre
dsactiv, si le compte de l'utilisateur supporte les dures de vie
pour les mots de passe. Disponible uniquement pour root.

.IP \fB-S\fR
Cela affiche une information courte sur le statut du mot de passe pour
un compte donn. Disponible uniquement pour root.

.SH "Rappelez-vous les deux principes suivants\ :"

.IP \fBProtgez\ votre\ mot\ de\ passe.\fR
N'crivez nulle part votre mot de passe - mmorisez-le. En
particulier, ne le laissez pas traner n'importe o et ne le placez
pas non plus dans un fichier non crypt !  Utilisez des mots de passe
non lis sur des systmes contrls par diffrentes organisations. Ne
divulguez ni ne partagez votre mot de passe, en particulier 
quelqu'un prtendant faire partie du support technique, ou du
personnel d'un vendeur. Ne laissez personne regarder votre mot de
passe pendant que vous le tapez. N'entrez pas votre mot de passe sur
un ordinateur auquel vous ne faites pas confiance, ou s'il se passe
quelque chose qui \ semble amusant\ \ ; quelqu'un pourrait tre en
train d'essayer de dtourner votre mot de passe. Utilisez votre mot de
passe pour une dure limite et modifiez-le priodiquement.

.IP \fBChoisissez\ un\ mot\ de\ passe\ difficile\ \ deviner.\fR
.I passwd
essaiera de vous empcher de choisir un mot de passe rellement
mauvais, mais il n'est pas infaillible\ ; crez votre mot de passe
sagement. N'utilisez pas quelque chose que vous pouvez trouver dans un
dictionnaire (dans n'importe quel langue ou jargon). N'utilisez pas de
nom (incluant celui d'un conjoint, d'un parent, d'un enfant, d'un
animal domestique, d'un personnage imaginaire, d'un personnage
clbre, ou d'un endroit connu), ou de variation sur votre nom
personnel ou votre nom de compte. N'utilisez aucune information
personnelle qui soit accessible (comme votre numro de tlphone,
plaque d'immatriculation ou numro de scurit sociale), ou sur les
personnes de votre entourage. N'utilisez pas une date d'anniversaire
ou un motif simple comme \ azerty\ , \ qwerty\ , \ abc\  ou
\ aaa\ ). N'utilisez aucun lment parmi ceux cits ci-dessus suivi
ou prcd par un chiffre. Au lieu de cela, utilisez une combinaison
de lettres minuscules et majuscules, de chiffres et de signes de
ponctuation. Quand vous choisissez un nouveau mot de passe,
assurez-vous qu'il n'ait rien en commun avec l'ancien. Utilisez des
mots de passe longs (disons d'au moins 8 caractres). Vous pourriez
utiliser une paire de mots avec un signe de ponctuation insr, une
phrase de passe (une squence de mots comprhensible), ou la premire
lettre de chaque mot dans une phrase de passe.

.SH ""
Ces principes sont partiellement imposs par le systme, mais
uniquement partiellement. Une certaine vigilance de votre ct rendra
le systme beaucoup plus sr.

.SH "VALEUR RENVOYE"

En cas de succs,
.B passwd
se terminera avec une valeur de retour de 0. Une valeur de retour de 1
indique qu'une erreur s'est produite. Les erreurs textuelles sont
crites dans le flux d'erreur standard.

.SH "CONFORMIT"
.br
.BR Linux-PAM
(Pluggable Authentication Modules pour Linux).
.br
Notez que si votre distribution de Linux-PAM se conforme au Linux
Filesystem Standard (standard de systme de fichiers sous Linux), vous
pouvez trouver les modules dans
.I /lib/security/
au lieu de /usr/lib/security/, comme indiqu dans l'exemple.

.SH "FICHIERS"
.br
.B /etc/pam.d/passwd
- le fichier de configuration de
.BR Linux-PAM

.SH BOGUES
.sp 2
Inconnus au bataillon.

.SH "VOIR AUSSI"

.BR pam "(8), "
et
.BR pam_chauthok "(2). "

.sp
Pour des informations plus compltes sur la faon de configurer cette
application avec
.BR Linux-PAM ", "
voyez le
.BR "Linux-PAM System Administrators' Guide" " sur "
.br
.I "<http://parc.power.net/morgan/Linux-PAM/index.html>"

.SH AUTEUR
Cristian Gafton <gafton@redhat.com>

.SH TRADUCTION
Frdric Delanoy <\fIdelanoy_f at yahoo.com\fR>, 2002.
