<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright (c) 1995 Michael Chastain (mec@shell.portal.com), 15 April 1995. -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  The GNU General Public License's references to "object code" -->
<!--  and "executables" are to be interpreted as the output of any -->
<!--  document formatting or typesetting system, including -->
<!--  intermediate and printed output. -->
<!--  -->
<!--  This manual is distributed in the hope that it will be useful, -->
<!--  but WITHOUT ANY WARRANTY; without even the implied warranty of -->
<!--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the -->
<!--  GNU General Public License for more details. -->
<!--  -->
<!--  You should have received a copy of the GNU General Public -->
<!--  License along with this manual; if not, write to the Free -->
<!--  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, -->
<!--  USA. -->
<!--  -->
<!--  Traduction 14/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  mj 9/12/1997 (LDP man-pages 1.18) -->
<!--  mj 30/05/2001 (LDP man-pages 1.36) -->
<!--  mj 18/07/2003 (LDP man-pages 1.56) -->
<br/><h1>ADJTIMEX</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
adjtimex - Rgler l'horloge du noyau (kernel clock).
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/timex.h&gt;</b> <b></b>  <br/><br/>

<b>int adjtimex(struct timex *</b> <i>buf</i> );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Linux utilise l'algorithme d'ajustement d'horloge de David L. Mills (RFC 1305).
L'appel-systme
<b>adjtimex</b> <b></b>  lit, et crit ventuellement les paramtres d'ajustement pour cet algorithme.
Il utilise un pointeur sur une structure
<i>timex </i> pour mettre  jour les paramtres du noyau avec les valeurs de ses champs,
et renvoyer la mme structure avec les valeurs actuelles du noyau.
La structure est dclare comme suit<br/><br/>
.RS

struct timex {
    int modes;           /* mode selector */
    long offset;         /* time offset (usec) */
    long freq;           /* frequency offset (scaled ppm) */
    long maxerror;       /* maximum error (usec) */
    long esterror;       /* estimated error (usec) */
    int status;          /* clock command/status */
    long constant;       /* pll time constant */
    long precision;      /* clock precision (usec) (read only) */
    long tolerance;      /* clock frequency tolerance (ppm)
                            (read only) */
    struct timeval time; /* current time (read only) */
    long tick;           /* usecs between clock ticks */
};


<br/><br/>
Le champ
<i>modes</i> dtermine les paramtres ventuels  crire.
Il contient un
OU </i>
binaire ( | ) entre les valeurs suivantes:<br/><br/>
.RS

#define ADJ_OFFSET            0x0001 /* time offset */
#define ADJ_FREQUENCY         0x0002 /* frequency offset */
#define ADJ_MAXERROR          0x0004 /* maximum time error */
#define ADJ_ESTERROR          0x0008 /* estimated time error */
#define ADJ_STATUS            0x0010 /* clock status */
#define ADJ_TIMECONST         0x0020 /* pll time constant */
#define ADJ_TICK              0x4000 /* tick value */
#define ADJ_OFFSET_SINGLESHOT 0x8001 /* old-fashioned adjtime */


<br/><br/>
Les utilisateurs normaux sont limits  une valeur de
<i>mode </i>
nulle, seul le Super-User peut crire les paramtres.
<br/>
.ne 12v
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
S'il russit,
<b>adjtimex</b> <b></b>  renvoie l'tat de l'horloge&nbsp;:<br/><br/>
.RS

#define TIME_OK   0 /* clock synchronized */
#define TIME_INS  1 /* insert leap second */
#define TIME_DEL  2 /* delete leap second */
#define TIME_OOP  3 /* leap second in progress */
#define TIME_WAIT 4 /* leap second has occurred */
#define TIME_BAD  5 /* clock not synchronized */


<br/><br/>
En cas d'chec
<b>adjtimex</b> <b></b>  renvoie -1 et remplit
<i>errno .</i>
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EFAULT</b> <b></b>  <i>buf</i> pointe en dehors de l'espace d'adressage accessible.
<br/><br/>

<b>EPERM</b> <b></b>  <i>buf.mode</i> est non nul, et l'utilisateur n'est pas Super-User.
<br/><br/>

<b>EINVAL</b> <b></b>  Une tentative est faite de remplir
<i>buf.offset</i> en dehors de l'intervalle -131071  +131071,
ou de mettre
<i>buf.status</i> a une valeur autre que celle liste ci-dessus,
ou
<i>buf.tick</i> en dehors de l'intervalle
900000/ HZ</b>

1100000/ HZ ,</b>
o
<b>HZ</b> <b></b>  est la frquence d'interruption de l'horloge systme.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
<b>adjtimex</b> est spcifique  Linux, et ne doit pas tre employ dans des
programmes destins  tre ports sur d'autres systmes. Un appel
<b>adjtime</b> moins gnral existe sous SVr4.
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>settimeofday (2).</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
