<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright (C) 2003 Andi Kleen -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--   -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--     MJ  18/7/03 - LDP-1.56 -->
<br/><h1>ARCH_PRCTL</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">notes</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">auteur</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
arch_prctl - Fixe l'tat spcifique  l'architecture.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;asm/prctl.h&gt;</b> <b></b>  <br/><br/>

<b>#include</b> <b></b>  <b>&lt;sys/prctl.h&gt;</b> <b></b>  <br/><br/>

<b>int arch_prctl(int code, unsigned long adr)</b>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>arch_prctl</b> <b></b>  fixe l'tat spcifique  l'architecture pour le thread ou le processus.
<i>code</i> slectionne une sous-fonction
et lui passe
l'argument
<i>addr .<br/><br/></i>
Les sous-fonctions pour les architectures x86-64 sont&nbsp;:
<br/><br/>

<b>ARCH_SET_FS</b> <b></b>  Remplit la base 64-bits pour le registre
<i>FS</i> avec
<i>adr .</i>
<br/><br/>

<b>ARCH_GET_FS</b> <b></b>  Renvoie la base 64-bits pour le registre
<i>FS</i> du thread en cours dans la variable
<i>unsigned long</i> pointe par le
paramtre
<i>adr .</i>
<br/><br/>

<b>ARCH_SET_GS</b> <b></b>  Remplit la base 64-bits pour le registre
<i>GS</i> avec
<i>addr .</i>
<br/><br/>

<b>ARCH_GET_GS</b> <b></b>  Renvoie la base 64-bits pour le registre
<i>GS</i> du thread en cours dans la variable
<i>unsigned long</i> pointe par le
paramtre
<i>adr .</i>
</div><br/><br /><h1 class="TitreSection0" id="L4">notes</h1>
<div class="paragraph">
<i>arch_prctl</i> n'est seulement support sur Linux/x86-64 pour les programmes 64-bits.<br/><br/>
La base 64-bits change lorsqu'un nouveau selecteur de segment 32-bits est charg.<br/><br/>
<b>ARCH_SET_GS</b> <b></b>  est inactif dans certains noyaux.<br/><br/>
Les changements de contextes pour les bases 64-bits sont assez coteux. Il peut tre
plus rapide de fixer une base 32-bits avec un slecteur de segment en fixant
une LDT avec
<b>modify_ldt (2)</b>
ou en utilisant l'appel-systme
<b>set_thread_area (2)</b>
des noyaux 2.5.
<b>arch_prctl</b> <b></b>  n'est utile que si vous dsirez fixer des bases plus grandes que 4Go.
La mmoire dans les premiers 2 Go d'adressage peut tre alloue en utilisant
<b>mmap (2)</b>
avec
l'attribut.
<i>MAP_32BIT .<br/><br/></i>
Il n'y a pas de prototype pour
<i>arch_prctl</i> Dans la GlibC 2.2. Vous devez le dclarer vous-mme.
Ceci sera corrig dans les futures versions de la GlibC.<br/><br/>
<i>FS </i> peut tre dj utilis par la bibliothque de multi-threading.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EINVAL</b> <b></b>  <i>code </i> n'est pas une sous-commande valide.
<br/><br/>

<b>EPERM</b> <b></b>  <i>adr</i> pointe en dehors de l'espace d'adressage du processus.
<br/><br/>

<b>EFAULT</b> <b></b>  <i>adr </i> pointe vers une adresse non affecte ou est en dehors de l'espace d'adressage.
</div><br/><br /><h1 class="TitreSection0" id="L6">auteur</h1>
<div class="paragraph">
Page de manuel crite par Andi Kleen.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
<i>arch_prctl</i> est une extension Linux/x86-64 et ne doit pas tre employe dans un programme portable.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>mmap (2),</b>
<b>modify_ldt (2),</b>
<b>prctl (2),</b>
<b>set_thread_area (2)</b>
<br/><br/>

Manuel du programmeur AMD X86-64
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
