<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright 1993 Rickard E. Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--   -->
<!--  Traduction 23/01/1997 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise  jour 18/05/99 - LDP-man-pages-1.23 -->
<!--  mj 15/01/02 LDP-man-pages 1.47 -->
<!--  mj 18/07/03 LDP-man-pages 1.56 -->
<br/><h1>FLOCK</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
flock - Placer ou enlever un verrou coopratif sur un fichier ouvert.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/file.h&gt;</b> <b></b>  <br/><br/>

<b>int flock(int </b> fd <b>, int </b> operation );</b>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Place ou enlve un verrou consultatif sur un fichier ouvert dont le descripteur est
<i>fd .</i>
Le paramtre
<i>operation</i> est l'un des suivants&nbsp;:
.RS
<br/><br/>

<br/><br/>
 1.0i
LOCK_SH
Verrouillage partag.
Plusieurs processus peuvent disposer d'un verrouillage
partag simultanment sur un mme fichier.
<br/><br/>

LOCK_EX
Verrouillage exclusif.
Un seul processus dispose d'un verrouillage exclusif
sur un fichier,  un moment donn.
<br/><br/>

LOCK_UN
Dverrouillage d'un verrou tenu par le processus.
<br/><br/>

<br/><br/>
Un appel
<b>flock()</b>
peut bloquer si un verrou incompatible est tenu par un autre processus.
Pour que la requte soit non-bloquante, il faut inclure
<b>LOCK_NB</b> <b></b>  (par un
<i>OU </i>
binaire | ) avec la constante prcisant l'opration.<br/><br/>
Un mme fichier ne peut pas avoir simultanment des verrous partags et exclusifs.<br/><br/>
Les verrous crs avec
<b>flock ()</b>
sont associs  un fichier, ou plus prcisment une entre de la table des fichiers
ouverts. Ainsi les descripteurs de fichiers dupliqus (par exemple avec
<b>fork </b>(2) ou <b> dup (2))</b>
se rfrent au mme verrou, et celui-ci peut tre relch ou modifi 
travers n'importe lequel des descripteurs.
De plus, un verrou est relche par une opration explicite
<b>LOCK_UN</b> <b></b>  sur l'un quelconque des descripteurs, ou lorsqu'ils ont tous t
ferms.<br/><br/>
Un processus ne peut avoir qu'une seul type de verrou (partag ou exclusif)
sur un fichier.
En consquence un appel
<b>flock ()</b>
sur un fichier dj verrouill modifiera le type de
verrouillage.<br/><br/>
Les verrous crs par
<b>flock ()</b>
sont conserv lors d'un appel
<b>execve ().<br/><br/></b>
Un verrou partag ou exclusif peut tre plac sur un fichier quelque soit le
mode d'ouverture du fichier.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>flock</b>
renvoie 0 s'il russit, ou -1 en cas d'chec, auquel cas
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EWOULDBLOCK</b> <b></b>  Le fichier est verrouill et l'attribut
<b>LOCK_NB</b> <b></b>  a t prcis.
<br/><br/>

<b>EBADF</b> <b></b>  <i>fd</i> n'est pas un descripteur de fichier ouvert.
<br/><br/>

<b>EINTR</b> <b></b>  Durant l'attente pour acqurir le verrou,
l'appel a t interrompu par un signal captur par un gestionnaire.
<br/><br/>

<b>EINVAL</b> <b></b>  <i>operation</i> est invalide.
<br/><br/>

<b>ENOLCK</b> <b></b>  Le noyau n'a pas assez de mmoire pour les allocations de verrou.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
4.4BSD (l'appel systme
<b>flock (2)</b>
est apparu pour la premire fois dans 4.2BSD).
Une version de
<b>flock (2)</b>
parfois implment  partir de
<b>fcntl (2),</b>
est apparue sur la plupart des Unix.
</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
<b>flock (2)</b>
ne verrouille par les fichiers  travers NFS. Utilisez
<b>fcntl (2)</b>
 la place : il fonctionne avec NFS si la version de Linux est suffisamment
rcente et si le serveur accepte les verrouillages.<br/><br/>
Depuis le noyau 2.0,
<b>flock (2)</b>
est implment par un appel-systme plutt que d'tre
mul par une routine de la bibliothque C invoquant
<b>fcntl (2).</b>
Ceci correspond  la vritable smantique BSD&nbsp;:
il n'y a pas d'interaction entre les verrous
placs 
<b>flock (2)</b>
et
<b>fcntl (2),</b>
et
<b>flock (2)</b>
ne dtecte pas les cas de blocage (deadlock).<br/><br/>
<b>flock (2)</b>
place uniquement des verrous coopratifs&nbsp;: suivant les permissions du fichier
un processus peut ignorer l'utilisation de
<b>flock (2)</b>
et faire des entres/sorties sur le fichier.<br/><br/>
<b>flock (2) </b>
et
<b>fcntl (2)</b>
ont des smantiques diffrents par rapport aux processus "forks" et
<b>dup (2).</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>open (2),</b>
<b>close (2),</b>
<b>dup (2),</b>
<b>execve (2),</b>
<b>fcntl (2),</b>
<b>fork (2),</b>
<b>lockf (3)<br/><br/></b>
On peut galement se reporter aux fichiers
<i>locks.txt</i> et
<i>mandatory.txt</i> dans le rpertoire
<i>/usr/src/linux/Documentation .<br/><br/></i>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
