<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright (c) 1992 Drew Eckhardt (drew@cs.colorado.edu), March 28, 1992 -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Modified by Michael Haardt (u31b3hs@pool.informatik.rwth-aachen.de) -->
<!--  Modified Sat Jul 24 13:22:07 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  Modified 21 Aug 1994 by Michael Chastain (mec@shell.portal.com): -->
<!--    Referenced 'clone(2)'. -->
<!--  Modified 10 June 1995 by Andries Brouwer (aeb@cwi.nl) -->
<!--  -->
<!--   -->
<!--  Traduction  9/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise  jour 09/06/99 -->
<!--  mj 26/06/2000 LDP 1.30 -->
<!--  mj 30/05/2001 LDP 1.36 -->
<!--  mj 18/07/2003 LDP 1.36 -->
<br/><h1>FORK</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">exemple</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
fork - Crer un processus fils.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <br/><br/>

<b>pid_t</b> <b></b>  <b>fork(void);</b> <b></b>  </div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>fork</b> <b></b>  cre un processus fils qui diffre du processus parent uniquement par ses
valeurs PID et PPID et par le fait que toutes les statistiques d'utilisation
des ressources sont remises  zro. Les verrouillages de fichiers, et les signaux en
attente ne sont pas hrits.<br/><br/>
Sous Linux,
<b>fork</b> <b></b>  est implement en utilisant une mthode de copie  l'criture. 
Ceci consiste  ne faire la vritable duplication d'une page
mmoire que lorsqu'un processus en modifie une instance. Tant
qu'aucun des deux processus n'crit dans une page donne, celle-ci
n'est pas vraiment duplique.
Ainsi les
seules pnalisations induites par fork sont le temps et la mmoire 
ncessaires  la copie de
la table des pages du parent ainsi que la cration d'une structure de
tche pour le fils.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
En cas de succs, le PID du fils est renvoy au processus parent, et 
0 est renvoy au processus fils. En cas d'chec -1 est renvoy dans le
contexte du parent, aucun processus fils n'est cr, et
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EAGAIN</b> <b></b>  <b>fork</b> <b></b>  ne peut pas allouer assez de mmoire pour copier la table des pages du
pre et une structure de tche pour le fils.
<br/><br/>

<b>ENOMEM</b> <b></b>  <b>fork</b> <b></b>  a chou car le noyau n'a plus assez de mmoire.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">exemple</h1>
<div class="paragraph">

    pid_t   pid;<br/><br/>
    pid = fork ();<br/><br/>
    if (pid &gt; 0) {
         /* Processus pre      */
    } else if (pid == 0) {
         /* Processus fils      */
    } else {
         /* Traitement d'erreur */
    }

<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
L'appel-systme
<b>fork</b> <b></b>  est conforme  SVr4, SVID, POSIX, X/OPEN, BSD 4.3.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>clone (2),</b>
<b>execve (2),</b>
<b>vfork (2),</b>
<b>wait (2).<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
