<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  This manpage has been automatically generated by docbook2man  -->
<!--  from a DocBook document.  This tool can be found at: -->
<!--  &lt;http://shell.ipoline.com/~elmert/comp/docbook2X/&gt;  -->
<!--  Please send any bug reports, improvements, comments, patches,  -->
<!--  etc. to Steve Cheng &lt;steve@ggi-project.org&gt;. -->
<!--  -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--   MJ 18/07/2003 - LDP-1.56 -->
<br/><h1>"FUTEX"</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">notes</a>
<br /><a class="summaryIndent0" href="#L5">auteurs</a>
<br /><a class="summaryIndent0" href="#L6">versions</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
futex - Mcanisme de verrouillage rapide en mode utilisateur.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<br/><br/>

<b>#include</b> <b></b>  <b>&lt;linux/futex.h&gt;"</b> <b></b>  <br/><br/>

<b>#include</b> <b></b>  <b>&lt;sys/time.h&gt;"</b> <b></b>  <br/><br/>

<b>int sys_futex (void *</b> futex <i>, int </i> op <b>, int </b> val <i>, const struct timespec *</i> timeout );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph"><br/><br/>
L'appel-systme
<b>sys_futex</b> <b></b>  donne  un programme la possibilit d'attendre qu'une valeur  une adresse donne
change, ou de rveiller tous ceux qui sont en attente sur cette adresse. Bien
que les adresses soient diffrentes dans des processus spars, le noyau
fera la correspondant lors de l'appel-systme.
Ceci est typiquement employ pour implmenter
les verrous en mmoire partag, tels qu'ils
sont dcrits dans
<b>futex (4).<br/><br/></b>
Quant une opration
<b>futex (4)</b>
ne se termine pas de manire satisfaisante dans l'espace utilisateur, un appel
au noyau est ncessaire pour l'arbitrage. Ceci signifie soit endormir le
processus appelant, soit rveiller le processus en attente.<br/><br/>
Les appelants de cette fonction doivent accepter les smantiques dcrites dans
<b>futex (4).</b>
Comme celles-ci impliquent l'criture d'instructions non-portables en assembleur,
leurs utilisateurs sont des auteurs de bibliothques plus que des dveloppeurs applicatifs.<br/><br/>
L'argument
<i>futex</i> doit pointer sur un entier align qui stocke le compteur. L'opration  excuter
est transmise dans le paramtre
<i>op ,</i>
avec la valeur
<i>val .<br/><br/></i>
Trois oprations sont dfinies pour le moment&nbsp;:
<br/><br/>

<b>FUTEX_WAIT</b> <b></b>  Cette opration vrifie que l'adresse du futex contient toujours la valeur indique
et s'endort en attendant un
<i>FUTEX_WAKE</i>  cette adresse. Les deux tapes sont lies atomiquement. Si l'argument
<i>timeout</i> est non-NULL, il contient la dure maximale de sommeil. Sinon elle est infinie.
D'aprs
<b>futex (4),</b>
cet appel est excut si la dcrmentation du compteur donne une valeur ngative
(indiquant un conflit) et le sommeil durera jusqu' ce qu'un autre processus
relche le futex et excute
<b>FUTEX_WAKE .</b>
<br/><br/>

<b>FUTEX_WAKE</b> <b></b>  Cette opration rveille au plus
<i>val</i> processus en attente sur l'adresse du futex (endormis dans
<i>FUTEX_WAIT ).</i>
D'aprs
<b>futex (4),</b>
ceci est excut si l'incrmentation du compteur montre qu'il y a des processus
en attente, une fois que la valeur du futex a t mise  1 (indiquant qu'il
est disponible).
<br/><br/>

<b>FUTEX_FD</b> <b></b>  Pour permettre des rveils asynchrones, cette opration associe un descripteur de
fichier avec un futex. Si un autre processus excute un
<b>FUTEX_WAIT ,</b>
l'appelant recevra le signal dont le numro a t indiqu dans
<i>val .</i>
L'appelant doit refermer le descripteur de fichier aprs utilisation.<br/><br/>
Pour viter les situations de concurrence, l'appelant doit tester si le futex a
t libr aprs le retour de
<b>FUTEX_FD .</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph"><br/><br/>
Suivant l'opration excute, la valeur renvoye peut avoir diffrentes significations.
<br/><br/>

<b>FUTEX_WAIT</b> <b></b>  Renvoie 0 si le processus a t rveill par un
<b>FUTEX_WAKE .</b>
Renvoie ETIMEDOUT en cas de dpasse de dlai. Renvoie EWOULDBLOCK si le futex
n'avait pas la valeur attendue. L'arrive d'un signal peut faire renvoyer EINTR.
<br/><br/>

<b>FUTEX_WAKE</b> <b></b>  Renvoie le nombre de processus rveills.
<br/><br/>

<b>FUTEX_FD</b> <b></b>  Renvoie le nouveau descripteur associ au futex.
</div><br/><br /><h1 class="TitreSection0" id="L5">notes</h1>
<div class="paragraph"><br/><br/>
Rptons-le, les futex de base ne sont pas conus comme une abstraction facile 
employer pour les utilisateurs. Les implmenteurs doivent maitriser l'assembleur
et avoir lu les sources de la bibliothque en espace utilisateur dcrite plus bas.
</div><br/><br /><h1 class="TitreSection0" id="L6">auteurs</h1>
<div class="paragraph"><br/><br/>
Les futex ont t conus et crs par Hubertus Franke (IBM Thomas J. Watson Research Center), 
Matthew Kirkwood, Ingo Molnar (Red Hat) et Rusty Russell (IBM Linux Technology Center).
Cette page a t crite par Bert Hubert.
</div><br/><br /><h1 class="TitreSection0" id="L7">versions</h1>
<div class="paragraph"><br/><br/>
Le support initial des futex a t ajout dans Linux 2.5.7 mais avec une smantique
diffrent de celle dcrite ci-dessus, qui est disponible depuis Linux 2.5.40.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph"><br/><br/>
<b>futex (4),<br/><br/></b>
`Fuss, Futexes and Furwocks: Fast Userlevel Locking in Linux' (proceedings of the Ottawa Linux Symposium 2002), <br/><br/>
Bibliothque futex-*.tar.bz2 &lt;URL:ftp://ftp.nl.kernel.org:/pub/linux/kernel/people/rusty/&gt;.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
