<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 2001 Andries Brouwer (aeb@cwi.nl) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 18/07/2003   LDP-1.56 -->
<!--   -->
<br/><h1>GETCONTEXT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getcontext, setcontext - Lire ou crire le contexte utilisateur.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;ucontext.h&gt;</b> <b></b>  <br/><br/>

<b>int getcontext(ucontext_t *</b> ucp );
<br/>
<b>int setcontext(const ucontext_t *</b> ucp );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Dans un environnement de type SysV, il existe deux types
<b>mcontext_t </b> et <b> ucontext_t</b>
dfinis dans
<i>&lt;ucontext.h&gt;</i> et les quatre fonctions
<b>getcontext </b>(), <b> setcontext </b>(), <b> makecontext </b>() et <b> swapcontext ()</b>
permettent le changement de contexte au niveau utilisateur entre plusieurs
fils de contrle au sein du mme processus (threads).<br/><br/>
Le type
<b>mcontext_t</b> <b></b>  est opaque et dpend de la machine. Le type
<b>ucontext_t</b> <b></b>  est une structure ayant au moins les champs suivants&nbsp;:
.RS

typedef struct ucontext {
	struct ucontext *uc_link;
	sigset_t uc_sigmask;
	stack_t uc_stack;
	mcontext_t uc_mcontext;
	...
} ucontext_t;



Les types
<b>sigset_t</b> <b></b>  <b></b> <b></b>  <b>et</b> <b></b>  <b></b> <b></b>  <b>stack_t</b> <b></b>  sont dfinis dans
<i>&lt;signal.h&gt; .</i>
Ici,
<i>uc_link</i> pointe sur le contexte qui doit tre restaur lorsque le contexte courant
se terminera (si le contexte en cours a t cr par
<b>makecontext ()),</b>
<i>uc_sigmask</i> est l'ensemble des signaux bloqus dans ce contexte (voir
<b>sigaltstack (2)),</b>
et
<i>uc_mcontext</i> est la reprsentation - dpendant de la machine - du contexte sauvegard,
qui inclue les registres du processeur pour le thread appelant.<br/><br/>
La fonction
<b>getcontext ()</b>
remplit la structure pointe par
<i>ucp</i> avec le contexte actuellement actif.<br/><br/>
La fonction
<b>setcontext ()</b>
restaure le contexte utilisateur point par
<i>ucp .</i>
Un appel russi ne revient pas. Le contexte doit avoir t obtenu par un appel
<b>getcontext (),</b>
ou
<b>makecontext (),</b>
ou pass en troisime argument  un gestionnaire de signal.<br/><br/>
Si le contexte a t obtenu par un appel
<b>getcontext (),</b>
l'excution du programme reprend comme si cet appel venait juste de se terminer.<br/><br/>
Si le contexte a t obtenu par un appel
<b>makecontext (),</b>
l'excution du programme continue par l'appel de la fonction
<i>func</i> indique en second argument de
<b>makecontext ().</b>
Quand la fonction
<i>func</i> se terminer, on continue avec le membre
<i>uc_link</i> de la structure
<i>ucp</i> spcifie en premier argument de l'appel
<b>makecontext ().</b>
Si ce membre est NULL, le thread se termine.<br/><br/>
Si le contexte a t obtenu lors d'un appel  un gestionnaire de signal, alors
le texte des anciens standards dit que "l'excution du programme continue avec
l'instruction suivant celle qui a t interrompue par le signal". Toutefois
cette phrase a t supprime de SUSv2, et remplace par "le rsultat
n'est pas spcifi".
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Lorsqu'ils russissent,
<b>getcontext ()</b>
renvoie zro et
<b>setcontext ()</b>
ne revient pas. En cas d'erreur, ils retournent -1 et remplissent
<i>errno</i> avec le code d'erreur adquat.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
Aucune dfinie.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
L'incarnation la plus ancienne de ce mcanisme tait constitue de la paire
<b>setjmp </b>()/<b> longjmp ().</b>
Comme ils ne prcisent pas la gestion des signaux, l'tape suivante fut
<b>sigsetjmp </b>()/<b> siglongjmp ().</b>
Le mcanisme actuel donne plus de contrle. En revanche, il n'y a pas de
moyen simple pour savoir si le retour de
<b>getcontext ()</b>
se fait depuis son premier appel ou par l'intermdiaire d'un appel
<b>setcontext ().</b>
L'utilisateur doit inventer son propre systme de comptabilisation, et pas
dans un registre car il serait restaur.<br/><br/>
Lorsqu'un signal arrive, le contexte utilisateur courant est sauvegard et 
un nouveau contexte est cr par le noyau pour excuter le gestionnaire.
N'utilisez pas
<b>longjmp ()</b>
dans le gestionnaire, le comportement est indfini. Utilisez
<b>siglongjmp </b>() ou <b> setcontext ().</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SUSv2
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>sigaction (2),</b>
<b>sigaltstack (2),</b>
<b>sigprocmask (2),</b>
<b>longjmp (3),</b>
<b>sigsetjmp (3),</b>
<b>makecontext (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
