<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1995 Andries Brouwer (aeb@cwi.nl) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Written 11 June 1995 by Andries Brouwer (aeb@cwi.nl) -->
<!--  Modified 22 July 1995 by Michael Chastain (mec@duracef.shout.net): -->
<!--    Derived from 'readdir.2'. -->
<!--   -->
<!--  Traduction  11/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise a jour 8/04/97 -->
<!--  Mise a jour 18/07/03 LDP-1.56 -->
<br/><h1>GETDENTS</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getdents - Obtenir les points d'entre d'un rpertoire.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;linux/types.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;linux/dirent.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;linux/unistd.h&gt;</b> <b></b>  <br/><br/>

<b>_syscall3(int</b> <b></b> ,<b></b>  <b>getdents</b> <b></b> ,<b></b>  <b>uint</b> <b></b> ,<b></b>  <b>fd</b> <b></b> ,<b></b>  <b>struct</b> <b></b>  <b>dirent</b> <b></b>  <b>*</b> <b></b> ,<b></b>  <b>dirp</b> <b></b> ,<b></b>  <b>uint</b> <b></b> ,<b></b>  <b>count);</b> <b></b>  <br/><br/>

<b>int getdents(unsigned int </b> fd <i>, struct dirent *</i> dirp <b>, unsigned int </b> count );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>getdents</b> <b></b>  lit plusieurs structures
<i>dirent</i> depuis un rpertoire point
par le descripteur de fichier
<i>fd</i> et les place dans la zone de mmoire pointe par
<i>dirp .</i>
Le paramtre
<i>count</i> est la taille de la zone mmoire.<br/><br/>
La structure 
<i>dirent</i> est dclare ainsi :<br/><br/>
.RS

struct dirent
{
    long d_ino;                 /* numro d'i-noeud            */
    off_t d_off;                /* distance au prochain dirent */
    unsigned short d_reclen;    /* longueur de ce dirent       */
    char d_name [NAME_MAX+1];   /* nom de fichier (fini par 0) */
}


<br/><br/>
<i>d_ino</i> est un numro d'i-noeud.
<i>d_off</i> est la distance entre le dbut du rpertoire et le dbut de la prochaine structure
<i>dirent .</i>
<i>d_reclen</i> est la taille complte de
<i>dirent .</i>
<i>d_name</i> est le nom de fichier termin par un caractre nul.<br/><br/>
Cette fonction remplace
<b>readdir (2).</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>getdents</b> <b></b>  renvoie le nombre d'octets lus s'il russit (0 en fin de rpertoire),
ou -1 s'il choue, auquel cas
<i>errno</i> contient le code d'erreur.  
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EBADF</b> <b></b>  <i>fd</i>
n'est pas un descripteur de fichier valide.
<br/><br/>

<b>EFAULT</b> <b></b>  L'argument pointe en dehors de l'espace d'adressage disponible.
<br/><br/>

<b>EINVAL</b> <b></b>  Le buffer de rsultat est trop petit.
<br/><br/>

<b>ENOENT</b> <b></b>  Rpertoire inexistant.
<br/><br/>

<b>ENOTDIR</b> <b></b>  Le descripteur de fichier ne pointe pas sur un rpertoire.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
SVr4, SVID.  SVr4 documente les erreurs supplmentaires
ENOLINK, et EIO.
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>readdir (2),</b>
<b>readdir (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
