<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright 1993 Rickard E. Faith (faith@cs.unc.edu) -->
<!--   -->
<!--  Traduction  10/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise  jour 25/04/98 (LDP-man-pages-1.19) -->
<!--  Mise  jour 30/05/01 (LDP-man-pages-1.36) -->
<!--  Mise  jour 18/07/03 (LDP-man-pages-1.56) -->
<br/><h1>GETGROUPS</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getgroups, setgroups - Lire/crire la liste des groupes supplmentaires d'un processus.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <br/><br/>

<b>int getgroups(int </b> size <i>, gid_t </i> list []);
<br/><br/>

<b>#include</b> <b></b>  <b>&lt;grp.h&gt;</b> <b></b>  <br/><br/>

<b>int setgroups(size_t </b> size <i>, const gid_t *</i> list );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<br/><br/>

<b>getgroups</b> <b></b>  retourne une liste
<i>list</i>
contenant jusqu'
<i>size</i> ID de groupes additionnels.
Le groupe effectif du processus appelant peut tre inclus ou non dans
la liste (ainsi une application devrait galement appeler
<b>getegid (2)</b>
et ajouter ou supprimer la valeur rsultante).
Si
<i>size</i> vaut zro,
<i>list</i> n'est pas modifie, mais le nombre total de groupes supplmentaires
pour le processus est renvoy.
<br/><br/>

<b>setgroups</b> <b></b>  fixe des ID groupes supplmentaires pour le processus. Seul le Super-User peut
utiliser cette fonction.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<br/><br/>

<b>getgroups</b> <b></b>  renvoie le nombre d'ID de groupes supplmentaires du processus
s'il russit, ou -1 s'il choue, auquel cas
<i>errno</i> contient le code d'erreur.
<br/><br/>

<b>setgroups</b> <b></b>  renvoie 0 s'il russit, ou -1 s'il choue, auquel cas
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EFAULT</b> <b></b>  <i>list</i> pointe en dehors de l'espace d'adressage accessible.
<br/><br/>

<b>EPERM</b> <b></b>  Pour
<b>setgroups ,</b>
l'utilisateur n'est pas le Super-User.
<br/><br/>

<b>EINVAL</b> <b></b>  Pour
<b>setgroups ,</b>
<i>size</i> est plus grand que
<b>NGROUPS</b> <b></b>  (32 avec Linux 2.0.32).
Pour
<b>getgroups ,</b>
<i>size</i> est infrieur au nombre d'ID de groupes supplmentaires, et n'est pas nul.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Un processus peut avoir jusqu' NGROUPS_MAX ID de groupes supplmentaires
en plus de son ID de groupe effectif. Le jeu d'ID de groupes supplmentaires
est hrit du processus parent, et peut tre modifi avec
<b>setgroups .</b>
Le nombre maximal d'ID de groupes supplmentaires peut tre obtenus avec
<b>sysconf (3):</b>

    long ngroups_max;
    ngroups_max = sysconf(_SC_NGROUPS_MAX);


La valeur de retour maximale de
<b>getgroups</b> <b></b>  ne peut pas tre plus grande que 1 plus la valeur ainsi obtenue.<br/><br/>
Le prototype de
<b>setgroups</b> <b></b>  n'est disponible que si
<b>_BSD_SOURCE</b> <b></b>  est dfinie (soit explicitement, soit implicitement en ne dfinissant pas
_POSIX_SOURCE ou en compilant avec l'option -ansi).
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SVr4, SVID (version 4 uniquement), X/OPEN, 4.3BSD.
<b>getgroups</b> <b></b>  est conforme a POSIX.1 (et prsent dans BSD 4.3).  Comme
<b>setgroups</b> <b></b>  ncessite des privilges, il n'est pas couvert par POSIX.1.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>initgroups (3), </b>
<b>getgid (2),</b>
<b>setgid (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
