<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright (c) 1992 Drew Eckhardt, March 28, 1992 -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Modified by Michael Haardt (u31b3hs@pool.informatik.rwth-aachen.de) -->
<!--  Modified Fri Jul 23 21:18:14 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  Modified Jan 13, 1996 by Arnt Gulbrandsen &lt;agulbra@troll.no&gt; -->
<!--   -->
<!--  Traduction  11/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise a jour 8/04/97 -->
<!--  mj 09/04/99 LDP-man-pages 1.22 -->
<!--  mj 30/05/01 LDP-man-pages 1.36 -->
<!--  mj 19/01/2002 LDP 1.47 -->
<!--  mj 18/07/2003 - LDP 1.56 -->
<br/><h1>GETRLIMIT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">note</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getrlimit, getrusage, setrlimit - Lire/crire les limites et utilisations des ressources.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/time.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;sys/resource.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <br/><br/>

<b>int getrlimit (int </b> resource <i>, struct rlimit *</i> rlim );
<br/>
<b>int getrusage (int </b> who <i>, struct rusage *</i> usage );
<br/>
<b>int setrlimit (int </b> resource <i>, const struct rlimit *</i> rlim );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>getrlimit</b> <b></b>  et
<b>setrlimit</b> <b></b>  lisent ou crivent les limites des ressources systmes. Chaque ressource
a une limite souple et une limite stricte dfinies par la structure
<b>rlimit</b> <b></b>  (l'argument
<i>rlim</i> de
<b>getrlimit </b>() et <b> setrlimit </b>()) :<b><br/><br/></b>
.in +0.5i

struct rlimit {
  rlim_t rlim_cur; /* limite souple */
  rlim_t rlim_max; /* limite stricte (plafond
                      de rlim_cur) */
};<br/><br/>


.in -0.5i
La limite souple est la valeur que le noyau prend en compte pour la
ressource correspondante.
La limite stricte agit comme un plafond pour la limite souple&nbsp;: un processus
non-privilgi peut seulement modifier sa limite souple dans l'intervalle entre
zro et la limite stricte, et diminuer (de manire irrversible) sa limite
stricte. Un processus privilgi peut modifier ses deux limites  sa guise.<br/><br/>
La valeur
<b>RLIM_INFINITY</b> <b></b>  indique une limite infinie pour la ressource (aussi bien pour
<b>getrlimit ()</b>
que pour
<b>setrlimit ().<br/><br/></b>
<i>resource</i> doit tre l'un des lments suivants :
<br/><br/>

<b>RLIMIT_CPU</b> <b></b>  Limite de temps CPU en secondes. 
Si un processus atteint cette limite souple, il reoit le signal
<b>SIGXCPU .</b>
L'action par dfaut en est la terminaison du processus.
Mais le signal peut tre captur et le gestionnaire
peut renvoyer le contrle au programme
principal.
Si le processus continue  consommer du temps CPU, il recevra
<b>SIGXCPU</b> <b></b>  toutes les secondes jusqu' atteindre sa limite stricte,
o il recevra
<b>SIGKILL .</b>
(Ceci correspond au comportement de Linux 2.2 et 2.4.
Les implmentations varient sur le comportement vis--vis d'un processus
qui continue  consommer du temps CPU aprs dpassement de sa limite souple.
Les applications portables qui doivent capturer ce signal devrait
prvoir une terminaison propre ds la premire rception de
<b>SIGXCPU ).</b>
<br/><br/>

<b>RLIMIT_DATA</b> <b></b>  Taille maximale du segment de donnes d'un processus (donnes initialises,
non-initialises, et tas).
Cette limite affecte les appels
<b>brk </b>() et <b> sbrk (),</b>
qui chouent avec l'erreur
<b>ENOMEM</b> <b></b>  si la limite souple est dpasse.
<br/><br/>

<b>RLIMIT_FSIZE</b> <b></b>  Taille maximal d'un fichier que le processus peut crer.
Les tentatives d'extension d'un fichier au-del de cette limite resultent en
un signal
<b>SIGXFSZ .</b>
Par dfaut ce signal termine le processus, mais il peut tre
captur, et dans ce cas l'appel-systme concern (par exemple
<b>write </b>(), <b> truncate ())</b>
chouent avec l'erreur
<b>EFBIG .</b>
<b>RLIMIT_LOCKS</b> <b></b>  Une limite sur le nombre combin de verrous
<b>flock ()</b>
et
<b>fcntl() </b>
que le processus peut tablir
(Linux 2.4 et suivants).
<!--  to be precise: Linux 2.4.0-test9 and later -->
<br/><br/>

<b>RLIMIT_MEMLOCK</b> <b></b>  Le nombre maximal d'octets de mmoire virtuelle que le processus peut
verrouiller en RAM  l'aide des appels
<b>lock </b>() et <b> mlockall ().</b>
<br/><br/>

<b>RLIMIT_NOFILE</b> <b></b>  Le nombre maximal de descripteurs de fichiers qu'un processus
peut ouovrir simultanment.
Les tentatives d'ouverture
( open <b>(), </b> pipe <b>(), </b> dup <b>(), etc)</b></b>
dpassant cette limite renverront l'erreur
<b>EMFILE .</b>
<br/><br/>

<b>RLIMIT_NPROC</b> <b></b>  Le nombre maximum de processus qui peuvent tre crs pour l'UID rel
du processus appelant.
Une fois cette limite atteinte,
<b>fork ()</b>
choue avec l'erreur
<b>EAGAIN .</b>
<br/><br/>

<b>RLIMIT_RSS</b> <b></b>  Indique la limite (en pages) pour la taille de l'ensemble rsident du processus
(le nombre de page de mmoire virtuelle en RAM).
Cette limite n'a d'effet que depuis Linux 2.4, et n'affecte
que les appels
<b>madvise ()</b>
indiquant
<b>MADVISE_WILLNEED .</b>
<br/><br/>

<b>RLIMIT_STACK</b> <b></b>  La taille maximal de la pile du processus, en octets.
Une fois cette limite atteinte, un signal
<b>SIGSEGV</b> <b></b>  est dclench.
Pour grer ce signal, le processus doit utiliser une pile spcifique pour signaux
( sigaltstack (2)).<br/><br/></b>
<b>RLIMIT_OFILE</b> <b></b>  <b></b>  est le nom BSD pour
<b>RLIMIT_NOFILE .</b>
<b>getrusage</b> <b></b>  renvoie l'utilisation courante des ressources, pour <i>who</i>
valant  
<b>RUSAGE_SELF</b>
ou
<b>RUSAGE_CHILDREN .</b>
Le premier correspond aux ressources consommes par le processus appelant
et le second par l'ensemble des processus fils termins qui ont t attendus
par un <b>wait</b>().<br/><br/> 
.in +0.5i

struct rusage {
  struct timeval ru_utime; /* Temps utilisateur coul         */
  struct timeval ru_stime; /* Temps systme coul             */
  long  ru_maxrss;         /* Taille rsidente maximale        */
  long  ru_ixrss;          /* Taille de mmoire partage       */
  long  ru_idrss;          /* Taille des donnes non partages */
  long  ru_isrss;          /* Taille de pile                   */
  long  ru_minflt;         /* Demandes de pages                */
  long  ru_majflt;         /* Nombre de fautes de pages        */
  long  ru_nswap;          /* Nombre de swaps                  */
  long  ru_inblock;        /* Nombre de lectures de blocs      */
  long  ru_oublock;        /* Nombre d'critures de blocs      */
  long  ru_msgsnd;         /* Nombre de messages mis          */
  long  ru_msgrcv;         /* Nombre de messages reus         */
  long  ru_nsignals;       /* Nombre de signaux reus          */
  long  ru_nvcsw;          /* Chgmnts de contexte volontaires  */
  long  ru_nivcsw;         /* Chgmnts de contexte involontaires*/
};


.in -0.5i
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Ces fonctions renvoient 0 si elles russissent, ou -1 si elles chouent, auquel cas
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EFAULT</b> <b></b>  <i>rlim</i> ou
<i>usage</i> pointent en dehors de l'espace d'adressage disponible.
<br/><br/>

<b>EINVAL</b> <b></b>  <b>getrlimit </b> ou <b> setrlimit</b>
est appel avec un mauvais argument <i>resource</i>, 
ou <b>getrusage</b> est appel avec un mauvais argument <i>who</i>.
<br/><br/>

<b>EPERM</b> <b></b>  Tentative d'utiliser <b>setrlimit()</b> sans tre Super-User pour
augmenter ses limites, ou alors le Super-User essaye d'augmenter
les limites au-dessus des maxima du noyau.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
SVr4, BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L7">note</h1>
<div class="paragraph">
L'inclusion de
<i>&lt;sys/time.h&gt;</i> n'est plus obligatoire mais amliore la portabilit.
(En fait,
<i>struct timeval</i> est dfinie dans
<i>&lt;sys/time.h&gt; ).<br/><br/></i>
Sous Linux, si le traitement de
<b>SIGCHLD</b> <b></b>  <b></b>  est configur avec
<b>SIG_IGN</b> <b></b>  <b></b>  alors les statistiques d'utilisation des processus enfants
sont automatiquement incluses dans les valeurs renvoyes par
<b>RUSAGE_CHILDREN ,</b>
bien que POSIX 1003.1-2001 interdise explicitement cela.<br/><br/>
Les structures ci-dessous sont extraites de BSD 4.3 Reno.
Tous les champs ne sont pas significatifs sous Linux. Actuellement 
(Linux 2.4) seuls les champs
<b>ru_utime ,</b>
<b>ru_stime ,</b>
<b>ru_minflt ,</b>
<b>ru_majflt ,</b>
et
<b>ru_nswap</b>
sont remplis.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>dup (2),</b>
<b>fcntl (2),</b>
<b>fork (2),</b>
<b>mlock (2),</b>
<b>mlockall (2),</b>
<b>mmap (2), </b>
<b>open (2),</b>
<b>quotactl (2),</b>
<b>sbrk (2),</b>
<b>wait3 (2),</b>
<b>wait4 (2),</b>
<b>malloc (3), </b>
<b>ulimit (3),</b>
<b>signal (7)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
