<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright (c) 1992 Drew Eckhardt (drew@cs.colorado.edu), March 28, 1992 -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Modified by Michael Haardt (u31b3hs@pool.informatik.rwth-aachen.de) -->
<!--  Modified Fri Jul 23 21:26:27 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  Modified 21 Aug 1994 by Michael Chastain (mec@shell.portal.com): -->
<!--    Fixed necessary '#include' lines. -->
<!--  Modified 15 Apr 1995 by Michael Chastain (mec@shell.portal.com): -->
<!--    Added reference to adjtimex. -->
<!--  Removed some nonsense lines pointed out by urs@isnogud.escape.de (Urs Thuermann), -->
<!--    aeb, 950722. -->
<!--  -->
<!--   -->
<!--  Traduction  10/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise a jour 23/01/97 -->
<!--  Mise a jour 8/04/97 -->
<!--  Mise a jour 28/04/98 (LDP-man-pages-1.19) -->
<!--  Mise a jour 30/05/01 (LDP-man-pages-1.36) -->
<!--  mj 19/01/2002 LDP 1.47 -->
<!--  mj 18/07/2003 LDP 1.56 -->
<br/><h1>GETTIMEOFDAY</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">note</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
gettimeofday, settimeofday - Lire / crire l'heure actuelle.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/time.h&gt;</b> <b></b>  <br/><br/>

<b>int gettimeofday(struct timeval *</b> tv <i>, struct timezone *</i> tz );
<br/>
<b>int settimeofday(const struct timeval *</b> tv
<b>, const struct timezone *</b> tz );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les fonctions
<b>gettimeofday</b> <b></b>  et
<b>settimeofday</b> <b></b>  servent  lire ou programmer l'heure ainsi que le fuseau horaire (timezone).
L'argument
<i>tv</i> est une structure
<b>timeval</b> <b></b>  <b></b>  dcrite dans /usr/include/sys/time.h :
<br/><br/>


struct timeval {
.in +8
int  tv_sec;  /* secondes */
int  tv_usec; /* microsecondes */
.in -8
};


<br/><br/>

et donne le nombre de secondes et microsecondes coules depuis le 1er janvier 1970 (voir 
<b>time (2)).</b>
L'argument
<i>tz</i> est une structure 
<b>timezone</b> <b></b>  compose ainsi&nbsp;:
<br/><br/>


struct timezone {
.in +8
int tz_minuteswest; /* minutes  l'ouest de Greenwich  */
int tz_dsttime;     /* type de changement horaire      */
};
.in -8

<br/><br/>
L'utilisation de la structure timezone est obsolte, le champ
<i>tz_dsttime</i> n'a jamais t utilis sous Linux, il n'a jamais t gr, et
ne le sera jamais par la libc ou glibc.
Toute occurrence de ce champ dans les sources du noyau (sauf
pour les dclarations) est un bug. Ainsi le paragraphe suivant
n'a qu'un intrt historique.<br/><br/>
Le champ
<i>tz_dsttime</i> contient une constante symbolique (dont les valeurs sont fournies
ci-dessous) qui indique quelle partie du changement horaire annuel
est en cours.
(Remarque : Cette valeur est constante tout au long de l'anne, elle
n'indique pas rellement la valeur horaire en cours, elle slectionne
un algorithme).
Les changements horaires (Daylight saving - DST) sont
dfinis comme suit :<br/><br/>
.ta 14
<b>DST_NONE</b>    /* Aucun */
<br/>
<b>DST_USA</b>     /* USA */
<br/>
<b>DST_AUST</b>    /* Australie */
<br/>
<b>DST_WET</b>     /* Europe occidentale */
<br/>
<b>DST_MET</b>     /* Europe centrale */
<br/>
<b>DST_EET</b>     /* Europe Orientale */
<br/>
<b>DST_CAN</b>     /* Canada */
<br/>
<b>DST_GB</b>      /* Grande-Bretagne et Irlande */
<br/>
<b>DST_RUM</b>     /* Roumanie */
<br/>
<b>DST_TUR</b>     /* Turquie */
<br/>
<b>DST_AUSTALT</b> /* Australie avec dcalage en 1986 */<br/><br/>
Il est vident que le dcalage horaire en cours ne peut pas
tre uniquement fourni par un algorithme par pays. Ce dcalage
dpend de dcisions politiques imprvisibles. Ainsi cette mthode
des fuseaux horaires a t abandonne.
Sous Linux, durant un appel 
<b>settimeofday</b> <b></b>  le champ
<i>tz_dsttime</i> doit tre nul.<br/><br/>
Sous Linux, il existe une smantique particulire associe  l'appel
systme
<b>settimeofday</b> <b></b>  si, durant la premire invocation (aprs le boot), il a un argument
<i>tz</i> non-NULL, un argument
<i>tv</i> NULL et un champ
<i>tz_minuteswest</i> diffrent de zro. Dans ce cas, on suppose que l'horloge CMOS de la
machine est configure sur le temps local, et que l'on doit l'augmenter
de cette valeur pour obtenir le temps UTC.
Bien entendu, il faut viter autant que possible d'utiliser cette particularit.<br/><br/>
Les macros suivantes permettent de manipuler les structures timeval :
<br/>

#define	timerisset(tvp)\\
.ti +8
((tvp)-&gt;tv_sec || (tvp)-&gt;tv_usec)
#define	timercmp(tvp, uvp, cmp)\\
.in +8
((tvp)-&gt;tv_sec cmp (uvp)-&gt;tv_sec ||\\
(tvp)-&gt;tv_sec == (uvp)-&gt;tv_sec &&\\
(tvp)-&gt;tv_usec cmp (uvp)-&gt;tv_usec)
.in -8
#define timerclear(tvp)\\
.ti +8
((tvp)-&gt;tv_sec = (tvp)-&gt;tv_usec = 0)

<br/><br/>
Si
<i>tv</i> ou 
<i>tz</i> est nulle, la structure correspondante n'est ni programme ni renvoye.<br/><br/>
Seul le Super-User peut appeler
<b>settimeofday .</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>gettimeofday</b> <b></b>  et
<b>settimeofday</b> <b></b>  renvoient 0 s'ils russissent, ou -1 s'ils chouent, auquel
cas
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EPERM</b> <b></b>  <b></b>  <b>settimeofday</b> <b></b>  est appel par quelqu'un d'autre que le Super-User
<br/><br/>

<b>EINVAL</b> <b></b>  le fuseau horaire (ou autre chose) est invalide.
<b>EFAULT</b> <b></b>  <i>tv</i> ou
<i>tz</i> pointent en dehors de l'espace d'adressage autoris.
</div><br/><br /><h1 class="TitreSection0" id="L6">note</h1>
<div class="paragraph">
Le prototype de
<b>settimeofday</b> <b></b>  et les dfinitions de
<b>timercmp ,</b>
<b>timerisset ,</b>
<b>timerclear ,</b>
<b>timeradd ,</b>
<b>timersub</b>
sont (depuis GlibC 2.2.2) disponibles uniquement si
<b>_BSD_SOURCE</b> <b></b>  est dfini (explicitement ou implicitement en ne dfinissant pas
_POSIX_SOURCE ou en utilisant l'option de compilation -ansi).
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SVr4, BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>date (1),</b>
<b>adjtimex (2),</b>
<b>time (2),</b>
<b>ctime (3),</b>
<b>ftime (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
