<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright (C) 2001 Bert Hubert &lt;ahu@ds9a.nl&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Created Sun Jun 3 17:23:32 2001 by bert hubert &lt;ahu@ds9a.nl&gt; -->
<!--  Slightly adapted, following comments by Hugh Dickins, aeb, 2001-06-04. -->
<!--  -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt;  -->
<!--  17/01/2002 - LDP-man-pages-1.38 -->
<!--  mj 19/01/2002 LDP 1.47 -->
<!--  mj 18/07/2003 LDP 1.56 -->
<!--  mj 30/07/2003 LDP 1.58 -->
<br/><h1>MINCORE</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">bogues</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">historique</a>
<br /><a class="summaryIndent0" href="#L8">disponibilit</a>
<br /><a class="summaryIndent0" href="#L9">voir aussi</a>
<br /><a class="summaryIndent0" href="#L10">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
mincore - savoir quelles pages se trouvent en mmoire physique.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;sys/mman.h&gt;</b> <b></b>  <br/><br/>

<b>int mincore(void *</b> start <i>, size_t </i> length <b>, unsigned char *</b> vec );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>mincore</b> <b></b>  rclame un vecteur (une table) indiquant quelles pages d'un fichier se trouvent en mmoire
physique et peuvent tre lues sans accs disque. Le noyau fournira les donnes concernant les
<i>length</i> octets  partir de l'adresse
<i>start .</i>
En retour, le noyau aura rempli la zone
<i>vec</i> avec des octets dont le bit de poids faible indiquent si la page est en
mmoire physique.<br/><br/>
Pour que
<b>mincore</b> <b></b>  russisse, 
<i>start</i> doit tre aligne sur une frontire de page. C'est la responsabilit de l'appelant d'arrondir
l'adresse  la page la plus proche.
Le paramtre
<i>length</i> n'est pas ncessairement un multiple de la taille de page. Le vecteur
<i>vec</i> doit tre assez grand pour contenir (length+PAGE_SIZE-1)/PAGE_SIZE octets.
On peut connatre la taille de page en invoquant
<b>getpagesize(2).<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Si elle russit, la fonction
<b>mincore</b> <b></b>  renvoie zro.
En cas d'erreur, elle renvoie -1 et rempli
<i>errno</i> avec la valeur d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<b>EAGAIN</b> <b></b>  le noyau manque temporairement de ressources.
<br/><br/>

<b>EINVAL</b> <b></b>  .i start
n'est pas align sur une frontire de page, ou
.i len
n'est pas une valeur positive.
<br/><br/>

<b>EFAULT</b> <b></b>  <i>vec</i> pointe vers une adresse illgale.
<br/><br/>

<b>ENOMEM</b> <b></b>  la zone entre
<i>address</i> et
<i>address </i> + <i> length</i>
contient de la mmoire autre qu'une projection de fichier.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">bogues</h1>
<div class="paragraph">
<b>mincore</b> <b></b>  devrait renvoyer un vecteur de bits et non un vecteur d'octets.
A l'heure de Linux 2.4.20, on ne peut pas obtenir d'information
sur les pages en mmoire physique qui ne sont pas une projection d'un fichier.
En d'autres termes, appeler
<b>mincore</b> <b></b>  sur une zone fournie par un appel anonyme 
<b>mmap(2)</b> <b></b>  avec
<b>MAP_PRIVATE</b> <b></b>  ne fonctionne pas et remplit errno avec ENOMEM. A moins que les pages ne soit verrouilles en mmoire,
le contenu de
<i>vec</i> peut tre prim au moment o ces donnes atteignent l'espace utilisateur.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
<b>mincore</b> <b></b>  n'appartient ni  POSIX ni aux Spcifications Single Unix. 
</div><br/><br /><h1 class="TitreSection0" id="L8">historique</h1>
<div class="paragraph">
La fonction mincore() est apparue dans 4.4BSD.
</div><br/><br /><h1 class="TitreSection0" id="L9">disponibilit</h1>
<div class="paragraph">
Depuis Linux 2.3.99pre1 et GlibC 2.2.
</div><br/><br /><h1 class="TitreSection0" id="L10">voir aussi</h1>
<div class="paragraph">
<b>getpagesize (2),</b>
<b>mmap (2)<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L11">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
