<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  This manpage is Copyright (C) 1992 Drew Eckhardt; -->
<!--                                1993 Michael Haardt -->
<!--                                1993,1994 Ian Jackson. -->
<!--  You may distribute it under the terms of the GNU General -->
<!--  Public Licence. It comes with NO WARRANTY. -->
<!--  -->
<!--   -->
<!--  Traduction  10/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise a Jour 8/04/97 -->
<!--  mj 10/12/1997 (LDP man-pages 1.18) -->
<!--  mj 30/05/2001 (LDP man-pages 1.36) -->
<!--  mj 19/01/2002 LDP 1.47 -->
<!--  mj 18/07/2003 LDP 1.56 -->
<!--  mj 30/07/2003 LDP 1.58 -->
<br/><h1>MKNOD</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
mknod - Crer un noeud du systme de fichiers.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/stat.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;fcntl.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <br/><br/>

<b>int mknod(const char *</b> pathname <i>, mode_t </i> mode <b>, dev_t </b> dev );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>mknod</b> <b></b>  cre un noeud du systme de fichiers (fichier, fichier spcial de priphrique ou
tube) appel
<i>pathname ,</i>
avec les attributs
<i>mode</i> et
<i>dev .<br/><br/></i>
L'argument
<i>mode</i> dfinit  la fois les permissions d'utilisation, et le type de noeud
 crer. C'est une combinaison par 
<i>OU binaire</i> ( | ) 
entre l'un des types de noeuds ci-dessous et les permissions d'accs
pour le nouveau noeud.<br/><br/>
Les permissions sont modifies par le
<b>umask</b>
du processus : les permissions effectivement crites sont
<b>(mode & ~umask)</b> .<br/><br/></b>
Le type de noeud doit tre l'un des suivants
<b>S_IFREG , </b>
<b>S_IFCHR , </b>
<b>S_IFBLK</b>
<b>S_IFIFO</b>
ou
<b>S_IFSOCK</b>
<!--  (S_IFSOCK since Linux 1.2.4) -->
pour indiquer respectivement un fichier normal (vide  la cration),
un fichier spcial mode caractre, un fichier spcial mode bloc,
un tube nomm (FIFO) ou une socket du domaine Unix.
On peut galement utiliser 0 pour crer un fichier normal.<br/><br/>
Si le noeud est de type
<b>S_IFCHR </b> or <b> S_IFBLK</b>
alors
<i>dev</i> doit spcifier les numros majeurs et mineurs du priphrique
associ, pour les autres types de noeuds,
<i>dev</i> est ignor.<br/><br/>
Si
<i>pathname</i> existe dj, ou est un lien symbolique, l'appel choue avec l'erreur EEXIST.<br/><br/>
Le noeud nouvellement cr aura pour propritaire l'UID effectif
du processus. Si le rpertoire contenant ce noeud a son bit
Set-GID  1, ou si le systme de fichier est mont avec une
smantique BSD, le nouveau noeud hritera de l'appartenance au
groupe de son parent. Sinon il appartiendra au groupe effectif
du processus.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>mknod</b>
renvoie 0 s'il russit, ou -1 s'il choue, auquel cas
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EPERM</b> <b></b>  <i>mode</i> demande la cration d'un noeud autre qu'un fichier rgulier
une FIFO (tube nomm) ou une socket du domaine Unix, alors que
le processus appelant n'est pas le Super-User. Cette erreur se
produit galement si le systme de fichier contenant
<i>pathname</i> ne supporte pas les noeuds du type demand.
<br/><br/>

<b>EINVAL</b> <b></b>  <i>mode</i> demande la cration d'autre chose qu'un fichier normal, fichier
spcial de priphrique, DIFO ou socket.
<br/><br/>

<b>EEXIST</b> <b></b>  <i>pathname</i> existe dj
<br/><br/>

<b>EFAULT</b> <b></b>  <i>pathname </i> pointe en-dehors de l'espace d'adressage accessible.<i></i>
<br/><br/>

<b>EACCES</b> <b></b>  Le rpertoire parent n'autorise pas l'criture au processus, ou l'un
des rpertoires de
<i>pathname</i>
n'autorise pas la consultation de son contenu.
<br/><br/>

<b>ENAMETOOLONG</b> <b></b>  <i>pathname </i> trop long.<i></i>
<br/><br/>

<b>ENOENT</b> <b></b>  Un rpertoire du chemin d'accs
<i>pathname</i> n'existe pas ou est un lien symbolique pointant nulle part.
<br/><br/>

<b>ENOTDIR</b> <b></b>  Un lment utilise dans le chemin
<i>pathname</i> n'est pas un rpertoire.
<br/><br/>

<b>ENOMEM</b> <b></b>  Pas assez de mmoire pour le noyau.
<br/><br/>

<b>EROFS</b> <b></b>  <i>pathname</i> serait plac sur un systme de fichier en lecture seule.
<br/><br/>

<b>ELOOP</b> <b></b>  <i>pathname</i> contient une rfrence circulaire ( travers un lien symbolique).
<br/><br/>

<b>ENOSPC</b> <b></b>  Le priphrique contenant
<i>pathname</i> n'a pas assez de place pour le nouveau noeud.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
SVr4 (mais l'appel y ncessite des privilges, alors qu'il n'y en a
pas besoin dans POSIX), BSD 4.4. La version Linux diffre de celle de
SVr4 en ceci qu'elle n'a pas besoin de privilges root pour crer des
tubes, et qu'elle ne dcrit pas les erreurs EMULTIHOP, ENOLINK, et EINTR.
</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
Posix 1003.1-2001 dit : "Le seul usage portable de
<b>mknod ()</b>
est rserv  la cration de fichiers spciaux FIFO. Si le 
<i>mode</i> n'est pas S_IFIFO ou si 
<i>dev</i> n'est pas 0, alors le comportement de
<b>mknod ()</b>
est indtermin.<br/><br/>
Sous Linux
<b>mknod</b> <b></b>  ne peut pas tre utilis pour crer des rpertoires.
Il faut crer les rpertoires avec
<b>mkdir ,</b>
et les FIFO avec
<b>mkfifo .<br/><br/></b>
Il y a de nombreux problmes avec le protocole sous-jacent  NFS, certains
d'entre-eux pouvant affecter
<b>mknod .</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>fcntl (2),</b>
<b>mkdir (2),</b>
<b>mount (2),</b>
<b>socket (2),</b>
<b>stat (2),</b>
<b>umask (2),</b>
<b>unlink (2),</b>
<b>mkfifo (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
