<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  1995-11-26  Markus Kuhn &lt;mskuhn@cip.informatik.uni-erlangen.de&gt; -->
<!--       First version written -->
<!--  -->
<!--  -->
<!--  Traduction  11/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise a jour 08/04/1997 -->
<!--  Mise a jour 19/07/1997 -->
<!--  Mise a jour 18/07/2003 -->
<!--  Mise a jour 30/07/2003 LDP-1.58 -->
<br/><h1>MLOCK</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">notes</a>
<br /><a class="summaryIndent0" href="#L4">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L5">erreurs</a>
<br /><a class="summaryIndent0" href="#L6">conformit </a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
mlock - Dsactiver la pagination pour certaines parties de la mmoire.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/mman.h&gt;</b> <b></b>  <br/><br/>

\fBint mlock(const void *<i>addr</i>, size_t <i>len</i>);


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>mlock</b> <b></b>  dsactive la pagination pour la portion de mmoire dbutant  l'adresse
<i>addr</i> avec une longueur de
<i>len</i> octets.  Quand l'appel systme
<b>mlock</b> <b></b>  russit, on a l'assurance que toutes les pages contenant une partie 
de la zone mmoire spcifie rsident en mmoire vive (RAM) et y
resteront jusqu' un dverrouillage par la fonction
<b>munlock</b> <b></b>  ou
<b>munlockall</b> <b></b> ,<b></b>  jusqu' ce que les pages soit libres avec
<b>munmap ,</b>
ou encore jusqu' ce que le processus se termine ou dmarre un programme avec
<b>exec.</b>
Les processus fils n'hritent pas du verrouillage des pages  travers un
<b>fork.<br/><br/></b>
Il y a deux domaines principaux d'applications au verrouillage de pages&nbsp;:
les algorithmes en temps rel, et le traitement de donnes confidentielles.
Les applications temps rel rclament un comportement temporel dterministe, et
la pagination est, avec l'ordonnancement, une cause majeure de dlais imprvus.
Ces algorithmes basculent habituellement sur un ordonnancement temps rel avec
<b>sched_setscheduler.</b>
Les logiciels de cryptographie manipulent souvent quelques octets hautement
confidentiels, comme des mots de passe ou des cls prives. A cause de la
pagination ces donnes secrtes risquent d'tre transfres sur un support
physique o elles pourraient tre lues par un ennemi longtemps aprs que le
logiciel se soit termin. (Soyez toutefois conscient que le mode suspendu
sur les portables et certains ordinateurs de bureau sauvegarde une copie
de la mmoire sur le disque, quelques soient les verrouillages).<br/><br/>
Il n'y a pas d'empilement des verrouillages mmoire, ce qui signifie qu'une
page verrouille plusieurs fois par
<b>mlock</b> <b></b>  ou
<b>mlockall</b> <b></b>  sera libre en un seul appel 
<b>munlock</b> <b></b>  pour la zone mmoire correspondante ou par un appel 
<b>munlockall.</b>
Les pages qui sont verrouilles par plusieurs zones, ou par plusieurs processus
restent verrouilles en mmoire vive tant qu'il y a au moins un processus ou une
zone qui les verrouille.<br/><br/>
Sur les systmes POSIX o
<b>mlock</b> <b></b>  et
<b>munlock</b> <b></b>  sont disponibles, la constante symbolique
<b>_POSIX_MEMLOCK_RANGE</b> <b></b>  est dfinie dans &lt;unistd.h&gt; et la valeur symbolique
<b>PAGESIZE</b> <b></b>  de &lt;limits.h&gt; indique le nombre d'octets par page.
</div><br/><br /><h1 class="TitreSection0" id="L4">notes</h1>
<div class="paragraph">
Dans l'appel-systme de Linux,
<i>addr</i> est automatiquement arrondie  la frontire de page la plus proche.
Toutefois, POSIX 1003.1-2001 permet  l'implmentation d'imposer que
<i>addr</i> soit aligne sur une frontire de page. Les programmes portable en prendront soin.
</div><br/><br /><h1 class="TitreSection0" id="L5">valeur renvoye</h1>
<div class="paragraph">
L'appel
<b>mlock</b> <b></b>  renvoie 0 si il russit, ou -1 s'il choue, auquel cas
<i>errno</i> contient le code d'erreur, et rien n'est modifi sur les verrouillages
de la mmoire du processus.
</div><br/><br /><h1 class="TitreSection0" id="L6">erreurs</h1>
<div class="paragraph">
<br/><br/>
 
<b>ENOMEM</b> <b></b>  Une partie des adresses incluses dans la zone dsire ne correspond
pas  une page de l'espace d'adressage accessible, ou le processus
a essay de dpasser le nombre maximal de pages verrouilles.
<br/><br/>

<b>EPERM</b> <b></b>  L'appelant n'a pas les privilges appropris, seul le Super-User 
peut verrouiller des pages.
<br/><br/>

<b>EINVAL</b> <b></b>  <i>len</i> n'est pas un nombre positif.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit </h1>
<div class="paragraph">
POSIX.1b, SVr4. SVr4 documente un code d'erreur EAGAIN supplmentaire.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>munlock (2),</b>
<b>mlockall (2), </b>
<b>munlockall (2).</b>
<b>munmap (2),</b>
<b>setrlimit (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
