<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  1995-11-26  Markus Kuhn &lt;mskuhn@cip.informatik.uni-erlangen.de&gt; -->
<!--       First version written -->
<!--  -->
<!--  Traduction  11/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise a jour 8/04/97 -->
<!--  Mise a jour 30/05/2001 - LDP-man-pages-1.36 -->
<!--  Mise a jour 18/07/2003 - LDP-man-pages-1.56 -->
<br/><h1>MLOCKALL</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
mlockall - Dsactiver la pagination pour le processus appelant.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/mman.h&gt;</b> <b></b>  <br/><br/>

\fBint mlockall(int <i>flags</i>);


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>mlockall</b> <b></b>  dsactive la pagination pour toutes les pages prsentes dans l'espace d'adressage
du processus appelant. Ceci inclut les pages de code, de donnes, et la pile,
tout autant que les bibliothques partages, les donnes utilisateur dans le
noyau, la mmoire partage et les fichiers projets en mmoire. Quand l'appel
<b>mlockall</b> <b></b>  russit, on a l'assurance que toutes les pages concernes rsident en mmoire
vive (RAM) et y resteront jusqu' un dverrouillage par la fonction
<b>munlock</b> <b></b>  ou
<b>munlockall</b> <b></b>  ou encore jusqu' ce que le processus se termine ou dmarre
un programme avec
<b>exec .</b>
Les processus fils n'hritent pas du verrouillage des pages
 travers un
<b>fork .<br/><br/></b>
Il y a deux domaines principaux d'applications au verrouillage de pages&nbsp;:
les algorithmes en temps rel, et le traitement de donnes confidentielles.
Les applications temps rel rclament un comportement temporel
dterministe, et la pagination est, avec l'ordonnancement, une
cause majeure de dlais imprvus.
Ces algorithmes basculent habituellement sur un ordonnancement temps rel avec
<b>sched_setscheduler.</b>
Les logiciels de cryptographie manipulent souvent quelques
octets hautement confidentiels, comme des mots de passe ou
des cls prives. A cause de la pagination ces donnes secrtes
risquent d'tre transfres sur un support physique o elles
pourraient tre lues par un ennemi longtemps aprs que le
logiciel se soit termin.
Nanmoins pour les applications scurises, seule une petite
partie de la mmoire doit tre verrouille, pour laquelle la
fonction
<b>mlock</b> <b></b>  est parfaitement approprie.<br/><br/>
Le paramtre
<i>flags</i> est constitu par un
<i>OU binaire</i> ( | ) entre les constantes symboliques suivantes :
<br/><br/>
 1.2i
<b>MCL_CURRENT</b> <b></b>  Verrouiller toutes les pages correspondant actuellement  l'espace
d'adressage du processus.
<br/><br/>

<b>MCL_FUTUR</b> <b></b>  Verrouiller toutes les pages qui seront dans l'espace d'adressage
du processus dans le futur. Ceci concerne par exemple les nouvelles
pages rclames par un agrandissement de la pile ou du tas, autant
que les nouveaux fichier projets en mmoire, ou les nouvelles
rgions de mmoire partage.<br/><br/>
Si
<b>MCL_FUTUR</b> <b></b>  a t rclam, et que le nombre de pages verrouilles
excde la limite maximale, l'appel systme ayant entran le
dpassement chouera avec une erreur
<b>ENOMEM.</b>
Si le problme se pose  cause de l'expansion de la pile, le noyau
empchera l'agrandissement de celle-ci et dclenchera un signal
<b>SIGSEGV.<br/><br/></b>
Les processus temps-rel doivent rserver suffisamment de pages
avant d'entrer dans des portions critiques, pour viter tout
dclenchement de faute de page.
Ceci peut tre effectu simplement en appelant une fonction
rclamant une variable automatique suffisamment grande, et qui
crit dans cette variable de manire  allouer ces pages pour
la pile.
L'criture dans la variable garantit qu'il ne se produira mme pas
de faute de page de copie-sur-criture durant l'excution de la 
section critique.<br/><br/>
Il n'y a pas d'empilement des verrouillages mmoire, ce qui
signifie qu'une page verrouille plusieurs fois par
<b>mlock</b> <b></b>  ou
<b>mlockall</b> <b></b>  sera libre en un seul appel 
<b>munlock</b> <b></b>  pour la zone mmoire correspondante ou par un appel 
<b>munlockall.</b>
Les pages qui sont verrouilles par plusieurs zones, ou
par plusieurs processus restent en mmoire vive tant qu'il
y a au moins un processus ou une zone qui les verrouille.<br/><br/>
Sur les systmes POSIX o
<b>mlockall</b> <b></b>  et
<b>munlockall</b> <b></b>  sont disponibles, la constante symbolique
<b>_POSIX_MEMLOCK</b> <b></b>  est dfinie dans &lt;unistd.h&gt;
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>mlockall</b> <b></b>  renvoie 0 si il russit, ou -1 s'il choue, auquel cas
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>
 
<b>ENOMEM</b> <b></b>  Le processus a dpass le nombre maximal de page verrouilles.
<br/><br/>

<b>EPERM</b> <b></b>  L'appelant n'a pas les privilges appropris, seul le Super-User 
peut verrouiller des pages.
<br/><br/>

<b>EINVAL</b> <b></b>  Un attribut inconnu a t spcifi.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
POSIX.1b, SVr4. SVr4 documente un code d'erreur EAGAIN supplmentaire.
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>munlockall(2) ,</b>
<b>mlock(2) , </b>
<b>munlock(2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
