<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  -*- nroff -*-  -->
<!--  -->
<!--  Copyright (C) 1995 Michael Shields &lt;shields@tembel.org&gt;. -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and author of this work. -->
<!--  -->
<!--  Traduction  12/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise a Jour 3/06/97 -->
<!--  Mise a Jour 18/07/03 LDP-1.56 -->
<br/><h1>MPROTECT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">exemple d'utilisation</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
mprotect - Contrler les autorisations d'accs  une partie de la mmoire.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/mman.h&gt;</b> <b></b>  <br/><br/>

\fBint mprotect(const void *<i>addr</i>, size_t *<i>len</i>, int <i>prot</i>);


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>mprotect</b> <b></b>  contrle la manire d'accder  une portion de la mmoire. Si un
accs interdit se produit, le programme reoit un signal
<b>SIGSEGV.<br/><br/></b>
<i>prot</i> est un OU binaire ( | ) entre les valeurs suivantes&nbsp;:
<br/><br/>
 1.1i
<b>PROT_NONE</b> <b></b>  On ne peut pas accder du tout  la zone de mmoire.
<br/><br/>

<b>PROT_READ</b> <b></b>  On peut lire la zone de mmoire.
<br/><br/>

<b>PROT_WRITE</b> <b></b>  On peut crire dans la zone de mmoire.
<br/><br/>

<b>PROT_EXEC</b> <b></b>  La zone de mmoire peut contenir du code excutable.<br/><br/>
La nouvelle protection remplace toute autre protection prcdente.
Par exemple, si la mmoire a t marque prcdemment <b>PROT_READ</b>, 
et si l'on appelle <b>mprotect</b> avec <b>PROT_WRITE</b>, la zone
concerne ne sera plus lisible.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>mprotect</b> <b></b>  renvoie 0 si il russit, ou -1 s'il choue, auquel cas
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>
 
<b>EINVAL</b> <b></b>  <i>addr</i> n'est pas un pointeur valide, ou ce n'est pas un multiple de
PAGESIZE.
<br/><br/>

<b>EFAULT</b> <b></b>  La mmoire n'est pas accessible.
<br/><br/>

<b>EACCES</b> <b></b>  L'accs spcifi n'est pas possible sur ce type de mmoire. Ceci
se produit par exemple si vous utilisez
<b>mmap (2)</b>
pour reprsenter un fichier en lecture-seule en mmoire, et
si vous demandez de marquer cette zone avec
<b>PROT_WRITE.</b>
<br/><br/>

<b>ENOMEM</b> <b></b>  Pas assez de mmoire pour le noyau
</div><br/><br /><h1 class="TitreSection0" id="L6">exemple d'utilisation</h1>
<div class="paragraph">

#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;errno.h&gt;
#include &lt;sys/mman.h&gt;<br/><br/>
#include &lt;limits.h&gt; /* pour avoir PAGESIZE */
#ifndef PAGESIZE
  #define PAGESIZE 4096
#endif<br/><br/>
int
main(void)
{
    char *p;
    char c;<br/><br/>
    /* Allocation d'un buffer, protection 
       par dfaut PROT_READ|PROT_WRITE. */
    p = malloc(1024 + PAGESIZE - 1);
    if (!p) {
        perror("Impossible d'allouer suffisamment de mmoire");
        exit(errno);
    }<br/><br/>
    /* 
     * Aligner p sur un multiple de PAGESIZE (que l'on suppose tre
     * une puissance de 2)
     */
    p = (char *) (((int) p + PAGESIZE-1) & ~(PAGESIZE-1));<br/><br/>
    c = p[666];         /* lecture ok */
    p[666] = 42;        /* ecriture ok */<br/><br/>
    /* Buffer marqu en lecture-seule */
    if (mprotect(p, 1024, PROT_READ)) {
        perror("Impossible d'utiliser mprotect");
        exit(errno);
    }<br/><br/>
    c = p[666];         /* lecture ok */
    p[666] = 42;        /* criture, fin du programme avec SIGSEGV */<br/><br/>
    exit(0);
}


</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SVr4, POSIX.1b (anciennement POSIX.4).  SVr4 dfinit un code d'erreur
EAGAIN supplmentaire. Les conditions d'erreur SVr4 ne correspondent pas
tout  fait  celles de Linux.
POSIX.1B prcise que
<b>mprotect</b> <b></b>  ne peut tre utilis que sur des zones de mmoire obtenues avec
<b>mmap (2).</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>mmap (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
