<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 Giorgio Ciucci (giorgio@crcc.it) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction 14/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a Jour 8/04/97 -->
<!--  Mise a Jour 30/05/2001 LDP-man-page-1.36 -->
<!--  Mise a Jour 18/07/2003 LDP-man-page-1.56 -->
<br/><h1>MSGCTL</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
msgctl - Contrler les messages.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

.B
#include &lt;sys/types.h&gt;
.B
#include &lt;sys/ipc.h&gt;
.B
#include &lt;sys/msg.h&gt;


<br/><br/>

<b>int msgctl ( int </b> msqid ,
<b>int  </b> cmd ,
<b>struct msqid_ds *</b> buf  );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette fonction permet d'effectuer l'opration 
indique par
<i>cmd</i> sur la file de messages ayant l'identificateur
<i>msqid.</i>
Les valeurs possibles de
<i>cmd</i> sont&nbsp;:
<br/><br/>

<b>IPC_STAT</b> <b></b>  Copier les informations depuis la structure reprsentant
la file de messages dans la structure pointe par
<i>buf .</i>
L'appelant doit avoir des privilges d'accs en lecture sur
la file de messages.
<br/><br/>

<b>IPC_SET</b> <b></b>  crire la valeurs de certains champs de la structure
<b>msqid_ds</b> <b></b>  pointe par
<i>buf</i> dans la structure reprsentant la file de messages, 
en mettant  jour le champ
<b>msg_ctime .</b>
Les champs suivant de la structure peuvent tre mis  jour&nbsp;:

<br/><br/>

.ft B
	msg_perm.uid
	msg_perm.gid
	msg_perm.mode \fR/* 9 bits poids faibles */\fP
	msg_qbytes


.ft R
<br/><br/>

L'UID effectif du processus appelant doit tre soit 
celui du Super-User
soit celui du crateur ou du propritaire 
de la file de messages.
Seul le Super-User peut augmenter la valeur de
<b>msg_qbytes</b> <b></b>  au-dessus de la constante systme
<b>MSGMNB.</b>
<br/><br/>

<b>IPC_RMID</b> <b></b>  Effacer immdiatement la file de messages et ses structures
de donnes, en rveillant tous les processus crivains et
lecteurs en attente. Ils obtiendront un code d'erreur, et
<b>errno</b> <b></b>  aura la valeur
<b>EIDRM.</b>
L'UID effectif du processus appelant doit tre soit celui 
du Super-User
soit celui du crateur ou du propritaire de la file de messages.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>msgctl</b>
renvoie 0 s'il russit, ou -1 s'il choue, auquel
cas
<b>errno</b> <b></b>  contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EACCES</b> <b></b>  L'argument
<i>cmd</i> rclame l'opration
<b>IPC_STAT</b> <b></b>  mais le processus appelant n'a pas d'accs en lecture sur la
file de messages
<i>msqid.</i>
<br/><br/>

<b>EFAULT</b> <b></b>  L'argument
<i>cmd</i> rclame l'opration
<b>IPC_SET</b> <b></b>  ou
<b>IPC_STAT</b> <b></b>  mais
<i>buf</i> pointe en dehors de l'espace d'adressage accessible.
<br/><br/>

<b>EIDRM</b> <b></b>  La file de messages a dj t supprime.
<br/><br/>

<b>EINVAL</b> <b></b>  <i>cmd</i> ou
<i>msqid </i>
ont une valeur illgale.
<br/><br/>

<b>EPERM</b> <b></b>  L'argument
<i>cmd</i> rclame l'opration
<b>IPC_SET</b> <b></b>  ou
<b>IPC_RMID</b> <b></b>  mais l'UID effectif du processus appelant n'a pas
assez de privilges pour raliser la commande.
C'est aussi le cas d'un processus non Super-User
tentant d'augmenter
<b>msg_qbytes</b> <b></b>  au-dessus de la valeur
<b>MSGMNB .</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Les appels
<b>IPC_INFO ,</b>
<b>MSG_STAT</b>
et
<b>MSG_INFO</b> <b></b>  sont utiliss par le programme
<b>ipcs (8)</b>
pour fournir des informations sur les ressources alloues
dans le futur, ceci peut tre modifi si besoin, ou remplac par
une interface avec le systme de fichiers proc.<br/><br/>
Divers champs de la structure <i>struct msqid_ds</i> taient des shorts sous
Linux 2.2 et sont devenus longs sous Linux 2.4. Pour en profiter, une
recompilation avec la GlibC 2.1.91 ou ultrieure devrait suffire.
(Le noyau distingue les appels anciens et nouveaux par un drapeau IPC_64 dans
<i>cmd ).</i>
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SVr4, SVID. SVID ne documente pas la condition d'erreur EIDRM.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>ipc (5),</b>
<b>msgget (2),</b>
<b>msgsnd (2),</b>
<b>msgrcv (2).</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
