<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 Giorgio Ciucci (giorgio@crcc.it) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction 14/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a Jour 8/04/97 -->
<!--  Mise a Jour 18/07/2003 LDP-1.56 -->
<br/><h1>MSGGET</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">bogues</a>
<br /><a class="summaryIndent0" href="#L7">conformit</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
msgget - Obtenir un identificateur de file de messages.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

.B
#include &lt;sys/types.h&gt;
.B
#include &lt;sys/ipc.h&gt;
.B
#include &lt;sys/msg.h&gt;


<br/><br/>

<b>int msgget ( key_t </b> key ,
<b>int </b>msgflg <i> );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette fonction renvoie l'identificateur de la file de
messages associe  la cl
<i>key.</i> Une nouvelle file de messages est cre si
<i>key</i> a la valeur
<b>IPC_PRIVATE</b> <b></b>  ou si
aucune file de message n'est associe 
<i>key ,</i>
et si la valeur
<b>IPC_CREAT</b> <b></b>  a t introduite dans
<i>msgflg</i> (c'est  dire
msgflg & IPC_CREAT
non nul).
La prsence des champs
<b>IPC_CREAT</b> <b></b>  et
<b>IPC_EXCL</b> <b></b>  dans
<i>msgflg</i> joue le mme rle, par rapport  l'existence de
la file de messages, que la prsence des champs
<b>O_CREAT</b> <b></b>  et
<b>O_EXCL</b> <b></b>  dans l'argument
<i>mode</i> de l'appel systme
<b>open </b>(2) :<b></b>
La fonction
<b>msgget</b> <b></b>  chouera si
<i>msgflg</i> indique  la fois
<b>IPC_CREAT</b> <b></b>  et
<b>IPC_EXCL</b> <b></b>  et si une file de messages existe dj associe 
<i>key.<br/><br/></i>
Lors de la cration, les 9 bits de poids faibles de l'argument
<i>msgflg</i> dfinissent les permissions d'accs  la file de message
(pour le propritaire, le groupe, et les autres) avec le
mme format et la mme signification que les permissions
d'accs dans les appels
<b>open (2)</b>
ou
<b>creat (2)</b>
(bien que la permission d'excution ne soit pas utilise).<br/><br/>
Pendant la cration, l'appel systme initialise la structure
systme 
<b>msqid_ds</b> <b></b>  de la file de messages comme suit :
.IP
<b>msg_perm.cuid</b> <b></b>  et
<b>msg_perm.uid</b> <b></b>  sont remplis avec l'UID effectif du processus appelant.
.IP
<b>msg_perm.cgid</b> <b></b>  et
<b>msg_perm.gid</b> <b></b>  sont remplis avec le GID effectif du processus appelant.
.IP
Les 9 bits de poids faibles de
<i>msgflg</i>
sont copis dans les 9 bits de poids faibles de
<b>msg_perm.mode .</b>
.IP
<b>msg_qnum ,</b>
<b>msg_lspid ,</b>
<b>msg_lrpid ,</b>
<b>msg_stime</b>
et
<b>msg_rtime</b> <b></b>  sont fixs  0.
.IP
<b>msg_ctime</b> <b></b>  est rempli avec l'heure actuelle.
.IP
<b>msg_qbytes</b> <b></b>  est rempli avec la limite systme
<b>MSGMNB .<br/><br/></b>
Si la file de message existe dj, les permissions d'accs sont
contrles, et une vrification est faite pour voir si la file
est prte  tre dtruite.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>msgget</b>
renvoie l'identificateur de la file de messages (un entier positif), 
s'il russit.
En cas d'chec -1 est renvoy et
<b>errno</b> <b></b>  contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>
 11
<b>EACCES</b> <b></b>  Une file de messages existe associe  la cl
<i>key ,</i>
mais le processus appelant n'a pas de permissions sur cette
file.
<br/><br/>

<b>EEXIST</b> <b></b>  Une file de messages existe associe  la cl
<b>key</b> <b></b>  et
<i>msgflg</i> rclame  la fois
<b>IPC_CREAT</b> <b></b>  et
<b>IPC_EXCL .</b>
<br/><br/>

<b>ENOENT</b> <b></b>  Aucune file de messages n'existe associe  la cl
<i>key</i> et
<i>msgflg</i> ne contient pas
<b>IPC_CREAT .</b>
<br/><br/>

<b>ENOMEM</b> <b></b>  Pas assez de mmoire pour les nouvelles structures de donnes.
<br/><br/>

<b>ENOSPC</b> <b></b>  Le nombre maximum de files de messages sur le systme
( MSGMNI )</b>
est atteint.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
<b>IPC_PRIVATE</b> <b></b>  n'est pas destin au champ
<i>msgflg</i> mais est du type
<b>key_t.</b> <b></b>  Si cette valeur spciale est fournie  la place de
<i>key ,</i>
l'appel systme ignorera tout sauf les 9 bits de poids faibles de
<i>msgflg</i> et crera une nouvelle file de messages.<br/><br/>
La limite systme concernant les files de messages et affectant
<b>msgget</b> <b></b>  est
<br/><br/>
 11
<b>MSGMNI</b> <b></b>  Nombre maximum de files de messages sur le systme.
</div><br/><br /><h1 class="TitreSection0" id="L7">bogues</h1>
<div class="paragraph">
L'utilisation de
<b>IPC_PRIVATE</b> <b></b>  n'empche pas les autres processus d'avoir accs  la file
de messages alloue. Le nom IPC_PRIVATE a t mal choisi, ICP_NEW aurait t mieux.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">conformit</h1>
<div class="paragraph">
SVr4, SVID.  SVr4 ne documente pas le code d'erreur EIDRM.
Jusqu' la version 2.3.20, Linux renvoyait EIDRM pour un
<b>msgget</b> <b></b>  sur une file de messages prte  tre supprime.
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>ftok (3),</b>
<b>ipc (5),</b>
<b>msgctl (2),</b>
<b>msgsnd (2),</b>
<b>msgrcv (2) </b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
