<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright (C) Markus Kuhn, 1996 -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  The GNU General Public License's references to "object code" -->
<!--  and "executables" are to be interpreted as the output of any -->
<!--  document formatting or typesetting system, including -->
<!--  intermediate and printed output. -->
<!--  -->
<!--  This manual is distributed in the hope that it will be useful, -->
<!--  but WITHOUT ANY WARRANTY; without even the implied warranty of -->
<!--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the -->
<!--  GNU General Public License for more details. -->
<!--  -->
<!--  You should have received a copy of the GNU General Public -->
<!--  License along with this manual; if not, write to the Free -->
<!--  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, -->
<!--  USA. -->
<!--  -->
<!--  1996-04-10  Markus Kuhn &lt;mskuhn@cip.informatik.uni-erlangen.de&gt; -->
<!--              First version written -->
<!--  -->
<!--  Traduction 14/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a Jour 8/04/97 -->
<!--  Mise a Jour 18/07/2003 -->
<br/><h1>NANOSLEEP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">erreurs</a>
<br /><a class="summaryIndent0" href="#L4">bogues</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
nanosleep - Arrter l'excution pendant une dure donne.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;time.h&gt;</b> <b></b>  <br/><br/>

\fBint nanosleep(const struct timespec *<i>req</i>, struct timespec *<i>rem</i>);


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>nanosleep</b> <b></b>  suspend l'excution du programme en cours pour une dure valant
au moins
<i>*req .</i>
Cette fonction peut se terminer plus tt que prvu si un signal a
t reu par le processus. Dans ce cas, elle renvoie -1, 
positionne <i>errno</i>  la valeur
<b>EINTR ,</b>
et inscrit le temps restant dans la structure pointe par
<i>rem</i>
a moins que
<i>rem</i> soit
<b>NULL .</b>
La valeur de
<i>*rem</i> peut tre utilise pour rappeler  nouveau
<b>nanosleep</b> <b></b>  afin de terminer la pause.<br/><br/>
La structure
<i>timespec</i> est utilise pour indiquer l'intervalle de temps en nano-secondes.
Elle est dfinie dans 
<i>&lt;time.h&gt;</i> et a la forme suivante
<br/><br/>

.RS

.ne 12
.ta 8n 16n 32n
struct timespec
{
	time_t	tv_sec;			/* secondes */
	long	tv_nsec;		/* nano-secondes */
};
.ta


<br/><br/>
La valeur du champ nano-seconde doit tre dans l'intervalle 0  999 999 999.<br/><br/>
Par rapport 
<b>sleep  (3)</b>
et
<b>usleep (3),</b>
<b>nanosleep</b> <b></b>  a l'avantage de n'affecter aucun signal, d'tre au standard POSIX,
de fournir une meilleure rsolution, et de permettre de continuer facilement
un sommeil interrompu par un signal.
</div><br/><br /><h1 class="TitreSection0" id="L4">erreurs</h1>
<div class="paragraph">
En cas d'erreur ou d'interruption, l'appel systme
<b>nanosleep</b> <b></b>  renvoie -1 et place dans
<i>errno</i> une des valeurs suivantes :
<br/><br/>

<b>EINTR</b> <b></b>  La pause a t interrompue par un signal non-bloqu dlivr au
processus. Le temps restant de sommeil a t inscrit dans 
*<i>rem</i> pour que le processus puisse terminer facilement son
sommeil.
<br/><br/>

<b>EINVAL</b> <b></b>  La valeur du champ
<i>tv_nsec</i> n'est pas dans l'intervalle 0  999&nbsp;999&nbsp;999 ou
<i>tv_sec</i> est ngatif.
</div><br/><br /><h1 class="TitreSection0" id="L5">bogues</h1>
<div class="paragraph">
L'implmentation actuelle de
<b>nanosleep</b> <b></b>  est construite sur le mcanisme de temporisation du noyau, qui
dispose d'une rsolution valant 1/<i>HZ</i>&nbsp;s 
(10&nbsp;ms sur Linux/i386 et 1&nbsp;ms sur Linux/Alpha).
Ainsi,
<b>nanosleep</b> <b></b>  dormira toujours pour une dure au moins gale au temps spcifi, 
mais il peut prendre jusqu' 10 ms de plus (i386) avant de faire
redmarrer le processus.
Pour la mme raison, la valeur retourne dans *<i>rem</i> en cas 
d'interruption par un signal est arrondie au multiple suprieur
de 1/<i>HZ</i>&nbsp;s.<br/><br/>
Certaines applications ncessitant des pauses plus prcises
(par exemple pour le contrle de priphriques matriels
avec un dlai critique),
<b>nanosleep</b> <b></b>  peut aussi offrir des pauses avec une prcision plus leve.
Si le processus est mis sous le contrle d'un ordonnanceur
temps rel comme
<i>SCHED_FIFO</i> ou
<i>SCHED_RR ,</i>
les pauses jusqu' 2&nbsp;ms seront effectues avec des boucles actives
d'une prcision de l'ordre de la micro-seconde.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
POSIX.1b (anciennement POSIX.4).
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>sleep (3),</b>
<b>usleep (3),</b>
<b>sched_setscheduler (2),</b>
<b>timer_create (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
