<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--    MJ 18/07/2003 LD-1.56 -->
<br/><h1>PIVOT_ROOT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">notes</a>
<br /><a class="summaryIndent0" href="#L4">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L5">erreurs</a>
<br /><a class="summaryIndent0" href="#L6">bogues</a>
<br /><a class="summaryIndent0" href="#L7">conformit</a>
<br /><a class="summaryIndent0" href="#L8">historique</a>
<br /><a class="summaryIndent0" href="#L9">voir aussi</a>
<br /><a class="summaryIndent0" href="#L10">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
pivot_root - Modifier la racine du systme de fichiers.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;linux/unistd.h&gt;</b> <b></b>  <br/><br/>

<b>_syscall2(int</b> <b></b> ,<b>pivot_root</b> <b></b> ,<b>const</b> <b></b>  <b>char</b> <b></b>  <b>*</b> <b></b> ,<b>new_root</b> <b></b> ,<b>const</b> <b></b>  <b>char</b> <b></b>  <b>*</b> <b></b> ,<b>put_old)</b> <b></b>  <br/><br/>

<b>int pivot_root(const char *</b> new_root <i>, const char *</i> put_old );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>pivot_root</b> dplace la racine du systme de fichiers pour le processus courant
vers le rpertoire <i>put_old</i> et fait de <i>new_root</i> la nouvelle racine du
systme de fichiers pour le processus en cours.<br/><br/>
L'utilisation typique de \fbpivot_root\fP est durant le boot, lorsque le systme
monte un systme de fichiers temporaire (par ex. un <b>initrd</b>) puis monte
le vritable systme de fichier, et le transforme en racine pour tous les
processus et threads concerns.<br/><br/>
<b>pivot_root</b> peut changer ou non le rpertoire de travail en cours
de tous les processus et threads qui utilisaient l'ancien rpertoire racine.
L'appelant de <b>pivot_root</b> doit s'assurer que les processus ayant pour
racine ou rpertoire de travail l'ancien rpertoire se comportent correctement.
Le meilleur moyen est de modifier leur rpertoire de travail et rpertoire
racine avant d'invoquer <b>pivot_root</b>.<br/><br/>
Le paragraphe ci-dessus est intentionellement flou, car l'implmentation
de <b>pivot_root</b> peut changer dans le futur. Actuellement,
<b>pivot_root</b> modifie la racine et le rpertoire de travail de tous les
processus ou threads en <i>new_root</i> s'ils pointent sur l'ancien rpertoire.
Ceci est ncessaire pour viter que des threads du noyau ne conservent
l'ancien rpertoire occup, mme s'ils accdent au nouveau systme de fichiers.
Dans le futur, il y aura peut-tre un mcanisme pour les threads du noyau
pour renoncer explicitement  tout accs au systme de fichiers, ce qui
vitera ce mcanisme un peu invasif.<br/><br/>
Notez que ceci s'applique aussi au processus en cours&nbsp;: <b>pivot_root</b>
peut changer ou non son rpertoire de travail. Il vaut mieux donc appeler
<b>chdir("/")</b> immdiatement aprs <b>pivot_root</b>.<br/><br/>
Les restrictions suivantes s'appliquent <i>new_root</i> et <i>put_old</i>&nbsp;:
</div><div class="paragraph">-<br/>
Ils doivent tre des rpertoires,
</div><div class="paragraph">-<br/>
<i>new_root</i> et <i>put_old</i> ne doivent pas tre sur le mme systme de
fichiers que la racine actuelle.
</div><div class="paragraph">-<br/>
<i>put_old</i> doit tre un descendant de <i>new_root</i>&nbsp;: ajouter un nombre
non-nul de <b>/..</b>  la chane <i>put_old</i> doit ramener au mme
rpertoire que <i>new_root</i>.
</div><div class="paragraph">-<br/>
Aucun systme de fichiers ne doit tre mont sur <i>put_old</i>.<br/><br/>
Voir <b>pivot_root(8)</b> pour des exemples d'utilisation supplmentaires.<br/><br/>
Si la racine en cours n'est pas un point de montage (aprs un <b>chroot(2)</b>
ou un <b>pivot_root</b>, voir plus bas), ce n'est pas l'ancien rpertoire,
mais le point de montage du systme de fichiers qui est mont dans <i>put_old</i>.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">notes</h1>
<div class="paragraph">
<i>new_root</i> n'a pas besoin d'tre un point de montage. Dans ce cas,
<b>/proc/mounts</b> montrera le point de montage concernant
<i>new_root</i> comme racine (<b>/</b>).
</div><br/><br /><h1 class="TitreSection0" id="L5">valeur renvoye</h1>
<div class="paragraph">
S'il russit, l'appel renvoie zro. Sinon il renvoie -1 et rempli
<i>errno</i>.
</div><br/><br /><h1 class="TitreSection0" id="L6">erreurs</h1>
<div class="paragraph">
<b>pivot_root</b> peut renvoyer  (dans <i>errno</i>) toute erreur renvoye par
<b>stat(2)</b>. De plus, il peut renvoyer&nbsp;:<br/><br/>
<br/><br/>

<b>EBUSY</b> <b></b>  <i>new_root</i> ou <i>put_old</i> sont sur le systme de fichier principal actuel,
ou un systme de fichiers est dj mont sur <i>put_old</i>.
<br/><br/>

<b>EINVAL</b> <b></b>  <i>put_old</i> n'est pas un descendant de <i>new_root</i>.
<br/><br/>

<b>ENOTDIR</b> <b></b>  <i>new_root</i> ou <i>put_old</i> n'est pas un rpertoire.
<br/><br/>

<b>EPERM</b> <b></b>  Le processus appelant n'a pas les capacits d'administration.
</div><br/><br /><h1 class="TitreSection0" id="L7">bogues</h1>
<div class="paragraph">
<b>pivot_root</b> ne devrait pas modifier le rpertoire racine et le rpertoire
de travail des autres processus du systme.<br/><br/>
Les utilisations les plus obscures de <b>pivot_root</b> peuvent rapidement
rendre fou.
</div><br/><br /><h1 class="TitreSection0" id="L8">conformit</h1>
<div class="paragraph">
<b>pivot_root</b> est spcifique  Linux et donc non portable.
</div><br/><br /><h1 class="TitreSection0" id="L9">historique</h1>
<div class="paragraph">
<b>pivot_root</b> a t introduit dans Linux 2.3.41.
</div><br/><br /><h1 class="TitreSection0" id="L10">voir aussi</h1>
<div class="paragraph">
<b>chdir (2),</b>
<b>chroot (2),</b>
<b>initrd (4),</b>
<b>pivot_root (8),</b>
<b>stat (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L11">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
