<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright (C) 1997 Andries Brouwer (aeb@cwi.nl) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction 21/07/1997 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  mj 10/12/1997 (LDP man-pages 1.18) -->
<!--  mj 18/07/2003 (LDP man-pages 1.56) -->
<!--  MJ 25/07/2003 LDP-1.57 -->
<!--  MJ 30/07/2003 LDP-1.58 -->
<br/><h1>POLL</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
poll - Attendre un vnement concernant un descripteur de fichier.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;linux/asm/poll.h&gt;</b> <b></b>  <br/><br/>

<b>int poll(struct pollfd *</b> ufds <i>, unsigned int </i> nfds <b>, int </b> dlai );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>poll</b> <b></b>  est une variation sur le thme de
<b>select (2).</b>
Il utilise une table de
<i>nfds</i> structures du type
<br/>

        struct pollfd {
                int fd;         /* Descripteur de fichier */
                short events;   /* vnements attendus	  */
                short revents;  /* vnements dtects    */
        };


et un
<i>dlai</i> en millisecondes. Une valeur ngative indique un dlai infini.
Le champ
<i>fd</i> contient un descripteur de fichier ouvert.
Le champ
<i>events</i> est un paramtre d'entre, un masque de bits indiquant les vnements
qui intressent l'application.
Le champ
<i>revents</i> est un paramtre de sortie, rempli par le noyau avec les vnements qui
se sont effectivement produits, du type demand, ou de l'une des valeurs
<b>POLLERR ,</b>
<b>POLLHUP</b>
ou
<b>POLLNVAL .</b>
(Ces trois bits n'ont pas de signification dans la demande
<i>events ,</i>
et se trouvent positionns dans la valeur de retour
<i>revents</i> si l'une des conditions correspondantes se produit).<br/><br/>
Si aucun vnement attendu (ni aucune erreur) ne s'est dj produit, le noyau
attend leur occurrence pendant
<i>timeout</i> millisecondes.
Les bits possibles pour ces masques sont dfinis dans &lt;sys/poll.h&gt;&nbsp;:
<br/>

    #define POLLIN    0x0001  /* Donnes disponibles en lecture  */
    #define POLLPRI   0x0002  /* Donnes urgentes disponibles    */
    #define POLLOUT   0x0004  /* Une criture ne bloquera pas    */
    #define POLLERR   0x0008  /* Condition d'erreur              */
    #define POLLHUP   0x0010  /* Dconnexion                     */
    #define POLLNVAL  0x0020  /* Requte invalide, fd pas ouvert */


Pour un fichier source XPG4.2, on a aussi&nbsp;:
<br/>

#ifdef _XOPEN_SOURCE
    #define POLLRDNORM 0x0040 /* Donnes normales prtes  lire */
    #define POLLRDBAND 0x0080 /* Donnes prioritaires  lire    */
    #define POLLWRNORM 0x0100 /* criture normale possible      */
    #define POLLWRBAND 0x0200 /* criture prioritaire possible  */
#endif


De plus, Linux connait une constante
<br/>

#ifdef _GNU_SOURCE
    #define POLLMSG   0x0400
#endif


</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
S'il russit,
<b>poll</b> <b></b>  renvoie une valeur positive reprsentant le nombre de structures
ayant un champ
<i>revents</i> non-nul. C'est  dire le nombre de structures pour lesquels un vnement
attendu, ou une erreur, s'est produit.
Une valeur de retour nulle indique un dpassement du dlai d'attente.
S'il choue,
<b>poll</b> <b></b>  renvoie -1, et 
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EBADF</b> <b></b>  Un descripteur de fichier invalide est prsent dans un ensemble.
<br/><br/>

<b>ENOMEM</b> <b></b>  Pas assez de mmoire pour allouer la table des descripteurs de fichiers.
<br/><br/>

<b>EFAULT</b> <b></b>  La table fournie en argument n'est pas dans l'espace d'adressage du processus
appelant.
<br/><br/>

<b>EINTR</b> <b></b>  Un signal a t reu avant qu'un vnement intressant ne se produise.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
XPG4-UNIX
</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
L'appel systme <b>poll</b>() a t introduit dans la version 2.1.23
du noyau Linux. La fonction de bibliothque <b>poll</b>() est apparue
dans la version 5.4.28 de la libc, et fournit une mulation base sur
l'appel systme <b>select</b>() si le noyau n'a pas d'appel systme <b>poll</b>().
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>select (2)</b>
<b>select_tut (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
