<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright 2003 Abhijit Menon-Sen &lt;ams@wiw.org&gt; -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 18/07/2003 LDP-1.56 -->
<br/><h1>POSIX_FADVISE</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
posix_fadvise - Prdclarer des accs aux donnes d'un fichier.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;fcntl.h&gt;</b> <b></b>  <br/><br/>

<b>int posix_fadvise(int </b> fd <i>, off_t </i> offset <b>, size_t </b> len <i>, int </i> advice <b>);</b>


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les programmes peuvent utiliser <b>posix_fadvise</b> pour annoncer leur intention
d'accder aux donnes d'un fichier suivant un certain ordre, permettant ainsi au
noyau de raliser les optimisations appropries.<br/><br/>
L'indication
<i>advice</i> s'applique  une rgion (pas ncessairement existante) dbutant  <i>offset</i>
et s'tendant sur <i>len</i> octets (ou jusqu' la fin du fichier si <i>len</i>
vaut zro) dans le fichier rfrenc par <i>fd</i>.
L'indication n'oblige  rien, il s'agit seulement d'une supposition concernant
le comportement futur de l'application.<br/><br/>
Les valeurs possibles pour <i>advice</i> incluent&nbsp;:
<br/><br/>

<b>POSIX_FADV_NORMAL</b> <b></b>  Indique que l'application n'a pas d'indice particulier concernant les accs aux
donnes du fichier. Le noyau appliquera son comportement pa dfaut.
<br/><br/>

<b>POSIX_FADV_SEQUENTIAL</b> <b></b>  L'application pense accder aux donnes squentiellement (dans l'ordre de
offsets croissants).
<br/><br/>

<b>POSIX_FADV_RANDOM</b> <b></b>  Les accs se feront de manire alatoire.
<br/><br/>

<b>POSIX_FADV_NOREUSE</b> <b></b>  Les donnes ne seront accdes qu'une seule fois.
<br/><br/>

<b>POSIX_FADV_WILLNEED</b> <b></b>  Les donnes seront accdes dans le futur proche.
<br/><br/>

<b>POSIX_FADV_DONTNEED</b> <b></b>  Les donnes ne seront pas accdes dans le futur proche.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
L'appel renvoie zro s'il russit, ou -1 s'il choue auquel cas <i>errno</i>
contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EBADF</b> <b></b>  L'argument <i>fd</i> n'est pas un descripteur de fichier valide.
<br/><br/>

<b>EINVAL</b> <b></b>  L'indication <i>advice</i> est invalide.
<br/><br/>

<b>ESPIPE</b> <b></b>  Le descripteur correspond  un tube ou une FIFO. (Linux renvoie en fait
EINVAL dans ce cas).
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Sous Linux, <b>POSIX_FADV_NORMAL</b> configure la fentre de lecture anticipe 
sa taille par dfaut pour le priphrique concern. <b>POSIX_FADV_SEQUENTIAL</b>
double cette taille, et <b>POSIX_FADV_RANDOM</b> dsactive la lecture anticipe.
Ces modifications affectent le fichier entier, pas seulement la rgion indique
(mais les autres descripteurs ouverts sur le mme fichier ne sont pas modifis).<br/><br/>
<b>POSIX_FADV_WILLNEED</b> et <b>POSIX_FADV_NOREUSE</b> initialisent tous deux une
lecture non-bloquante de la rgion indique dans le cache. La quantit de donnes
lues peut tre diminue suivant la charge mmoire (quelques mga-octets seront
en gnral disponibles et souvent suffisants).<br/><br/>
<b>POSIX_FADV_DONTNEED</b> essaye de librer les pages de cache associes avec la
rgion indique. Ceci est utile par exemple lors du parcours de trs gros
fichiers. Un programme peut ainsi demander rgulirement au noyau de librer
les pages dj utilises, pour viter que des pages plus utiles ne soit
limines  leur place.<br/><br/>
Les pages qui n'ont pas encore t crites ne sont pas affectes, ainsi si une
application veut s'assurer que les pages seront relches, elle devrait
appeler <b>fsync</b> ou <b>fdatasync</b> d'abord.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SUSv3 (Advanced Realtime Option)
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>posix_fallocate (2),</b>
<b>posix_madvise (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
