<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  This manpage is Copyright (C) 1992 Drew Eckhardt; -->
<!--                                1993 Michael Haardt, Ian Jackson. -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Modified Sat Jul 24 00:06:00 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction  12/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise a Jour 08/04/97 -->
<!--  Mise a Jour 19/07/97 -->
<!--  Mise a Jour 20/01/02 - LDP-man-pages-1.47 -->
<!--  Mise a Jour 18/07/03 - LDP-man-pages-1.56 -->
<br/><h1>READ</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">restrictions</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
read - Lire le contenu d'un fichier.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <br/><br/>

<b>ssize_t read(int </b> fd <i>, void *</i> buf <b>, size_t </b> count );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>read</b> <b></b>  lit jusqu'
<i>count</i> octets depuis le descripteur de fichier
<i>fd</i> dans le buffer point par
<i>buf.<br/><br/></i> Si
<i>count</i> vaut zro, 
<b>read</b> <b></b>  renvoie zro et n'a pas d'autres effets.
Si
<i>count</i> est suprieur  SSIZE_MAX, le rsultat est indfini.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>read</b> <b></b>  renvoie -1 s'il choue, auquel cas
<i>errno</i> contient le code d'erreur, et la position de la tte
de lecture est indfinie.
Sinon, 
<b>read</b> <b></b>  renvoie le nombre d'octets lus (0 en fin de fichier), et avance la
tte de lecture de ce nombre. Le fait que le nombre renvoy soit
plus petit que le nombre demand n'est pas une erreur. Ceci se
produit  la fin du fichier, ou si on lit depuis un tube ou un
terminal, ou encore si
<b>read</b> <b></b>  a t interrompu par un signal.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>
 
<b>EINTR</b> <b></b>  <b>read</b> <b></b>  a t interrompu par un signal avant d'avoir eu le temps de lire quoi que ce soit.
<br/><br/>

<b>EAGAIN</b> <b></b>  <b></b>  On utilise une lecture non bloquante (attribut
<b>O_NONBLOCK</b> <b></b>  du descripteur de fichier) et aucune donne n'tait disponible.
<br/><br/>

<b>EIO</b> <b></b>  Erreur d'entre/sortie. Ceci arrive si un processus est dans un groupe
en arrire-plan et tente de lire depuis le terminal. Il reoit
un signal
SIGTTIN mais il l'ignore ou le bloque. Ceci se produit galement si une
erreur d'entre/sortie bas-niveau s'est produite pendant la lecture d'un
disque ou d'une bande.
<br/><br/>

<b>EISDIR</b> <b></b>  <i>fd</i> est un rpertoire.
<br/><br/>

<b>EBADF</b> <b></b>  <i>fd</i> n'est pas un descripteur valide, ou n'est pas ouvert en lecture.
<br/><br/>

<b>EINVAL</b> <b></b>  <i>fd</i> correspond  un objet ne permettant pas la lecture.
<br/><br/>

<b>EFAULT</b> <b></b>  <i>buf</i> pointe en dehors de l'espace d'adressage accessible.<br/><br/>
D'autres erreurs peuvent se produire, suivant le type d'objet associ  
<i>fd .</i>
POSIX permet  un 
<b>read</b> <b></b>  interrompu par un signal de renvoyer soit le nombre d'octets lus  ce point,
soit -1, et de placer 
<i>errno</i>  
<b>EINTR .</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
SVr4, SVID, AT&T, POSIX, X/OPEN, BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L7">restrictions</h1>
<div class="paragraph">
Sur un systme de fichiers NFS, la lecture de petites quantits de donnes
ne mettra  jour l'horodatage du fichier que lors de la premire lecture.
Les lectures suivantes ne modifieront pas cette heure. En effet la plupart,
si ce n'est tous les clients NFS disposent d'un cache des attributs de
fichiers et n'effectuent pas la mise  jour du champ 'atime' du ct serveur.
La vritable smantique UNIX peut tre obtenue en dsactivant le cache des
attributs du ct client, mais gnralement ceci augmente sensiblement
la charge du serveur, et dgrade ses performances.<br/><br/>
Beaucoup de disques et systmes de fichiers ont t considrs comme suffisamment
rapides pour que l'implmentation de
<b>O_NONBLOCK</b> <b></b>  soit juge inutile. Ainsi cet attribut peut ne pas tre disponibles sur
les fichiers et/ou les disques.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>close (2),</b>
<b>fcntl (2),</b>
<b>ioctl (2),</b>
<b>lseek (2),</b>
<b>readdir (2),</b>
<b>readlink (2),</b>
<b>select (2),</b>
<b>write (2),</b>
<b>fread (3),</b>
<b>readv (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
