<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1995 Andries Brouwer (aeb@cwi.nl) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Written 11 June 1995 by Andries Brouwer (aeb@cwi.nl) -->
<!--  Modified 22 July 1995 by Michael Chastain (mec@duracef.shout.net): -->
<!--    In 1.3.X, returns only one entry each time; return value is different. -->
<!--  -->
<!--  Traduction  12/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise a Jour 8/04/97 -->
<!--  Mise a Jour 18/07/2003 LDP-1.56 -->
<br/><h1>READDIR</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
readdir - Lire une entre de rpertoire.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;linux/dirent.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;linux/unistd.h&gt;</b> <b></b>  <br/><br/>

<b>_syscall3(int</b> <b></b> ,<b></b>  <b>readdir</b> <b></b> ,<b></b>  <b>uint</b> <b></b> ,<b></b>  <b>fd</b> <b></b> ,<b></b>  <b>struct</b> <b></b>  <b>dirent</b> <b></b>  <b>*</b> <b></b> ,<b></b>  <b>dirp</b> <b></b> ,<b></b>  <b>uint</b> <b></b> ,<b></b>  <b>count);</b> <b></b>  <br/><br/>

<b>int readdir(unsigned int </b> fd <i>, struct dirent *</i> dirp <b>, unsigned int </b> count );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette fonction n'est normalement pas intressante
pour les programmeurs.
Utiliser
<b>readdir (3)</b>
pour les fonctionnalits conformes POSIX.
Cette page documente l'interface de l'appel systme bas-niveau,
qui peut changer, et qui est remplace par
<b>getdents (2).<br/><br/></b>
<b>readdir</b> <b></b>  lit une structure
<i>dirent</i> depuis le rpertoire point par
<i>fd</i> et la place en mmoire dans la zone pointe par
<i>dirp.</i>
Le paramtre
<i>count</i> est ignor, au plus une structure dirent est lue.<br/><br/>
La structure 
<i>dirent</i> est dclare comme suit :<br/><br/>
.RS

struct dirent
{
    long d_ino;                 /* inode number */
    off_t d_off;                /* offset to this <i>dirent</i> */
    unsigned short d_reclen;    /* length of this <i>d_name</i> */
    char d_name [NAME_MAX+1];   /* file name (null-terminated) */
}


<br/><br/>
<i>d_ino</i> est un numro d'i-node.
<i>d_off</i> est la distance entre le dbut du rpertoire et cette
structure
<i>dirent.</i>
<i>d_reclen</i> est la longueur
<i>d_name,</i>
sans compter le caractre nul final.
<i>d_name</i> est le nom de fichier termin par un caractre nul.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>readdir</b>
renvoie 1 s'il russit, 0 en fin de rpertoire, ou -1 s'il choue, 
auquel cas
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EBADF</b> <b></b>  <i>fd</i>
est invalide.
<br/><br/>

<b>EFAULT</b> <b></b>  L'argument pointe en dehors de l'espace d'adressage.
<br/><br/>

<b>EINVAL</b> <b></b>  Le buffer de rsultat est trop petit.
<br/><br/>

<b>ENONENT</b> <b></b>  Rpertoire inexistant.
<br/><br/>

<b>ENOTDIR</b> <b></b>  Le descripteur est associ  un fichier, pas  un rpertoire.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
Cet appel-systme est spcifique  Linux.
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>getdents (2),</b>
<b>readdir (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
