<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  man2/sched_setaffinity.2 - sched_setaffinity and sched_getaffinity man page -->
<!--  -->
<!--  Copyright (C) 2002 Robert Love -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  The GNU General Public License's references to "object code" -->
<!--  and "executables" are to be interpreted as the output of any -->
<!--  document formatting or typesetting system, including -->
<!--  intermediate and printed output. -->
<!--  -->
<!--  This manual is distributed in the hope that it will be useful, -->
<!--  but WITHOUT ANY WARRANTY; without even the implied warranty of -->
<!--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the -->
<!--  GNU General Public License for more details. -->
<!--  -->
<!--  You should have received a copy of the GNU General Public -->
<!--  License along with this manual; if not, write to the Free -->
<!--  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, -->
<!--  USA. -->
<!--  -->
<!--  19 Nov 2002	Robert Love &lt;rml@tech9.net&gt; -->
<!--  		initial version -->
<!--  -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 18/07/2003 - LDP-1.56 -->
<br/><h1>SCHED_SETAFFINITY</h1>
<br /><a class="summaryIndent0" href="#L0">synopsis</a>
<br /><a class="summaryIndent0" href="#L1">description</a>
<br /><a class="summaryIndent0" href="#L2">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L3">erreurs</a>
<br /><a class="summaryIndent0" href="#L4">historique</a>
<br /><a class="summaryIndent0" href="#L5">voir aussi</a>
<br /><a class="summaryIndent0" href="#L6">traduction</a>
<br/><br/>sched_setaffinity, sched_getaffinity - set and get a process's CPU affinity
mask
<br /><h1 class="TitreSection0" id="L1">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sched.h&gt;</b> <b></b>  <br/><br/>

\fBint sched_setaffinity(pid_t <i>pid</i>, unsigned int <i>lg</i>, unsigned long *<i>masque</i>);
<br/><br/>

\fBint sched_getaffinity(pid_t <i>pid</i>, unsigned int <i>lg</i>, unsigned long *<i>masque</i>);<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">description</h1>
<div class="paragraph">
<b>sched_setaffinity</b> <b></b>  fixe le masque des prfrences du processus
<i>pid</i> vis--vis du CPU.
Si
<i>pid</i> vaut zro, il s'agit du processus appelant.
<br/><br/>

Les prfrences sont reprsentes par les bits stockes dans le
<i>masque .</i>
Le bit de moindre poid reprsente le numro logique du premier processeur, tandis
que le bit de poid le plus fort reprsent le numro de dernier processeur.
Un bit activ correspond  un processeur utilisable pour l'ordonnancement
alors qu'un bit inhib reprsent un processeur refuse. En d'autres terme,
le processus est attach et ne s'excutera que sur les processeurs dont
les bits sont activs. D'habitude tous les bits du masque sont valids.
<br/><br/>

L'argument
<i>lg</i> reprsente la longueur des donnes pointes par le
<i>masque .</i>
Normalement, il s'agit de la taille d'un mot du systme. Pour assurer la
compatibilits avec les futurs noyaux Linux, comme cette taille peut varier,
le masque fourni doit tre au moins aussi grand que le masque d'affinit
stock dans le noyau.
<br/><br/>

La fonction
<b>sched_getaffinity</b> <b></b>  crit dans la zone pointe par
<i>masque</i> (dont la taille est
<i>lg )</i>
le masque de prfrences du processus
<i>pid .</i>
Si
<i>pid</i> vaut zro, le masque du processus en cours est renvoy.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">valeur renvoye</h1>
<div class="paragraph">
S'ils russissent
<b>sched_setaffinity</b>
et
<b>sched_getaffinity</b>
renvoient tous deux zro.
S'ils chouent, ils renvoient -1 et
<i>errno</i> sera rempli avec le code d'erreur.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EFAULT</b> <b></b>  Une adresse mmoire est invalide.
<br/><br/>

<b>ESRCH</b> <b></b>  Impossible de trouver le processus du <i>pid</i> indiqu.
<br/><br/>

<b>EPERM</b> <b></b>  Le processus appelant n'a pas les privilges appropris. Le processus qui
invoque 
<b>sched_setaffinity</b>
doit avoir un UID effectif gal  l'UID effectif ou rel du
processus identifi par
<i>pid ,</i>
ou avoir la capacit
<i>CAP_SYS_NICE .</i>
<br/><br/>

<b>EINVAL</b> <b></b>  Le 
<i>masque</i> des prfrences ne contient pas de processeurs prsents sur le systme, ou
<i>lg</i> est plus petit que la taille du masque d'affinit utilis par le noyau.
</div><br/><br /><h1 class="TitreSection0" id="L5">historique</h1>
<div class="paragraph">
Les appels-systme d'affinit ont t introduit dans Linux 2.5.8.
</div><br/><br /><h1 class="TitreSection0" id="L6">voir aussi</h1>
<div class="paragraph">
<b>sched_setscheduler (2),</b>
<b>sched_getscheduler (2),</b>
<b>sched_get_priority_max (2),</b>
<b>sched_get_priority_min (2),</b>
<b>nice (2),</b>
<b>setpriority (2),</b>
<b>getpriority (2),<br/><br/></b>
<b>sched_setscheduler (2)</b>
dcrit le fonctionnement de l'ordonnancement sous Linux.
</div><br/><br /><h1 class="TitreSection0" id="L7">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
