<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright (C) Tom Bjorkholm & Markus Kuhn, 1996 -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  The GNU General Public License's references to "object code" -->
<!--  and "executables" are to be interpreted as the output of any -->
<!--  document formatting or typesetting system, including -->
<!--  intermediate and printed output. -->
<!--  -->
<!--  This manual is distributed in the hope that it will be useful, -->
<!--  but WITHOUT ANY WARRANTY; without even the implied warranty of -->
<!--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the -->
<!--  GNU General Public License for more details. -->
<!--  -->
<!--  You should have received a copy of the GNU General Public -->
<!--  License along with this manual; if not, write to the Free -->
<!--  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, -->
<!--  USA. -->
<!--  -->
<!--  1996-04-01 Tom Bjorkholm &lt;tomb@mydata.se&gt; -->
<!--             First version written -->
<!--  1996-04-10 Markus Kuhn &lt;mskuhn@cip.informatik.uni-erlangen.de&gt; -->
<!--             revision -->
<!--  -->
<!--  Traduction 14/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a Jour 8/04/97 -->
<!--  Mise a Jour 18/07/2003 LDP-1.56 -->
<br/><h1>SCHED_SETPARAM</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
sched_getparam, sched_setparam - Lire / crire les paramtres d'ordonnancement.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sched.h&gt;</b> <b></b>  <br/><br/>

\fBint sched_setparam(pid_t <i>pid</i>, const struct sched_param *<i>p</i>);
<br/><br/>

\fBint sched_getparam(pid_t <i>pid</i>, struct sched_param *<i>p</i>);
<br/><br/>


.ta 4n
\fBstruct sched_param {
	...
	int <i>sched_priority</i>;
	...
};
.ta


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>sched_setparam</b> <b></b>  fixe les paramtres associs  la politique d'ordonnancement 
du processus identifi par <i>pid</i>. 
Si <i>pid</i> vaut zro, les paramtres concernant le processus
en cours sont fixs. L'interprtation des paramtres dpend
de la politique d'ordonnancement utilise. Actuellement les
trois politiques suivantes sont disponibles sous Linux :
<i>SCHED_FIFO , </i>
<i>SCHED_RR ,</i>
et
<i>SCHED_OTHER.<br/><br/></i>
<b>sched_getparam</b> <b></b>  lit les paramtres associs  la politique d'ordonnancement 
du processus identifi par <i>pid</i>. 
Si <i>pid</i> vaut zro, les paramtres concernant le processus
en cours sont lus.<br/><br/>
<b>sched_setparam</b> <b></b>  vrifie la validit de <i>p</i> pour la politique concerne. Le paramtre
<i>p-&gt;sched_priority</i> doit se situer dans l'intervalle obtenu
par <b>sched_get_priority_min</b> et
<b>sched_get_priority_max</b>.<br/><br/>
Les systmes POSIX sur lesquels
<b>sched_setparam</b> <b></b>  et
<b>sched_getparam</b> <b></b>  sont disponibles dfinissent
<i>_POSIX_PRIORITY_SCHEDULING</i> dans &lt;unistd.h&gt;.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>sched_setparam</b>
et
<b>sched_getparam</b>
renvoient 0 s'ils russissent.
En cas d'chec, -1 est renvoy, et
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>
 
<b>ESRCH</b> <b></b>  Le processus numro <i>pid</i> n'existe pas.
<br/><br/>

<b>EPERM</b> <b></b>  Le processus appelant n'a pas les privilges ncessaires. L'appel
<b>sched_setparam</b>
ncessite un UID effectif gal  celui du processus identifi par
<i>pid ,</i>
ou doit tre Super-User.
<br/><br/>

<b>EINVAL</b> <b></b>  Le paramtre <i>p</i> n'a pas de sens pour la politique 
d'ordonnancement utilise.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
POSIX.1b (POSIX.4)
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>sched_setscheduler (2), </b>
<b>sched_getscheduler (2), </b>
<b>sched_get_priority_max (2), </b>
<b>sched_get_priority_min (2), </b>
<b>nice (2), </b>
<b>setpriority (2), </b>
<b>getpriority (2), <br/><br/></b>
<b>sched_setscheduler (2) </b>
dcrit les politiques d'ordonnancement sous Linux.<br/><br/>
<i>Programming for the real world - POSIX.4</i> by Bill O. Gallmeister, O'Reilly & Associates, Inc., ISBN 1-56592-074-0
<br/>
<i>IEEE Std 1003.1b-1993</i> (standard POSIX.1b)
<br/>
<i>ISO/IEC 9945-1:1996</i> </div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
