<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 Giorgio Ciucci (giorgio@crcc.it) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction 15/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a Jour 8/04/97 -->
<!--  Mise a jour 18/05/99 - LDP-man-pages-1.23 -->
<!--  Mise a jour 18/07/03 - LDP-man-pages-1.56 -->
<br/><h1>SEMGET</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">bogues</a>
<br /><a class="summaryIndent0" href="#L7">conformit</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
semget - Obtenir l'identificateur d'un ensemble de smaphores.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/ipc.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/sem.h&gt;</b> <b></b>  

<br/><br/>

<b>int semget (key_t </b> key ,
<b>int </b> nsems ,
<b>int </b> semflg  );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette fonction retourne l'identificateur de l'ensemble de 
smaphores associ  la valeur de cl
<i>key .</i>
Un nouvel ensemble contenant
<i>nsems</i> smaphores est cr si 
<i>key</i> a la valeur
<b>IPC_PRIVATE</b> <b></b>  ou si aucun ensemble n'est associ 
<i>key ,</i>
et si l'option
<b>IPC_CREAT</b> <b></b>  est prsente dans
<i>semflg.</i> (i.e.
<i>semflg </i> &<i></i>
<b>IPC_CREAT</b> <b></b>  diffrent de zro).<br/><br/>
La prsence de
<b>IPC_CREAT</b> <b></b>  et
<b>IPC_EXCL</b> <b></b>  dans le champ
<i>semflg</i> joue le mme rle, par rapport  l'existence du
jeu de smaphores, que la prsence de
<b>O_CREAT</b> <b></b>  et
<b>O_EXCL</b> <b></b>  dans l'argument de mode de l'appel systme
<b>open (2)</b>
i.e. la fonction
<b>semget</b> <b></b>  chouera si
<i>semflg</i> demande  la fois
<b>IPC_CREAT</b> <b></b>  et
<b>IPC_EXCL</b> <b></b>  et si un smaphore associ a
<i>key </i> existe dj.<br/><br/>
Pendant la cration, les 9 bits de poids faibles de
l'argument
<i>semflg</i> dfinissent les permissions d'accs (pour le propritaire,
le groupe et les autres) au jeu de smaphores, en utilisant
le mme format et la mme signification  que les droits
d'accs dans
<b>open (2)</b>
ou
<b>creat (2).</b>
Les permissions d'excutions ne sont pas utilises par le systme, et
pour un jeu de smaphores, l'autorisation d'criture signifie
autorisation de modification.<br/><br/>
Durant la cration, la structure de donnes
<b>semid_ds</b> <b></b>  contrlant le jeu de smaphores est initialise ainsi :
.IP
<b>sem_perm.cuid</b> <b></b>  et
<b>sem_perm.uid</b> <b></b>  contiennent l'UID effectif du processus appelant.
.IP
<b>sem_perm.cgid</b> <b></b>  et
<b>sem_perm.gid</b> <b></b>  contiennent le GID effectif du processus appelant.
.IP
le 9 bits de poids faibles de
<b>sem_perm.mode</b> <b></b>  sont remplis avec les 9 bits de poids faibles de
<i>semflg .</i>
.IP
<b>sem_nsems</b> <b></b>  reoit la valeur
<i>nsems .</i>
.IP
<b>sem_otime</b> <b></b>  est mis a 0.
.IP
<b>sem_ctime</b> <b></b>  est rempli avec l'heure actuelle.<br/><br/>
l'argument
<i>nsems</i> peut valoir
<b>0</b> <b></b>  (ignore)
si l'appel systme n'est pas une cration d'ensemble de smaphores.
Autrement
<i>nsems</i> doit tre suprieur 
<b>0</b> <b></b>  et infrieur ou gal au nombre maximal de smaphores par ensemble,
( SEMMSL ).<br/><br/></b>
Si le jeu de smaphores existe dj, les permissions d'accs sont
contrles, et l'on vrifie si l'ensemble est sur le point
d'tre dtruit.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Si l'appel russit, il renvoie l'identificateur de l'ensemble (un
entier positif), sinon il renvoie
<b>-1</b> <b></b>  et
<b>errno</b> <b></b>  contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>
 11
<b>Eaccs</b> <b></b>  Le jeu de smaphore associ 
<i>key </i>
existe, mais le processus n'a aucun droit d'accs sur lui
<br/><br/>

<b>EEXIST</b> <b></b>  Le jeu de smaphore associ a
<b>key</b> <b></b>  existe mais l'argument
<i>semflg</i> prcise  la fois
<b>IPC_CREAT</b> <b></b>  et
<b>IPC_EXCL .</b>
<!--  <br/><br/>
 -->
<!--  <b>EIDRM</b> <b></b>  <b>--></b> <b></b>  <!--  le jeu de smaphores est prt  tre dtruit -->
<br/><br/>

<b>ENOENT</b> <b></b>  Aucun jeu de smaphore associ a
<i>key</i> n'existe
et l'argument
<i>semflg</i> ne prcise pas
<b>IPC_CREAT .</b>
<br/><br/>

<b>EINVAL</b> <b></b>  <i>nsems</i>
est infrieur  zro ou suprieur  la limite sur le nombre de smaphores
par ensemble,
( SEMMSL ),</b>
ou l'ensemble de smaphores identifi par
<i>key</i> existe dj, et
<i>nsems</i> est plus grand que le nombre de smaphores par ensemble..
<br/><br/>

<b>ENOMEM</b> <b></b>  Pas assez de mmoire pour crer les structures ncessaires.
<br/><br/>

<b>ENOSPC</b> <b></b>  Le nombre maximal de jeux de smaphores sur le systme
( SEMMNI )</b>
est atteint,
ou le nombre maximal de smaphores sur le systme est atteint
( SEMMNS ).</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
<b>IPC_PRIVATE</b> <b></b>  n'est pas une option, mais un objet de type
<b>key_t .</b>
Si l'on utilise cette valeur spciale dans l'argument
<i>key ,</i>
l'appel systme ne se proccupera que des 9 bits de poids
faibles de
<i>semflg</i> et tentera de crer un nouveau jeu de smaphores.<br/><br/>
Les limites suivantes concernent l'appel systme
<b>semget</b> <b></b>  <b>:</b> <b></b>  <br/><br/>
 11
<b>SEMMNI</b> <b></b>  Nombre maximal d'ensembles de smaphores sur le systme.
<br/><br/>

<b>SEMMSL</b> <b></b>  Nombre maximal de smaphores par ensemble.
<br/><br/>

<b>SEMMNS</b> <b></b>  Nombre maximal de smaphores sur le systme&nbsp;: dpend de l'implmentation.
Les valeurs suprieures 
<b>SEMMSL</b> <b></b>  <b>*</b> <b></b>  <b>SEMMNI</b> <b></b>  sont incorrectes.
</div><br/><br /><h1 class="TitreSection0" id="L7">bogues</h1>
<div class="paragraph">
L'utilisation de 
<b>IPC_PRIVATE</b> <b></b>  n'empche pas les autres processus d'accder au jeu de smaphores allou.
Le choix de ce mot est malheureux, il aurait mieux valu utiliser IPC_NEW.<br/><br/>
Les structures de donnes associes a chaque smaphore dans l'ensemble
ne sont pas initialises lors de l'appel systme.
Pour effectuer cette initialisation, il faut excuter un appel 
<b>semctl (2)</b>
avec les commandes
<b>SETVAL</b> <b></b>  ou
<b>SETALL.</b> <b></b>  </div><br/><br /><h1 class="TitreSection0" id="L8">conformit</h1>
<div class="paragraph">
SVr4, SVID.  SVr4 documente des conditions d'erreur supplmentaires
EFBIG, E2BIG, EAGAIN, ERANGE, et EFAULT.
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>ftok (3),</b>
<b>ipc (5),</b>
<b>semctl (2),</b>
<b>semop (2).</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
