<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 Giorgio Ciucci (giorgio@crcc.it) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction 15/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a Jour 8/04/97 -->
<!--  Mise a Jour 18/07/2003   LDP-1.56 -->
<!--  MJ 25/07/2003 LDP-1.57 -->
<!--  MJ 30/07/2003 LDP-1.58 -->
<br/><h1>SEMOP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">bogues</a>
<br /><a class="summaryIndent0" href="#L7">conformit</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
semop, semtimedop - Oprations sur les smaphores.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/ipc.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/sem.h&gt;</b> <b></b>  

<br/><br/>

<b>int semop (int </b> semid ,
<b>struct sembuf *</b> sops ,
<b>unsigned </b> nsops  );
<br/><br/>

<b>int semtimedop (int </b> semid ,
<b>struct sembuf *</b> sops ,
<b>unsigned </b> nsops ,
<b>struct timespec *</b> timeout );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Un smaphore est reprsent par une structure anonyme
incluant les membres suivants&nbsp;:
<br/><br/>

.in +4n

unsigned short  semval;   /* valeur du smaphore   */
unsigned short  semzcnt;  /* # Attente pour zro   */
unsigned short  semncnt;  /* # Attente d'incrment */
pid_t           sempid;   /* dernier processus agissant */
<br/><br/>
 
.in -4n

 
La fonction
<b>semop</b> <b></b>  effectue des oprations sur les membres de l'ensemble de smaphores identifi par
<i>semid .</i>
Chacun des
<i>nsops</i> lments dans le tableau point par
<i>sops</i> indique une opration  effectuer sur un smaphore 
en utilisant une structure
<b>struct</b> <b></b>  <b>sembuf"</b> <b></b>  dfinie comme suit:
<br/><br/>

.in +4n

  short sem_num;  /* Numro du smaphore (0=premier) */ 
  short sem_op;   /* Opration sur le smaphore      */
  short sem_flg;  /* Options pour l'opration        */
<br/><br/>

.in -4n


Les options possibles pour
<b>sem_flg</b> <b></b>  sont
<b>IPC_NOWAIT</b> <b></b>  et
<b>SEM_UNDO .</b>
Si une opration indique l'option
<b>SEM_UNDO ,</b>
elle sera annule lorsque le processus se terminera.<br/><br/>
L'ensemble des oprations contenues dans
<i>sops</i> est effectu
<i>atomiquement .</i>
Les oprations sont toutes ralises en mme temps, et seulement si elle
peuvent toutes tre effectues.
Le comportement de l'appel-systme si toutes les oprations ne sont pas
ralisables dpend de la prsence de l'attribut
<b>IPC_NOWAIT</b> <b></b>  dans les champs
<i>sem_flg</i> dcrits plus bas.<br/><br/>
Chaque opration est effectue sur le
<b>sem_num -ime</b>
smaphore de l'ensemble. Le premier smaphore est le
numro
<b>0</b> <b></b>  <b>.</b> <b></b>  Pour chaque smaphore l'opration est l'une des trois dcrites
ci-dessous.<br/><br/>
Si l'argument
<b>sem_op</b> <b></b>  est un entier positif, la fonction ajoute cette
valeur 
<b> semval .</b>
De plus si
<b>SEM_UNDO</b> <b></b>  est demand, le systme met  jour le compteur "undo" du smaphore
( semadj ).</i>
Cette opration n'est jamais bloquante.
Le processus appelant doit avoir l'autorisation de modification
sur le jeu de smaphores.<br/><br/>
Si 
<b>sem_op</b> <b></b>  vaut zro le processus attend que 
<b>semval</b> <b></b>  soit nul. Plusieurs cas sont possibles :
Si
<b>semval</b> <b></b>  vaut zro, l'appel systme continue immdiatement
Sinon, si l'on a rclam
<b>IPC_NOWAIT</b> <b></b>  dans
<b>sem_flg ,</b>
l'appel systme choue (en annulant les actions prcdentes)
et
<b>errno</b> <b></b>  contient
le code d'erreur
<b>EAGAIN .</b>
Autrement
<b>semzcnt</b> <b></b>  est incrment
de 1 et le processus s'endort jusqu' ce que l'un
des vnements suivants se produise&nbsp;:
.IP \(bu
<i>semval</i> devient gal  0, alors
<i>semzcnt</i> est dcrment. L'appel systme continue
.IP \(bu
Le jeu de smaphores est supprim. L'appel systme
choue et
<i>errno</i> contient le code d'erreur
<b>EIDRM .</b>
.IP \(bu
Le processus reoit un signal  intercepter, la
valeur de 
<i>semzcnt</i> est dcrmente et l'appel systme choue avec
<i>errno</i> contenant le code d'erreur
<b>EINTR .</b>
.IP \(bu
La limite temporelle indique par
<i>timeout</i> dans un
<b>semtimedop</b> <b></b>  a expir&nbsp;: l'appel-systme choue avec
<i>errno</i> contenant
<b>EAGAIN .<br/><br/></b>
Si
<b>sem_op</b> <b></b>  est infrieur  zro, le processus appelant doit avoir 
l'autorisation de modification sur le jeu de smaphores.
Si
<b>semval</b> <b></b>  est suprieur ou gal  la valeur absolue de
<b>sem_op ,</b>
la valeur absolue de 
<b>sem_op</b> <b></b>  est soustraite de
<b>semval .</b>
Si 
<b>SEM_UNDO</b> <b></b>  est indiqu, le systme met  jour le compteur "undo" du
smaphore. Puis l'appel systme continue.
Autrement si l'on a rclam
<b>IPC_NOWAIT</b> <b></b>  dans
<b>sem_flg ,</b>
l'appel systme choue (annulant les actions prcdentes
et
<b>errno</b> <b></b>  contient le code d'erreur
<b>EAGAIN .</b>
Sinon
<b>semncnt</b> <b></b>  est dcrment de un et le processus s'endort jusqu' ce
que l'un des vnements suivants se produise :
.IP \(bu
<i>semval</i> devient suprieur ou gal  la valeur absolue de 
<i>sem_op ,</i>
alors la valeur
<i>semncnt</i> est dcrmente, la valeur absolue de
<i>sem_op</i> est soustraite de
<i>semval</i> et si
<b>SEM_UNDO</b> <b></b>  est demand le systme met  jour le compteur "undo" du
smaphore. Puis l'appel systme continue.
.IP \(bu
Le jeu de smaphores est supprim. L'appel systme
choue et
<b>errno</b> <b></b>  contient le code d'erreur
<b>EIDRM .</b>
.IP \(bu
Le processus reoit un signal  intercepter, la
valeur de 
<b>semncnt</b> <b></b>  est dcrmente et l'appel systme choue avec
<b>errno</b> <b></b>  contenant le code d'erreur
<b>EINTR .</b>
.IP \(bu
La limite temporelle indiqu par
<i>timeout</i> dans un
<b>semtimedop</b> <b></b>  a expir&nbsp;: l'appel-systme choue avec
<i>errno</i> contenant
<b>EAGAIN .<br/><br/></b>
en cas de succs, le membre 
<b>sempid</b> <b></b>  de la structure
<b>sem</b> <b></b>  de chacun des smaphores indiqus dans le tableau point par
<i>sops</i> est rempli avec le PID du processus appelant.
Enfin
<b>sem_otime</b> <b></b>  est fix  l'heure actuelle.<br/><br/>
La fonction
<b>semtimedop</b> <b></b>  se comporte comme
<b>semop</b> <b></b>  sauf que dans le cas o le processus doit dormir, la
dure maximale du sommeil est limite par la valeur
spcifie dans la structure
<b>timespec</b> <b></b>  dont l'adresse est transmise dans le paramtre
<i>timeout .</i>
Si la limite indique a t atteint,
l'appel-systme choue avec
<i>errno</i> contenant
<b>EAGAIN</b> <b></b>  (et aucune opration de
<i>sops</i> n'est ralise).
Si le paramtre
<i>timeout</i> est
<b>NULL ,</b>
alors
<b>semtimedop</b> <b></b>  se comporte exactement comme
<b>semop .</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
. semop
renvoie la valeur
<b>0 ,</b>
s'il russit et
<b>-1</b> <b></b>  s'il choue auquel cas 
<b>errno</b> <b></b>  contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>E2BIG</b> <b></b>  l'argument
<i>nsops</i> est suprieur 
<b>SEMOPM ,</b>
le nombre maximal d'oprations par appel systme.
<br/><br/>

<b>EACCES</b> <b></b>  Le processus appelant n'a pas les permissions d'accs ncessaires.
<br/><br/>

<b>EAGAIN</b> <b></b>  Une opration a chou et
<b>IPC_NOWAIT</b>
a t indiqu dans l'argument
<i>sem_flg ,</i>
ou la dure limite indique dans
<i>timeout</i> a expir.
<br/><br/>

<b>EFAULT</b> <b></b>  <i>sops</i> pointe en dehors de l'espace d'adressage accessible.
<br/><br/>

<b>EFBIG</b> <b></b>  La valeur de
<b>sem_num</b> <b></b>  est infrieure  0 ou suprieure ou gale au nombre de
smaphores dans l'ensemble.
<br/><br/>

<b>EIDRM</b> <b></b>  Le jeu de smaphores a t supprim.
<br/><br/>

<b>EINTR</b> <b></b>  Un signal a t reu pendant l'attente.
<br/><br/>

<b>EINVAL</b> <b></b>  L'ensemble de smaphores n'existe pas ou
<i>semid</i> est infrieur  zro, ou
<i>nsops</i> n'a pas une valeur positive.
<br/><br/>

<b>ENOMEM</b> <b></b>  L'argument
<i>sem_flg</i> de certaines oprations demande
<b>SEM_UNDO</b> <b></b>  et le systme n'a pas assez de mmoire pour allouer les structures ncessaires.
<br/><br/>

<b>ERANGE</b> <b></b>  <b>semop</b> <b></b>  <b>+</b> <b></b>  <b>semval</b> <b></b>  est suprieur 
<b>SEMVMX.</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Les structures
<b>sem_undo</b> <b></b>  d'un processus ne sont pas hrites par ses enfants lors d'un
<b>fork (2).</b>
par contre elles sont transmises lors d'un
<b>execve (2).<br/><br/></b>
<b>semop</b> <b></b>  n'est jamais relanc automatiquement aprs avoir t interrompu par un gestionnaire
de signal quelque soit l'attribut
<b>SA_RESTART</b> <b></b>  durant l'installation du gestionnaire.<br/><br/>
<i>semadj</i> est un entier pour le processus qui reprsente simplement le compte (ngatif)
des oprations sur le smaphore ralises par
l'attribut
<b>SEM_UNDO .</b>
Quand la valeur d'un smaphore est fixe directement par une requte
<b>SETVAL</b> <b></b>  ou
<b>SETALL</b> <b></b>  de
<b>semctl (2),</b>
la valeur
<i>semadj</i> correspondante est efface dans tous les processus.<br/><br/>
Les valeurs <i>semval</i>, <i>sempid</i>, <i>semzcnt</i>, et <i>semnct</i>
pour un smaphore peuvent tre retrouves avec des appels
<b>semctl (2)</b>
spcifiques.<br/><br/>
Les limites systme suivantes concernent
<b>semop</b> <b></b>  <b>:</b> <b></b>  <br/><br/>

<b>SEMOPM</b> <b></b>  Nombre maximal d'oprations pour un appel systme
<b>semop (32).</b>
<br/><br/>

<b>SEMVMX</b> <b></b>  Valeur maximale pour
<b>semval </b> :<b></b>
dpendante de l'implmentation (32767).<br/><br/>
L'implmentation n'a pas de limites intrinsques pour
la valeur maximale d'effacement en sortie
( SEMAEM ), </b>
le nombre de structure d'annulation sur le systme
( SEMMNU ),</b>
et le nombre maximal de structures d'annulation pour un processus.
</div><br/><br /><h1 class="TitreSection0" id="L7">bogues</h1>
<div class="paragraph">
Quand un processus se termine, l'ensemble des structures
<i>semadj</i> qui lui sont associes servent  annuler les effets de toutes les oprations
sur les smaphores ralises avec
l'attribut.
<b>SEM_UNDO .</b>
Ceci pose un problme&nbsp;: si l'une (ou plusieurs) des modifications sur les
smaphores demande une descente du compteur d'un smaphore en-dessous de
zro, que doit faire l'implmentation&nbsp;?
Une approche possible consiste  bloquer jusqu' ce que la modification
du smaphore soit possible.
C'est nanmoins peu dsirable car la terminaison du processus peut
bloquer pendant une priode arbitrairement longue.
Une autre possibilit est d'ignorer la modification
du smaphore (comme un chec lorsque
<b>IPC_NOWAIT</b> <b></b>  est spcifi durant une opration).
Linux adopte une troisime approche&nbsp;: dcrotre la valeur du smaphore
autant que possible (jusqu' zro) et permettre au processus de
se terminer immdiatement.
</div><br/><br /><h1 class="TitreSection0" id="L8">conformit</h1>
<div class="paragraph">
SVr4, SVID.  SVr4 documente les conditions d'erreur supplmentaires
EINVAL, EFBIG, et ENOSPC.
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>ipc (5),</b>
<b>semctl (2),</b>
<b>semget (2),</b>
<b>sigaction (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
