<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 1995, Thomas K. Dyas &lt;tdyas@eden.rutgers.edu&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Created   Sun Aug  6 1995      Thomas K. Dyas &lt;tdyas@eden.rutgers.edu&gt; -->
<!--  -->
<!--  Traduction 15/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a Jour 8/04/97 -->
<!--  Mise  jour 30/08/2000 LDP 1.31 -->
<!--  Mise  jour 18/07/2003 LDP 1.56 -->
<br/><h1>SETFSGID</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">conformit</a>
<br /><a class="summaryIndent0" href="#L5">bogues</a>
<br /><a class="summaryIndent0" href="#L6">note</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
setfsgid - Fixer le GID pour les vrifications d'accs au systme de fichiers.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  /* glibc uses &lt;sys/fsuid.h&gt; */
<br/><br/>

<b>int setfsgid(uid_t </b> fsgid )
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>setfsgid</b> <b></b>  fixe le GID que le noyau Linux utilisera pour vrifier tous
les accs du processus au systme de fichiers.
Normalement la valeur de
<i>fsgid</i> va masquer la valeur  du GID effectif. En fait, si
le GID effectif est modifi,
<i>fsgid</i> sera aussi modifi pour la nouvelle valeur du GID effectif.<br/><br/>
L'appel explicite de
<b>setfsgid</b> <b></b>  n'est normalement utile qu'aux programmes tels que le serveur
NFS qui ont besoin de modifier le GID utilis pour les
accs aux fichiers sans changer vritablement leurs
GID rels et effectifs.
Une modification du GID normal d'un programme comme 
un serveur NFS serait un trou de scurit qui l'exposerait
 des signaux indsirables en provenance d'autres processus
du mme groupe.<br/><br/>
<b>setfsgid</b> <b></b>  ne russira que si l'appelant est le Super-User ou si
<i>fsgid</i> correspond au vritable GID, au GID effectif,
au GID sauv, ou encore  la valeur actuelle de
<i>fsgid .</i>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>setfsgid</b> <b></b>  renvoie la valeur prcdente
<i>fsgid</i> s'il russit. 
En cas d'erreur la valeur actuelle de
<i>fsgid</i> est renvoye.
</div><br/><br /><h1 class="TitreSection0" id="L5">conformit</h1>
<div class="paragraph">
<b>setfsgid</b> <b></b>  est spcifique  Linux et ne doit pas tre employ dans des programmes
conus pour tre portables.
Il est prsent depuis Linux 1.1.44 et dans la bibliothque C depuis libc 4.7.6.
</div><br/><br /><h1 class="TitreSection0" id="L6">bogues</h1>
<div class="paragraph">
Il n'y a pas de messages d'erreur renvoys. Il serait bon d'avoir au moins
un code d'erreur
<b>EPERM .</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">note</h1>
<div class="paragraph">
Lorsque la bibliothque GlibC s'aperoit que l'argument n'est pas un GID valide, elle revoie -1 et
place EINVAL dans <i>errno</i> sans essayer d'appeler l'appel-systme rel.<br/><br/>
Notez que lors de l'introduction de cet appel-systme, un processus pouvait
envoyer un signal  un autre processus avec le mme UID effectif. De nos
jours les permissions pour les signaux sont lgrement diffrentes.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>kill (2),</b>
<b>setfsuid (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
