<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 Giorgio Ciucci (giorgio@crcc.it) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Modified Sun Nov 28 17:06:19 1993, Rik Faith (faith@cs.unc.edu) -->
<!--           with material from Luigi P. Bai (lpb@softint.com) -->
<!--  Portions Copyright 1993 Luigi P. Bai -->
<!--  -->
<!--  Traduction 16/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a Jour 15/04/97 -->
<!--  Mise a Jour 20/01/2002 - LDP-man-pages-1.47 -->
<!--  Mise a Jour 18/07/2003 - LDP-man-pages-1.56 -->
<br/><h1>SHMOP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">autres appels systmes</a>
<br /><a class="summaryIndent0" href="#L4">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L5">erreurs</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">conformit</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
shmop, shmat, shmdt - Oprations sur la mmoire partage.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/shm.h&gt;</b> <b></b>  

<br/><br/>

<b>void *shmat ( int </b> shmid ,
<b>const void * </b> shmaddr ,
<b>int </b> shmflg );
<br/><br/>

<b>int shmdt (const void * </b> shmaddr );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>shmat</b> <b></b>  attache le segment de mmoire partage identifi par
<b>shmid</b> <b></b>  au segment de donnes du processus appelant.
L'adresse d'attachement est indique par
<i>shmaddr</i> avec les critres suivants&nbsp;:
.IP
Si
<i>shmaddr</i> vaut
<b>NULL ,</b>
le systme essaye de trouver une adresse libre pour attacher
le segment.
.IP
Si
<i>shmaddr</i> n'est pas
<b>NULL</b> <b></b>  et si
<b>SHM_RND</b> <b></b>  est indiqu dans
<i>shmflg ,</i>
l'attachement a lieu  l'adresse 
<i>shmaddr</i> arrondie au multiple infrieur de
<b>SHMLBA .</b>
Sinon
<i>shmaddr</i> doit tre aligne sur une frontire de page, o l'attachement a lieu.<br/><br/>
Si
<b>SHM_RDONLY</b> <b></b>  est indiqu dans
<i>shmflg ,</i>
le segment est attach en lecture seulement, et le processus doit disposer
de la permission de lecture dessus. Sinon le segment est attach en lecture
et criture et le processus doit disposer des deux permissions d'accs.
Il n'y a pas de notion d'criture seule pour les
segments de mmoire partage.<br/><br/>
L'option (spcifique  Linux)
<b>SHM_REMAP</b> <b></b>  peut tre ajoute dans
<i>shmflg</i> pour indiquer que la projection du segment doit remplacer une projection
prcdente dans l'intervalle commenant en
<i>shmaddr</i> et s'tendant sur la taille du segment.
(Normalement une erreur
<b>EINVAL</b> <b></b>  se produirait si une projection existait dj dans l'intervalle indiqu).
Dans ce cas,
<i>shmaddr</i> ne doit pas tre
<b>NULL .<br/><br/></b>
La valeur
<b>brk</b> <b></b>  du processus appelant n'est pas altre par l'attachement. Le segment est
automatiquement dtach quand le processus se termine. Le mme segment peut tre
attach  la fois en lecture seule et en lecture/criture. Il peut galement
tre attach en plusieurs endroits de l'espace d'adressage du processus.<br/><br/>
Si 
<b>shmat</b> <b></b>  russit, les membres de la structure
<b>shmid_ds</b> <b></b>  associe au segment de mmoire partage sont mis  jour ainsi :
.IP
<b>shm_atime</b> <b></b>  correspond  l'heure actuelle.
.IP
<b>shm_lpid</b> <b></b>  contient le PID de l'appelant.
.IP
<b>shm_nattch</b> <b></b>  est incrment de 1<br/><br/>
Notez que l'attachement russit mme si le segment de mmoire est
marqu pour destruction.<br/><br/>
La fonction
<b>shmdt</b> <b></b>  dtache le segment de mmoire partage situe  l'adresse indique par
<i>shmaddr .</i>
Le segment doit tre effectivement attach, et l'adresse
<i>shmaddr</i> doit tre celle renvoye prcdement par
<b>shmat.<br/><br/></b>
Quand
<b>shmdt</b> <b></b>  russit, les membres de la structure
<b>shmid_ds</b> <b></b>  associe au segment de mmoire partage sont mis  jour ainsi :
.IP
<b>shm_dtime</b> <b></b>  correspond  l'heure actuelle.
.IP
<b>shm_lpid</b> <b></b>  contient le PID de l'appelant.
.IP
<b>shm_nattch</b> <b></b>  est dcrment de 1. S'il devient nul, et si le
segment est marqu pour destruction, il est
effectivement dtruit.<br/><br/>
La rgion occupe de l'espace d'adressage du processus est
libre.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">autres appels systmes</h1>
<div class="paragraph">
<br/><br/>

<b>fork()</b> <b></b>  Aprs un
<b>fork()</b> <b></b>  le fils hrite des segments de mmoire partage.
<br/><br/>

<b>exec()</b> <b></b>  Aprs un
<b>exec()</b> <b></b>  tous les segments de mmoire partage sont dtachs (pas dtruits).
<br/><br/>

<b>exit()</b> <b></b>  Lors d'un
<b>exit()</b> <b></b>  tous les segments de mmoire partage sont dtachs (pas dtruits).<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">valeur renvoye</h1>
<div class="paragraph">
Les deux fonctions renvoient
<b>-1</b> <b></b>  si elles chouent, auquel cas
<b>errno</b> <b></b>  contient le code d'erreur.
Sinon
<b>shmat</b> <b></b>  renvoie l'adresse d'attachement du segment de mmoire partage, et
<b>shmdt</b> <b></b>  renvoie
<b>0 .</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">erreurs</h1>
<div class="paragraph">
<b>shmat </b> :<b></b>
<br/><br/>

<b>EACCES</b> <b></b>  L'appelant n'a pas les permissions d'accs ncessaires pour l'attachement.
<br/><br/>

<b>EINVAL</b> <b></b>  <i>shmid</i> est invalide,
<i>shmaddr</i> est mal aligne,
ou
<b>SH_REMAP</b> <b></b>  a t rclam et
<i>shmaddr</i> est
<b>NULL .</b>
<br/><br/>

<b>ENOMEM</b> <b></b>  Pas assez de mmoire pour le systme.<br/><br/>
<b>shmdt </b> :<b></b>
<br/><br/>

<b>EINVAL .</b>
Pas de segment attach  l'adresse
<i>shmaddr.</i>
</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
Utiliser
<b>shmat</b> <b></b>  avec 
<i>shmaddr</i> ggale 
<b>NULL</b> <b></b>  est la manire conseille, portable, d'attecher un segment de mmoire partag.
Soyez conscients que le segment attach de cette manire peut l'tre 
des adresses diffrentes dans les diffrents processus.
Ainsi, tout pointeur contenu dans la mmoire partag doit tre relatif
(typiquement par rapport au dbut du segment) et pas
absolu.<br/><br/>
Les paramtres systme suivant influent sur
<b> shmat </b> :<b></b>
<br/><br/>
 
<b>SHMLBA</b> <b></b>  Multiple pour l'adresse de dbut de segment.
Doit tre align sur une frontire de page.
Pour l'implmentation actuelle,
<b>SHMBLA</b> <b></b>   la mme valeur que
<b>PAGE_SIZE .<br/><br/></b>
L'implmentation n'a pas de limite intrinsque pour le nombre maximal de
segment de mmoire partage par processus.
( SHMSEG ).</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">conformit</h1>
<div class="paragraph">
SVr4, SVID. SVr4 mentionne une condition d'erreur supplmentaire EMFILE.
Dans SVID-v4 le type de l'argument <i>shmaddr</i> a t modifi de
<b>char</b> <b></b>  <b>*"</b> <b></b>  en
<b>const void *</b> ,</b>
et le type de retour de <i>shmat</i>() de
<b>char</b> <b></b>  <b>*"</b> <b></b>  en
<b>void *</b> .</b>
(Les bibliothques Linux libc4 et libc5 avaient le prototype
<b>char</b> <b></b>  <b>*"</b> <b></b>  <b></b> ,<b></b>  la GlibC 2 celui
<b>void *</b> ).</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>brk (2),</b>
<b>ipc (5),</b>
<b>mmap (2),</b>
<b>shmctl (2),</b>
<b>shmget (2).</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
