<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
'\" t
<!--  Copyright (c) 2001, Michael Kerrisk (mtk16@ext.canterbury.ac.nz) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--  -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein. -->
<!--  -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  aeb, various minor fixes -->
<!--  -->
<!--  Traduction 27/05/2002 par Stphan Rafin (stephan.rafin@laposte.net) -->
<!--  MJ 18/07/2003 LDP-1.56 C.Blaess -->
<br/><h1>SIGALTSTACK</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">historique</a>
<br /><a class="summaryIndent0" href="#L7">conformit</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
sigaltstack -  Consulter ou fixer la pile de signal.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;signal.h&gt;</b> <b></b>  <br/><br/>

<b>int sigaltstack(const stack_t *</b> ss <i>, stack_t *</i> oss );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>sigaltstack</b> permet  un processus de dfinir une nouvelle
pile spcifique pour les gestionnaires de signaux et/ou de rcuprer
l'tat d'une pile spcifique de signal dj existante. 
Une pile spcifique de signal est utilise durant l'excution d'un 
gestionnaire de signal si la mise en place de ce gestionnaire ( voir
<b>sigaction (2))</b>
le spcifiait.<br/><br/>
La squence d'actions nominale pour utiliser une pile spcifique de signal 
est la suivante :
<br/><br/>

1.
Allouer une zone mmoire qui sera utilise comme pile spcifique 
de signal.
<br/><br/>

2.
Utiliser <b>sigaltstack</b> afin d'informer le systme de l'existence
et de la position de la pile spcifique de signal.
<br/><br/>

3.
Lors de la mise en place du gestionnaire de signal en utilisant
<b>sigaction</b>, informer le systme que ce gestionnaire de 
signal doit tre excut sur la pile spcifique de signal en 
positionnant le drapeau <b>SA_ONSTACK</b>.<br/><br/>
L'argument <i>ss</i> est utilis afin de dfinir
une nouvelle pile spcifique de signal, tandis que
l'argument <i>oss</i> est utilis afin de rcuprer des
informations sur la pile de signal actuellement en place.
Si une seule de ces actions vous intresse,
alors l'autre argument peut tre positionn  NULL.
Chacun de ces paramtres est une structure du type suivant :
<br/><br/>

.RS

typedef struct {
    void  *ss_sp;     /* Adresse de base de la pile*/
    int    ss_flags;  /* drapeaux */
    size_t ss_size;   /* Nombre d'octets dans la pile */
} stack_t;


<br/><br/>
Afin de mettre en place une nouvelle pile spcifique de signal,
<i>ss.ss_flags</i> est positionn  zro, et <i>ss<br/><br/>
_sp</i> et
<i>ss.ss_size</i> spcifient l'adresse de dbut et la taille
de la pile.
La constante <b>SIGSTKSZ</b> est dfinie de faon  tre 
suffisamment grande pour couvrir les besoins typiques en espace mmoire
d'une pile spcifique de signal,
et la constante <b>MINSIGSTKSZ</b> dfinit la taille minimum
ncessaire  l'excution d'un gestionnaire de signal.<br/><br/>
Afin de dsactiver une pile existante, positionnez <i>ss.ss_flags</i>
 <b>SS_DISABLE</b>. Dans ce cas, les autres champs de 
<i>ss</i> sont ignors.<br/><br/>
Si <i>oss</i> ne vaut pas NULL, alors il est utilis afin de renvoyer
des informations sur la pile spcifique de signal qui tait utilise 
avant l'appel  <b>sigaltstack</b>.
Les champs <i>oss.ss_sp</i> et <i>oss.ss_size</i> renvoient l'adresse
de dpart et la taille de cette pile.
Le champ <i>oss.ss_flags</i> peut renvoyer l'une des valeurs suivantes :<br/><br/>
<br/><br/>

<b>SS_ONSTACK</b> <b></b>  Le processus s'excute actuellement sur la pile
spcifique de signal. (Remarquez qu'il n'est pas possible
de changer la pile spcifique de signal si le processus
est en train de s'excuter sur cette dernire.)
<br/><br/>

<b>SS_DISABLE</b> <b></b>  La pile spcifique de signal est actuellement dsactive.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>sigaltstack</b> renvoie 0 en cas de succs, ou -1 en cas d'chec
en positionnant alors <i>errno</i> pour prciser l'erreur.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>ENOMEM</b> <b></b>  La taille de la nouvelle pile spcifique de signal 
indique(<i>ss.ss_size</i>) est infrieure  <b>MINSTKSZ</b>.
<br/><br/>

<b>EFAULT</b> <b></b>  L'un des paramtres <i>ss</i> ou <i>oss</i> ne vaut pas NULL et pointe 
vers une zone mmoire n'appartenant pas  l'espace d'adressage du 
processus.
<br/><br/>

<b>EPERM</b> <b></b>  On a essay de modifier la pile spcifique de signal alors
que celle ci tait active (i.e, le processus tait dj en train
de s'excuter sur la pile spcifique de signal courante).
<br/><br/>

<b>EINVAL</b> <b></b>  <i>ss</i> ne vaut pas NULL et le champ \fPss_flags\fP contient
une valeur non nulle diffrente de SS_DISABLE.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Le segment de code suivant donne un exemple d'utilisation de 
<b>sigaltstack</b>:<br/><br/>
.RS

stack_t ss;<br/><br/>
ss.ss_sp = malloc(SIGSTKSZ);
if (ss.ss_sp == NULL)
    /* Traitement de l'erreur */;
ss.ss_size = SIGSTKSZ;
ss.ss_flags = 0;
if (sigaltstack(&ss, NULL) == -1)
    /* Traitement de l'erreur */;


<br/><br/>
La mise en place d'une pile spcifique de signal est utile si
un processus souponne qu'il est susceptible d'puiser sa pile
standard.
Cela peut se produire, par exemple, lorsque la pile grossit au
point de rencontrer la limite suprieure du tas, ou si elle 
atteint une limite tablie par un appel  <b>setrlimit(RLIMIT_STACK, &rlim)</b>.
Si la pile standard est puise, le noyau envoie au
processus un signal <b>SIGSEGV</b>.
Dans ces circonstances, la seule faon d'intercepter ce signal 
est d'utiliser une pile spcifique de signal.<br/><br/>
Sur la plupart des architectures supportes par Linux, les piles
s'tendent vers les adresses dcroissantes. <b>sigaltstack</b>
prend automatiquement en charge le sens d'expansion de la 
pile. <br/><br/>
Les fonctions appeles depuis un gestionnaire de signal s'excutant
sur une pile spcifique de signal utilisent galement cette pile.
(Cela s'applique galement  tous les gestionnaires invoqus pour 
d'autres signaux alors que le processus s'excute sur la pile spcifique
de signal.)
Contrairement  la pile standard, le systme n'accrot pas
automatiquement la pile spcifique de signal.
Dpasser la taille alloue pour la pile spcifique de signal 
conduit  des rsultats imprvisibles.<br/><br/>
Un appel <b>execve</b> russi dtruit toutes piles spcifiques de 
signal existantes.<br/><br/>
<b>sigaltstack</b> succde  l'ancien appel <b>sigstack</b>.
Pour des raisons de compatibilit, la glibc implante
<b>sigstack</b>.
Toutes les nouvelles applications devraient tre crites en utilisant
<b>sigaltstack</b>.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">historique</h1>
<div class="paragraph">
BSD 4.2 possdait un appel systme <i>sigstack</i>(). Il utilisait 
une structure lgrement diffrente, et avait comme dsavantage 
principal la ncessit pour  l'appelant de connatre le sens 
d'expansion de la pile.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">conformit</h1>
<div class="paragraph">
SUSv2, SVr4, POSIX 1003.1-2001.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>sigaction (2),</b>
<b>setrlimit (2),</b>
<b>execve (2),</b>
<b>sigsetjmp (3),</b>
<b>siglongjmp (3),</b>
<b>signal (7)</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Stphan Rafin, 2002.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
