<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) 2002 Michael Kerrisk &lt;mtk16@ext.canterbury.ac.nz&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.   -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  added note on self-signalling, aeb, 2002-06-07 -->
<!--  -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 18/07/2003 LDP-1.56 -->
<br/><h1>SIGQUEUE</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
sigqueue - Enregistrer un signal et des donnes pour un processus
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;signal.h&gt;</b> <b></b>  <br/><br/>

<b>int sigqueue(pid_t </b> pid <i>, int </i> sig <b>, const union sigval </b> valeur <i>);
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>sigqueue ()</b>
envoie le signal
<i>sig</i> au processus indiqu par
<i>pid .</i>
Les permissions requises pour l'mission du signal sont les mme que pour
<b>kill (2).</b>
Comme avec
<b>kill (2),</b>
le signal nul (0) peut servir  vrifier si un processus existe
avec un PID donn.<br/><br/>
L'argument
<i>valeur</i> sert  indiquer une donne (soit un entier, soit un pointeur) qui accompagnera
le signal et se prsente avec le type suivant&nbsp;:
<br/><br/>

.in +2n

union sigval {
    int   sival_int;
    void *sival_ptr;
};


.in -2n<br/><br/>
Si le processus rcepteur a install un gestionnaire pour le signal avec l'option
<b>SA_SIGINFO</b> <b></b>  lors du
<b>sigaction (2),</b>
il pourra obtenir la donne dans le champ
<i>si_value</i> de la structure
<i>siginfo_t</i> passe en second argument au gestionnaire.
De plus, le champ
<i>si_code</i> de la structure contiendra
<b>SI_QUEUE .</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
L'appel
<b>sigqueue ()</b>
renvoie s'il russit, indiquant que le signal a bien t
mis dans la file du processus rcepteur.
Sinon il renvoie -1 ete
<i>errno</i> contient le code de l'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EAGAIN</b> <b></b>  La limite du nombre de signaux en file a t atteinte.
(Voir
<b>signal (7)</b>
pour plus d'informations).
<br/><br/>

<b>EINVAL</b> <b></b>  <i>sig</i> est invalide.
<br/><br/>

<b>ESRCH</b> <b></b>  Il n'y a pas de processus correspondan au
<i>pid .</i>
<br/><br/>

<b>EPERM</b> <b></b>  Le processus n'a pas la permission d'envoyer un signal
au processus vis.
(Voir
<b>kill (2)</b>
pour plus d'informations).
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Si l'appel consiste  envoyer un signal au processus qui l'a invoqu,
et si le signal n'est pas bloqu par le thread appelant, et si aucun autre
thread ne peut traiter le signal (soit en l'ayant
dbloqu, ou en faisant une attente avec
<b>sigwait (3)),</b>
alors au moins quelques signaux seront dlivrs au thread appelant avant
que la fonction ne revienne.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
POSIX 1003.1-2001
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>kill (2),</b>
<b>sigaction (2),</b>
<b>signal (2),</b>
<b>sigwait (3),</b>
<b>signal (7)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
