<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) 2002 Michael kerrisk &lt;mtk16@ext.canterbury.ac.nz&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--  -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein. -->
<!--  -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction Christophe Blaess &lt;ccb@lub-internet.fr&gt; -->
<!--  MJ 18/07/2003   LDP1.56 -->
<br/><h1>SIGWAITINFO</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
sigwaitinfo, sigtimedwait - Attente synchrone de signaux.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;signal.h&gt;</b> <b></b>  <br/><br/>

<b>int sigwaitinfo(const sigset_t *</b> set <i>, siginfo_t *</i> info <b>);</b>
<br/><br/>

<b>int sigtimedwait(const sigset_t *</b> set <i>, siginfo_t *</i> info <b>, </b>
<b>const struct timespec </b> timeout <i>);</i>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>sigwaitinfo ()</b>
suspend l'excution du processus appelant jusqu' ce que l'un des signaux
de l'ensemble
<i>set</i> soit reu. (Si l'un des signaux de l'ensemble
<i>set</i> est dj en attente pour le processus appelant,
<b>sigwaitinfo ()</b>
revient immdiatement avec les informations concernant le signal).<br/><br/>
<b>sigwaitinfo ()</b>
retire le signal de la liste des signaux en attente pour le processus, 
et renvoie le numro du signal en retour de fonction.
Si l'argument
<i>info</i> n'est pas
<b>NULL ,</b>
alors il sera rempli avec une structure du type
<i>siginfo_t</i> (voir
<b>sigaction (2))</b>
contenant les informations concernant le signal.<br/><br/>
Les signaux reus via
<b>sigwaitinfo ()</b>
sont dlivrs dans l'ordre habituel, voir
<b>signal (7)</b>
pour plus de dtails.<br/><br/>
<b>sigtimedwait ()</b>
opre exactement commee
<b>sigwaitinfo ()</b>
mais elle a un argument supplmentaire,
<i>timeout ,</i>
qui permet de fixer une limite maximale au temps
d'attente.
Cet argument est du type&nbsp;:
<br/><br/>

.in +2n

struct timespec {
    long    tv_sec;         /* secondes */
    long    tv_nsec;        /* nanosecondes */
}


.in -2n
<br/><br/>

Si les deux champs de cette structure sont nuls, 
<b>sigtimedwait ()</b>
revient tout de suite, soit avec des informations sur un signal dj en
attente, soit avec une erreur si aucun
signaux de l'ensemble
<i>set</i> n'taient disponibles.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
S'ils russissent
<b>sigwaitinfo ()</b>
et
<b>sigtimedwait ()</b>
renvoient un numro de signal (une valeur suprieure  zro).
S'ils chouent, ils renvoient -1, et
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EAGAIN</b> <b></b>  Aucun signal de l'ensemble
<i>set</i> n'a t reu avant expiration du dlai
<i>timeout</i> indiqu pour
<b>sigtimedwait ().</b>
<br/><br/>

<b>EINVAL</b> <b></b>  <i>timeout</i> etait invalide.
<br/><br/>

<b>EINTR</b> <b></b>  L'appel a t interrompu par un gestionaire de signal
(un signal autre que ceux prsents dans l'ensemble
<i>set .)</i>
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
En utilisation habituelle, l'appelant bloque les signaux de l'ensemble
<i>set</i> au pralable avec un appel
<b>sigprocmask ()</b>
(afin que la dlivrance des signaux ne se produise pas en dehors
de l'appel
<b>sigwaitinfo ()</b>
ou
<b>sigtimedwait())</b>
et n'installe pas de gestionnaire pour ces signaux.<br/><br/>
POSIX ne spcifie as le comportement si une valeur
<b>NULL</b> <b></b>  est indique pour l'argument
<i>timeout</i> de
<b>sigtimedwait ()</b>
permettant par exemple d'avoir le mme comportement
que celui de
<b>sigwaitinfo (),</b>
ce qui est le cas sous Linux.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
POSIX 1003.1-2001
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>kill (2),</b>
<b>sigaction (2),</b>
<b>signal (2),</b>
<b>sigpending (2),</b>
<b>sigprocmask (2),</b>
<b>sigqueue (2),</b>
<b>signal (7),</b>
<b>sigsetops (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
