<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 1996 Andries Brouwer (aeb@cwi.nl) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Written 11 April 1996 by Andries Brouwer (aeb@cwi.nl) -->
<!--  960412: Added comments from Stephen Tweedie -->
<!--  -->
<!--  Traduction 15/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a Jour 15/04/97 -->
<!--  mj 11/12/1997 (LDP man-pages 1.18) -->
<!--  mj 25/04/98 (LDP man-pages 1.19) -->
<!--  mj 18/07/03 (LDP man-pages 1.56) -->
<br/><h1>SYSCTL</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">exemple</a>
<br /><a class="summaryIndent0" href="#L4">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L5">erreurs</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">bogues</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
sysctl - Lire / crire les paramtres systme.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <br/><br/>

<b>#include</b> <b></b>  <b>&lt;linux/unistd.h&gt;</b> <b></b>  <br/><br/>

<b>#include</b> <b></b>  <b>&lt;linux/sysctl.h&gt;</b> <b></b>  <br/><br/>

<b>_syscall1(int</b> <b></b> ,<b></b>  <b>_sysctl</b> <b></b> ,<b></b>  <b>struct</b> <b></b>  <b>__sysctl_args</b> <b></b>  <b>*</b> <b></b> ,<b></b>  <b>args);</b> <b></b>  <br/><br/>

<b>int _sysctl(struct __sysctl_args *</b> args );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
L'appel systme
<b>_sysctl</b> <b></b>  lit et/ou crit les paramtres du noyau. Par exemple le nom d'hte
ou le nombre maximum de fichiers ouverts. L'argument a la forme<br/><br/>

struct __sysctl_args {
        int *name;        /* integer vector describing variable */
        int nlen;         /* length of this vector */
        void *oldval;     /* 0 or address where to store old value */
        size_t *oldlenp;  /* available room for old value,
                             overwritten by actual size of old value */
        void *newval;     /* 0 or address of new value */
        size_t newlen;    /* size of new value */
};

<br/><br/>
Cet appel effectue une recherche dans la structure arborescente
regroupe sous le repertoire
<b>/proc/sys ,</b>
puis,
si les valeurs rclames y sont trouves, appelle les routines
appropries pour lire ou modifier les valeurs.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">exemple</h1>
<div class="paragraph">

#include &lt;linux/unistd.h&gt;
#include &lt;linux/types.h&gt;
#include &lt;linux/sysctl.h&gt;<br/><br/>
_syscall1(int, _sysctl, struct __sysctl_args *, args);
int sysctl(int *name, int nlen, void *oldval, size_t *oldlenp,
           void *newval, size_t newlen)
{
        struct __sysctl_args args={name,nlen,oldval,oldlenp,newval,newlen};
        return _sysctl(&args);
}<br/><br/>
#define SIZE(x) sizeof(x)/sizeof(x[0])
#define OSNAMESZ 100<br/><br/>
char osname[OSNAMESZ];
int osnamelth;
int name[] = { CTL_KERN, KERN_OSTYPE };<br/><br/>
main(){
        osnamelth = SIZE(osname);
        if (sysctl(name, SIZE(name), osname, &osnamelth, 0, 0))
                perror("sysctl");
        else
                printf("Cette machine fonctionne avec %*s\en", osnamelth, osname);
        return 0;
}

<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">valeur renvoye</h1>
<div class="paragraph">
<b>_sysctl</b> <b></b>  renvoie 0 s'il russit, et -1 s'il choue auquel cas
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L6">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>ENOTDIR</b> <b></b>  <i>name</i> non trouv
<br/><br/>

<b>EPERM</b> <b></b>  pas de droits de parcours sur l'un des "rpertoires" rencontrs, 
ou pas de permission de lecture avec
<i>oldval</i> non nul, ou encore pas de permission d'criture avec
<i>newval</i> non nul.
<br/><br/>

<b>EFAULT</b> <b></b>  Demande de lecture de la valeur prcdente en fournissant
<i>oldval</i> non NULL, mais pas de place disponible dans
<i>oldlenp .</i>
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
Cet appel systme est spcifique Linux et ne doit pas tre employ 
dans les programmes destins  tre portables.
Un appem
<b>sysctl</b> <b></b>  est prsent dans Linux depuis la version 1.3.57. Il existait
dans BSD 4.4. Seul Linux dispose du mirroir
<i>/proc/sys</i> et les conventions de noms d'objets diffrent entre Linux et BSD 4.4,
mais les dclarations de la fonction
<b>sysctl (2)</b>
sont identiques sur les deux systmes.
</div><br/><br /><h1 class="TitreSection0" id="L8">bogues</h1>
<div class="paragraph">
Les noms des objets peuvent varier d'une version  l'autre du noyau.
CET APPEL-SYSTEME N'A AUCUN INTERET POUR LES APPLICATIONS. Utilisez
l'interface
<i>/proc/sys</i>  la place.
<br/>
Tous les objets disponibles ne sont pas proprement documents.
<br/>
Il n'est pas possible de changer de systme d'exploitation en crivant dans
<i>/proc/sys/kernel/ostype .</i>
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>proc (5)</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
