<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  -*- nroff -*- -->
<!--  -->
<!--  (C)opyright 1993 by Dan Miner (dminer@nyx.cs.du.edu) -->
<!--  -->
<!--   Permission is granted to freely distribute or modify this file -->
<!--   for the purpose of improving Linux or its documentation efforts. -->
<!--   If you modify this file, please put a date stamp and HOW you -->
<!--   changed this file.  Thanks.   -DM -->
<!--  -->
<!--  Modified Sat Jul 24 12ai:35:12 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 15/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a Jour 15/04/97 -->
<!--  Mise  jour 12/12/1998 - LDP-man-pages-1.21 -->
<!--  Mise  jour 27/06/2000 - LDP-man-pages-1.30 -->
<!--  Mise  jour 18/07/2003 - LDP-man-pages-1.56 -->
<br/><h1>SYSINFO</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
sysinfo - Obtenir des informations statistiques sur le systme.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/sysinfo.h&gt;</b> <b></b>  <br/><br/>

<b>int sysinfo(struct sysinfo *</b> info );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Jusqu'au noyau 2.3.16,
<b>sysinfo</b> <b></b>  renvoyait les informations dans la structure suivante&nbsp;:<br/><br/>
.RS

struct sysinfo {
  long uptime;             /* Secondes coules depuis le boot.*/
  unsigned long loads[3];  /* Charges depuis 1, 5, et 15 mn.   */
  unsigned long totalram;  /* Mmoire totale du systme.       */
  unsigned long freeram;   /* Mmoire disponible.              */
  unsigned long sharedram; /* Mmoire partage.                */
  unsigned long bufferram; /* Mmoire utilise par les buffers */
  unsigned long totalswap; /* Taille totale du swap.           */
  unsigned long freeswap;  /* Espace disponible dans le swap.  */
  unsigned short procs;    /* Nombre de processus actuels.     */
  char          _f[22];    /* Remplissage jusqu' 64 octets.   */
};


<br/><br/>
et les tailles taient fournies en octets. Depuis le noyau 2.3.23 (i386) et
2.3.48 (toutes architectures), la structure est devenue :<br/><br/>
.RS

struct sysinfo {
  long uptime;             /* Secondes coules depuis le boot.*/
  unsigned long loads[3];  /* Charges depuis 1, 5, et 15 mn.   */
  unsigned long totalram;  /* Mmoire totale du systme.       */
  unsigned long freeram;   /* Mmoire disponible.              */
  unsigned long sharedram; /* Mmoire partage.                */
  unsigned long bufferram; /* Mmoire utilise par les buffers */
  unsigned long totalswap; /* Taille totale du swap.           */
  unsigned long freeswap;  /* Espace disponible dans le swap.  */
  unsigned short procs;    /* Nombre de processus actuels.     */
  unsigned long totalhigh; /* Taille totale mmoire haute.     */
  unsigned long freehigh;  /* Taille mmoire haute libre.      */
  usigned int   mem_unit;  /* Taille de bloc mmoire en octets */
  char _f [20 - 2*sizeof(long) - sizeof(int)];  /* remplissage */
};


<br/><br/>
et les tailles sont indiqus sous forme de multiples de <i>mem_unit</i>.<br/><br/>
<b>sysinfo</b> <b></b>  permet d'obtenir facilement des statistiques systmes. C'est
plus portable que la lecture de <i>/dev/kmem</i>.
Pour avoir un exemple d'utilisation, reportez-vous 
<b>intro (2).</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>sysinfo</b> <b></b>  renvoie 0 s'il russit et -1 s'il choue auquel cas
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EFAULT</b> <b></b>  <i>struct&nbsp;sysinfo</i> pointe en dehors de l'espace d'adressage accessible.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
Cette fonction est spcifique Linux et ne doit pas tre employe dans des
programmes destins  tre portables.
<br/><br/>

Le noyau Linux dispose d'un appel-systme <b>sysinfo</b> depuis la version
0.98pl6. La bibliothque libc de Linux contient une routine <b>sysinfo</b>()
depuis la version 5.3.5, et la bibliothque glibc depuis 1.90.
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>proc (5)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
