<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright (c) 1992 Drew Eckhardt (drew@cs.colorado.edu), March 28, 1992 -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Modified by Michael Haardt (u31b3hs@pool.informatik.rwth-aachen.de) -->
<!--  Modified Sat Jul 24 14:29:17 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 15/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a jour 25/01/97 -->
<!--  Mise a Jour 15/04/97 -->
<!--  Mise a Jour 04/06/2001  LDP-man-pages-1.36 -->
<!--  Mise a Jour 18/07/2003  LDP-man-pages-1.56 -->
<br/><h1>TIMES</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">notes</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">historique</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
times - Obtenir les statistiques temporelles du processus.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/times.h&gt;</b> <b></b>  <br/><br/>

<b>clock_t times(struct tms *</b> buf );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>times ()</b>
stocke les dures statistiques du processus en cours dans la structure
<b>struct</b> <b></b>  <b>tms"</b> <b></b>  pointe par
<i>buf .  </i>
La structure
<i>struct tms</i> est dfinie ainsi dans
<i>/usr/include/sys/times.h :</i>
<br/><br/>


struct  tms  {
.RS
clock_t tms_utime;  /* dure utilisateur          */
clock_t tms_stime;  /* dure systme              */
clock_t tms_cutime; /* dure utilisateur des fils */
clock_t tms_cstime; /* dure systme des fils     */

};

<br/><br/>
Le champ 
<i>tms_utime</i> contient le temps CPU coul en excutant les instructions du processus
appelant.
Le champ
<i>tms_stime</i> contient le temps CPU pass dans les fonctions systme excutes pour le
compte du processus appelant.
Le champ
<i>tms_cutime</i> contient la somme des valeurs de
<i>tms_utime</i> et
<i>tms_cutime</i> pour tous les processus fils termins ayant t attendus.
Le champ
<i>tms_cstime</i> contient la somme des valeurs de
<i>tms_stime</i> et
<i>tms_cstime</i> pour tous les processus fils termins ayant t attendus.<br/><br/>
Les dures des processus fils termins (et de leurs descendants) sont
ajoutes au moment o 
<b>wait (2)</b>
ou
<b>waitpid(2)</b>
renvoient leur numro de PID. En particulier, les dures des petits-fils
que le fils n'a pas attendu ne sont jamais vues.<br/><br/>
Toutes les dures sont exprimes en ticks d'horloge.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>times</b> <b></b>  renvoie le nombre de tops d'horloge couls depuis un instant arbitraire dans
le pass. Sous Linux, il s'agit du dmarrage du systme.  Cette valeur peut
dborder de l'intervalle contenu dans un clock_t.
En cas d'erreur (clock_t) -1 est renvoy et
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">notes</h1>
<div class="paragraph">
Le nombre de ticks d'horloge par seconde peut tre obtenu en consultant
.RS
sysconf(_SC_CLK_TCK);

Dans POSIX-1996, le symbole CLK_TCK (dfini dans
<i>&lt;time.h&gt; )</i>
est indiqu en voie d'obsolescence. Il est dsormais obsolte.<br/><br/>
Sous Linux, si le traitement de SIGCHLD est configur avec
<b>SIG_IGN</b> <b></b>  alors les dures des enfants termins sont automatiquement
incluses dans les champs
<i>tms_cstime</i> et
<i>tms_cutime ,</i>
bien que POSIX 1003.1-2001 prcise que ceci ne doit se produire
que si le processus appelant a fait un
<b>wait ()</b>
pour ses enfants.
<!--  See the description of times() in XSH, which says: -->
<!--      The times of a terminated child process are included... when wait() -->
<!--      or waitpid() returns the process ID of this termianted child. --><br/><br/>
Notez que
<b>clock (3)</b>
renvoie des valeurs de types clock_t qui ne sont pas mesures en ticks
d'horloges mais en CLOCKS_PER_SEC.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
SVr4, SVID, POSIX, X/OPEN, BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L7">historique</h1>
<div class="paragraph">
SVr1-3 renvoit un
<b>long</b> <b></b>  et les membres de la structure sont de type
<b>time_t</b> <b></b>  bien qu'ils stockent des ticks et pas des secondes depuis le 1er janvier 1970.
V7 utilisait des
<b>long</b> <b></b>  pour les membres des structures, car il n'avait pas encore de type
<b>time_t .<br/><br/></b>
Sur les anciens systmes, le nombre de ticks d'horloge par seconde est donn
par la variable HZ.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>time (1),</b>
<b>getrusage (2),</b>
<b>wait (2),</b>
<b>clock (3),</b>
<b>sysconf (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
