<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 1995, Thomas K. Dyas &lt;tdyas@eden.rutgers.edu&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Created   Wed Aug  9 1995      Thomas K. Dyas &lt;tdyas@eden.rutgers.edu&gt; -->
<!--  -->
<!--  Traduction 15/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a Jour 15/04/97 -->
<!--  Mise  jour 04/06/2001 - LDP-man-pages-1.36 -->
<!--  Mise  jour 18/07/2003 - LDP-man-pages-1.56 -->
<br/><h1>USTAT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
ustat - Obtenir les statistiques sur le systme de fichiers.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <br/>
<b>#include &lt;unistd.h&gt;</b> <b>    /* libc[45] */</b></b>
<br/>
<b>#include &lt;ustat.h&gt;</b> <b>     /* glibc2 */</b></b>
<br/><br/>
 
<b>int ustat(dev_t </b> dev <i>, struct ustat * </i> ubuf );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>ustat</b> <b></b>  renvoie des informations sur un systme de fichiers mont.
<i>dev</i> est le numro de priphrique contenant le systme de fichiers mont.
<i>ubuf</i> est un pointeur sur une structure ustat dfinie ainsi :<br/><br/>
<br/><br/>

.RS

.ne 7
.ta 8n 16n 32n
daddr_t	f_tfree;	/* Total free blocks */
ino_t	f_tinode;	/* Number of free inodes */
char	f_fname[6];	/* Filsys name */
char	f_fpack[6];	/* Filsys pack name */
.ta


<br/><br/><br/><br/>
Les deux derniers champs, f_fname et f_fpack, ne sont pas implments
actuellement et sont remplis avec des caractres nuls.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>ustat</b> <b></b>  renvoie zro s'il russit, et la structure pointe par
<i>ubuf</i> sera remplie. S'il choue l'appel systme renvoie -1 et
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EINVAL</b> <b></b>  <i>dev</i> n'est pas un priphrique contenant un systme de fichiers mont.
<br/><br/>

<b>EFAULT</b> <b></b>  <i>ubuf</i> pointe en-dehors de l'espace d'adressage accessible.
<br/><br/>

<b>ENOSYS</b> <b></b>  Le systme de fichiers mont indiqu par
<i>dev</i> ne permet pas cette opration. (Cette erreur est aussi
produite par tous les noyaux Linux antrieurs au 1.3.16)
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
<b>ustat</b> <b></b>  est fourni  titre de compatibilit, les nouveaux programmes
devraient utiliser
<b>statfs (2)</b>
 la place.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SVr4. SVr4 mentionne les conditions d'erreur supplmentaires ENOLINK, ECOMM,
et EINTR, mais n'indique pas l'erreur ENOSYS.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>statfs (2),</b>
<b>stat (2) </b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
