<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  This manpage is Copyright (C) 1992 Drew Eckhardt; -->
<!--                                1993 Michael Haardt, Ian Jackson. -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Modified Sat Jul 24 13:35:59 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  Modified Sun Nov 28 17:19:01 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  Modified Sat Jan 13 12:58:08 MET 1996 by Michael Haardt (michael@cantor.informatik.rwth-aachen.de) -->
<!--   -->
<!--  Traduction  12/10/1996 Christophe BLAESS (ccb@club-internet.fr) -->
<!--  Mise a Jour 15/04/97 -->
<!--  Mise  jour 13/11/99 (LDP-man-pages 1.24) -->
<!--  Mise  jour 04/06/2001 (LDP-man-pages 1.36) -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.37 -->
<!--  Mise  jour 20/01/2002 - LDP-man-pages-1.47 -->
<!--  Mise  jour 18/07/2003 - LDP-man-pages-1.56 -->
<br/><h1>WRITE</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
write - crire dans un descripteur de fichier.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <br/><br/>

<b>ssize_t write(int </b> fd <i>, const void *</i> buf <b>, size_t </b> count );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>write</b> <b></b>  crit jusqu'
<i>count</i> octets dans le fichier associ au descripteur
<i>fd</i> depuis le buffer point par
<i>buf.</i> POSIX rclame qu'une lecture avec <b>read()</b> effectue aprs le
retour d'une criture avec <b>write()</b>, renvoie les nouvelles
donnes. Notez que tous les systmes de fichiers ne sont pas
compatibles avec POSIX.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>write</b> <b></b>  renvoie le nombre d'octets crits (0 signifiant aucune criture), 
ou -1 s'il choue,
auquel cas
<i>errno</i> contient le code d'erreur.
Si <i>count</i> vaut zro, et si le descripteur est associ  un
fichier normal, 0 sera renvoy sans effets de bord. Pour un
fichier spcial, les rsultats ne sont pas portables.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EBADF</b> <b></b>  <i>fd</i> n'est pas un descripteur de fichier valide, ou n'est pas ouvert
en criture.
<br/><br/>

<b>EINVAL</b> <b></b>  <i>fd</i> correspond  un objet ne permettant pas l'criture.
<br/><br/>

<b>EFAULT</b> <b></b>  <i>buf</i> pointe en dehors de l'espace d'adressage accessible.
<br/><br/>

<b>EFBIG</b> <b></b>  Tentative d'crire un fichier dont la taille dpasse un maximum dpendant
de l'implmentation ou du processus, ou d'crire  une position qui dpasse
le dplacement maximal autoris.
<br/><br/>

<b>EPIPE</b> <b></b>  <i>fd</i> est connect  un tube (pipe) ou une socket dont l'autre extrmit est
ferme. Quand ceci se produit, le processus crivain reoit un signal
<b>SIGPIPE</b> <b></b>  <b>.</b> <b></b>  S'il intercepte, bloque ou ignore ce signal, 
<b>EPIPE</b> <b></b>  est renvoy.
<br/><br/>

<b>EAGAIN</b> <b></b>  L'criture est non-bloquante (attribut
<b>O_NONBLOCK</b> <b></b>  du descripteur), et l'opration devrait bloquer.
<br/><br/>

<b>EINTR</b> <b></b>  L'appel systme a t interrompu par un signal avant d'avoir pu crire
quoique ce soit.
<br/><br/>

<b>ENOSPC</b> <b></b>  Le priphrique correspondant  
<i>fd</i> n'a plus de place disponible.
<br/><br/>

<b>EIO</b> <b></b>  Une erreur d'entre/sortie bas niveau s'est produite durant la modification
de l'i-noeud.<br/><br/>
D'autres erreurs peuvent se produire suivant le type d'objet associ 
<i>fd .</i>
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
SVr4, SVID, POSIX, X/OPEN, BSD 4.3.  SVr4 mentionne des conditions d'erreur
supplmentaires EDEADLK, ENOLCK, ENOLNK, ENOSR, ENXIO, EPIPE, et ERANGE.
Sous SVr4, un appel <b>write</b>() peut tre interrompu, et renvoyer EINTR 
n'importe quel moment, pas seulement avant l'criture des donnes.
</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
Une russite de
<b>write</b> <b></b>  n'offre aucune garantie que les donnes se trouvent sur le disque.
En fait, sur certaines implmentations errones, elle ne garantie mme pas
que l'espace suffisant a t rserv pour les donnes.
La seule manire d'tre sr de la russite est d'invoquer
<b>fsync (2)</b>
aprs avoir crit les donnes.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>close (2),</b>
<b>fcntl (2), </b>
<b>fsync (2),</b>
<b>ioctl (2), </b>
<b>lseek (2),</b>
<b>open (2),</b>
<b>read (2), </b>
<b>select (2),</b>
<b>fwrite (3),</b>
<b>writev (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
