<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Mon Mar 29 22:31:13 1993, David Metcalfe -->
<!--  Modified Sun Jun  6 23:27:50 1993, David Metcalfe -->
<!--  Modified Sat Jul 24 21:45:37 1993, Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 22/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise  jour 04/06/2001 - LDP-man-pages-1.36 -->
<!--  Mise  jour 18/07/2003 - LDP-man-pages-1.56 -->
<br/><h1>ABS</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">conformit</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
abs, labs, llabs, imaxabs - Calcule la valeur absolue d'un entier.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdlib.h&gt;</b> <b></b>  <br/><br/>

<b>int abs (int </b> j );
<br/>
<b>long int labs(long int </b> j );
<br/>
<b>long long int llabs(long long int </b> j );
<br/><br/>

<b>#include</b> <b></b>  <b>&lt;inttypes.h&gt;</b> <b></b>  <br/><br/>

<b>intmax_t imaxabs(intmax_t </b> j );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>abs()</b> calcule la valeur absolue de l'argument entier <i>j</i>.
Les fonctions <b>labs()</b>, <b>llabs()</b> et <b>imaxabs()</b> calculent les
valeurs absolues de leurs arguments <i>j</i> du type entier appropri pour
la fonction.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Chaque fonction renvoie la valeur absolue de son argument.
</div><br/><br /><h1 class="TitreSection0" id="L5">conformit</h1>
<div class="paragraph">
SVID 3, POSIX, BSD 4.3, ISO/IEC 9899. POSIX.1 (dition 1996) ne demande
que la fonction <b>abs()</b>. ISO/IEC 9899:1990 (C89) n'inclue que
<b>abs()</b> et <b>labs()</b>. Les fonctions <b>llabs()</b> et <b>imaxabs()</b>
ont t ajoutes dans C99.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
La valeur absolue du nombre entier ngatif le plus petit est indfinie, car le
codage d'entier sign sur n bits offre un intervalle de valeurs allant de
-2^(n-1)  2^(n-1) - 1.<br/><br/>
La fonction <b>llabs()</b> est incluse dans la GlibC depuis la version 2.0, mais
pas dans LibC 5 et LibC 4. La fonction <b>imaxabs()</b> est incluse dans la
GlibC depuis la version 2.1.1.<br/><br/>
Pour que <b>llabs()</b> soit dclare, il peut tre ncessaire de dfinir
<b>_ISOC99_SOURCE</b> ou <b>_ISOC9X_SOURCE</b> (suivant la version de GlibC)
avant l'inclusion des fichiers d'entte standard.<br/><br/>
GCC traite <b>abs()</b> et <b>labs()</b> comme des fonctions internes.
GCC 3.0 traite galement <b>llabs()</b> et <b>imaxabs()</b> comme des
fonctions internes.
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>ceil (3),</b>
<b>floor (3),</b>
<b>fabs (3),</b>
<b>rint (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
