<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  (c) 2000 by Michael Kerrisk (michael.kerrisk@gmx.net) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  License. -->
<!--  Created, 14 Dec 2000 by Michael Kerrisk -->
<!--  Traduction 04/06/2001 par Christophe Blaess (ccb@club-internet.fr) -->
<!--             LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>BASENAME</h1>
<br /><a class="summaryIndent0" href="#L0">non</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">exemple</a>
<br /><a class="summaryIndent0" href="#L4">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L5">bogues</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">non</h1>
<div class="paragraph">
basename, dirname - Analyse des composants d'un chemin d'accs.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;libgen.h&gt;</b> <b></b>  <br/><br/>

<b>char *basename(char </b> <i>*chemin</i> );
.nl
<b>char *dirname(char </b> <i>*chemin</i> );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les fonctions
<b>basename</b> <b></b>  et
<b>dirname</b> <b></b>  dcomposent une chane termine par un caractre nul, reprsentant un chemin
d'accs en ses composants rpertoire et nom de fichier.
En gnral,
<b>dirname</b> <b></b>  renvoie la chane s'tendant jusqu'au dernier '/', non compris, et
<b>basename</b> <b></b>  renvoie la partie se trouvant aprs le dernier '/'.
Les caractres '/' en fin de chane ne font pas partie du chemin.<br/><br/>
Si le
<i>chemin</i> ne contient pas de slash,
<b>dirname</b> <b></b>  renvoie la chane "." et
<b>basename</b> <b></b>  renvoie une copie de la chane
<i>chemin .</i>
Si le
<i>chemin</i> est reprsent par la chane "/", alors
<b>dirname</b> <b></b>  et
<b>basename</b> <b></b>  renvoient tout deux la chane "/".
Si le
<i>chemin</i> est un pointeur NULL, ou pointe vers une chane vide, alors
<b>dirname</b> <b></b>  et
<b>basename</b> <b></b>  renvoient tout deux la chane "."<br/><br/>
En mettant bout  bout la chane renvoye par
<b>dirname ,</b>
un "/", et la chane renvoye par
<b>basename ,</b>
on obtient un chemin d'accs complet.<br/><br/>
Autant
<b>dirname</b> <b></b>  que
<b>basename</b> <b></b>  peuvent modifier le contenu de la chane
<i>chemin ,</i>
aussi si vous devez conserver la chane originale, il
faut leur transmettre des copies de la chane. De plus,
<b>dirname</b> <b></b>  et
<b>basename</b> <b></b>  peuvent renvoyer des pointeurs sur des zones mmoires alloues
statiquement, qui peuvent tre crases par des appels conscutifs.<br/><br/>
La liste suivante d'exemple (prise dans SUSv2) 
montre les chanes renvoyes par
<b>dirname</b> <b></b>  et
<b>basename</b> <b></b>  pour diffrents chemin d'accs :
<br/><br/>


<b></b>  chemin      dirname  basename
"/usr/lib"  "/usr"   "lib"
"/usr/"     "/"      "usr"
"usr"       "."      "usr"
"/"         "/"      "/"
"."         "."      "."
".."        "."      ".."


</div><br/><br /><h1 class="TitreSection0" id="L4">exemple</h1>
<div class="paragraph">

char *dirc, *basec, *bname, *dname;
char *chemin = "/etc/passwd";<br/><br/>
dirc = strdup(chemin);
basec = strdup(chemin);
dname = dirname(dirc);
bname = basename(basec);
printf("dirname=%s, basename=%s\\n", dname, bname);
free(dirc);
free(basec);


</div><br/><br /><h1 class="TitreSection0" id="L5">valeur renvoye</h1>
<div class="paragraph">
Les fonctions
<b>dirname</b> <b></b>  et
<b>basename</b> <b></b>  renvoient des pointeurs sur des chanes termines par un caractre nul.
</div><br/><br /><h1 class="TitreSection0" id="L6">bogues</h1>
<div class="paragraph">
Dans les versions de la GlibC jusqu' 2.2.1 comprise,
<b>dirname</b> <b></b>  ne grait pas correctement les chemins se terminant par un caractre '/'
et dclenchait une erreur de segmentation en recevant un pointeur NULL.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SUSv2
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>dirname (1),</b>
<b>basename (1),</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2001-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
