<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) 1990, 1993 -->
<!-- 	The Regents of the University of California.  All rights reserved. -->
<!--  -->
<!--  Redistribution and use in source and binary forms, with or without -->
<!--  modification, are permitted provided that the following conditions -->
<!--  are met: -->
<!--  1. Redistributions of source code must retain the above copyright -->
<!--     notice, this list of conditions and the following disclaimer. -->
<!--  2. Redistributions in binary form must reproduce the above copyright -->
<!--     notice, this list of conditions and the following disclaimer in the -->
<!--     documentation and/or other materials provided with the distribution. -->
<!--  3. All advertising materials mentioning features or use of this software -->
<!--     must display the following acknowledgement: -->
<!-- 	This product includes software developed by the University of -->
<!-- 	California, Berkeley and its contributors. -->
<!--  4. Neither the name of the University nor the names of its contributors -->
<!--     may be used to endorse or promote products derived from this software -->
<!--     without specific prior written permission. -->
<!--  -->
<!--  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND -->
<!--  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE -->
<!--  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE -->
<!--  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE -->
<!--  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL -->
<!--  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS -->
<!--  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) -->
<!--  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT -->
<!--  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY -->
<!--  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF -->
<!--  SUCH DAMAGE. -->
<!--  -->
<!-- 	@(#)btree.3	8.4 (Berkeley) 8/18/94 -->
<!--  -->
<!--  Traduction 06/05/1999 par Christophe Blaess (ccb@club-internet.fr) -->
<!--                        LDP-man-pages-1.23 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>BTREE</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">erreurs</a>
<br /><a class="summaryIndent0" href="#L4">voir aussi</a>
<br /><a class="summaryIndent0" href="#L5">bogues</a>
<br /><a class="summaryIndent0" href="#L6">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
btree - Mthodes d'accs  une base de donnes en arbre binaire.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

.ft B
#include &lt;sys/types.h&gt;
#include &lt;db.h&gt;
.ft R


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La routine
<i>dbopen</i>
est l'interface de bibliothque pour les fichiers de base de donnes.
L'un des formats de fichier supports est le type des arbres binaires.
La description gnrale des mthodes d'accs  une base de donnes
est fournie dans la page de manuel
<i>dbopen (3).</i>
La page prsente ne dcrit que les informations spcifiques aux arbres
binaires.<br/><br/>
Une telle structure de donnes est un arbre quilibr, tri, mmorisant
les paires cls-donnes associes. <br/><br/>
La structure de donnes spcifique aux mthodes d'accs aux arbres binaires,
et que l'on transmet 
<i>dbopen</i> est dfinie dans le fichier d'en-tte &lt;db.h&gt; ainsi :<br/><br/>
typedef struct {
.RS
u_long flags;
<br/>
u_int cachesize;
<br/>
int maxkeypage;
<br/>
int minkeypage;
<br/>
u_int psize;
<br/>
int (*compare)(const DBT *key1, const DBT *key2);
<br/>
size_t (*prefix)(const DBT *key1, const DBT *key2);
<br/>
int lorder;

} BTREEINFO;<br/><br/>
Les lments de cette structures sont les suivants :
<br/><br/>

flags
Cet attribut est rempli avec un OU binaire entre les valeurs suivantes :
.RS
<br/><br/>

R_DUP
Autoriser les cls dupliques dans l'arbre, c'est  dire, permettre l'insertion
mme si la cl existe dj dans l'arbre.
Le comportement par dfaut, comme dcrit dans
<i>dbopen (3),</i>
est d'craser la cl existante ou d'chouer si la valeur d'attribut
R_NOOVERWRITE est indique.
L'attribut R_NOOVERWRITE a priorit sur R_DUP, et une tentative d'insertion
de cl dj existante chouera s'ils sont tous les deux mentionns.
.IP
Si la base de donnes contient des cls dupliques, l'ordre de
rcupration des paires cl-valeur est indfini si l'on utilise
la routine
<i>get .</i>
Toutefois la routine
<i>seq</i> avec l'attribut R_CURSOR positionn renvoie la cl "logiquement premire"
de chaque groupe de cls dupliques. 

<br/><br/>

cachesize
Une suggestion de taille maximale (en octets) du cache mmoire.
Cette valeur est
<b>seulement</b> <b></b>  indicative, et les mthodes d'accs alloueront plus de mmoire plutt que
d'chouer.
Comme chaque recherche examine la page racine de l'arbre, le cache des
pages les plus rcemment consultes amliore les temps d'accs.
De plus, les critures physiques sont retardes aussi longtemps que possible,
ainsi un cache, mme modeste, peut amliorer sensiblement les oprations
d'entre/sortie. Bien sr l'utilisation d'un cache augmente la probabilit
(jamais nulle toutefois) de corruption ou de perte de donnes si le
systme se plante alors qu'un arbre est en cours de modification.
Si 
<i>cachesize</i> vaut 0 (pas de taille indique) on utilise un cache par dfaut.
<br/><br/>

maxkeypage
Le nombre maximum de cls qui seront stockes sur une seule page.
Pas encore implment.
<br/><br/>

minkeypage
Le nombre minimum de cls qui seront stockes sur la mme page. Cette valeur
sert  dterminer quelles cls seront stockes sur des pages de dbordement.
Lorsqu'un cl ou une donne est plus grande que la taille de page divise
par le nombre minimum de cls, elle est stocke sur des pages de
dbordement plutt que sur la page elle-mme.
Si
<i>minkeypage</i> est nulle (pas de nombre minimum de cls indiqu), on utilise la valeur 2.
<br/><br/>

psize
Taille (en octets) des pages utilises pour les noeuds de l'arbre. La taille
minimale est 512 octets, et la taille maximale 64 K.
Si
<i>psize</i> vaut 0, (pas de taille indique), la taille de page est choisie en fonction
de la taille des blocs d'entre/sortie du systme de fichiers sous-jacent.
<br/><br/>

compare
Fonction de comparaison de cl. Elle doit renvoyer un entier infrieur, gal
ou suprieur  zro lorsque le premier argument est respectivement infrieur,
gal ou suprieur au second.
La mme fonction de comparaison doit toujours tre utilis pour un arbre donn,
mme lors de la rouverture ultrieure de la base de donnes.
Si
<i>compare</i> vaut NULL (pas de fonction indique), les cls sont compares de manire
lexicographique, les cls les plus courtes considres comme infrieures aux
cls les plus longues.
<br/><br/>

prefix
Fonction de comparaison avec prfixe.
Si elle est fournie, cette routine doit renvoyer le nombre d'octets du second
argument cl qui sont ncessaires pour dterminer s'il est suprieur au
premier argument. Si les cls sont gales, on doit renvoyer la longueur de
la cl. Remarquez que l'utilit d'une telle routine dpend dans une trs
large mesure du type de donnes manipules, mais il arrive que cette routine
fournisse des rductions significatives de taille d'arbre et de temps de
recherche.
Si
<i>prefix</i> vaut NULL (pas de fonction indique),
<b>et</b> <b></b>  si aucune fonction de comparaison n'est mentionne, une routine de comparaison
lexicographique est employe.
Si
<i>prefix</i> est NULL mais si un routine de comparaison est founie, aucune comparaison
de prfixe n'est effectue.
<br/><br/>

lorder
L'ordre des octets pour les entiers stocks dans la base de donnes.
Ce nombre doit reprsenter l'ordre sous forme d'entier. Par exemple l'ordre
poids faible-poids fort (big endian) est reprsent par le nombre 4321.
Si
<i>lorder</i> vaut 0 (pas d'ordre indiqu), on utilise l'ordre des octets du systme hte.<br/><br/>
Si le fichier existe dj (et si le drapeau O_TRUNC) n'est pas spcifi),
les valeurs indiques par les paramtres flags, lorder, et psize sont
ignores, et remplaces par les valeurs fournies lors de la cration
de l'arbre.<br/><br/>
Le balayage squentiel de l'arbre vers l'avant se droule de la plus petite
cl vers la plus grande.<br/><br/>
L'espace libr par la destruction des paires cls/donnes n'est jamais
rcupr, bien qu'il soit thoriquement disponible pour tre r-utilis. Ceci
signifie qu'une base de donnes en arbre binaire ne fait que grandir.
Il faut donc viter les destructions exagres, ou reconstruire rgulirement
un nouvel arbre en balayant systmatiquement l'ancien.<br/><br/>
Les recherches, les insertions et les suppressions dans un arbre binaire
s'effectuent en O lg base N, o base reprsente le facteur de remplissage
moyen.
Souvent, l'insertion de donnes dj ordonnes dans un arbre binaire rsulte
en un facteur d'insertion faible. Cette implmentation a t modifie pour
rendre l'insertion d'lments ordonns encore plus profitable. Ceci
donne un facteur de remplissage de pages encore meilleur. 
</div><br/><br /><h1 class="TitreSection0" id="L4">erreurs</h1>
<div class="paragraph">
Les routines d'accs aux
<i>arbres binaires</i> peuvent chouer et renvoyer dans
<i>errno</i> le code de toutes les erreurs indiques pour les routines de la bibliothque
<i>dbopen (3).</i>
</div><br/><br /><h1 class="TitreSection0" id="L5">voir aussi</h1>
<div class="paragraph">
<i>dbopen (3),</i>
<i>hash (3),</i>
<i>mpool (3),</i>
<i>recno (3)</i>
<br/><br/>

<i>The Ubiquitous B-tree</i> ,</i>
Douglas Comer, ACM Comput. Surv. 11, 2 (June 1979), 121-138.
<br/><br/>

<i>Prefix B-trees</i> ,</i>
Bayer and Unterauer, ACM Transactions on Database Systems, Vol. 2, 1
(March 1977), 11-26.
<br/><br/>

<i>The Art of Computer Programming Vol. 3: Sorting and Searching</i> , </i>
D.E. Knuth, 1968, pp 471-480.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">bogues</h1>
<div class="paragraph">
Seuls les ordres d'octets big-endian et little-endian fonctionnent.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1999-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
