<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  (c) 1993 by Thomas Koenig (ig25@rz.uni-karlsruhe.de) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  License. -->
<!--  Modified Sat Jul 24 19:53:02 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 23/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  -->
<br/><h1>CONFSTR</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">exemples</a>
<br /><a class="summaryIndent0" href="#L5">erreurs</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">bogues</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
confstr - Lire une chane de caractres dpendant de la configuration.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#define</b> <b></b>  <b>_POSIX_C_SOURCE	2</b> <b></b>  or
<b>#define</b> <b></b>  <b>_XOPEN_SOURCE</b> <b></b>  .nl
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <br/><br/>

<b>size_t confstr (int </b> <i>name</i> <b>, char *</b> buf <i>, size_t </i> len );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>confstr ()</b>
fournit la valeur d'une chane de caractres dpendante de la configuration.<br/><br/>
L'argument 
<i>name</i> est la variable systme rclame.
Les variables suivantes sont supportes&nbsp;:
<br/><br/>

<b>_CS_PATH</b> <b></b>  Une valeur de la variable
<b>PATH</b> <b></b>  indiquant les emplacements ou les
utilitaires standards POSIX.2 peuvent tre trouvs.<br/><br/>
Si
<i>buf</i> n'est pas
<b>NULL ,</b>
et si
<i>len</i> est diffrent de 0, alors
<b>confstr ()</b>
copie la valeur de la chane dans le buffer
<i>buf ,</i>
en limitant la longueur 
<i>len - 1</i> caractres, termine par un caractre nul.
On peut dtecter la troncature de la chane en comparant le rsultat de
<b>confstr ()</b>
avec le paramtre
<i>len .<br/><br/></i>
Si
<i>len</i> est nulle, et si
<i>buf</i> vaut
<b>NULL ,</b>
alors
<b>confstr</b> <b></b>  <b>()</b> <b></b>  renvoie simplement la longueur de la variable systme.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Si
<i>name</i> ne correspond  aucune variable de configuration valide,
<b>confstr ()</b>
renvoie 0.
</div><br/><br /><h1 class="TitreSection0" id="L5">exemples</h1>
<div class="paragraph">
Le fragment de code ci-dessous dtermine le chemin d'accs aux utilitaires
POSIX.2 :
<br/>

.in 10<br/><br/>
char *pathbuf; size_t n;<br/><br/>
n = confstr(_CS_PATH,NULL,(size_t)0);
if ((pathbuf = malloc(n)) == NULL) abort();
confstr(_CS_PATH, pathbuf, n);
</div><br/><br /><h1 class="TitreSection0" id="L6">erreurs</h1>
<div class="paragraph">
Si la valeur de
<i>name</i> est invalide,
<i>errno</i> contient
<b>EINVAL .</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
proposition POSIX.2
</div><br/><br /><h1 class="TitreSection0" id="L8">bogues</h1>
<div class="paragraph">
POSIX.2 n'est pas encore un standard tabli, les informations contenues dans
cette page de manuel peuvent changer.
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>sh (1),</b>
<b>exec (3),</b>
<b>system (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
