<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 19:49:27 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  Modified Fri Apr 26 12:38:55 MET DST 1996 by Martin Schulze (joey@linux.de) -->
<!--  -->
<!--  -->
<!--  Traduction 23/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise  jour 05/05/99 - LDP-man-pages-1.23 -->
<!--  Mise  jour 21/01/2002 - LDP-man-pages-1.47 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>CTIME</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">notes</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
ctime, asctime, gmtime, localtime, mktime - Conversions de dates et heures binaires en ASCII.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;time.h&gt;</b> <b></b>  <br/><br/>

<b>char *asctime (const struct tm *</b> tm );
<br/><br/>

<b>char *asctime_r (const struct tm *</b> tm <i>, char *</i> buf );
<br/><br/>

<b>char *ctime (const time_t *</b> timep );
<br/><br/>

<b>char *ctime_r (const time_t *</b> timep <i>, char *</i> buf );
<br/><br/>

<b>struct tm *gmtime (const time_t *</b> timep );
<br/><br/>

<b>struct tm *gmtime_r (const time_t *</b> timep <i>, struct tm *</i> result );
<br/><br/>

<b>struct tm *localtime (const time_t *</b> timep );
<br/><br/>

<b>struct tm *localtime_r (const time_t *</b> timep <i>, struct tm *</i> result );
<br/><br/>

<b>time_t mktime (struct tm *</b> tm );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les fonctions <b>ctime()</b>, <b>gmtime()</b> et <b>localtime()</b> prennent
toutes un argument de type <i>time_t</i> qui reprsente une date.
Si l'on interprte cet argument comme une valeur absolue, il s'agit du
nombre de secondes coules depuis le 1er Janvier 1970  00h 00m 00s en
Temps Universel (TU).<br/><br/>
Les fonctions <b>asctime()</b> et <b>mktime()</b> utilisent toutes deux un
argument de type <i>struct tm</i>, c'est  dire une reprsentation binaire
divise en anne, mois, jour, heure...<br/><br/>
Cette structure <i>tm</i> est dfinie
dans <i>&lt;time.h&gt;</i> ainsi :
<br/><br/>

.RS

.ne 11
.ta 8n 16n 32n
struct tm {
	int	tm_sec;			/* secondes           */
	int	tm_min;			/* minutes            */
	int	tm_hour;		/* heures             */
	int	tm_mday;		/* quantime du mois  */
	int	tm_mon;			/* mois (0  11 !)    */
	int	tm_year;		/* anne              */
	int	tm_wday;		/* jour de la semaine */
	int	tm_yday;		/* jour de l'anne    */
	int	tm_isdst;		/* dcalage horaire   */
};
.ta


<br/><br/>
Les membres de la structure <i>tm</i> sont :
<br/><br/>

<i>tm_sec</i> Le nombre de secondes coules depuis le dernier changement de minute.
Normalement dans l'intervalle 0  59, ce membre peut aller jusqu'
61 durant les secondes de rattrapage priodique.
<br/><br/>

<i>tm_min</i> Le nombre de minutes coules depuis le dernier changement d'heure, dans
l'intervalle 0  59.
<br/><br/>

<i>tm_hour</i> Le nombre d'heures coules depuis Minuit, dans l'intervalle 0  23.
<br/><br/>

<i>tm_mday</i> Le quantime du mois, dans l'intervalle 1  31.
<br/><br/>

<i>tm_mon</i> Le nombre de mois couls depuis le dbut de l'anne, dans l'intervalle 0  11.
<br/><br/>

<i>tm_year</i> Le nombre d'annes coules depuis 1900.
<br/><br/>

<i>tm_wday</i> Le nombre de jours couls depuis Dimanche, dans l'intervalle 0  6.
<br/><br/>

<i>tm_yday</i> Le nombre de jours couls depuis le 1er Janvier, dans l'intervalle
0  365 (0  364 si l'anne n'est pas bissextile).
<br/><br/>

<i>tm_isdst</i> Un drapeau indiquant si le dcalage d'heure hiver/te est en cours au
moment de l'appel. La valeur retourne est positive si le dcalage est
en fonction, nulle s'il ne l'est pas, et ngative si l'information n'est
pas disponible.<br/><br/>
L'appel
ctime( t )
est quivalent 
asctime(localtime( t)) \fR.
Il convertit la date <i>t</i> en une chane de caractres de le forme
<br/><br/>

.RS
"Wed Jun 30 21:49:08 1993\\n"

<br/><br/>

L'internationalisation de la date est possible en utilisant la fonction
<b>setlocale</b>(3) et <b>strftime</b>(3).<br/><br/>
Les abrviations pour les jours de la semaine sont `Sun', `Mon', `Tue', `Wed',
`Thu', `Fri', et `Sat'.  
les abrviations pour les mois sont `Jan', `Feb', `Mar', `Apr', `May', `Jun',
`Jul', `Aug', `Sep', `Oct', `Nov', et `Dec'.  
La valeur renvoye pointe sur une chane statique qui sera crase 
chaque appel de l'une des fonctions ci-dessus.
La fonction renseigne galement la variable externe <i>tzname</i> avec
les informations concernant le fuseau horaire (voir 
<b>tzset (3)).<br/><br/></b>
La version rentrante <b>ctime_r()</b> effectue le mme travail mais stocke
la chane dans un buffer fourni par l'appelant, d'une longueur minimale de
26 caractres. Elle ne renseigne pas ncessairement <i>tzname</i>.<br/><br/>
la fonction <b>gmtime()</b> convertit la date <i>timep</i> en une reprsentation
<b>struct tm</b> exprime en Temps Universel.
Elle peut renvoyer NULL quand l'anne ne tient pas dans un entier. La valeur
renvoye pointe vers une structure alloue statiquement qui peut tre crase
par une invocation ultrieure d'une fonction de date ou d'heure.
La fonction rentrante <b>gmtime_r()</b> effectue le mme travail mais stocke
le rsultat dans une structure fournie par l'appelant.<br/><br/>
La fonction <b>localtime()</b> convertit la date <i>timep</i> en une 
reprsentation <b>struct tm</b> exprime en fonction du fuseau horaire de
l'utilisateur. Cette fonction se comporte comme si elle appelait
<b>tzset (3)</b>
et renseigne les variables externes <i>tzname</i>
avec les informations concernant le fuseau horaire, <i>timezone</i> avec
la diffrence (en secondes) entre Temps Universel et Temps Local,
et <i>daylight</i> avec une valeur non-nulle si le dcalage horaire
saisonnier s'applique.
La valeur
renvoye pointe vers une structure alloue statiquement qui peut tre crase
par une invocation ultrieure d'une fonction de date ou d'heure.
La fonction rentrante <b>localtime_r()</b> effectue le mme travail mais stocke
le rsultat dans une structure fournie par l'appelant.<br/><br/>
La fonction <b>asctime()</b> convertit la date <i>tm</i> exprime
sous forme <b>struct tm</b> en une chane de caractres du mme format 
que <b>ctime()</b>.
La valeur renvoye pointe sur une chane statique qui sera crase 
chaque appel de l'une des fonctions ci-dessus.
La version rentrante <b>asctime_r()</b> effectue le mme travail mais stocke
la chane dans un buffer fourni par l'appelant, d'une longueur minimale de
26 caractres.<br/><br/>
La fonction <b>mktime()</b> convertit la date <i>timeptr</i> exprime
sous forme <b>struct tm</b> en une date locale sous forme <b>time_t</b>.
La fonction ignore les valeurs transmises des membres <i>tm_wday</i>
et <i>tm_yday</i> de la structure, et les recalcule en utilisant les
autres membres.
Si des membres de la structure dbordent de l'intervalle autoris, ils
seront corrigs (par exemple le 40 Octobre devient le 9 Novembre).
L'appel de <b>mktime()</b> renseigne galement la variable
externe <i>tzname</i> avec les informations concernant le fuseau
horaire.
Si la structure transmise ne peut pas tre convertie, <b>mktime()</b>
renvoie la valeur (time_t)(-1) et ne modifie pas les membres
<i>tm_wday</i> et <i>tm_yday</i>.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Chacune de ces fonctions renvoie la valeur dcrite plus haut, ou NULL
(-1 dans le cas de <b>mktime()</b>) si une erreur est dtecte.
</div><br/><br /><h1 class="TitreSection0" id="L5">notes</h1>
<div class="paragraph">
Les quatre fonctions
<b>asctime() ,</b>
<b>ctime() ,</b>
<b>gmtime()</b> <b></b>  et
<b>localtime()</b> <b></b>  renvoient un pointeur vers des donnes statiques et ne sont donc pas sres dans
un contexte multi-threads. Les versions rentrantes
<b>asctime_r() ,</b>
<b>ctime_r() ,</b>
<b>gmtime_r()</b> <b></b>  et
<b>localtime_r()</b>
sont mentionnes dans SUSv2, et disponibles depuis la libc 5.2.5.<br/><br/>
La version GlibC de la struct tm a des champs supplmentaires&nbsp;:
<br/><br/>

.RS

long tm_gmtoff;           /* Secondes vers l'Est du temps TU */
const char *tm_tm_zone;   /* Abrviation du nom de fuseau */



<br/><br/>

prsents quand _BSD_SOURCE est dfini avant l'inclusion de
<i>&lt;time.h&gt; .</i>
Ceci est une extension BSD, prsente dans 4.3BSD-Reno.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
SVID 3, POSIX, BSD 4.3, ISO 9899
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>date (1),</b>
<b>gettimeofday (2),</b>
<b>newctime (3),</b>
<b>time (2),</b>
<b>utime (2),</b>
<b>clock (2),</b>
<b>difftime (3),</b>
<b>strftime (3),</b>
<b>strptime (3),</b>
<b>tzset (3),</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
