<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) 1990, 1993 -->
<!-- 	The Regents of the University of California.  All rights reserved. -->
<!--  -->
<!--  Redistribution and use in source and binary forms, with or without -->
<!--  modification, are permitted provided that the following conditions -->
<!--  are met: -->
<!--  1. Redistributions of source code must retain the above copyright -->
<!--     notice, this list of conditions and the following disclaimer. -->
<!--  2. Redistributions in binary form must reproduce the above copyright -->
<!--     notice, this list of conditions and the following disclaimer in the -->
<!--     documentation and/or other materials provided with the distribution. -->
<!--  3. All advertising materials mentioning features or use of this software -->
<!--     must display the following acknowledgement: -->
<!-- 	This product includes software developed by the University of -->
<!-- 	California, Berkeley and its contributors. -->
<!--  4. Neither the name of the University nor the names of its contributors -->
<!--     may be used to endorse or promote products derived from this software -->
<!--     without specific prior written permission. -->
<!--  -->
<!--  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND -->
<!--  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE -->
<!--  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE -->
<!--  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE -->
<!--  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL -->
<!--  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS -->
<!--  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) -->
<!--  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT -->
<!--  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY -->
<!--  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF -->
<!--  SUCH DAMAGE. -->
<!--  -->
<!-- 	@(#)dbopen.3	8.5 (Berkeley) 1/2/94 -->
<!--  -->
<!--  Traduction 06/05/1999 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP-man-pages-1.23 -->
<!--  Mise  jour 25/01/2002 - LDP-man-pages-1.47 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>DBOPEN</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">paires cls/donnes</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">voir aussi</a>
<br /><a class="summaryIndent0" href="#L6">bogues</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
dbopen - Mthodes d'accs aux bases de donnes.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

.ft B
#include &lt;sys/types.h&gt;
#include &lt;limits.h&gt;
#include &lt;db.h&gt;<br/><br/>
DB *
dbopen(const char *fichier, int attributs, int mode, DBTYPE type_base,
.ti +5
const void *openinfo);
.ft R


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<i>Dbopen</i>
est l'interface de bibliothque pour les fichiers de bases de donnes.
Les formats de fichiers supports sont les arbres binaires, les fichiers
hachs et les fichiers UNIX.
L'arbre binaire est une reprsentation d'une structure quilibre et trie.
Les fichiers hachs reprsentent des tables de hachage extensibles et dynamiques.
Le format de fichier Unix est un flux d'octets avec des enregistrements
de longueur fixe ou variable.
Les formats et les informations spcifiques aux fichiers sont fournis en
dtail dans les pages de manuel respectives
<i>btree (3),</i>
<i>hash (3)</i>
et
<i>recno (3).<br/><br/></i>
Dbopen ouvre le
<i>fichier</i> en lecture et/ou criture.
Les fichiers qui n'ont en aucun cas besoin d'tre sauvegards sur disque
peuvent tre crs avec le paramtre de fichier  NULL.<br/><br/>
Les arguments
<i>attribut</i> et 
<i>mode</i> doivent tre spcifis pour la routine
<i>open (2),</i>
toutefois seuls les attributs O_CREAT, O_EXCL, O_EXLOCK, O_NONBLOCK,
O_RDONLY, O_RDWR, O_SHLOCK et O_TRUNC ont un sens.
(Notez que l'ouverture d'un fichier de base de donnes en mode O_WRONLY n'est pas possible.)<br/><br/>
Le
<i>type_base</i> est un argument ayant le type DBTYPE (dfini dans le fichier d'en-tte &lt;db.h&gt;)
et peut prendre les valeurs DB_BTREE, DB_HASH ou DB_RECNO.<br/><br/>
L'argument
<i>openinfo</i> est un pointeur vers une structure spcifique  la mthode d'accs dcrite dans
la page de manuel de cette mthode d'accs. Si
<i>openinfo</i> est NULL, chaque mthode d'accs utilisera un comportement par dfaut appropri
pour le systme et le type de base de donnes.<br/><br/>
<i>Dbopen</i> renvoie un pointeur sur une structure DB s'il russit, ou NULL en cas d'erreur.
La structure DB est dfinie dans le fichier d'en-tte &lt;db.h&gt; et contient, au moins,
les champs suivants :
<br/><br/>


typedef struct {
.RS
DBTYPE type;
int (*close)(const DB *db);
int (*del)(const DB *db, const DBT *cl, u_int flags);
int (*fd)(const DB *db);
int (*get)(const DB *db, DBT *cl, DBT *data, u_int flags);
int (*put)(const DB *db, DBT *cl, const DBT *data,
.ti +5
u_int flags);
int (*sync)(const DB *db, u_int flags);
int (*seq)(const DB *db, DBT *cl, DBT *data, u_int flags);

} DB;

<br/><br/>
Ces lments dcrivent un type de base de donnes et un jeu de fonctions effectuant
diverses actions.
Ces fonctions reoivent un pointeur sur une structure semblable  celle renvoye par
<i>dbopen ,</i>
et parfois un ou plusieurs pointeurs sur des structures cls/donnes et une valeur
d'attribut.
<br/><br/>

type
Le type de mthode d'accs sous-jacente (et le type de fichier).
<br/><br/>

close
Un pointeur sur une routine qui vide vers le disque toutes les informations en cache,
libre les ressources alloues, et ferme le(s) fichier(s) de support.
Comme les paires cls/donnes peuvent tre caches en mmoire, l'oubli de synchronisation
du fichier avec les fonctions 
<i>close</i> ou
<i>sync</i> peut rsulter dans des donnes incohrentes ou perdues.
La routine
<i>close</i> renvoie -1 en cas d'erreur (et remplit
<i>errno )</i>
et 0 si elle russit.
<br/><br/>

del
Un pointeur vers une routine permettant de supprimer des paires cls/donnes
de la base de donnes.
.IP
Le paramtre
<i>flag</i> peut prendre l'une des valeurs suivantes:
.RS
<br/><br/>

R_CURSOR
Supprimer l'enregistrement rfrenc par le curseur. Ce curseur
doit bien entendu avoir t prcdemment positionn.

.IP
La routine
<i>delete</i> renvoie 0 si elle russit, -1 en cas d'erreur (et remplit
<i>errno ),</i>
ou 1 si la
<i>cl</i> indique n'a pas t trouve dans le fichier.
<br/><br/>

fd
Un pointeur vers une routine qui renvoie le descripteur du fichier
reprsentant la base de donnes. Le mme descripteur de fichier doit
tre fourni  tous les processus qui invoquent
<i>dbopen</i> avec le mme nom de
<i>fichier .</i>
Ce descripteur de fichier doit pouvoir servir d'argument aux
fonctions de verrouillage
<i>fcntl (2)</i>
et
<i>flock (2).</i>
Le descripteur de fichier n'est pas ncessairement associ avec
l'un des fichiers sous-jacents utiliss par les mthodes d'accs.
Aucun descripteur n'est disponible pour les base de donnes en mmoire.
La routine
<i>fd</i> renvoie -1 en cas d'erreur (et remplit
<i>errno ),</i>
ou le descripteur de fichiers en cas de succs.
<br/><br/>

get
Un pointeur vers la routine d'interface de recherche assiste d'une cl dans
la base de donnes. L'adresse et la longueur des donnes associes avec la
<i>cl</i> indique sont fournies dans une structure rfrence par l'argument
<i>data .</i>
La routine
<i>get</i> renvoie -1 en cas d'erreur (et remplit
<i>errno ),</i>
0 en cas de russite, ou 1 si la
<i>cl</i> n'a pas t trouve dans le fichier.
<br/><br/>

put
Un pointeur vers une routine permettant de stocker les paires cls/donnes dans
la base de donnes.
.IP
Le paramtre
<i>flag</i> peut prendre l'une des valeurs suivantes :
.RS
<br/><br/>

R_CURSOR
Remplacer la paire cl/donne rfrence par le curseur. Ce curseur
doit avoir t positionn prcdemment.
<br/><br/>

R_IAFTER
Ajouter les donnes immdiatement aprs les donnes rfrences par la
<i>cl ,</i>
crant ainsi une nouvelle paire cl/donne.
Le numro d'enregistrement de la paire ajoute est renvoy dans la structure
<i>cl.</i> (Utilisable uniquement avec la mthode d'accs DB_RECNO)
<br/><br/>

R_IBEFORE
Ajouter les donnes immdiatement avant les donnes rfrences par la
<i>cl ,</i>
crant ainsi une nouvelle paire cl/donne.
Le numro d'enregistrement de la paire insre est renvoy dans la structure
<i>cl.</i> (Utilisable uniquement avec la mthode d'accs DB_RECNO)
<br/><br/>

R_NOOVERWRITE
N'ajouter la paire cl/donne que si la cl n'existe pas prcdement.
<br/><br/>

R_SETCURSOR
Enregistrer la paire cl/donne, en positionnant ou initialisant la
position du curseur pour la rfrencer.
(Utilisable uniquement avec les mthodes d'accs DB_RECNO et DB_TREE)

.IP
R_SETCURSOR n'est disponible que pour les mthodes DB_BTREE et DB_RECNO
car cela implique que les cls ont un ordre inhrent immuable.
.IP
R_IAFTER et R_IBEFORE ne sont disponibles qu'avec la mthode DB_RECNO
car ils impliquent que la mthode d'accs soit capable de crer de
nouvelles cls. Ceci n'est vrai que si les cls sont ordonnes et
indpendantes, comme des numros d'enregistrement.
.IP
Le comportement par dfaut de la routine
<i>put</i> est de stocker une nouvelle paire cl/donne, en remplaant toute
cl existant prcdemment.
.IP
Les routines
<i>put</i> renvoient -1 en cas d'erreur (et remplissent
<i>errno ),</i>
0 en cas de succs, ou 1 si l'attribut R_NOOVERWRITE
a t indiqu dans
<i>flag ,</i>
et si la cl existait dj dans le fichier.
<br/><br/>

seq
Un pointeur vers la routine d'interface pour la recherche squentielle
dans la base de donnes. L'adresse et la longueur de la cl sont
renvoyes dans une structure rfrence par
<i>cl ,</i>
et l'adresse et la longueur des donnes dans une structure rfrence par
<i>data .</i>
.IP
La rechercher squentielle de paire cl/donne peut avoir lieu  tout
moment, et la position du ``curseur'' n'est pas affecte par les routine
<i>del ,</i>
<i>get ,</i>
<i>put ,</i>
ou
<i>sync .</i>
Les modifications de la base de donnes durant un balayage squentiel seront
visibles par le balayage, c'est  dire que les enregistrements insrs avant
le curseur ne seront pas vus, mais les enregistrements insrs aprs le
curseur seront renvoys.
.IP
La valeur de
<i>flag</i> <b>doit</b> <b></b>  tre l'une des valeurs suivantes :
.RS
<br/><br/>

R_CURSOR
La routine renvoie les donnes associes avec la cl indique. Ceci
est diffrent du comportement de la routine 
<i>get</i> car le curseur est galement positionn ou initialis.
(Notez que pour la mthode d'accs DB_BTRE, la cl renvoye ne correspond
pas ncessairement  la cl indique. On retourne la plus petite cl
suprieure ou gale  celle indique, ce qui permet des correspondances
partielles ou des recherches d'intervalles).
<br/><br/>

R_FIRST
On renvoie la premire paire cl/donne de la base, et le curseur
est initialis ou positionn pour la rfrencer.
<br/><br/>

R_LAST
On renvoie la dernire paire cl/donne de la base, et le curseur
est initialis ou positionn pour la rfrencer.
(Disponible uniquement pour les mthodes DB_TREE et DB_RECNO).
<br/><br/>

R_NEXT
Renvoyer la paire cl/donne immdiatement aprs le curseur. Si le
curseur n'est pas positionn, le comportement est le mme que R_FIRST.
<br/><br/>

R_PREV
Renvoyer la paire cl/donne immdiatement avant le curseur. Si le
curseur n'est pas positionn, le comportement est le mme que R_LAST.
(Disponible uniquement pour les mthodes DB_TREE et DB_RECNO).

.IP
R_LAST et R_PREV ne sont disponibles que pour les mthodes DB_BTREE et DB_RECNO
car ils impliquent que les cls aient un ordre inhrent immuable.
.IP
La routine
<i>seq</i> renvoie -1 en cas d'erreur (et remplit
<i>errno ),</i>
0 en cas de succs, et 1 s'il n'y a pas de paire cl/donne suprieure ou
gale  la cl indique ou courante. Si on tuilise la mthode DB_RECNO,
si le fichier de base de donnes est un fichier spcial en mode caractres,
et si aucune paire cl/donne complte n'est actuellement disponible, la
routine
<i>seq</i> renvoie 2.
<br/><br/>

sync
Un pointeur vers une routine permettant de vider sur disque toutes les
informations en cache. Si la base de donnes est uniquement en mmoire,
la routine
<i>sync</i> n'a pas d'effet, et russira toujours.
.IP
La valeur de
<i>flag</i> peut tre la suivante :
.RS
<br/><br/>

R_RECNOSYNC
Si on utilise la mthode DB_RECNO, cet attribut oblige la
synchronisation  s'appliquer au fichier B-Tree sous-jacent au
fichier RecNo, et non pas  ce dernier.
(voir le champs
<i>bfname</i> de la page de manuel
<i>recno (3)</i>
pour plus d'informations.)

.IP
La routine
<i>sync</i> renvoie -1 en cas d'erreur (et remplit
<i>errno )</i>
ou 0 en cas de russite.
</div><br/><br /><h1 class="TitreSection0" id="L4">paires cls/donnes</h1>
<div class="paragraph">
L'accs  tous les types de fichiers est bas sur les paires cls/donnes.
La structure de donne suivante reprsente  la fois les cls et les donnes.<br/><br/>
typedef struct {
.RS
void *data;
<br/>
size_t size;

} DBT;<br/><br/>
Les lments de la structure DBT sont dfinis ainsi :
<br/><br/>

data
Un pointeur vers une chane d'octets.
<br/><br/>

size
La longueur de la chane d'octets<br/><br/>
Les chanes d'octets des cls et des donnes peuvent avoir n'importe quelle
longueur, avec la limitation que deux quelconques d'entre-elles doivent 
pouvoir tenir simultanment en mmoire.
Remarquez que les mthodes d'accs ne fournissent aucune garantie en ce
qui concerne les alignements des chanes d'octets.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
La routine
<i>dbopen</i> peut chouer et placer dans
<i>errno</i> n'importe laquelle des erreurs renvoyes par les routines
<i>open (2)</i>
et
<i>malloc (3)</i>
ou l'une des erreurs suivantes :
<br/><br/>

[EFTYPE]
Un fichier est mal formatt.
<br/><br/>

[EINVAL]
Un paramtre indiqu (par exemple fonction de hachage) est incompatible avec
les spcifications du fichier actuel, ou n'a pas de sens pour la fonction
(par exemple utiliser le curseur sans initialisation pralable). Ou encore,
il y a une incompatibilit dans les numros de version du fichier et du
logiciel.<br/><br/>
Les routines
<i>close</i> peuvent chouer et fournir dans
<i>errno</i> l'une quelconque des erreurs indiques par les routines de bibliothque
<i>close (2),</i>
<i>read (2),</i>
<i>write (2),</i>
<i>free (3),</i>
ou
<i>fsync (2).<br/><br/></i>
Les routines
<i>del ,</i>
<i>get ,</i>
<i>put</i> et
<i>seq</i> peuvent chouer et fournir dans
<i>errno</i> l'une quelconque des erreurs indiques par les routines de bibliothque
<i>read (2),</i>
<i>write (2),</i>
<i>free (3)</i>
ou
<i>malloc (3).<br/><br/></i>
Les routine
<i>fd</i> peuvent chouer et remplir
<i>errno</i> avec l'erreur ENOENT pour les bases de donnes en mmoire.<br/><br/>
Les routines
<i>sync</i> peuvent chouer et fournir dans
<i>errno</i> l'une quelconque des erreurs indiques par la routine de bibliothque
<i>fsync (2).</i>
</div><br/><br /><h1 class="TitreSection0" id="L6">voir aussi</h1>
<div class="paragraph">
<i>btree (3),</i>
<i>hash (3),</i>
<i>mpool (3),</i>
<i>recno (3)</i>
<br/><br/>

<i>LIBTP: Portable, Modular Transactions for UNIX</i> ,</i>
Margo Seltzer, Michael Olson, USENIX proceedings, Winter 1992.
</div><br/><br /><h1 class="TitreSection0" id="L7">bogues</h1>
<div class="paragraph">
Le typedef DBT est un mnmonique pour ``data base thang'', qui a t
choisi car personne n'arrivait  trouver un nom raisonnable et pas encore
utilis.<br/><br/>
L'interface avec les descripteurs de fichiers est une bidouille et sera supprime
dans les versions futures de l'interface.<br/><br/>
Aucune mthode d'accs ne fournit de transactions, de verrouillages ou d'accs concurrents.
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1999-2003.<br/><br/>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
