<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright 2002 Ian Redfern (redferni@logica.com) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      FreeBSD 4.4 man pages -->
<!--  -->
<!--  Minor additions, aeb, 2002-07-20 -->
<!--  Traduction Christophe Blaess, &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>ETHER_ATON</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">bogues</a>
<br /><a class="summaryIndent0" href="#L4">conformit</a>
<br /><a class="summaryIndent0" href="#L5">voir aussi</a>
<br /><a class="summaryIndent0" href="#L6">traductions</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
ether_aton, ether_ntoa, ether_ntohost, ether_hosttonn, ether_line, ether_ntoa_r, ether_aton_r - Routines de manipulation d'adresses Ethernet.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;netinet/ether.h&gt;</b> <b></b>  <br/><br/>

<b>char *</b>
<b>ether_ntoa(const struct ether_addr *</b> addr );
<br/><br/>

<b>struct ether_addr *</b>
<b>ether_aton(const char *</b> asc );
<br/><br/>

<b>int</b>
<b>ether_ntohost(char *</b> hostname <i>, const struct ether_addr *</i> addr );
<br/><br/>

<b>int</b>
<b>ether_hostton(const char *</b> hostname <i>, struct ether_addr *</i> addr );
<br/><br/>

<b>int</b>
<b>ether_line(const char *</b> line <i>, struct ether_addr *</i> addr ,
<b>    char *</b> hostname );
<br/><br/>

/* extensions GNU */
<br/>
<b>char *</b>
<b>ether_ntoa_r(const struct ether_addr *</b> addr <i>, char *</i> buf );
<br/><br/>

<b>struct ether_addr *</b>
<b>ether_aton_r(const char *</b> asc <i>, struct ether_addr *</i> addr );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>ether_aton()</b> convertit une adresse d'hte Ethernet sur 48-bits <i>asc</i>
de la notation standard hexadcimal et sparateurs deux-points en donnes
binaire dans l'ordre des octets du rseau et renvoie un pointeur dans un buffer
allou de manire statique, que les appels ultrieurs craseront. <b>ether_aton</b>
renvoie NULL si l'adresse est invalide.<br/><br/>
La fonction <b>ether_ntoa()</b> convertit l'adresse d'hte Etherne binaire
<i>addr</i> dans l'ordre des octets du rseau en une chane dans la notation
standard hexadcimal et deux-points, en omettant les zros en tte.
La chane est renvoye dans un buffer allou de manire statique,
que les appels ultrieurs craseront.<br/><br/>
La fonction <b>ether_ntohost()</b> met en correspondance une adresse Ethernet
en un nom d'hte trouv dans
<b>/etc/ethers</b> <b></b>  et renvoie une valeur non-nulle si elle ne trouve pas.<br/><br/>
La fonction <b>ether_ntohost()</b> met en correspondance un nom d'hte et
une adresse Ethernet dans
<b>/etc/ethers</b> <b></b>  et renvoie une valeur non-nulle si elle ne trouve pas.<br/><br/>
La fonction <b>ether_line()</b> examine une ligne dans le format de
<b>/etc/ethers</b> <b></b>  (adresse Ethernet suivi de blancs et d'un nom d'hte&nbsp;; '#' introduit un
commentaire) et renvoie une paire adresse / nom d'hte, ou une valeur
non-nulle si elle ne trouve pas.
Le buffer point par
<i>hostname</i> doit tre assez grand, par exemple avoir la mme longueur que la ligne
<i>line .<br/><br/></i>
Les fonctions <b>ether_ntoa_r</b> et <b>ether_aton_r</b> sont des versions
rentrantes et sres en multi-threads de <b>ether_ntoa</b> et <b>ether_aton</b>
respectivement, et n'utilisent pas de buffers statiques.<br/><br/>
La structure <i>ether_addr</i> est dfinie dans <i>net/ethernet.h</i> ainsi&nbsp;:
<br/><br/>

.RS

.ta 8n 16n
struct ether_addr {
  u_int8_t ether_addr_octet[6];
}
.ta



</div><br/><br /><h1 class="TitreSection0" id="L4">bogues</h1>
<div class="paragraph">
L'implmentation de ether_line() dans la GlibC 2.2.5 est errone.
</div><br/><br /><h1 class="TitreSection0" id="L5">conformit</h1>
<div class="paragraph">
BSD 4.3, SunOS
</div><br/><br /><h1 class="TitreSection0" id="L6">voir aussi</h1>
<div class="paragraph">
<b>ethers (5)</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">traductions</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
