<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 19:43:49 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  Added a fix from urs@isnogud.escape.de (Urs Thuermann), aeb 950722 -->
<!--  -->
<!--  Traduction 23/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise  jour 25/01/2002 - LDP-man-pages-1.47 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  -->
<br/><h1>EXIT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">conformit</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
exit - Fin normale d'un programme.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdlib.h&gt;</b> <b></b>  <br/><br/>

<b>void exit (int </b> status );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>exit()</b> termine normalement le programme en cours.
La valeur <i>status & 0377</i> est renvoye au processus parent.
(voir
<b>wait (2)).</b>
Toutes les fonctions enregistres avec <b>atexit</b>(3) et <b>on_exit()</b>
sont invoques dans l'ordre inverse de l'enregistrement, les flux ouverts
sont vids et ferms.
Les fichiers crs par <b>tmpfile</b>(2) sont supprims.<br/><br/>
Le standard C mentionne deux constantes symboliques <i>EXIT_SUCCESS</i> et
<i>EXIT_FAILURE</i> qui peuvent tre passe  <b>exit()</b> pour indiquer
respectivement une terminaison en succs ou en chec.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>exit()</b> ne revient jamais.
</div><br/><br /><h1 class="TitreSection0" id="L5">conformit</h1>
<div class="paragraph">
SVID 3, POSIX, BSD 4.3, ISO 9899 ("ANSI C")
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Durant le traitement de exit, il est possible d'enregistrer des
fonctions supplmentaires avec <b>atexit()</b> et <b>on_exit()</b>.
C'est toujours la dernire fonction enregistre qui est extraite de
leur liste et invoque.
Le comportement est indfini si durant ce traitement, on invoque
<b>exit()</b> ou <b>longjmp()</b>.<br/><br/>
L'utilisation d'EXIT_SUCCESS et EXIT_FAILURE est lgrement plus portable
(vers des environnements non-Unix) que celle de zro et d'une valeur non-nulle
comme 1 ou -1. En particulier, VMS utilise une convention diffrente.<br/><br/>
BSD a tent de standardiser les codes de sortie, voir le fichier
<i>&lt;sysexits.h&gt; .<br/><br/></i>
Aprs un <b>exit()</b>, le code de retour doit tre transmis au processus
parent. Il y a trois cas. Si le parent a mentionn SA_NOCLDWAIT ou s'il
a positionn le comportement de SIGCHLD  SIG_IGN, le status est ignor.
Si le pre tait en attente de la fin de son fils, il reoit le status
de retour. Dans ces deux cas, le fils meurt immdiatement.
Si le parent n'est pas en attente, mais n'a pas indiqu qu'il
dsire ignorer le code de retour, le processus fils devient un "zombie".
Ce n'est rien d'autre qu'une coquille enveloppant le code de retour,
que le processus pre pourra consulter ultrieurement grce  l'une des
fonctions de la famille <i>wait()</i>.<br/><br/>
Si l'implmentation supporte le signal SIGCHLD, celui-ci est envoy au
processus pre. Si le pre a mentionn SA_NOCLDWAIT, il n'est pas prcis
si SIGCHLD est envoy ou non.<br/><br/>
Si le processus est un leader de session, et si son terminal de contrle est
le terminal de la session, alors chaque processus du groupe de processus en
avant-plan su ce terminal reoit un signal SIGHUP, et le terminal est
dissoci de la session, lui permettant d'tre racquis par un nouveau processus
de contrle.<br/><br/>
Si la fin du processus rend orphelin un groupe de processus, et si certain
membres de ce groupe sont arrts, alors tous les processus du groupe vont recevoir
SIGHUP suivi de SIGCONT.
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>_exit (2),</b>
<b>wait (2),</b>
<b>atexit (3),</b>
<b>on_exit (3)</b>
<b>tmpfile (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
