<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) 2000 Andries Brouwer (aeb@cwi.nl) -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  The GNU General Public License's references to "object code" -->
<!--  and "executables" are to be interpreted as the output of any -->
<!--  document formatting or typesetting system, including -->
<!--  intermediate and printed output. -->
<!--  -->
<!--  This manual is distributed in the hope that it will be useful, -->
<!--  but WITHOUT ANY WARRANTY; without even the implied warranty of -->
<!--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the -->
<!--  GNU General Public License for more details. -->
<!--  -->
<!--  You should have received a copy of the GNU General Public -->
<!--  License along with this manual; if not, write to the Free -->
<!--  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, -->
<!--  USA. -->
<!--  -->
<!--  Traduction 31/08/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.31 -->
<!--  Mise  jour 04/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  MJ 30/07/2003 LDP-1.58 -->
<br/><h1>FENV</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">dtails gnu</a>
<br /><a class="summaryIndent0" href="#L4">conformit</a>
<br /><a class="summaryIndent0" href="#L5">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
feclearexcept, fegetexceptflag, feraiseexcept, fesetexceptflag, fetestexcept, fegetenv, fegetround, feholdexcept, fesetround, fesetenv, feupdateenv, fedisableexcept, feenableexcept, fegetexcept - Gestion des exceptions C99 pour les arrondis et les erreurs en virgule flottante.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;fenv.h&gt;</b> <b></b>  <br/><br/>

<b>void feclearexcept(int </b> excepts );
<br/>
<b>void fegetexceptflag(fexcept_t *</b> flagp <i>, int </i> excepts );
<br/>
<b>void feraiseexcept(int </b> excepts );
<br/>
<b>void fesetexceptflag(const fexcept_t *</b> flagp <i>, int </i> excepts );
<br/>
<b>int fetestexcept(int </b> excepts );
<br/><br/>

<b>int</b> <b></b>  <b>fegetround(void);"</b> <b></b>  <br/>
<b>int fesetround(int </b> rounding_mode );
<br/><br/>

<b>void fegetenv(fenv_t *</b> envp );
<br/>
<b>int feholdexcept(fenv_t *</b> envp );
<br/>
<b>void fesetenv(const fenv_t *</b> envp );
<br/>
<b>void feupdateenv(const fenv_t *</b> envp );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Ces onze fonctions ont t dfinies dans le C99, et permettent de paramtrer
les arrondis et les gestions d'erreurs (dbordement, division par zro, etc.) en virgule flottante.
</div><br/><h2 class="TitreSection1" id="L7">Exceptions</h2>
<div class="paragraph">
L'exception DivideByZero se produit quand une opration sur des nombres finis
donne un infini comme rponse exacte.<br/><br/>
L'exception Overflow se produit quand un rsultat doit tre reprsent par un
nombre en virgule flottante, mais que sa valeur absolue est trop grande
pour tre reprsente par un nombre fini.<br/><br/>
L'exception Underflow se produit quand un rsultat doit tre reprsent par un
nombre en virgule flottante, mais que sa valeur absolue est trop petite pour
tre reprsente.<br/><br/>
L'exception Inexact se produit quand le rsultat arrondi d'une opration
n'est pas gal au rsultat en prcision infinie. Elle peut se dclencher
quand les exceptions Overflown ou Underflow se produisent.<br/><br/>
L'exception Invalid se produit quand il n'y a pas de rsultat bien dfini
pour une opration, comme 0/0 ou infini-infi ou sqrt(-1).
</div><br/><h2 class="TitreSection1" id="L7">Gestion des exceptions</h2>
<div class="paragraph">
Les exceptions sont reprsentes de deux manires : en tant qu'un unique bit
(exception prsente ou absente) correspondant de manire dpendant de
l'implmentation avec une position au sein d'un entier, et aussi en tant que
structure opaque pouvant vhiculer plus d'information
concernant l'exception (ventuellement l'adresse du code dclenchant l'erreur).<br/><br/>
Chacune des macros
<b>FE_DIVBYZERO ,</b>
<b>FE_INEXACT ,</b>
<b>FE_INVALID ,</b>
<b>FE_OVERFLOW ,</b>
<b>FE_UNDERFLOW</b>
est dfinie lorsque l'implmentation supporte la gestion
de l'exception correspondante. Les bits sont alors dfinis,
ainsi on peut appeler par exemple les fonctions de gestion
des exceptions avec un argument entier
<b>FE_OVERFLOW | FE_UNDERFLOW .</b>
D'autres exceptions peuvent tre supportes. La macro
<b>FE_ALL_EXCEPT</b> <b></b>  est un masque regroupant par OU binaire tous les bits des exceptions supportes.<br/><br/>
La fonction
<b>feclearexcept</b> <b></b>  efface les exceptions supportes reprsentes par les bits prsents
dans son argument.<br/><br/>
La fonction
<b>fegetexceptflag</b> <b></b>  stocke une reprsentation de l'tat des exceptions contenues dans 
son argument
<i>excepts</i> dans l'objet opaque
* flagp .<br/><br/></i>
La fonction
<b>feraiseexcept</b> <b></b>  dclenche les exceptions supportes reprsentes par les bits de l'argument
<i>excepts .<br/><br/></i>
La fonction
<b>fesetexceptflag</b> <b></b>  fixe l'tat des exceptions reprsentes par l'argument
<i>excepts</i> en employant la valeur
* flagp .</i>
Cette dernire doit tre le rsultat d'un appel pralable 
<b>fegetexceptflag</b> <b></b>  avec un dernier argument contenant au moins tous les bits prsents dans
<i>excepts .<br/><br/></i>
La fonction
<b>fetestexcept</b> <b></b>  renvoie un mot dont les bits galement prsents dans
l'argument
<i>excepts</i> seront positionns si l'exception correspondante est prsente.
</div><br/><h2 class="TitreSection1" id="L7">Arrondis</h2>
<div class="paragraph">
Chacune des macros
<b>FE_DOWNWARD ,</b>
<b>FE_TONEAREST ,</b>
<b>FE_TOWARDZERO ,</b>
<b>FE_UPWARD</b>
est dfinie lorsque l'implmentation supporte l'usage 
de la direction d'arrondi correspondante.<br/><br/>
La fonction
<b>fegetround</b> <b></b>  renvoie la macro correspondant au mode d'arrondi
en cours.<br/><br/>
La fonction
<b>fesetround</b> <b></b>  fixe le mode d'arrondi tel qu'il est spcifi par son argument
et renvoie zro lorsqu'elle russit.
</div><br/><h2 class="TitreSection1" id="L7">Environnement en virgule flottante.</h2>
<div class="paragraph">
L'environnement de travail en virgule flottante, y compris
les modes de contrle et les tats peuvent tre manipuls
sous forme d'un objet opaque de type
<i>fenv_t .</i>
L'environnement par dfaut, est reprsent par
<b>FE_DFL_ENV</b> <b></b>  (de type
<i>const fenv_t *</i> ).</i>
Il s'agit de la configuration de l'environnement au dmarrage du programme
et elle est dfinie par ISO C comme ayant un arrondi au plus proche, toutes
les exceptions effaces et un mode non-stop (continuer sur exception).<br/><br/>
La fonction
<b>fegetenv</b> <b></b>  sauve l'environnement de travail en virgule flottante en cours dans
l'objet 
* envp .<br/><br/></i>
La fonction
<b>feholdexcept</b> <b></b>  effectue la mme chose, puis efface tous les drapeaux d'exceptions,
et bascule si possible sur un mode non-stop (continuer en prsence d'exceptions).
Elle renvoie zro si elle russit.<br/><br/>
La fonction
<b>fesetenv</b> <b></b>  recharge l'environnement de travail en virgule flottante 
partir de l'objet 
* envp .</i>
Cette objet doit tre valide, c'est  dire tre le rsultat de
<b>fegetenv ,</b>
de
<b>feholdexcept</b> <b></b>  ou gal 
<b>FE_DFL_ENV .</b>
Cet appel ne dclenche pas les exceptions.<br/><br/>
La fonction
<b>feupdateenv</b> <b></b>  installe l'environnement en virgule flottante reprsent par l'objet
* envp ,</i>
sauf que les exceptions dj dclenches ne sont pas effaces.
Aprs l'appel de cette fonction, les exception dclenches seront un OU
binaire entre l'ensemble prcdent, et celui contenu dans
* envp .</i>
Comme prcdemment, l'objet point par
<i>envp</i> doit tre valide.
 
</div><br/><br /><h1 class="TitreSection0" id="L4">dtails gnu</h1>
<div class="paragraph">
Si possible, la bibliothque Gnu LibC dfinit une macro
<b>FE_NOMASK_ENV</b> <b></b>  qui reprsente l'environnement quand toutes les exceptions dclenchent un
appel. On peut tester la prsence de cette macro en utilisant
<b>#ifdef .</b>
Elle n'est dfinie que si la constante symbolique
<b>_GNU_SOURCE</b> <b></b>  est dfinie.
Le standard C99 ne dfinit pas de manire de fixer des bits individuels dans
le masque, par exemple pour intercepter des exceptions particulires.
La GLibC 2.2 supporte
<i>feenableexcept</i> et
<i>fedisableexcept</i> pour fixer individuellement des interceptions, et
<i>fegetexcept</i> pour demander l'tat.
<br/><br/>


<b>#define</b> <b></b>  <b>_GNU_SOURCE"</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;fenv.h&gt;"</b> <b></b>  <br/><br/>

<b>int feenableexcept (int </b> excepts );
<br/>
<b>int fedisableexcept (int </b> excepts );
<br/>
<b>int fegetexcept (void);</b>
<br/>

<br/><br/>
Les fonctions
<b>feenableexcept</b> <b></b>  et
<b>fedisableexcept</b> <b></b>  activent (dsactivent) l'interception pour chaque exception reprsente par
<i>excepts</i> et renvoient l'ensemble prcdent des exceptions actives lorsqu'elle
russissent, et -1 sinon.
La fonction
<b>fegetexcept</b> <b></b>  renvoie l'ensemble des exceptions actuellement actives.<br/><br/>
.SH
Effectuez l'dition des liens avec l'option
<b>-lm .<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L5">conformit</h1>
<div class="paragraph">
IEC 60559 (IEC 559:1989), ANSI/IEEE 854, ISO C99 (ISO/IEC 9899:1999).
</div><br/><br /><h1 class="TitreSection0" id="L6">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.<br/><br/>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
