<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 2001 Andries Brouwer &lt;aeb@cwi.nl&gt;. -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction 22/04/2002 par Stphan Rafin (stephan.rafin@laposte.net) -->
<!--  -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>LOCKFILE</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">disponibilit</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
flockfile, ftrylockfile, funlockfile - Verrouillage d'un flux pour stdio.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdio.h&gt;</b> <b></b>  <br/><br/>

<b>void flockfile(FILE *</b> filehandle );
<br/>
<b>int ftrylockfile(FILE *</b> filehandle );
<br/>
<b>void funlockfile(FILE *</b> filehandle );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les fonctions stdio peuvent tre utilises dans un contexte multithread.
Ceci est ralis en affectant  chaque objet de type FILE 
un compteur et (si le compteur est non nul) un thread propritaire.
Lors de chaque appel  la librairie stdio, ces fonctions attendent jusqu' ce que
l'objet FILE ne soit plus verrouill par un thread diffrent, puis elles le verrouillent,
ralisent l'entre sortie demande, et librent l'objet.<br/><br/>
(Remarque : ce verrouillage n'a rien  voir avec le verrouillage de fichier ralis
par des fonctions comme 
<b>flock (2)</b>
et
<b>lockf (3).)<br/><br/></b>
Tout ceci est invisible au programmeur en C, mais il existe deux raisons 
de souhaiter un contrle plus fin. D'une part, un thread peut raliser
une  srie d'entres/sorties interdpendantes, ces oprations
ne devant pas tre interrompues par les entres sorties d'autres threads.
D'autre part, on peut dsirer supprimer l'overhead induit par ce verrouillage 
afin d'obtenir de meilleures performances.<br/><br/>
A cette fin, un thread peut verrouiller explicitement un objet de type FILE,
puis raliser sa srie d'entres sorties, et enfin, relcher le verrou.
Cela empche les autres threads d'intervenir (sur le flux)
entre-temps. Si la motivation du verrouillage est la recherche de 
meilleures  performances, on peut raliser l'entre sortie  l'aide des 
versions non bloquantes des fonctions stdio : avec
<i>getc_unlocked</i>() et <i>putc_unlocked</i>() au lieu de 
<i>getc</i>() et <i>putc</i>().<br/><br/>
La fonction <b>flockfile()</b> attend jusqu' ce que *<i>filehandle</i> ne
soit plus verrouill par un autre thread, puis affecte  *<i>filehandle</i> 
au thread actuel, et incrmente le compteur.<br/><br/>
La fonction <b>funlockfile()</b> dcrmente le compteur de verrou.<br/><br/>
La fonction <b>ftrylockfile()</b> est une version non bloquante de 
<b>flockfile()</b>. Elle ne fait rien lorsqu'un autre thread
dtient *<i>filehandle</i>, sinon, elle se l'approprie  et incrmente 
le compteur.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>ftrylockfile()</b> renvoie zro en cas de succs 
(le verrou a t obtenu), et une valeur diffrente de zro en cas d'chec.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
Aucune.
</div><br/><br /><h1 class="TitreSection0" id="L6">disponibilit</h1>
<div class="paragraph">
Ces fonctions sont disponibles lorsque _POSIX_THREAD_SAFE_FUNCTIONS
est dfini. Elles sont prsentes dans la libc depuis la version 5.1.1 
et dans la glibc depuis la glic 2.0.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
POSIX.1
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>unlocked_stdio (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Stphan Rafin, 2002.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
