<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 19:34:42 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 23/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  MJ 30/07/2003 LDP-1.58 -->
<br/><h1>FREXP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">exemple</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
frexp, frexpf, frexpl - Conversion de rel en fraction normalise.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;math.h&gt;</b> <b></b>  <br/><br/>

<b>double frexp (double </b> x <i>, int *</i> exp );
<br/><br/>

<b>float frexpf (float </b> x <i>, int *</i> exp );
<br/><br/>

<b>long double frexpl (long double </b> x <i>, int *</i> exp );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>frexp()</b> est utilise pour scinder le nombre <i>x</i> en une
fraction normalise et un exposant qui est stock dans <i>exp</i>.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>frexp()</b> renvoie la fraction normalise.<br/><br/>
Si <i>x</i> est
non nul, <i>x</i> est gale  la fraction renvoye multipli par 2^<i>exp</i>.
La fraction est dans l'intervalle [1/2, 1[.<br/><br/>
Si <i>x</i> est nul, la fraction normalise vaut zro et <i>exp</i> galement.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">exemple</h1>
<div class="paragraph"><br/><br/>

#include &lt;math.h&gt;
#include &lt;stdio.h&gt;<br/><br/>
int
main (void)
{
   float x, f;
   int ex;
   while (1) {
      fscanf (stdin, "%f", & x);
      f = frexp (x, & ex);
      fprintf (stdout,"%f = %f x 2^%d\\n", x, f, ex);
   }
   return (0);
}<br/><br/>
$ ./a.out <br/><br/>
0
0.000000 = 0.000000 x 2^0
1
1.000000 = 0.500000 x 2^1
2
2.000000 = 0.500000 x 2^2
3
3.000000 = 0.750000 x 2^2
4
4.000000 = 0.500000 x 2^3
5
5.000000 = 0.625000 x 2^3<br/><br/>
$ <br/><br/>


</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
SVID 3, POSIX, BSD 4.3, ISO 9899
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>ldexp (3),</b>
<b>modf (3)<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
