<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 2000 Sam Varshavchik &lt;mrsam@stop.mail-abuse.org&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References: RFC 2553 -->
<!--  Traduction 31/08/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.31 -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  Mise  jour 25/01/2002 - LDP-man-pages-1.47 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>GETADDRINFO</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">voir aussi</a>
<br /><a class="summaryIndent0" href="#L5">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getaddrinfo, freeaddrinfo, gai_strerror - Traduction d'adresses et de services rseau.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;netdb.h&gt;</b> <b></b>  <br/><br/>

<b>int getaddrinfo(const char * </b> node <i>, const char * </i> service ,
<b>                   const struct addrinfo *</b> hints ,
<b>                   struct addrinfo ** </b> res );
<br/><br/>

<b>void freeaddrinfo(struct addrinfo * </b> res );
<br/><br/>

<b>char * gai_strerror(int </b> errcode );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>getaddrinfo (3)</b>
combine les possibilits offertes par les fonctions
<b>getipnodebyname (3),</b>
<b>getipnodebyaddr (3),</b>
<b>getservbyname (3),</b>
et 
<b>getservbyport (3)</b>
en une unique interface.
La fonction
<b>getaddrinfo (3)</b>
adapte aux contextes multithreads cre une ou plusieurs structures d'adresses de socket, utilisables par
<b>bind (2)</b>
et 
<b>connect (2)</b>
pour crer une socket de client ou de serveur.<br/><br/>
La fonction
<b>getaddrinfo (3)</b>
n'est pas limite aux structures d'adresses IPv4, 
elle permet galement la cration de structures IPv6 si le support en est disponible.
Ces structures peuvent tre utilises directement par
<b>bind (2)</b>
ou
<b>connect (2),</b>
pour prparer une socket de client ou de serveur.<br/><br/>
La structure
<b>addrinfo</b> <b></b>  utilise par cette fonction contient les membres suivants :
<br/><br/>


<b>struct</b> <b></b>  <b>addrinfo</b> <b></b>  <b>{"</b> <b></b>  <b>    int     </b> <i>ai_flags</i> <b>;</b>
<b>    int     </b> <i>ai_family</i> <b>;</b>
<b>    int     </b> <i>ai_socktype</i> <b>;</b>
<b>    int     </b> <i>ai_protocol</i> <b>;</b>
<b>    size_t  </b> <i>ai_addrlen</i> <b>;</b>
<b>    struct sockaddr *</b> <i>ai_addr</i> <b>;</b>
<b>    char   *</b> <i>ai_canonname</i> <b>;</b>
<b>    struct addrinfo *</b> <i>ai_next</i> <b>;</b>
<b>};"</b> <b></b>  
<br/><br/>
La fonction
<b>getaddrinfo (3)</b>
fait pointer
<i>res</i> vers une liste de structures
<b>addrinfo</b> <b></b>  nouvellement alloues, chanes par leurs membres
<i>ai_next .</i>
La liste peut contenir plusieurs structures
<b>addrinfo</b> <b></b>  pour plusieurs raisons, par exemple&nbsp;:
l'hte fonctionne en multi-home,
ou le mme service est disponible sur 
plusieurs types de sockets (une socket
<b>SOCK_STREAM</b> <b></b>  et une socket
<b>SOCK_DGRAM</b> <b></b>  par exemple).<br/><br/>
Les membres
<i>ai_family ,</i>
<i>ai_socktype ,</i>
et 
<i>ai_protocol</i> ont la mme signification que leurs homologues de l'appel-systme
<b>socket (2).</b>
La fonction
<b>getaddrinfo (3)</b>
renvoie les adresses de sockets autant en IPv4
qu'en IPv6
( ai_family</i>
contiendra
<b>PF_INET</b> <b></b>  ou
<b>PF_INET6 ).<br/><br/></b>
L'argument
<i>hints</i> permer de prciser 
le type prfr de socket ou de protocole.
Un argument
<i>hints</i> NULL indique que tout type d'adresse ou de protocole est acceptable.
Si ce paramtre n'est pas
<b>NULL</b> <b></b>  il doit pointeur sur une structure
<b>addrinfo</b> <b></b>  dont les
membres
<i>ai_family ,</i>
<i>ai_socktype ,</i>
et 
<i>ai_protocol</i> indique les types de socket prfrs.
<b>PF_UNSPEC</b> <b></b>  dans le membre
<i>ai_family</i> indique que toute famille de d'adresse (autant IPv4 que IPv6, par exemple) est acceptable.
De mme un 0 dans les membres
<i>ai_socktype</i> ou
<i>ai_protocol</i> indique que tout type de socket ou de protocole est admis.
Le membre
<i>ai_flags</i> indique des options supplmentaires
dcrites plus bas.
Divers attributs sont regroups par un OU binaire.
Tous les autres membres de l'argument
<i>hints</i> doivent contenir 0 ou tre des pointeurs NULL.<br/><br/>
L'argument
<i>node</i> ou l'argument
<i>service </i> peuvent tre NULL, mais pas les deux en mme temps.
<i>node</i> indique soit une adresse rseau en format numrique
(dcimal point pour l'IPv4, hexadcimal pour l'IPv6),
soit un nom d'hte, dont l'adresse rseau est alors rsolue.
Si le membre
<i>ai_flags</i> de l'argument
<i>hints</i> contient l'attribut
<b>AI_NUMERICHOST</b> <b></b>  alors le paramtre
<i>node</i> devra tre une adresse rseau numrique.
L'attribut
<b>AI_NUMERICHOST</b> <b></b>  empche toute tentative - ventuellement longue - de rsolution de nom d'hte.<br/><br/>
La fonction
<b>getaddrinfo (3)</b>
cre une liste chane de structures
<b>addrinfo ,</b>
une pour chaque adresse rseau soumise aux restrictions imposes
par l'argument
<i>hints .</i>
Le membre
<i>ai_canonname</i> pointera vers le nom officiel de l'hte si le membre
<i>ai_flags</i> de l'argument
<i>hints</i> contient l'attribut
<b>AI_CANONNAME .</b>
Les membres
<i>ai_family ,</i>
<i>ai_socktype ,</i>
et
<i>ai_protocol</i> indiquent les paramtres de cration de socket.
Un pointeur vers l'adresse de la socket est plac dans le membre
<i>ai_addr ,</i>
et la longueur de l'adresse de la socket, en octets,
est inscrite dans le membre
<i>ai_addrlen</i> de la structure.<br/><br/>
Si l'argument
<i>node</i> est NULL,
l'adresse rseau
dans chaque structure d'adresse est initialise en fonction de l'attribut
<b>AI_PASSIVE</b> <b></b>  que l'on inscrit dans le membre
<i>ai_flags</i> de l'argument
<i>hints .</i>
L'adresse rseau de chaque structure sera
laisse vide
si l'attribut
<b>AI_PASSIVE</b> <b></b>  est prsent.
Ceci est utilis par les serveurs qui dsirent accepter les
connexions des clients sur n'importe quelle interface rseau.
L'adresse rseau sera remplie avec l'adresse de boucle loopback
si l'attribut
<b>AI_PASSIVE</b> <b></b>  n'est pas utilis.
Ceci est utilis par les clients qui dsirent se connecter sur
un serveur fonctionnant sur le mme hte.<br/><br/>
L'argument
<i>service</i> indique le numro de port au sein de l'adresse rseau de la socket. Si
<i>service</i> est NULL le numro de port restera non initialis.<br/><br/>
La fonction
<b>freeaddrinfo (3)</b>
libre la mmoire qui a t alloue
dynamiquement pour la liste chane
<i>res .</i>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>getaddrinfo (3)</b>
renvoie 0 si elle russit, ou l'un des codes d'erreur non-nuls suivants :
<br/><br/>

<b>EAI_FAMILY</b> <b></b>  La famille d'adresse rclame n'est pas supporte du tout.
<br/><br/>

<b>EAI_SOCKTYPE</b> <b></b>  Le type de socket demand n'est pas support.
<br/><br/>

<b>EAI_BADFLAGS</b> <b></b>  <i>ai_flags</i> contient des attributs invalides.
<br/><br/>

<b>EAI_NONAME</b> <b></b>  Le contenu du champ
<i>node</i> ou de 
<i>service</i> est inconnu.
Cette erreur est aussi renvoye si 
<i>node</i> et 
<i>service</i> sont simultanment NULL.
<br/><br/>

<b>EAI_SERVICE</b> <b></b>  Le service demand n'est pas disponible pour le type de socket rclam.
Il peut tre disponible pour un autre type de socket.
<br/><br/>

<b>EAI_ADDRFAMILY</b> <b></b>  L'hte indiqu n'a pas d'adresse dans la 
famille rseau demande.
<br/><br/>

<b>EAI_NODATA</b> <b></b>  L'hte existe mais n'a pas
d'adresse rseau dfinie.
<br/><br/>

<b>EAI_MEMORY</b> <b></b>  Pas assez de mmoire.
<br/><br/>

<b>EAI_FAIL</b> <b></b>  Le serveur de noms a renvoy une erreur dfinitive.
<br/><br/>

<b>EAI_AGAIN</b> <b></b>  Le serveur de noms a renvoy une erreur temporaire.
Ressayez plus tard.
<br/><br/>

<b>EAI_SYSTEM</b> <b></b>  Autre erreur systme, voir
<i>errno</i> pour plus de dtail.<br/><br/>
La fonction
<b>gai_strerror (3)</b>
traduit ces codes d'erreur en une chane de caractres comprhensible,
utilisable pour rendre compte du problme.
</div><br/><br /><h1 class="TitreSection0" id="L5">voir aussi</h1>
<div class="paragraph">
<b>getipnodebyname (3),</b>
<b>getipnodebyaddr (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
