<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  (c) 1993 by Thomas Koenig (ig25@rz.uni-karlsruhe.de) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  License. -->
<!--  Modified Wed Jul 21 22:35:42 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  Modified 18 Mar 1996 by Martin Schulze (joey@infodrom.north.de): -->
<!--    Corrected description of getwd(). -->
<!--  -->
<!--  -->
<!--  Traduction 26/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>GETCWD</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getcwd, get_current_dir_name, getwd - Obtenir le rpertoire courant.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <br/><br/>

<b>char * getcwd (char * </b> buf <i>, size_t </i> size );
<b></b>  <b>char</b> <b></b>  <b>*</b> <b></b>  <b>get_current_dir_name</b> <b></b>  <b>(void);"</b> <b></b>  <b>char * getwd (char * </b> buf );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>getcwd ()</b>
copie le chemin d'accs absolu du rpertoire de travail courant dans la chane
pointe par
<i>buf ,</i>
qui est de longueur
<i>size .<br/><br/></i>
Si le chemin du rpertoire en cours ncessite un buffer plus long que
<i>size</i> octets, la fonction renvoie
<b>NULL ,</b>
et
<i>errno</i> contient le code d'erreur
<b>ERANGE .</b>
Une application doit dtecter cette erreur et allouer un buffer plus grand
si besoin est.<br/><br/>
Si
<i>buf</i> est NULL, le comportement de
<b>getcwd ()</b>
est indfini.<br/><br/>
Comme extension du standard POSIX.1, la version Linux (LibC4, LibC5, GlibC) de 
<b>getcwd()</b> <b></b>  alloue le buffer dynamiquement, en utilisant
<b>malloc (),</b>
si
<i>buf</i> est
<b>NULL</b> <b></b>  lors de l'appel.  Alors, le buffer allou a la longueur
<i>size</i>  moins que
<i>size</i> soit infrieure  zro, dans ce cas
<i>buf</i> a la taille ncessaire. Il est possible (et mme fortement conseill) de
librer le buffer avec
<b>free()</b> <b></b>  lorsqu'il a t obtenu ainsi.<br/><br/>
<b>get_current_dir_name ,</b>
qui ne possde un prototype que si la constante
<b>_GNU_SOURCE</b> <b></b>  est dfinie, allouera avec
<b>malloc (3)</b>
une chane suffisament grande pour contenir le nom du rpertoire. Si la
variable d'environnement 
<b>PWD</b> <b></b>  est configure, et correcte, cette valeur sera renvoye.<br/><br/>
<b>getwd ,</b>
qui ne possde un prototype que si les constantes
<b>_BSD_SOURCE</b> <b></b>  ou
<b>_XOPEN_SOURCE_EXTENDED</b> <b></b>  sont dfinies, n'allouera aucune mmoire.
L'argument
<i>buf</i> doit tre un pointeur sur une chane comportant au moins
<b>PATH_MAX</b> <b></b>  octets.
<b>getwd</b>
ne renverra que les
<b>PATH_MAX</b> <b></b>  premiers octets du nom rel.
Notez que
<b>PATH_MAX</b> <b></b>  n'est pas ncessairement une constante  la compilation. Elle peut dpendre du
systme de fichiers, voire tre illimite. Pour des raisons de portabilit et
de scurir, on dconseille l'utilisation de
<b>getwd .</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>NULL</b> <b></b>  en cas d'chec, avec
<i>errno</i> contenant le code d'erreur. En cas de russite
<i>buf</i> est renvoy. Le contenu de la chane pointe par
<i>buf</i> est indfini en cas d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EACCES</b> <b></b>  Impossible de lire ou de parcourir un composant du chemin d'accs.
<br/><br/>

<b>EFAULT</b> <b></b>  <i>buf</i>
pointe sur une adresse illgale.
<br/><br/>

<b>EINVAL</b> <b></b>  L'argument
<i>size </i>
vaut zro et
<i>buf</i>
n'est pas un pointeur NULL.
<br/><br/>

<b>ENOENT</b> <b></b>  Le rpertoire en cours a t supprim.
<br/><br/>

<b>ERANGE</b> <b></b>  L'argument
<i>size </i>
est infrieur  la longueur du nom du rpertoire.
Allouez un buffer plus grand et r-essayez.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Sous Linux, la fonction
<b>getcwd ()</b>
est un appel-systme (depuis le 2.1.92).
Sur des systmes plus anciens, elle interrogerait
<i>/proc/self/cwd .</i>
Si l'appel-systme et le systme de fichiers proc sont absents, une implmentation
gnrique est utilise. Dans ce cas seulement la fonction peut renvoyer
<b>EACCES</b> <b></b>  sous Linux.<br/><br/>
Ces fonctions sont souvent utilises pour sauver le rpertoire de travail
afin d'y revenir plus tard. Ouvrir le rpertoire courant (".") et appeler
<b>fchdir (2)</b>
pour y revenir est habituellement une alternative plus rapide et plus fiable
(surtout sur d'autres systmes que Linux) si l'on dispose de suffisament de
descripteurs de fichiers.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
POSIX.1
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>chdir (2),</b>
<b>fchdir (2),</b>
<b>open (2),</b>
<b>unlink (2),</b>
<b>free (3),</b>
<b>malloc (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
