<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 2002 Andries Brouwer (aeb@cwi.nl) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Inspired by a page written by Walter Harms. -->
<!--  -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>GETFSENT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">historique</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getfsent, getfsspec, getfsfile, setfsent, endfsent - Lire la table des systmes de fichiers.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;fstab.h&gt;</b> <b></b>  <br/><br/>

<b>void endfsent(void);</b>
<br/><br/>

<b>struct fstab *getfsent(void);</b>
<br/><br/>

<b>struct fstab *getfsfile(const char *</b> mount_point );
<br/><br/>

<b>struct fstab *getfsspec(const char *</b> special_file );
<br/><br/>

<b>int setfsent(void);</b>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Ces fonctions lisent dans le fichier
<i>/etc/fstab .</i>
La structure fstab est dfinie ainsi&nbsp;:<br/><br/>

struct fstab {
     char *fs_spec;          /* nom du priphrique bloc */
     char *fs_file;          /* point de montage */
     char *fs_vfstype;       /* type systme de fichiers */
     char *fs_mntops;        /* options de montage */
     const char *fs_type;    /* option rw/rq/ro/sw/xx */
     int fs_freq;            /* priode sauvegarde en jours */
     int fs_passno;          /* numro de passage parallle */
};


Ici, le champ
<i>fs_type</i> contient (sur un systme type BSD)
l'une des cinq chanes "rw", "rq", "ro", "sw", "xx"
(read-write, read-write et quotas, read-only, swap, ignore).<br/><br/>
La fonction
<b>setfsent()</b> <b></b>  ouvre le fichier au besoin et se positionne sur la premire ligne.<br/><br/>
La fonction
<b>getfsent()</b> <b></b>  examine la ligne suivante du fichier.
(Aprs ouverture si besoin).<br/><br/>
La fonction
<b>endfsent()</b> <b></b>  ferme le fichier si ncessaire.<br/><br/>
La fonction
<b>getfsspec()</b> <b></b>  recherche dans le fichier la premire entre pour laquelle le
champ
<i>fs_spec</i> corresponde 
l'argument
<i>special_file .<br/><br/></i>
La fonction
<b>getfsfile()</b> <b></b>  recherche dans le fichier la premire entre pour laquelle le
champ
<i>fs_file</i> corresponde 
l'argument
<i>mount_point .</i>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Si elles russissent, les fonctions
<b>getfsent() ,</b>
<b>getfsfile() ,</b>
et
<b>getfsspec()</b>
renvoient un pointeur sur une structure fstab, et
<b>setfsent()</b>
renvoie 1.
En chec ou en fin de fichier, ces fonctions renvoient NULL et 0, respectivement.
</div><br/><br /><h1 class="TitreSection0" id="L5">historique</h1>
<div class="paragraph">
La fonction
<b>getfsent()</b> <b></b>  est apparue dans 4.0BSD, les quatre autres fonctions dans 4.3BSD.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
Ces fonctions ne sont pas dans POSIX. Plusieurs systmes d'exploitation les 
proposent&nbsp;: *BSD, SunOS, Digital Unix, AIX (qui a galement une fonction
<i>getfstype() ).</i>
HP-UX a des fonctions avec les mmes noms, mais utilise une struct checklist
plutt que la struct fstab, et ces fonctions sont obsoltes, remplaces par
<b>getmntent (3).</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
Ces routines ne sont pas sres dans un contexte multi-threads.<br/><br/>
Comme Linux autorise le montage d'un priphrique bloc en plusieurs endroits,
comme plusieurs priphriques peuvent avoir le mme point de montage (le
dernier est celui qui compte), et comme
<b>getfsfile()</b> <b></b>  et
<b>getfsspec()</b> <b></b>  ne renvoient que les premires occurrences, ces deux fonctions ne sont pas
trs utilisables sous Linux.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>getmntent (3),</b>
<b>fstab (5)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
