<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 19:29:54 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 26/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a jour 21/07/1997 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>GETGRENT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">fichiers</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getgrent, setgrent, endgrent - Lire les enregistrement du fichier des groupes.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;grp.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <br/><br/>

<b>struct</b> <b></b>  <b>group</b> <b></b>  <b>*getgrent</b> <b></b>  <b>(void);</b> <b></b>  <br/><br/>

<b>void</b> <b></b>  <b>setgrent</b> <b></b>  <b>(void);</b> <b></b>  <br/><br/>

<b>void</b> <b></b>  <b>endgrent</b> <b></b>  <b>(void);</b> <b></b>  

</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>getgrent()</b> renvoie un pointeur sur une structure contenant
les enregistrements de groupes issus de <i>/etc/group</i>(5).  
Au premier appel elle renvoie le premier enregistrement, puis les autres
enregistrements lors des autres appels successifs.<br/><br/>
La fonction <b>setgrent()</b> ramne le pointeur au dbut du
fichier <i>/etc/group</i>.<br/><br/>
La fonction <b>endgrent()</b> ferme le fichier <i>/etc/group</i>.<br/><br/>
La structure <i>group</i> est dfinie dans <i>&lt;grp.h&gt;</i> ainsi :
<br/><br/>

.RS

.ta 8n 16n 32n
struct group {
     char   *gr_name;    /* Nom du groupe.          */
     char   *gr_passwd;  /* Mot de passe du groupe. */
     gid_t   gr_gid;     /* ID du groupe.           */
     char  **gr_mem;     /* Membres du groupe.      */
};
.ta



</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>getgrent()</b> renvoie la structure de groupe, ou NULL s'il
n'y a plus d'enregistrements, ou si une erreur se produit.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>ENOMEM</b> <b></b>  Pas assez de mmoire pour allouer une structure.
</div><br/><br /><h1 class="TitreSection0" id="L6">fichiers</h1>
<div class="paragraph">
<br/><br/>

<i>/etc/group</i> Base de donnes des groupes.


</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SVID 3, BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>fgetgrent (3),</b>
<b>getgrnam (3),</b>
<b>getgrgid (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
