<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 2000 Sam Varshavchik &lt;mrsam@stop.mail-abuse.org&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References: RFC 2553 -->
<!--  Traduction 31/08/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.31 -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  Mise  jour 25/01/2002 - LDP-man-pages-1.47 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>GETIPNODEBYNAME</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">notes</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getipnodebyname, getipnodebyaddr, freehostent - Obtenir les adresses rseau et noms d'hte.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;netdb.h&gt;</b> <b></b>  <br/><br/>

<b>struct hostent * getipnodebyname (const char * </b> name ,
<b>                         int </b> af <i>, int </i> flags ,
<b>                         int * </b> error_num );
<br/><br/>

<b>struct hostent * igetipnodebyaddr (const void * </b> addr ,
<b>                         size_t </b> len <i>, int </i> af ,
<b>                         int </b> flags <i>, int * </i> error_num );
<br/><br/>

<b>void freehostent (struct hostent * </b> ip );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Ces fonctions sont dconseilles. Utilisez
<b>getaddrinfo (3)</b>
et
<b>getnameinfo (2)</b>
 leur place.<br/><br/>
Les fonctions
<b>getipnodebyname (3)</b>
et
<b>getipnodebyaddr (3)</b>
renvoient le nom et l'adresse rseau d'un hte.
Ces fonctions renvoient un pointeur 
sur une structure dfinie comme suit :
<br/><br/>


<b>struct</b> <b></b>  <b></b>  <b>hostent</b> <b></b>  <b>{</b> <b></b>  <b>        char    *</b> <i>h_name</i> <b>;</b>
<b>        char    **</b> <i>h_aliases</i> <b>;</b>
<b>        int     </b> <i>h_addrtype</i> <b>;</b>
<b>        int     </b> <i>h_length</i> <b>;</b>
<b>        char    **</b> <i>h_addr_list</i> <b>;</b>
};

<br/><br/>
Ces fonctions remplacent les fonctions
<b>gethostbyname (3)</b>
et 
<b>gethostbyaddr (3)</b>
qui ne pouvaient qu'accder aux adresses rseau de la famille IPv4.
Les fonctions
<b>getipnodebyname (3)</b>
et
<b>getipnodebyaddr (3)</b>
peuvent fonctionner avec diverses familles d'adresses rseau.<br/><br/>
Contrairement aux fonctions du type
<b>gethostby ,</b>
Ces routines
renvoient des pointeurs
sur des zones de mmoires alloues dynamiquement.
La fonction
<b>freehostent (3)</b>
sert  librer la zone de mmoire alloue dynamiquement
une fois que l'on n'a plus besoin des
informations se trouvant dans la structure
<b>hostent .</b>
</div><br/><h2 class="TitreSection1" id="L9">Arguments de getipnodebyname</h2>
<div class="paragraph">
La fonction
<b>getipnodebyname (3)</b>
recherche l'adresse
rseau de l'hte indiqu
dans son
argument
<i>name .</i>
L'argument
<i>af</i> prend l'une des valeurs suivantes :
<br/><br/>

<b>AF_INET</b> <b></b>  Le paramtre
<i>name</i> reprsente une adresse dcimale pointe IPv4, ou le nom 
d'un hte sur un rseau IPv4.
<br/><br/>

<b>AF_INET6</b> <b></b>  Le paramtre
<i>name</i> reprsente une adresse hexadcimale IPv6, ou le nom 
d'un hte sur un rseau IPv6.<br/><br/>
L'argument
<i>flags</i> indique des options supplmentaires.
Plusieurs options peuvent tre indiques en 
les regroupant par un OU binaire.
<i>flags</i> doit tre mis  0
si aucune option n'est dsire.
<br/><br/>

<b>AI_V4MAPPED</b> <b></b>  Cet attribut est utilis avec
<b>AF_INET6</b> <b></b>  pour demander de rechercher une adresse IPv4 plutt
qu'une IPv6. L'adresse IPv4 devra toutefois
tre projete dans l'espace IPv6.
<br/><br/>

<b>AI_ALL</b> <b></b>  Cet attribut est utilis avec
<b>AI_V4MAPPED</b> <b></b>  pour demander une recherche simultane d'adresses IPv4 et IPv6.
Toute adresse IPv4 trouve sera projete dans l'espace IPv6.
<br/><br/>

<b>AI_ADDRCONFIG</b> <b></b>  Cet attribut est utilis avec
<b>AF_INET6</b> <b></b>  pour indiquer que les requtes ultrieures d'adresses IPv6
n'auront pas lieu  moins que le systme n'ait au moins une
adresse IPv6 affecte  une interface rseau. Symtriquement, 
les requtes d'adresses IPv4 n'auront lieu que si
le systme dispose au mons d'une adresse IPv4 affecte  une interface rseau.
Cet attribut peut tre utilis seul ou
avec
<b>AI_V4MAPPED .</b>
<br/><br/>

<b>AI_ALL</b> <b></b>  Cet attribut est quivalent 
<b>(AI_ADDRCONFIG | AI_V4MAPPED)</b> .</b>
</div><br/><h2 class="TitreSection1" id="L9">Arguments de getipnodebyaddr</h2>
<div class="paragraph">
La fonction
<b>getipnodebyaddr (3)</b>
recherche le nom d'un hte dont
l'adresse rseau
est indique
par
l'argument
<i>addr .</i>
L'argument
<i>af</i> prend l'une des valeurs suivantes :
<br/><br/>

<b>AF_INET</b> <b></b>  L'argument
<i>addr</i> pointe vers une structure
<b>struct</b> <b></b>  <b>in_addr"</b> <b></b>  et 
<i>len</i> doit valoir
<b>sizeof(struct in_addr)</b> .</b>
<br/><br/>

<b>AF_INET6</b> <b></b>  L'argument
<i>addr</i> pointe vers une structure
<b>struct</b> <b></b>  <b>in6_addr"</b> <b></b>  et 
<i>len</i> doit valoir
<b>sizeof(struct in6_addr)</b> .</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
En cas d'erreur, un pointeur NULL est renvoy, et
<i>error_num</i> contiendra un code d'erreur parmi les suivants :
<br/><br/>

<b>HOST_NOT_FOUND</b> <b></b>  Le nom d'hte ou l'adresse rseau n'ont pas t trouvs.
<br/><br/>

<b>NO_ADDRESS</b> <b></b>  Le serveur de noms reconnait l'adresse rseau ou le nom, 
mais n'a pas fourni de rponse.
Ceci peut se produire si l'hte n'a que des adresse IPv4, et
qu'on a demand uniquement des informations IPv6, ou l'inverse.
<br/><br/>

<b>NO_RECOVERY</b> <b></b>  Le serveur de noms a renvoy une erreur dfinitive.
<br/><br/>

<b>TRY_AGAIN</b> <b></b>  Le serveur de noms a renvoy une erreur temporaire.
Ressayez plus tard.<br/><br/>
Une recherche couronne de succs renvoie un pointeur sur une structure
<b>hostent</b> <b></b>  contenant les champs suivants&nbsp;:
<br/><br/>

<b>h_name</b> <b></b>  Nom officiel de l'hte.
<br/><br/>

<b>h_aliases</b> <b></b>  Table de pointeurs vers des alias non-officiels du mme hte.
La table est termine par un pointeur NULL.
<br/><br/>

<b>h_addrtype</b> <b></b>  Il s'agit d'une copie de l'argument
<i>af</i> de
<b>getipnodebyname (3)</b>
ou
<b>getipnodebyaddr (3).</b>
<i>h_addrtype</i> sera toujours
<b>AF_INET</b> <b></b>  si l'argument
<i>af</i> tait
<b>AF_INET .</b>
<i>h_addrtype</i> sera toujours
<b>AF_INET6</b> <b></b>  si l'argument
<i>af</i> tait
<b>AF_INET6 .</b>
<br/><br/>

<b>h_length</b> <b></b>  Ce champ contiendra la longueur
<b>sizeof(struct</b> <b></b>  <b>in_addr)</b> <b></b>  si
<i>h_addrtype</i> est AF_INET, et
<b>sizeof(struct</b> <b></b>  <b>in6_addr)</b> <b></b>  si
<i>h_addrtype</i> vaut AF_INET6.
<br/><br/>

<b>h_addr_list</b> <b></b>  Il s'agit d'une table de pointeurs vers les structures d'adresse
de l'hte.
La table est termine par un pointeur NULL.
</div><br/><br /><h1 class="TitreSection0" id="L5">notes</h1>
<div class="paragraph">
Ces fonctions taient prsentes dans la GlibC 2.1.91-95, mais en ont t
retires. Plusieurs systmes de type Unix les supportent, mais tous les
considrent comme dconseilles.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
RFC 2553
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>getaddrinfo (3),</b>
<b>getnameinfo (3),</b>
<b>inet_ntop (3),</b>
<b>inet_pton (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
