<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) 2001 John Levon &lt;moz@compsoc.man.ac.uk&gt; -->
<!--  Based in part on GNU libc documentation -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  License. -->
<!--   -->
<!--  Traduction 06/05/2002 par Stphan Rafin (stephan.rafin@laposte.net) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  -->
<br/><h1>GETLINE</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">exemple</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getline, getdelim - Saisie de chane dlimite.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#define</b> <b></b>  <b>_GNU_SOURCE</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;stdio.h&gt;</b> <b></b>  <br/><br/>

<b>ssize_t getline(char **</b> lineptr <i>, size_t *</i> n <b>, FILE *</b> stream );
.nl
<b>ssize_t getdelim(char **</b> lineptr <i>, size_t *</i> n <b>, int </b> delim <i>, FILE *</i> stream );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>getline()</b> <b></b>  lit une ligne entire et stocke l'adresse du tampon contenant 
le texte dans
<i>*lineptr</i>.</i>
Le tampon se termine par un 0 terminal et inclut le caractre saut-de-ligne, 
si un tel sparateur a t trouv.<br/><br/>
<!--  FIXME: what happens if *lineptr is NULL but *n isn't zero ? -->
<!--  Answer: *n is ignored and a new buffer is allocated -->
Si
<i>*lineptr</i></i>
vaut
<b>NULL</b>,</b>
la routine
<b>getline()</b>
alloue un tampon pour recevoir la ligne, ce tampon devra tre libr par le programme
utilisateur.
Alternativement, avant d'appeler
<b>getline()</b>,</b>
<i>*lineptr</i></i>
peut contenir un pointeur vers un tampon allou par
<b>malloc()</b></b>
et de taille 
<i>*n</i></i>
octets. Si le buffer n'est pas suffisant pour recevoir la ligne saisie,
<b>getline()</b> <b></b>  redimensionne le tampon afin de s'adapter grce  
<b>realloc()</b>,</b>
mettant  jour
<i>*lineptr</i></i>
et
<i>*n</i></i>
comme il se doit. Quoi qu'il en soit, en cas de succs,
<i>*lineptr</i></i>
et
<i>*n</i></i>
seront adapts afin de rendre compte respectivement de l'adresse et 
de la taille du tampon.<br/><br/>
<b>getdelim()</b>
fonctionne comme 
<b>getline()</b>,</b>
si ce n'est qu'un sparateur diffrent de saut-de-ligne peut tre spcifi
en tant qu'argument 
<i>delimiter.</i>
Tout comme avec
<b>getline()</b>,</b>
aucun sparateur n'est ajout s'il n'y en avait pas
dans l'entre avant que la fin du fichier ne soit atteinte.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
En cas de succs,
<b>getline()"</b> <b></b>  et
<b>getdelim()"</b> <b></b>  renvoient le nombre de caractres lus, sparateur inclus,
mais sans compter le zro terminal. Cette valeur peut tre utilise
afin de traiter les caractres null insrs dans la ligne lue.<br/><br/>
Les deux fonctions renvoient -1 en cas d'chec de lecture de la ligne (condition de fin de fichier incluse)<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EINVAL</b> <b></b>  Paramtres errons
( n</i>
ou
<i>lineptr</i> valent NULL, ou bien
<i>stream</i> n'est pas valide).<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">exemple</h1>
<div class="paragraph">

#define _GNU_SOURCE
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;<br/><br/>
int main(void)
{
	FILE * fp;
	char * line = NULL;
	size_t len = 0;
	ssize_t read;
	fp = fopen("/etc/motd", "r");
	if (fp == NULL)
		exit(EXIT_FAILURE);
	while ((read = getline(&line, &len, fp)) != -1) {
		printf("Retrieved line of length %zu :\en", read);
		printf("%s", line);
	}
	if (line)
		free(line);
	return EXIT_SUCCESS;
}


</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
getline() tout comme getdelim() sont des extensions GNU.
Elles sont disponibles depuis la libc 4.6.27.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>read (2),</b>
<b>fopen (3),</b>
<b>fread (3),</b>
<b>gets (3),</b>
<b>fgets (3),</b>
<b>scanf (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Stphan Rafin, 2002.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
