<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 21:46:57 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 27/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!-- 	mise a jour 25/01/97 -->
<!--  mj 11/12/1997 (LDP man-pages 1.18) -->
<!--  mj 26/06/2000 LDP 1.30 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>GETMNTENT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">fichiers</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getmntent, setmntent, addmntent, endmntent, hasmntopt - Obtenir des descriptions d'un systme de fichiers.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdio.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;mntent.h&gt;</b> <b></b>  <br/><br/>

<b>FILE *setmntent (const char *</b> filename <i>, const char *</i> type );
<br/><br/>

<b>struct mntent *getmntent (FILE *</b> filep );
<br/><br/>

<b>int addmntent (FILE *</b> filep <i>, const struct mntent *</i> mnt );
<br/><br/>

<b>int endmntent (FILE *</b> filep );
<br/><br/>

<b>char *hasmntopt (const struct mntent *</b> mnt <i>, const char *</i> opt );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Ces routines servent  accder au fichier de description des
systmes de fichiers <i>/etc/fstab</i> et aux descriptions des
systmes de fichiers monts <i>/etc/mtab</i>.<br/><br/>
La fonction <b>setmntent()</b> ouvre le fichier de description des
systmes de fichiers <i>filep</i> et renvoie un pointeur de fichier
utilisable avec <b>getmntent()</b>.
L'argument <i>type</i> est le type d'accs demand, et peut prendre les
mme valeurs que l'argument <i>mode</i> de <b>fopen</b>(3).<br/><br/>
La fonction <b>getmntent()</b> lit la ligne suivante du fichier de description
des systmes de fichiers <i>filep</i> et renvoie un pointeur sur une structure
dtaillant les champs de cette ligne. Il s'agit d'un pointeur sur une zone
de donnes statiques, qui peut tre crase par les appels ultrieurs 
<b>getmntent()</b>.<br/><br/>
La fonction <b>addmntent()</b> ajoute la structure mntent <i>mnt</i>  la
fin du fichier ouvert <i>filep</i>.<br/><br/>
La fonction <b>endmntent()</b> ferme le fichier de description des systmes
de fichiers <i>filep</i>.<br/><br/>
La fonction <b>hasmntopt()</b> parcourt le champ <i>mnt_opts</i>
(voir plus bas) de la structure mntent <i>mnt</i>,  la recherche
d'une chane correspondant  <i>opt</i>.
Voir <i>&lt;mntent.h&gt;</i> pour les options de montage.<br/><br/>
La structure <i>mntent</i> est dfinie dans <i>&lt;mntent.h&gt;</i> ainsi :
<br/><br/>

.RS

.ne 8
.ta 8n 16n 32n
struct mntent {
   char *mnt_fsname; /* Nom du systme de fichiers mont      */
   char *mnt_dir;    /* Chemin d'accs au systme de fichiers */
   char *mnt_type;   /* Type de montage (voir mntent.h)       */
   char *mnt_opts;   /* Options de montage (voir mntent.h)    */
   int   mnt_freq;   /* Frquence de sauvegarde (en jour)     */
   int   mnt_passno; /* Ordre de passage dans fsck            */
};
.ta



</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>getmntent()</b> renvoie un pointeur sur la structure mntent,
ou NULL en cas d'chec.<br/><br/>
La fonction <b>addmntent()</b> renvoie 0 si elle russit, et 1 si elle choue.<br/><br/>
La fonction <b>endmntent()</b> renvoie toujours 1.<br/><br/>
La fonction <b>hasmntopt()</b> renvoie l'adresse de la sous-chane si une
correspondance est trouve, ou NULL sinon.
</div><br/><br /><h1 class="TitreSection0" id="L5">fichiers</h1>
<div class="paragraph">

/etc/fstab  Description des systmes de fichiers.
/etc/mtab   Description des systmes de fichiers monts.


</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
SunOS 4.1.3
</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
SysV a aussi une fonction <b>getmntent</b>() mais l'appel est
diffrent, ainsi que la structure renvoye. Sous SysV, le
fichier <i>/etc/mnttab</i> est employ.
BSD 4.4 et Digital Unix ont une routine <b>getmntinfo</b>(),
qui sert  invoquer l'appel-systme <b>getfsstat</b>().
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>fopen (3),</b>
<b>fstab (5)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
