<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  This page is in the public domain. -->
<!--  Almost all details are from RFC 2553. -->
<!--  -->
<!--  Traduction 08/05/2002 par Stphan Rafin (stephan.rafin@laposte.net) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  --><br/><br/>
<br/><h1>getnameinfo</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">fichiers</a>
<br /><a class="summaryIndent0" href="#L6">note</a>
<br /><a class="summaryIndent0" href="#L7">exemples</a>
<br /><a class="summaryIndent0" href="#L8">conformit</a>
<br /><a class="summaryIndent0" href="#L9">voir aussi</a>
<br /><a class="summaryIndent0" href="#L10">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getnameinfo - Traduction d'adresse en nom de faon indpendante du protocole
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;netdb.h&gt;</b> <b></b>  <br/><br/>

<b>int getnameinfo(const struct sockaddr *</b> <i>sa</i> <b>, socklen_t </b> <i>salen</i> ,
<b>                char *</b> <i>host</i> <b>, size_t </b> <i>hostlen</i> ,
<b>                char *</b> <i>serv</i> <b>, size_t </b> <i>servlen</i> <b>, int </b> <i>flags</i> );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>getnameinfo (3)</b>
est dfinie afin de traduire des adresses en noms de noeuds de faon indpendante du protocole. Elle combine les fonctionnalits de
<b>gethostbyaddr (3)</b>
et
<b>getservbyport (3)</b>
et constitue la rciproque de 
<b>getaddrinfo (3).</b>
Le paramtre
<i>sa</i> est un pointeur vers l'adresse d'une structure de socket gnrique
(de type
<i>sockaddr_in</i> ou
<i>sockaddr_in6 )</i>
de taille
<i>salen</i>
qui contient l'adresse IP d'entre et le numro de port.
Les parmtres
<i>host</i> et
<i>serv</i> sont des pointeurs vers des tampons (de tailles respectives
<i>hostlen</i> et 
<i>servlen</i> ) destins  recevoir les valeurs renvoyes.<br/><br/>
L'appelant peut prciser qu'aucun nom d'hte (ou qu'aucun nom de service)
n'est ncessaire en fournissant NULL comme paramtre
<i>host</i> (ou
<i>serv )</i>
ou bien en passant un argument
<i>hostlen</i> (ou
<i>servlen )</i>
valant zro. Quoi qu'il en soit, au moins un nom d'hte ou un nom de service
doit tre demand.<br/><br/>
Le paramtre
<i>flags</i> modifie le comportement de 
<b>getnameinfo (3)</b>
comme indiqu ci dessous :
<br/><br/>

<b>NI_NOFQDN</b> <b></b>  renvoie seulement la partie nom de l'hte du FQDN (Fully-Qualified Domain Name) pour les htes locaux.
<br/><br/>

<b>NI_NUMERICHOST</b> <b></b>  La forme numrique du nom de l'hte est renvoye.
<!--  For example, by calling -->
<!--  <i>inet_ntop() --></i> <!--  instead of -->
<!--  <i>gethostbyaddr() . --></i>
(Mme si ce drapeau n'est pas lev, cela arrivera galement lorsque le
nom du noeud ne pourra pas tre rsolu.)
<br/><br/>

<b>NI_NAMEREQD</b> <b></b>  renvoie une erreur si le nom de l'hte ne peut tre rsolu.
<br/><br/>

<b>NI_NUMERICSERV</b> <b></b>  L'adresse du service est renvoye sous forme numrique, par exemple
sous la forme de son numro de port.
<br/><br/>

<b>NI_DGRAM</b> <b></b>  Indique que le service est plutt bas sur des datagrammes (UDP)
que sur un flux connect (TCP). Ce drapeau est ncessaire pour les
quelques ports (512-514) qui ont des services diffrents selon
le protocole utilis : UDP ou TCP.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
En cas de succs, 0 est renvoy, et, les noms du noeud et du service, s'ils
sont demands, sont renseigns sous forme de chanes  zro terminal, ventuellement
tronques afin de s'adapter aux tailles des tampons spcifis.
En cas d'erreur, une valeur non nulle est renvoye, et 
<i>errno</i> est affecte de faon adquate.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EAI_AGAIN</b> <b></b>  Le nom ne peut tre rsolu en ce moment. Ressayer plus tard.
<br/><br/>

<b>EAI_BADFLAGS</b> <b></b>  Le paramtre
<i>flags</i> n'est pas valide.
<br/><br/>

<b>EAI_FAIL</b> <b></b>  Une erreur irrcuprable est survenue.
<br/><br/>

<b>EAI_FAMILY</b> <b></b>  La famille d'adresse n'a pas t reconnue,
ou bien la taille de l'adresse tait invalide pour la famille spcifie.
<br/><br/>

<b>EAI_MEMORY</b> <b></b>  Pas assez de mmoire.
<br/><br/>

<b>EAI_NONAME</b> <b></b>  Le nom ne peut tre rsolu avec les paramtres fournis.
NI_NAMEREQD est spcifi et le nom de l'hte ne peut tre localis,
ou bien, on n'a demand ni un nom d'hte ni un nom de service.
<br/><br/>

<b>EAI_SYSTEM</b> <b></b>  Une erreur systme a eu lieu. Le code d'erreur peut tre lu dans 
<i>errno .</i>
</div><br/><br /><h1 class="TitreSection0" id="L6">fichiers</h1>
<div class="paragraph">
/etc/hosts
<br/>
/etc/nsswitch.conf
<br/>
/etc/resolv.conf
</div><br/><br /><h1 class="TitreSection0" id="L7">note</h1>
<div class="paragraph">
Afin d'aider les programmeurs  choisir des tailles raisonnables
pour les tampons fournis,
<i>&lt;netdb.h&gt;</i> dfinit les constantes
.RS

# define NI_MAXHOST      1025
<br/>
# define NI_MAXSERV      32



La premire est la constante MAXDNAME prsente dans les versions rcentes du 
fichier header  
<i>&lt;arpa/nameser.h&gt;</i> de BIND. 
La deuxime est dtermine en se basant sur les services rpertoris 
dans la RFC "Assigned numbers" (Numros affects) actuelle.
</div><br/><br /><h1 class="TitreSection0" id="L8">exemples</h1>
<div class="paragraph">
Le code suivant essaie d'obtenir le nom de l'hte ainsi que le nom du service
sous forme numrique, et ce, pour une adresse de socket donne. Remarquez qu'il
 n'y a aucune rfrence  une quelconque famille d'adresse code en dur.<br/><br/>
.RS

  struct sockaddr *sa;    /* input */
  char hbuf[NI_MAXHOST], sbuf[NI_MAXSERV];<br/><br/>
  if (getnameinfo(sa, sa-&gt;sa_len, hbuf, sizeof(hbuf), sbuf,
      sizeof(sbuf), NI_NUMERICHOST | NI_NUMERICSERV) == 0)
          printf("host=%s, serv=%s\en", hbuf, sbuf);


<br/><br/>
La version suivante vrifie si l'adresse de la socket peut
se voir associer un nom. <br/><br/>
.RS


  struct sockaddr *sa;    /* input */
  char hbuf[NI_MAXHOST];<br/><br/>
  if (getnameinfo(sa, sa-&gt;sa_len, hbuf, sizeof(hbuf),
      NULL, 0, NI_NAMEREQD))
         printf("could not resolve hostname");
  else
         printf("host=%s\en", hbuf);



</div><br/><br /><h1 class="TitreSection0" id="L9">conformit</h1>
<div class="paragraph">
RFC 2553. (Voir aussi XNS, rvision 5.2.)
</div><br/><br /><h1 class="TitreSection0" id="L10">voir aussi</h1>
<div class="paragraph">
<b>getaddrinfo (3),</b>
<b>gethostbyaddr (3),</b>
<b>getservbyname (3),</b>
<b>getservbyport (3),</b>
<b>inet_ntop (3),</b>
<b>socket (3),</b>
<b>hosts (5),</b>
<b>services (5),</b>
<b>hostname (7),</b>
<b>named (8)<br/><br/></b>
R. Gilligan, S. Thomson, J. Bound et W. Stevens,
<i>Basic Socket Interface Extensions for IPv6</i> ,</i>
RFC 2553, Mars 1999.<br/><br/>
Tatsuya Jinmei et Atsushi Onoe,
<i>An Extension of Format for IPv6 Scoped Addresses</i> ,</i>
internet draft, travail en cours.
ftp://ftp.ietf.org/internet-drafts/draft-ietf-ipngwg-scopedaddr-format-02.txt<br/><br/>
Craig Metz,
<i>Protocol Independence Using the Sockets API</i> ,</i>
compte rendu du sujet freenix&nbsp;:
confrence technique annuelle USENIX 2000, juin 2000.
http://www.usenix.org/publications/library/proceedings/usenix2000/freenix/metzprotocol.html
</div><br/><br /><h1 class="TitreSection0" id="L11">traduction</h1>
<div class="paragraph">
Stphan Rafin, 2002.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
