<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 21:48:06 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 28/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise  jour 14/12/1998 - LDP-man-pages-1.21 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>GETNETENT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">fichiers</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getnetent, getnetbyname, getnetbyaddr, setnetent, endnetent - Lire les informations rseau.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;netdb.h&gt;</b> <b></b>  <br/><br/>

<b>struct</b> <b></b>  <b>netent</b> <b></b>  <b>*getnetent</b> <b></b>  <b>(void);</b> <b></b>  <br/><br/>

<b>struct netent *getnetbyname (const char *</b> name );
<br/><br/>

<b>struct netent *getnetbyaddr (long </b> net <i>, int </i> type );
<br/><br/>

<b>void setnetent (int </b> stayopen );
<br/><br/>

<b>void</b> <b></b>  <b>endnetent</b> <b></b>  <b>(void);</b> <b></b>  

</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>getnetent()</b> lit la ligne suivante du fichier <i>/etc/networks</i>,
renvoie un pointeur sur une structure <i>netent</i> contenant les diffrents
champs de la ligne. Le fichier <i>/etc/networks</i> est ouvert en lecture si
besoin est.<br/><br/>
La fonction <b>getnetbyname()</b> renvoie une structure <i>netent</i>
concernant la ligne correspondant au nom de rseau <i>name</i> dans le
fichier <i>/etc/networks</i>.<br/><br/>
La fonction <b>getnetbyaddr()</b> renvoie une structure <i>netent</i> pour la
ligne correspondant au rseau de numro <i>net</i> et au <i>type</i> indiqu
dans le fichier <i>/etc/networks/</i>.<br/><br/>
La fonction <b>setnetent()</b> ouvre, ou revient au dbut, du fichier
<i>/etc/networks</i>.  Si <i>stayopen</i> est vrai (vaut 1), alors le fichier
ne sera pas referm entre deux appels  <b>getnetbyname()</b> ou 
<b>getnetbyaddr()</b>.<br/><br/>
La fonctions <b>endservent()</b> referme le fichier <i>/etc/networks</i>.<br/><br/>
La structure <i>netent</i> est dfinie dans <i>&lt;netdb.h&gt;</i> ainsi :
<br/><br/>

.RS

.ne 6
.ta 8n 16n 34n
struct netent {
   char             *n_name;     /* Nom officiel  du rseau */
   char            **n_aliases;  /* Liste d'alias           */
   int               n_addrtype; /* Type d'adresse rseau   */
   unsigned long int n_net;      /* Adresse du rseau       */
}
.ta


<br/><br/>
Les membres de la structures <i>netent</i> sont :
<br/><br/>

<i>n_name</i> Le nom officiel du rseau.
<br/><br/>

<i>n_aliases</i> Une liste, termine par zro, d'alternatives au nom du rseau.
<br/><br/>

<i>n_addrtype</i> Le type d'adresse du rseau, actuellement il vaut toujours AF_INET.
<br/><br/>

<i>n_net</i> L'adresse du rseau, utilisant l'ordre des octets de l'hte.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Les fonctions <b>getnetent()</b>, <b>getnetbyname()</b> et <b>getnetbyaddr()</b>
renvoient une structure <i>netent</i> ou un pointeur NULL si une erreur se
produit, ou si la fin du fichier est atteinte.
</div><br/><br /><h1 class="TitreSection0" id="L5">fichiers</h1>
<div class="paragraph">
<br/><br/>

<i>/etc/networks</i> Base de donnes des rseaux.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>getprotoent (3),</b>
<b>getservent (3),</b>
<b>networks (5),</b>
br
<b>RFC 1101</b> .</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
