<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 19:26:03 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 03/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  -->
<br/><h1>GETPROTOENT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">fichiers</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getprotoent, getprotobyname, getprotobynumber, setprotoent, endprotoent - Accder aux protocoles.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;netdb.h&gt;</b> <b></b>  <br/><br/>

<b>struct</b> <b></b>  <b>protoent</b> <b></b>  <b>*getprotoent</b> <b></b>  <b>(void);</b> <b></b>  <br/><br/>

<b>struct protoent *getprotobyname (const char *</b> name );
<br/><br/>

<b>struct protoent *getprotobynumber (int </b> proto );
<br/><br/>

<b>void setprotoent (int </b> stayopen );
<br/><br/>

<b>void</b> <b></b>  <b>endprotoent</b> <b></b>  <b>(void);</b> <b></b>  

</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>getprotoent()</b> lit la ligne suivante du fichier
<i>/etc/protocols</i> et renvoie une structure <i>protoent</i>
contenant la division des divers champs de la ligne.  Le fichier
<i>/etc/protocols</i> est ouvert si ncessaire.<br/><br/>
La fonction <b>getprotobyname()</b> renvoie une structure <i>protoent</i>
correspondant  la ligne du fichier <i>/etc/protocols</i> qui concerne
le protocole appel <i>name</i>.<br/><br/>
La fonction <b>getprotobynumber()</b> renvoie une structure <i>protoent</i>
pour la ligne correspondant au protocole numro <i>number</i>.<br/><br/>
La fonction <b>setprotoent()</b> ouvre le fichier <i>/etc/protocols</i>
et ramne le pointeur au dbut. Si <i>stayopen</i> est vrai (valant 1),
alors le fichier ne sera pas referm entre les appels successifs 
<b>getprotobyname()</b> ou <b>getprotobynumber()</b>.<br/><br/>
La fonction <b>endprotoent()</b> referme le fichier <i>/etc/protocols</i>.<br/><br/>
La structure <i>protoent</i> est dfinie dans <i>&lt;netdb.h&gt;</i> ainsi :
<br/><br/>

.RS

.ne 5
.ta 8n 16n 32n
struct protoent {
  char   *p_name;    /* Nom officiel du protocole */
  char  **p_aliases; /* Liste d'alias             */
  int     p_proto;   /* Numro du protocole       */
}
.ta


<br/><br/>
Les membres de la structure <i>protoent</i> sont :
<br/><br/>

<i>p_name</i> Le nom officiel du protocole.
<br/><br/>

<i>p_aliases</i> Une liste, termine par zro, d'autres noms pour le protocole.
<br/><br/>

<i>p_proto</i> Le numro du protocole.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Les fonctions <b>getprotoent()</b>, <b>getprotobyname()</b> et
<b>getprotobynumber()</b> renvoient une structure <i>protoent</i>, ou un
pointeur NULL si une erreur se produit, ou si la fin du fichier est atteinte.
</div><br/><br /><h1 class="TitreSection0" id="L5">fichiers</h1>
<div class="paragraph"><br/><br/>D 0
<br/><br/>

<i>/etc/protocols</i> Base de donne des protocoles<br/><br/>D
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>getservent (3),</b>
<b>getnetent (3),</b>
<b>protocols (5)<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
