<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  -->
<!--  Modified Sat Jul 24 19:20:36 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  Modified Mon May 27 21:37:47 1996 by Martin Schulze (joey@linux.de) -->
<!--  -->
<!--  Traduction 03/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>GETPWNAM</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">fichiers</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">notes</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getpwnam, getpwuid - Lire un enregistrement du fichier des mots de passe.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;pwd.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <br/><br/>

<b>struct passwd *getpwnam (const char * </b> name );
<br/><br/>

<b>struct passwd *getpwuid (uid_t </b> uid );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>getpwnam()</b> renvoie un pointeur sur une structure contenant
les divers champs de l'enregistrement de <i>/etc/passwd</i> correspondant au
nom d'utilisateur <i>name</i>.<br/><br/>
La fonction <b>getpwuid()</b> renvoie un pointeur sur une structure contenant
les divers champs de l'enregistrement de <i>/etc/passwd</i> correspondant au
 l'ID d'utilisateur <i>uid</i>.<br/><br/>
La structure <i>passwd</i> est dfinie dans <i>&lt;pwd.h&gt;</i> ainsi :
<br/><br/>

.RS

.ta 8n 16n 32n
struct passwd {
  char   *pw_name;   /* Nom d'utilisateur             */
  char   *pw_passwd; /* Mot de passe                  */
  uid_t   pw_uid;    /* ID de l'utilisateur           */
  gid_t   pw_gid;    /* ID du groupe de l'utilisateur */
  char   *pw_gecos;  /* Nom rel de l'utilisateur     */
  char   *pw_dir;    /* Rpertoire de connexion       */
  char   *pw_shell;  /* Programme Shell de connexion  */
};
.ta



</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Les fonctions <b>getpwnam()</b> et <b>getpwuid()</b> renvoient un pointeur sur
une structure passwd, ou NULL si une erreur se produit, ou si l'enregistrement correspondant
n'est pas trouv. En cas d'erreur,
<i>errno</i> est rempli.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>
 
<b>0 </b> ou <b> ENOENT </b> ou <b> ESRCH </b> ou <b> EBADF </b> ou <b> EPERM </b> ou ... <b></b>
Le nom
<i>name</i> ou l'identifiant
<i>uid</i> n'ont pas t trouvs.
<br/><br/>

<b>ENOMEM</b> <b></b>  Pas assez de mmoire pour allouer la structure passwd.
<!--  -->
<br/><br/>

<b>EIO</b> <b></b>  Erreur d'entre/sortie.
<br/><br/>

<b>EINTR</b> <b></b>  Un signal a t captur.
<br/><br/>

<b>EMFILE</b> <b></b>  Le nombre maximal (OPEN_MAX) de fichiers ouverts pour le processus est atteint.
<br/><br/>

<b>ENFILE</b> <b></b>  Le nombre maximal de fichiers ouverts sur le systme est atteint.
</div><br/><br /><h1 class="TitreSection0" id="L6">fichiers</h1>
<div class="paragraph">
<br/><br/>

<i>/etc/passwd</i> Base de donnes des mots de passe.


</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SVID 3, POSIX, BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L8">notes</h1>
<div class="paragraph">
La description "VALEUR RENVOYE" ci-dessu vient de Posix.1-2001. Elle ne
considre pas le cas "non trouv" commme une erreur, et ne spcifie pas
<i>errno</i> dans ce cas. Cela rend la dtection d'erreur impossible. On peut dire que
d'aprs Posix,
<i>errno</i> est inchang dans le cas o aucune entre n'est trouve. Des essais sur
de nombreux systmes Unix ont fait apparatre diffrentes valeurs dans ce
cas&nbsp;: 0, ENOENT, EBADF, ESRCH, EWOULDBLOCK, EPERM et probablement d'autres.
<!--  more precisely: -->
<!--  AIX 5.1 - gives ESRCH -->
<!--  libc, glibc, Irix 6.5 - give ENOENT -->
<!--  FreeBSD 4.8, OpenBSD 3.2, NetBSD 1.6 - give EPERM -->
<!--  SunOS 5.8 - gives EBADF -->
<!--  Tru64 5.1b, HP-UX-11i, SunOS 5.7 - give 0 -->
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>fgetpwent (3),</b>
<b>getgrnam (3),</b>
<b>getpwent (3),</b>
<b>setpwent (3),</b>
<b>endpwent (3),</b>
<b>getpw (3),</b>
<b>putpwent (3),</b>
<b>passwd (5)</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
