<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 19:19:11 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  Modified Wed Oct 18 20:23:54 1995 by Martin Schulze &lt;joey@infodrom.north.de&gt; -->
<!--  Modified Mon Apr 22 01:50:54 1996 by Martin Schulze &lt;joey@infodrom.north.de&gt; -->
<!--  -->
<!--  Traduction 03/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  -->
<!--  Mise  jour 25/01/2002 - LDP-man-pages-1.47 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>GETSERVENT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">fichiers</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
getservent, getservbyname, getservbyport, setservent, endservent - Accder aux informations sur les services.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;netdb.h&gt;</b> <b></b>  <br/><br/>

<b>struct</b> <b></b>  <b>servent</b> <b></b>  <b>*getservent</b> <b></b>  <b>(void);</b> <b></b>  <br/><br/>

<b>struct servent *getservbyname (const char *</b> name <i>, const char *</i> proto );
<br/><br/>

<b>struct servent *getservbyport (int </b> port <i>, const char *</i> proto );
<br/><br/>

<b>void setservent (int </b> stayopen );
<br/><br/>

<b>void</b> <b></b>  <b>endservent</b> <b></b>  <b>(void);</b> <b></b>  

</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>getservent()</b> lit l'enregistrement suivant du fichier
<i>/etc/services</i> et renvoie une structure <i>servent</i> contenant les
divers champs de l'enregistrement. Le fichier <i>/etc/services</i> est
ouvert si besoin est.<br/><br/>
La fonction <b>getservbyname()</b> renvoie une structure <i>servent</i>
pour l'enregistrement du fichier <i>/etc/services</i> qui correspond au
service nomm <i>name</i> et utilisant le protocole <i>proto</i>. Si <i>proto</i>
est NULL, n'importe quel protocole sera accept.<br/><br/>
La fonction <b>getservbyport()</b> renvoie une structure <i>servent</i>
pour l'enregistrement correspondant au <i>port</i> indiqu (dans l'ordre
des octets du rseau) et utilisant le protocole <i>proto</i>. Si <i>proto</i>
est NULL, n'importe quel protocole sera accept. <br/><br/>
La fonction <b>setservent()</b> ouvre, et ramne au dbut le pointeur du
fichier <i>/etc/services</i>. Si <i>stayopen</i> est vrai (valant 1), alors 
le fichiers ne sera pas referm entre les appels successifs 
<b>getservbyname()</b> et <b>getservbyport()</b>.<br/><br/>
la fonction <b>endservent()</b> ferme le fichier <i>/etc/services</i>.<br/><br/>
La structure <i>servent</i> est dfinie dans <i>&lt;netdb.h&gt;</i> ainsi :
<br/><br/>

.RS

.ne 6
.ta 8n 16n 32n
struct servent {
  char  *s_name;    /* Nom officiel du service */
  char **s_aliases; /* Liste d'alias           */
  int    s_port;    /* Numro de port          */
  char  *s_proto;   /* Protocole utilis       */
}
.ta


<br/><br/>
Les membres de la structure <i>servent</i> sont :
<br/><br/>

<i>s_name</i> Le nom officiel du service.
<br/><br/>

<i>s_aliases</i> Une liste termine par zro contenant d'autres noms utilisables pour le service.
<br/><br/>

<i>s_port</i> Le numro de port, donn dans l'ordre des octets du rseau.
<br/><br/>

<i>s_proto</i> Le nom du protocole utilis par ce service.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Les fonctions <b>getservent()</b>, <b>getservbyname()</b> et <b>getservbyport()</b>
renvoient une structure <i>servent</i>, ou un pointeur NULL si une erreur se
produit, ou si la fin du fichier est atteinte.
</div><br/><br /><h1 class="TitreSection0" id="L5">fichiers</h1>
<div class="paragraph">
<br/><br/>

<i>/etc/services</i> Base de donnes des services.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>getprotoent (3),</b>
<b>getnetent (3),</b>
<b>services(5)<br/><br/></b>
<b>SH TRADUCTION</b>
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
