<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) 1990, 1993 -->
<!-- 	The Regents of the University of California.  All rights reserved. -->
<!--  -->
<!--  Redistribution and use in source and binary forms, with or without -->
<!--  modification, are permitted provided that the following conditions -->
<!--  are met: -->
<!--  1. Redistributions of source code must retain the above copyright -->
<!--     notice, this list of conditions and the following disclaimer. -->
<!--  2. Redistributions in binary form must reproduce the above copyright -->
<!--     notice, this list of conditions and the following disclaimer in the -->
<!--     documentation and/or other materials provided with the distribution. -->
<!--  3. All advertising materials mentioning features or use of this software -->
<!--     must display the following acknowledgement: -->
<!-- 	This product includes software developed by the University of -->
<!-- 	California, Berkeley and its contributors. -->
<!--  4. Neither the name of the University nor the names of its contributors -->
<!--     may be used to endorse or promote products derived from this software -->
<!--     without specific prior written permission. -->
<!--  -->
<!--  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND -->
<!--  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE -->
<!--  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE -->
<!--  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE -->
<!--  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL -->
<!--  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS -->
<!--  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) -->
<!--  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT -->
<!--  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY -->
<!--  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF -->
<!--  SUCH DAMAGE. -->
<!--  -->
<!-- 	@(#)hash.3	8.6 (Berkeley) 8/18/94 -->
<!--  -->
<!--  Traduction 11/05/1999 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP-man-pages-1.23 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>HASH</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">erreurs</a>
<br /><a class="summaryIndent0" href="#L4">bogues</a>
<br /><a class="summaryIndent0" href="#L5">voir aussi</a>
<br /><a class="summaryIndent0" href="#L6">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
hash - Mthodes d'accs aux bases de donnes avec tables de hachage.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

.ft B
#include &lt;sys/types.h&gt;
#include &lt;db.h&gt;
.ft R


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La routine
<i>dbopen</i>
est l'interface de bibliothque pour les fichiers de base de donnes.
L'un des formats de fichier supports est la table de hachage.
La description gnrale des mthodes d'accs  une base de donnes
est fournie dans la page de manuel
<i>dbopen (3).</i>
La page prsente ne dcrit que les informations spcifiques aux tables
de hachage.<br/><br/>
Les structures de hachage reprsentent un schma de base de donnes
dynamique et extensible.<br/><br/>
La structure de donnes spcifique aux tables de hachage que
l'on transmet 
<i>dbopen</i> est dfinie dans &lt;db.h&gt; ainsi :
<br/><br/>

typedef struct {
.RS
u_int bsize;
<br/>
u_int ffactor;
<br/>
u_int nelem;
<br/>
u_int cachesize;
<br/>
u_int32_t (*hash)(const void *, size_t);
<br/>
int lorder;

} HASHINFO;<br/><br/>
Les lments de cette structure sont les suivants :
<br/><br/>

bsize
<i>Bsize</i> (bucket size) dfini la taille des cases de la table, et vaut,
par dfaut, 256 octets. Il est prfrable d'augmenter la taille de
page pour les table situes sur disque ayant des lments avec
beaucoup de donnes.
<br/><br/>

ffactor
<i>Ffactor</i> indique une densit dsire au sein de la table. Il s'agit d'une
approximation du nombre de cls pouvant s'accumuler dans une seule
case, ce qui dtermine le moment o la table doit s'aggrandir ou se
rtrcir. La valeur par dfaut est 8.
<br/><br/>

nelem
<i>Nelem</i> est une estimation de la taille finale de la table de hachage. S'il n'est
pas configur, ou s'il est configur trop bas, la table s'aggrandira
quand mme correctement au fur et  mesure de l'entre des cls,
bien qu'une lgre dgradation des performances puisse tre observe.
La valeur par dfaut est 1.
<br/><br/>

cachesize
Une taille maximale suggre de mmoire cache, en octets. Ceci n'a
qu'une valeur
<b>indicative ,</b>
et les mthodes d'accs alloueront plus de mmoire plutt que d'chouer.
<br/><br/>

hash
<i>Hash</i> est une fonction dfinie par l'utilisateur.
Comme aucune fonction de hachage ne se comporte parfaitement bien sur tout
type de donnes, il peut arriver que la fonction interne soit particulirement
mauvaise sur un jeu particulier de donnes. La fonction de hachage fournie
par l'utilisateur doit prendre deux arguments (un pointeur sur une chane
d'octets et une longueur) et renvoyer une valeur sur 32 bits utilisable
comme valeur de hachage.
<br/><br/>

lorder
L'ordre des octets pour les entiers stocks dans la base de donnes.
Ce nombre doit reprsenter l'ordre sous forme d'entier. Par exemple l'ordre
poids faible-poids fort (big endian) est reprsent par le nombre 4321.
Si
<i>lorder</i> vaut 0 (pas d'ordre indiqu), on utilise l'ordre des octets du systme hte.<br/><br/>
Si le fichier existe dj, on utilise l'ordre des octets indiqus lors
de sa cration.<br/><br/>
SI une fonction de hachage est indique,
<i>hash_open</i> essayera de dterminer s'il s'agit de la mme fonction que celle indique
lors de la cration de la base de donne, et chouera si ce n'est pas le
cas.<br/><br/>
Des interfaces pour les routines dcrites dans
<i>dbm (3),</i>
et
<i>ndbm (3)</i>
sont fournies, toutefois ces interfaces ne sont pas compatibles avec
les anciens formats de fichiers.
</div><br/><br /><h1 class="TitreSection0" id="L4">erreurs</h1>
<div class="paragraph">
Les routines des mthodes d'accs au
<i>tables de hachage</i> peuvent chouer et remplir
<i>errno</i> avec n'importe quelle erreur indique par la routine
<i>dbopen (3).</i>
</div><br/><br /><h1 class="TitreSection0" id="L5">bogues</h1>
<div class="paragraph">
Seuls les ordres d'octets big-endian et little-endian fonctionnent.
</div><br/><br /><h1 class="TitreSection0" id="L6">voir aussi</h1>
<div class="paragraph">
<i>btree (3),</i>
<i>dbopen (3),</i>
<i>mpool (3),</i>
<i>recno (3)</i>
<br/><br/>

<i>Dynamic Hash Tables</i> ,</i>
Per-Ake Larson, Communications of the ACM, April 1988.
<br/><br/>

<i>A New Hash Package for UNIX</i> ,</i>
Margo Seltzer, USENIX Proceedings, Winter 1991.
</div><br/><br /><h1 class="TitreSection0" id="L7">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1999-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
