<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) Bruno Haible &lt;haible@clisp.cons.org&gt; -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  References consulted: -->
<!--    GNU glibc-2 source code and manual -->
<!--    OpenGroup's Single Unix specification http://www.UNIX-systems.org/online.html -->
<!--  -->
<!--  Traduction 31/08/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.31 -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>ICONV</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
iconv - Conversion de caractres larges.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;iconv.h&gt;</b> <b></b>  <br/><br/>

<b>size_t iconv (iconv_t </b> cd ,
<b>              char ** </b> inbuf <i>, size_t * </i>inbytesleft ,
<b>              char ** </b> outbuf <i>, size_t * </i>outbytesleft );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
L'argument <i>cd</i> doit tre un descripteur de conversion fourni par la fonction <b>iconv_open</b>.<br/><br/>
L'utilisation principale de cette routine est avec <i>inbuf</i> non NULL et <i>*inbuf</i> non NULL.
Dans ce cas, <b>iconv</b> convertit la squence multi-octets dbutant en <i>*inbuf</i> en une
squence multi-octets commenant en <i>*outbuf</i>.
Au plus <i>*inbytesleft</i> octets seront lus, en partant de <i>*inbuf</i>.
Au plus <i>*outbytesleft</i> octets seront crits en commenant en <i>*outbuf</i>.<br/><br/>
La fonction <b>iconv</b> convertit un caractre multi-octets  la fois, et pour chaque conversion
elle augmente <i>*inbuf</i> et diminue <i>*inbytesleft</i> du nombre d'octets d'entre convertis, et
elle augmente <i>*outbuf</i> et diminue <i>*outbytesleft</i> du nombre d'octets de sortie crits.
Elle met  jour l'tat de conversion contenu au sein de <i>cd</i>.
La conversion peut s'arrter pour quatre raisons :<br/><br/>
1. Une squence multi-octets invalide a t trouve en entre. Dans ce cas la fonction
renvoie (size_t)(-1) aprs avoir mis <b>EILSEQ</b> dans <b>errno</b>. Ensuite <i>*inbuf</i>
pointera sur le dbut de la squence multi-octets invalide.<br/><br/>
2. La squence d'entre a t convertie entirement, c'est  dire que <i>*inbytesleft</i>
est descendu jusqu' zro. Dans ce cas <b>iconv</b> renvoie le nombre de conversions irrversibles
ralises durant l'appel.<br/><br/>
3. Une squence multi-octets incomplte a t trouve alors que la squence d'entre se terminait.
Dans ce cas la fonction renvoie (size_t)(-1) aprs avoir mis <b>EINVAL</b> dans <b>errno</b>.
Ensuite <i>*inbuf</i> pointera sur le dbut de la squence multi-octets incomplte.<br/><br/>
4. Le buffer de sortie n'a plus de place pour stocker le prochain caractre converti. Dans ce
cas <b>errno</b> contiendra <b>E2BIG</b> et la fonction renverra (size_t)(-1).<br/><br/>
Une autre possibilit se prsente quand <i>inbuf</i> ou <i>*inbuf</i> sont NULL, mais ni
<i>outbuf</i>, ni <i>*outbuf</i> ne sont NULL. Dans ce cas la fonction <b>iconv</b> essaye
de mettre l'tat de conversion de <i>cd</i> dans l'tat initial, et de mmoriser la
squence de dcalage correspondante dans <i>*outbuf</i>.
Au maximum <i>*outbytesleft</i> octets seront crits en commenant en <i>*outbuf</i>.
Si le buffer de sortie ne contient pas assez de place  pour rinitialiser la squence, la fonction
renvoie (size_t)(-1) aprs avoir mis <b>E2BIG</b> dans <b>errno</b>. Sinon elle augmente
<i>*outbuf</i> et dimininue <i>*outbytesleft</i> du nombre d'octets crits.<br/><br/>
Un troisime cas est possible, si <i>inbuf</i> ou <i>*inbuf</i> sont NULL, et <i>outbuf</i> 
ou <i>*outbuf</i> sont NULL. Alors, la fonction <b>iconv</b> replace <i>cd</i> dans l'tat
de conversion initial.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>iconv</b> renvoie le nombre de caractres convertis de manire irrversible
durant l'appel. Les conversions rversibles ne sont pas prises en compte. En cas d'erreur
la fonction remplit <b>errno</b> et renvoie (iconv_t)(-1).
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
Les erreurs suivantes peuvent se produire, entre autres :
<br/><br/>

<b>E2BIG</b> <b></b>  Il n'y a pas assez de place dans <i>*outbuf</i>.
<br/><br/>

<b>EILSEQ</b> <b></b>  Une squence multi-octets invalide a t trouve en entre.
<br/><br/>

<b>EINVAL</b> <b></b>  Une squence multi-octets incomplte a t trouve en entre.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
UNIX98
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>iconv_open (3), </b>
<b>iconv_close (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
