<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 2000 Sam Varshavchik &lt;mrsam@stop.mail-abuse.org&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References: RFC 2553 -->
<!--  Traduction 31/08/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.31 -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>INET_NTOP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">voir aussi</a>
<br /><a class="summaryIndent0" href="#L5">bogues</a>
<br /><a class="summaryIndent0" href="#L6">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
inet_ntop - Manipuler les adresses rseau.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;arpa/inet.h&gt;</b> <b></b>  <br/><br/>

<b>const char *inet_ntop(int </b> af <i>, const void * </i> src ,
<b>                        char * </b> dst <i>, size_t </i> cnt );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette fonction convertit une adresse rseau reprsente par  la structure
<i>src</i> de la famille
<i>af ,</i>
en une chane de caractres copie dans le buffer
<i>dst ,</i>
long de
<i>cnt</i> octets.<br/><br/>
<b>inet_ntop (3)</b>
tend les possibilits de la fonction
<b>inet_ntoa (3)</b>
pour grer plusieurs familles d'adresses.
L'utilisation de
<b>inet_ntoa (3)</b>
est  prsent dconseille au profit de
<b>inet_ntop (3).</b>
Les familles d'adresses suivantes sont supportes ds  prsent :
<br/><br/>

<b>AF_INET</b> <b></b>  <i>src</i> doit pointer sur une structure
<i>struct in_addr</i> (octets stocks dans l'ordre du rseau)
qui est convertie en une adresse rseau IPv4 dans le
format dcimal point "<i>ddd.ddd.ddd.ddd</i>".
Le buffer 
<i>dst</i> doit mesurer au minimum
<b>INET_ADDRSTRLEN</b> <b></b>  octets.
<br/><br/>

<b>AF_INET6</b> <b></b>  <i>src</i> doit pointer sur une structure
<i>struct in6_addr</i></i>
(octets stocks dans l'ordre du rseau)
qui est convertie dans la reprsentation la plus approprie de
l'adresse IPv6.
Le buffer
<i>dst</i> doit mesurer au minimum
<b>INET6_ADDRSTRLEN</b> <b></b>  octets.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>inet_ntop</b> <b></b>  renvoie un pointeur sur
<i>buf .</i>
Si une erreur se produit, la fonction renvoie NULL, et
<i>errno</i> contient
<b>EAFNOSUPPORT</b> <b></b>  si
<i>af</i> ne reprsente pas une famille d'adresses valide,
ou
<b>ENOSPC</b> <b></b>  si l'adresse convertie ne tient pas dans le buffer
<i>dst ,</i>
dont la taille est indique par l'argument
<i>cnt .</i>
</div><br/><br /><h1 class="TitreSection0" id="L5">voir aussi</h1>
<div class="paragraph">
<b>inet_pton (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">bogues</h1>
<div class="paragraph">
<b>AF_INET6</b> <b></b>  convertit les adresse IPv4 projetes dans l'espace IPv6 en
employant le format IPv6.
</div><br/><br /><h1 class="TitreSection0" id="L7">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
