<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 2000 Sam Varshavchik &lt;mrsam@stop.mail-abuse.org&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References: RFC 2553 -->
<!--  Traduction 31/08/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.31 -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>INET_PTON</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">voir aussi</a>
<br /><a class="summaryIndent0" href="#L5">bogues</a>
<br /><a class="summaryIndent0" href="#L6">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
inet_pton - Crer une structure d'adresse rseau.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;arpa/inet.h&gt;</b> <b></b>  <br/><br/>

<b>int inet_pton(int </b> af <i>, const char * </i> src <b>, void * </b> dst );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette fonction convertit la chane de caractres
<i>src</i> en une structure d'adresse rseau de la famille
<i>af ,</i>
puis copie cette structure dans
<i>dst .<br/><br/></i>
La fonction
<b>inet_pton (3)</b>
tend les possibilits de la fonction
<b>inet_addr (3)</b>
pour supporter de multiples familles d'adresses. L'utilisation de
<b>inet_addr (3)</b>
est dsormais dconseille, au profit de la fonction
<b>inet_pton (3).</b>
Les familles d'adresses suivantes sont ds  prsent supportes :
<br/><br/>

<b>AF_INET</b> <b></b>  <i>src</i> doit pointer sur une chane de caractre contenant une adresse rseau IPv4
au format dcimal point "<i>ddd.ddd.ddd.ddd</i>".
L'adresse est alors convertie 
en une structure
<i>struct in_addr</i> et copie dans
<i>dst,</i>
qui doit donc contenir au minimum
<i>sizeof(struct in_addr)</i> octets.
<br/><br/>

<b>AF_INET6</b> <b></b>  <i>src</i> pointe sur une chane de caractres contenant une adresse rseau IPv6 dans un
format IPv6 autoris.
L'adresse est convertie en une
structure
<i>struct in6_addr</i> et copie dans
<i>dst,</i>
qui doit donc contenir au moins
<i>sizeof(struct in6_addr)</i> octets.<br/><br/>
Certains formats hexadcimaux ou octaux lgitimes pour les adresses
<b>AF_INET</b> <b></b>  ne sont pas supports par
<i>inet_pton ,</i>
qui les rejettera.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>inet_pton</b> <b></b>  renvoie une valeur ngative et remplit
<i>errno</i> avec la valeur
<b>EAFNOSUPPORT</b> <b></b>  si 
<i>af</i> ne contient pas une famille d'adresse valide.
Elle renvoie une valeur nulle si
<i>src</i> ne contient pas une adresse rseau valide
pour la famille indique.
Enfin, une valeur positive est renvoye si la conversion a eu lieu 
avec succs.
</div><br/><br /><h1 class="TitreSection0" id="L5">voir aussi</h1>
<div class="paragraph">
<b>inet_ntop (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">bogues</h1>
<div class="paragraph">
<b>AF_INET6</b> <b></b>  ne reconnait pas les adresses IPv4.
Il faut dans ce cas fournir dans
<i>src</i> une adresse IPv4 projete dans l'espace IPv6
</div><br/><br /><h1 class="TitreSection0" id="L7">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
