<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 19:11:11 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 04/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>INFNAN</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">exemple</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
infnan - Traiter un rsultat infini ou non-numrique (NaN).
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;math.h&gt;</b> <b></b>  <br/><br/>

<b>double infnan (int </b> error );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>infnan()</b> renvoie une valeur acceptable pour un rsultat
infini ou non numrique ("NaN", Not-a-Number).
La valeur <i>error</i> peut tre ERANGE pour indiquer l'infini, ou
n'importe quoi d'autre pour reprsenter NaN. <i>errno</i> est galement
renseign.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Si <i>error</i> vaut ERANGE (Infini), HUGE_VAL est renvoy.<br/><br/>
Si <i>error</i> vaut -ERANGE (-Infini), -HUGE_VAL est renvoy.<br/><br/>
Si <i>error</i> vaut autre chose, NAN est renvoy.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>ERANGE</b> <b></b>  La valeur de <i>error</i> est infinie (positive ou ngative).
<br/><br/>

<b>EDOM</b> <b></b>  La valeur de <i>error</i> est non-numrique (NaN).
</div><br/><br /><h1 class="TitreSection0" id="L6">exemple</h1>
<div class="paragraph">

	#include &lt;signal.h&gt;
	#include &lt;math.h&gt;
	#include &lt;stdio.h&gt;<br/><br/>
	int
main (void)
{
	double x;<br/><br/>
	/* Ignorer le signal d'erreur pour division par zro */
	signal (SIGFPE, SIG_IGN);<br/><br/>
	x = 1.0;
	x = x / 0.0;
	printf ("x = 1.0/0.0, isnan (x) = %d\\n", isnan (x));
	printf ("             isinf (x) = %d\\n", isinf (x));<br/><br/>
	x = 0.0;
	x = x / 0.0;
	printf ("x = 0.0/0.0, isnan (x) = %d\\n", isnan (x));
	printf ("             isinf (x) = %d\\n", isinf (x));
	exit (0);
}<br/><br/>
$ ./a.out
x = 1.0/0.0, isnan (x) = 0
             isinf (x) = 1
x = 0.0/0.0, isnan (x) = 1
             isinf (x) = 0


</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
