<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 19:08:17 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 04/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  -->
<br/><h1>J0</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">conformit</a>
<br /><a class="summaryIndent0" href="#L4">bogues</a>
<br /><a class="summaryIndent0" href="#L5">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
j0, j0f j0l j1, j1f j1l jn, jnf, jnl y0, y0f, y0l, y1, y1f, y1l, yn, ynf, ynl - Fonctions de Bessel.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;math.h&gt;</b> <b></b>  <br/><br/>

<b>double j0 (double </b> x );
<br/><br/>

<b>double j1 (double </b> x );
<br/><br/>

<b>double jn (int </b> n <i>, double </i> x );
<br/><br/>

<b>double y0 (double </b> x );
<br/><br/>

<b>double y1 (double </b> x );
<br/><br/>

<b>double yn (int </b> n <i>, double </i> x );
<br/><br/>

<b>float j0f (float </b> x );
<br/>
<b>float j1f (float </b> x );
<br/>
<b>float jnf (int </b> n <i>, float </i> x );
<br/>
<b>float y0f (float </b> x );
<br/>
<b>float y1f (float </b> x );
<br/>
<b>float ynf (int </b> n <i>, float </i> x );
<br/><br/>

<b>long double j0l (long double </b> x );
<br/>
<b>long double j1l (long double </b> x );
<br/>
<b>long double jnl (int </b> n <i>, long double </i> x );
<br/>
<b>long double y0l (long double </b> x );
<br/>
<b>long double y1l (long double </b> x );
<br/>
<b>long double ynl (int </b> n <i>, long double </i> x );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les fonctions <b>j0()</b> et <b>j1()</b> renvoient les valeurs des fonctions
de Bessel de la premire espce, respectivement d'ordre 0 et 1, pour
la variable relle <i>x</i>. La fonction <b>jn()</b> renvoie la valeur de la
fonction de Bessel de la premire espece d'ordre <i>n</i>, pour la variable
relle <i>x</i>.<br/><br/>
Les fonctions <b>y0()</b> et <b>y1()</b> renvoient les valeurs des fonctions
de Bessel de la seconde espce, respectivement d'ordre 0 et 1, pour
la variable relle <i>x</i>. La fonction <b>yn()</b> renvoie la valeur de la
fonction de Bessel de la seconde espce d'ordre <i>n</i>, pour la variable
relle <i>x</i>.<br/><br/>
Pour les fonctions <b>y0()</b>, <b>y1()</b> et <b>yn()</b>, la valeur de <i>x</i>
doit tre positive. Si <i>x</i> est ngatif, ces fonctions renvoient -HUGE_VAL.<br/><br/>
Les fonctions <b>j0f()</b>, etc. ainsi que <b>j0l()</b> etc. en sont des versions
qui prennent en argument et renvoient des valeurs de type float ou long double.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">conformit</h1>
<div class="paragraph">
Les fonctions renvoyant des valeurs de type double se conforment  SVID 3, BSD 4.3, XPG4, et POSIX 1003.1-2001.
Les autres existebt par analogien comme sur plusieurs autres plates-formes.
</div><br/><br /><h1 class="TitreSection0" id="L5">bogues</h1>
<div class="paragraph">
Il peut y avoir une erreur allant jusqu'a 2e-16 dans les valeurs renvoyes
par <b>j0()</b>, <b>j1()</b> et <b>jn()</b> pour <i>x</i> compris entre -8 et 8.
</div><br/><br /><h1 class="TitreSection0" id="L6">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
