<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 2002 Walter Harms (walter.harms@informatik.uni-oldenburg.de) -->
<!--  Distributed under GPL -->
<!--  based on glibc infopages -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>LGAMMA</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">erreurs</a>
<br /><a class="summaryIndent0" href="#L4">conformit</a>
<br /><a class="summaryIndent0" href="#L5">voir aussi</a>
<br /><a class="summaryIndent0" href="#L6">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
lgamma, lgammaf, lgammal, lgamma_r, lgammaf_r, lgammal_r - Logarithme de la fonction gamma.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;math.h&gt;</b> <b></b>  <br/><br/>

<b>double lgamma(double </b> x );
<br/>
<b>float lgammaf(float </b> x );
<br/>
<b>long double lgammal(long double </b> x );
<br/><br/>

<b>double lgamma_r(double </b> x <i>, int *</i> signp );
<br/>
<b>float lgammaf_r(float </b> x <i>, int *</i> signp );
<br/>
<b>long double lgammal_r(long double </b> x <i>, int *</i> signp );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction Gamma est dfinie ainsi&nbsp;:
<br/><br/>

 Gamma(x) = intgrale de 0  l'infini de t^(x-1) e^-t dt
<br/><br/>

Elle est dfinie pour tous rels sauf les entiers ngatifs ou nuls.
Pour un entier non-ngatif <i>m</i> on a
<br/><br/>

 Gamma(m+1) = m!
<br/><br/>

et, plus gnralement pour tout <i>x</i>:
<br/><br/>

 Gamma(x+1) = x * Gamma(x)
<br/><br/>

Pour <i>x</i> &lt; 0.5 on peut crire
<br/><br/>

 Gamma(x) * Gamma(1-x) = PI/sin(PI*x)<br/><br/>
La fonctin <b>lgamma()</b> renvoie le logarithme naturel (nperien) de
la valeur absolue de la fonction Gamma.
Le signe de la fonction Gamma est stock dans la variable entire
externe <i>signgam</i> dclar dans
<i>&lt;math.h&gt; .</i>
Il vaut 1 si la fonction Gamma est positive ou nulle, -1
si elle est ngative.<br/><br/>
Comme l'utilisation de la variable statique
<i>signgam</i> n'est pas sre en multi-threads, les fonctions <b>lgamma_r()</b> etc. ont t
introduite, elles renvoient le signe dans le paramtre
<i>signp .<br/><br/></i>
Pour les <i>x</i> entiers ngatifs ou nuls, <b>lgamma()</b> renvoie HUGE_VAL,
remplit <i>errno</i> avec ERANGE, et dclenche l'exception Division par zro.
(De mm, <b>lgammaf()</b> renvoie HUGE_VALF et <b>lgammal()</b> renvoie
HUGE_VALL.)
</div><br/><br /><h1 class="TitreSection0" id="L4">erreurs</h1>
<div class="paragraph">
Une application voulant vrifier les conditions d'erreur doit mettre
<i>errno</i>  zro et appeler
<i>feclearexcept(FE_ALL_EXCEPT)</i> avant d'invoquer ces fontions. En retour, si
<i>errno</i> est non-null ou si
<i>fetestexcept(FE_INVALID | FE_DIVBYZERO | FE_OVERFLOW | FE_UNDERFLOW)</i> est non-nul, une erreur s'est produite.
<br/><br/>

<b>ERANGE</b> <b></b>  Argument invalide, valeur entire ngative dans <i>x</i>.
</div><br/><br /><h1 class="TitreSection0" id="L5">conformit</h1>
<div class="paragraph">
C99, SVID 3, BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L6">voir aussi</h1>
<div class="paragraph">
<b>tgamma (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
