<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1997 Nicols Lichtmaier &lt;nick@debian.org&gt; -->
<!--  Created Thu Aug  7 00:44:00 ART 1997 -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  The GNU General Public License's references to "object code" -->
<!--  and "executables" are to be interpreted as the output of any -->
<!--  document formatting or typesetting system, including -->
<!--  intermediate and printed output. -->
<!--  -->
<!--  This manual is distributed in the hope that it will be useful, -->
<!--  but WITHOUT ANY WARRANTY; without even the implied warranty of -->
<!--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the -->
<!--  GNU General Public License for more details. -->
<!--  -->
<!--  Traduction 31/08/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.31 -->
<!--  MJ 21/07/2003 LDP-1.57 -->
<br/><h1>LOCKF</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
lockf - Poser, examiner ou supprimer un verrou Posix sur un fichier ouvert.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;</b> <b></b>  <br/><br/>

<b>int lockf(int </b> fd <b>, int </b> cmd <b>, off_t </b> len );</b>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette fonction pose, examine, ou supprime un verrou Posix sur un fichier ouvert.
Le fichier est indiqu par 
<i>fd ,</i>
un descripteur ouvert en criture, l'action par
<i>cmd ,</i>
et la section par les octets aux positions
<i>pos .. pos + len -1</i>
si len est positive et 
<i>pos - len .. pos -1</i>
si len est ngative, o
<i>pos</i> est la position actuelle dans le fichier. Si
<i>len</i> vaut zro, la section s'tend de la position courant  l'infini, englobant
la fin-de-fichier et les extensiont ultrieures.
Dans tous les cas, la section peut s'tendre au-del de la fin du fichier.<br/><br/>
Sous Linux, cette fonction est juste une interface pour l'appel-systme
<b>fcntl </b>(2).<b></b>
(En gnral, les relations entre
<b>lockf</b> <b></b>  et
<b>fcntl</b> <b></b>  sont indtermines).<br/><br/>
Les oprations valides sont les suivantes&nbsp;:
<br/><br/>
 
<b>F_LOCK</b> <b></b>  Poser un verrou exclusif sur la section indique du fichier.
Si (une partie de) la section est dj verrouille, l'appel bloque jusqu' la
suppression du verrou prcdent.
Si la section recouvre un verrou existant (du mme processus), les deux sont
regroups.
Les verrouillages sont librs lorsque le processus ferme un descripteur du
fichier.
Un processus fils n'hrite pas du verrou.
<br/><br/>

<b>F_TLOCK</b> <b></b>  Comme
<b>F_LOCK</b> <b></b>  mais l'appel n'est pas bloquant, il renvoie une erreur si le fichier est
dj verrouill.
<br/><br/>

<b>F_ULOCK</b> <b></b>  Dverrouiller la section indique du fichier. Ceci peut conduire une section
verrouille  tre dcoupe en deux sections.
<br/><br/>

<b>F_TEST</b> <b></b>  Verifier s'il y a un verrou : l'appel renvoie 0 si la section indique est
libre ou verrouille par le processus appelant, et -1 avec
<b>EACCES</b> <b></b>  <b></b>  dans
<i>errno</i> si un autre processus possde le verrou.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Si elle russit, cette fonction renvoie 0. En cas d'erreur, elle renvoie -1 et
remplit
<i>errno</i> en consquence.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EAGAIN</b> <b></b>  Le fichier est verrouille et
<b>F_TLOCK</b> <b></b>  ou
<b>F_TEST</b> <b></b>  taient indiqus, ou encore l'opration est impossible car le fichier est
projete dans la mmoire d'un autre processus.
<br/><br/>

<b>EBADF</b> <b></b>  <i>fd</i> n'est pas un descripteur valide.
<br/><br/>

<b>EDEADLK</b> <b></b>  L'opration
<b>T_LOCK</b> <b></b>  demande amnerait  un cas de blocage.
<br/><br/>

<b>EINVAL</b> <b></b>  Une opration invalide a t rclame sur
<i>fd .</i>
<br/><br/>

<b>ENOLCK</b> <b></b>  La table des verrous est pleine.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
SYSV,  POSIX 1003.1-2001
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>fcntl (2),</b>
<b>flock (2)</b>
<br/>
On peut aussi examiner
<i>locks.txt</i> et
<i>mandatory.txt</i> dans la documentation Linux
<i>/usr/src/linux/Documentation .</i>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
