<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 2001 Andries Brouwer (aeb@cwi.nl) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction 14/05/2002 par Stphan Rafin (stephan.rafin@laposte.net) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  -->
<br/><h1>MAKECONTEXT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
makecontext, swapcontext - Manipulation du contexte utilisateur.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;ucontext.h&gt;</b> <b></b>  <br/><br/>

<b>void makecontext(ucontext_t *</b> ucp <i>, void *</i> func <b>(),
<b>int </b> argc <i>, ...);</i>
<br/>
<b>int swapcontext (ucontext_t *</b> oucp <i>, ucontext_t *</i> ucp );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Dans un environnement de type SysV, on dispose du type <b>ucontext_t</b> dfini dans
<i>&lt;ucontext.h&gt;</i> et des quatre fonctions 
<b>getcontext()</b>, <b>setcontext()</b>, <b>makecontext()</b>
et <b>swapcontext()</b> qui permettent, au niveau utilisateur, des permutations de contextes entre plusieurs threads de contrle au sein d'un processus.<br/><br/>
Pour le type et les deux premires fonctions, voir
<b>getcontext (2).<br/><br/></b>
La fonction <b>makecontext()</b> modifie le contexte point par 
<i>ucp</i> ( qui a t obtenu par un appel  <b>getcontext()</b>).
Avant d'appeler <b>makecontext()</b>, il faut allouer une nouvelle pile
pour ce contexte, l'affectant  <i>ucp-&gt;uc_stack</i>, et dfinir un
contexte successeur, l'affectant  <i>ucp-&gt;uc_link</i>.
Lorsque ce contexte est activ par la suite (en utilisant <b>setcontext()</b> ou
<b>swapcontext()</b>), alors, la fonction <i>func</i> est tout d'abord appele
avec les arguments spcifis  la suite de <i>argc</i> (o <i>argc</i>
doit prciser le nombre de ces arguments), et lorsque cette fonction
s'achve, le contexte successeur est activ. Quand le pointeur sur le 
contexte successeur vaut NULL, le thread se termine.<br/><br/>
La fonction <b>swapcontext()</b> sauvegarde le contexte actuel dans
la structure pointe par <i>oucp</i> et active ensuite le contexte 
point par <i>ucp</i>.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
En cas de succs, <b>makecontext()</b> renvoie 0 tandis que <b>swapcontext()</b>
ne rend pas la main  l'appelant. (On peut toutefois revenir  l'appelant en cas d'activation de
<i>oucp</i>. Dans un tel cas, <b>swapcontext()</b> se comporte comme si elle renvoyait 0.)
En cas d'erreur, les deux fonctions renvoient -1 et positionnent <i>errno</i> de faon approprie.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>ENOMEM</b> <b></b>  Espace de pile disponible insuffisant.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
L'interprtation de <i>ucp-&gt;uc_stack</i> est exactement la mme que pour
<b>sigaltstack (2),</b>
 savoir, cette structure contient l'adresse de dpart et la longueur 
d'une zone mmoire destine  tre utilise comme pile, et ce, sans considration
sur le sens d'expansion de la pile. Il n'est donc pas ncessaire pour le 
programme utilisateur de se soucier de ce sens.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SUSv2, POSIX 1003.1-2001.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>getcontext (2),</b>
<b>sigaction (2),</b>
<b>sigaltstack (2),</b>
<b>sigprocmask (2),</b>
<b>sigsetjmp (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Stphan Rafin, 2002.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
