<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 2002 Walter Harms (walter.harms@informatik.uni-oldenburg.de) -->
<!--  Distributed under GPL -->
<!--  Heavily based on glibc documentation -->
<!--  Polished, added docs, removed glibc doc bug, 2002-07-20, aeb -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>MALLOC_HOOK</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">exemple</a>
<br /><a class="summaryIndent0" href="#L4">voir aussi</a>
<br /><a class="summaryIndent0" href="#L5">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
__malloc_hook, __malloc_initialize_hook, __memalign_hook, __free_hook, __realloc_hook, __after_morecore_hook - Variables de dbogage de malloc.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<br/><br/>

<b>#include &lt;malloc.h&gt;</b></b>
<br/><br/>

<b>void *(*__malloc_hook)(size_t </b> size , 
<b>const void *</b> caller );
<br/><br/>

<b>void *(*__realloc_hook)(void *</b> ptr , 
<b>size_t </b> size , 
<b>const void *</b> caller );
<br/><br/>

<b>void *(*__memalign_hook)(size_t </b> alignment ,
<b>size_t </b> size ,
<b>const void *</b> caller );
<br/><br/>

<b>void (*__free_hook)(void *</b> ptr , 
<b>const void *</b> caller );
<br/><br/>

<b>void (*__malloc_initialize_hook)(void);</b>
<br/><br/>

<b>void (*__after_morecore_hook)(void);</b>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La bibliothque C GNU vous permet de modifier le comportement de
<i>malloc (),</i>
<i>realloc (),</i>
et
<i>free ()</i>
en fixant les points d'entre des routines. Vous pouvez utiliser ces points
pour faciliter le dbogage des programmes utilisant des allocations de mmoire
dynamique par exemple.<br/><br/>
La variable
<b>__malloc_initialize_hook</b> <b></b>  pointe vers une fonction qui est appele une seule fois  l'initialisation de
malloc. C'est une variable libre qui peut tre modifie par l'application avec
une dclaration comme celle-ci&nbsp;:
<br/>

    void (*__malloc_initialize_hook)(void) = my_init_hook;


<br/>
A prsent la fonction
<i>my_init_hook ()</i>
pourra faire toute l'initialisation des routines.<br/><br/>
Les quatre fonctions pointes par
<b>__malloc_hook ,</b>
<b>__realloc_hook ,</b>
<b>__memalign_hook ,</b>
<b>__free_hook</b>
ont des prototypes semblables  ceux des fonctions
<i>malloc (),</i>
<i>realloc (),</i>
<i>memalign (),</i>
<i>free (),</i>
respectivement, avec un argument final supplmentaire
<i>caller</i> qui fournit l'adresse du code appelant
<i>malloc (),</i>
etc.<br/><br/>
La variable
<b>__after_morecore_hook</b> <b></b>  pointe sur une fonction qui est invoque  chaque fois que
<i>sbrk ()</i>
a t appel pour augmenter le segment de donnes.
</div><br/><br /><h1 class="TitreSection0" id="L4">exemple</h1>
<div class="paragraph">
Voici un court exemple d'utilisation de ces variables.
<br/><br/>


#include &lt;stdio.h&gt;
#include &lt;malloc.h&gt;
     
/* Prototypes de nos routines */
static void my_init_hook(void);
static void *my_malloc_hook(size_t, const void *);<br/><br/>
/* Variables pour sauver la routine originale */
static void *(*old_malloc_hook)(size_t, const void *);
     
/* Ecrasement de la routine d'initialisaiton GlibC */
void (*__malloc_initialize_hook) (void) = my_init_hook;<br/><br/>
static void
my_init_hook(void) {
    old_malloc_hook = __malloc_hook;
    __malloc_hook = my_malloc_hook;
}<br/><br/>
static void *
my_malloc_hook (size_t size, const void *caller) {
    void *result;<br/><br/>
    /* Replacer la routine originale */
    __malloc_hook = old_malloc_hook;<br/><br/>
    /* Appel de la routine originale) */
    result = malloc (size);<br/><br/>
    /* Sauver la routine originale */
    old_malloc_hook = __malloc_hook;<br/><br/>
    /* `printf' peut appeler `malloc'...  protger. */
    printf ("malloc(%u) called from %p returns %p\n",
        (unsigned int) size, caller, result);<br/><br/>
    /* Replacer notre routine */
    __malloc_hook = my_malloc_hook;<br/><br/>
    return result;
}


</div><br/><br /><h1 class="TitreSection0" id="L5">voir aussi</h1>
<div class="paragraph">
<b>mallinfo (3), </b>
<b>malloc (3),</b>
<b>mtrace (3),</b>
<b>mcheck (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
