<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) Bruno Haible &lt;haible@clisp.cons.org&gt; -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  References consulted: -->
<!--    GNU glibc-2 source code and manual -->
<!--    Dinkumware C library reference http://www.dinkumware.com/ -->
<!--    OpenGroup's Single Unix specification http://www.UNIX-systems.org/online.html -->
<!--    ISO/IEC 9899:1999 -->
<!--  -->
<!--  Traduction 29/08/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.30 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>MBRTOWC</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">conformit</a>
<br /><a class="summaryIndent0" href="#L5">voir aussi</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
mbrtowc - Convertir une squence multi-octets en caractre large.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;wchar.h&gt;</b> <b></b>  <br/><br/>

<b>size_t mbrtowc (wchar_t *</b> pwc <i>, const char *</i> s <b>, size_t </b> n <i>, mbstate_t *</i> ps );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
L'usage principal de cette fonction est celui avec <i>s</i> non-NULL et <i>pwc</i> non-NULL.
Dans ce cas, la fonction <b>mbrtowc</b> examine au plus <i>n</i> octets de la squence commenant en <i>s</i>,
en extrait le prochain caractre multi-octets complet, et le place en <i>*pwc</i>.
Elle met  jour l'tat de dcalage <i>*ps</i>. Si le caractre large obtenu n'est pas L'\\0', elle renvoie
le nombre d'octets lus depuis <i>s</i>. Si le caractre large obtenu est L'\\0', elle rinitialise
l'tat de dcalage <i>*ps</i> et renvoie zro.<br/><br/>
Si les <i>n</i> octets commenant en <i>s</i> ne contiennent pas de caractre large complet, <b>mbrtowc</b>
renvoie <i>(size_t)(-2)</i>. Cela peut se produire mme si <i>n</i> &gt;= <i>MB_CUR_MAX</i>, lorsque la squence multi-octets
contient des squences de dcalage redondantes.<br/><br/>
Si la squence multi-octets commenant en <i>s</i> contient une squence invalide avant le prochain
caractre complet, <b>mbrtowc</b> renvoie <i>(size_t)(-1)</i> et place dans <b>errno</b> la valeur <b>EILSEQ</b>.
Dans ce cas, les effets sur <i>*ps</i> sont indfinis.<br/><br/>
Une autre situation est possible, si <i>s</i> est non-NULL, mais <i>pwc</i> est NULL. Dans ce cas, <b>mbrtowc</b>
se comporte comme prcdemment, mais n'enregistre pas le caractre large obtenu.<br/><br/>
Un troisime cas se prsente si <i>s</i> est NULL. Alors, <i>pwc</i> et <i>n</i> sont
ignors. Si l'tat de conversion reprsent par <i>*ps</i> indique une conversion
multi-octets incomplte, la fonction <b>mbrtowc</b> renvboie
<i>(size_t)(-1)</i>, remplie <b>errno</b> avec <b>EILSEQ</b>, et
laisse <i>*ps</i> dans un tat indfini. Sinon, la fonction <b>mbrtowc</b> function
remet <i>*ps</i> dans l'tat initial et renvoie 0.<br/><br/>
Dans tous ces cas, si <i>ps</i> est un pointeur NULL, une zone de mmoire statique
propre  mbrtowc() est utilis  sa place.
Sinon, <i>*ps</i> doit tre un objet <b>mbstate_t</b> valide.
Un tel objet <b>mbstate_t</b> not <i>a</i> peut tre initialis
en le mettant  zro, par exemple ainsi&nbsp;:
<br/><br/>

.RS
memset(&a, 0, sizeof(a));

</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>mbrtowc</b> renvoie le nombre d'octets balays depuis la squence commenant en <i>s</i>, si
un caractre large non nul a t reconnu. Elle renvoie zro si un caractre large nul est rencontr.
Elle renvoie (size_t)(-1) et remplit <b>errno</b> avec <b>EILSEQ</b>, si une squence invalide est trouve.
Elle renvoie (size_t)(-2) si elle n'a pas trouv de caractre entier, et si <i>n</i> doit tre augment.
</div><br/><br /><h1 class="TitreSection0" id="L5">conformit</h1>
<div class="paragraph">
ISO/ANSI C, UNIX98
</div><br/><br /><h1 class="TitreSection0" id="L6">voir aussi</h1>
<div class="paragraph">
<b>mbsrtowcs (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
Le comportement de <b>mbrtowc</b> dpend de la catgorie LC_CTYPE de la localisation.
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
