<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) Bruno Haible &lt;haible@clisp.cons.org&gt; -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  References consulted: -->
<!--    GNU glibc-2 source code and manual -->
<!--    Dinkumware C library reference http://www.dinkumware.com/ -->
<!--    OpenGroup's Single Unix specification http://www.UNIX-systems.org/online.html -->
<!--    ISO/IEC 9899:1999 -->
<!--  -->
<!--  Traduction 29/08/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.30 -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>MBSINIT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">conformit</a>
<br /><a class="summaryIndent0" href="#L5">voir aussi</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
mbsinit - Vrifier si la conversion est dans l'tat initial.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;wchar.h&gt;</b> <b></b>  <br/><br/>

<b>int mbsinit (const mbstate_t *</b> ps );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La conversion de caractres entre la reprsentation multi-octets et les caractres larges emploie
un tat de type <b>mbstate_t</b>. La conversion d'une chane utilise un automate  tats finis.
Lorsqu'elle est interrompue aprs la conversion d'un nombre entier de caractres, il peut tre ncessaire
de mmoriser son tat pour pouvoir traiter ultrieurement le reste de la chane. Un tel tat de conversion
est indispensable pour certains encodages tels que ISO-2022 et UTF-7.<br/><br/>
L'tat initial est celui du dbut de la conversion de chane. Il y a deux types d'tats, celui utilis par les conversions
multi-octets en caractres larges, comme <b>mbsrtowcs</b>, et celui employ par les conversions inverses, comme <b>wcsrtombs</b>.
Toutefois, les deux types peuvent tre stocks dans une variable <b>mbstate_t</b>, et ils se prsentent tous deux sous
la mme forme initiale.<br/><br/>
Pour les codages 8 bits ou UTF-8, tous les tats sont quivalent  l'tat initial.
Pour les encodages multioctets comme UTF-8, EUC-* BIG5 ou SJIS, la conversion
de caractre large en multioctet ne produit jamais d'tat non-initial, mais
la conversion multioctet en caractre large comme <b>mbrtowc</b> peut produire
un tat non initial si elle est interrompue au milieu d'un caractre.<br/><br/>
Une possibilit pour crer un tat mbstate_t initial est de le fixer  zro&nbsp;:

  mbstate_t state;
  memset(&state,0,sizeof(mbstate_t));

<br/><br/>
Sous Linux, on peut aussi utiliser la ligne suivante, mme si elle dclenche des avertissements du compilateur :

  mbstate_t state = { 0 };

<br/><br/>
La fonction <b>mbsinit</b> vrifie si <i>*ps</i> correspond  un tat initial.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>mbsinit</b> renvoie une valeur non-nulle si <i>*ps</i> est dans l'tat initial, ou si <i>ps</i> est un pointeur NULL.
Sinon elle renvoie zro.
</div><br/><br /><h1 class="TitreSection0" id="L5">conformit</h1>
<div class="paragraph">
ISO/ANSI C, UNIX98
</div><br/><br /><h1 class="TitreSection0" id="L6">voir aussi</h1>
<div class="paragraph">
<b>mbsrtowcs (3),</b>
<b>wcsrtombs (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
Le comportement de <b>mbsinit</b> dpend de la catgorie LC_CTYPE de la localisation.
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
