<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  This manpage is Copyright (C) 1995 James R. Van Zandt &lt;jrv@vanzandt.mv.com&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  changed section from 2 to 3, aeb, 950919 -->
<!--  -->
<!--  Traduction 05/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  -->
<br/><h1>MKFIFO</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
mkfifo - Crer un fichier spcial FIFO.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;sys/stat.h&gt;</b> <b></b>  <br/><br/>

<b>int mkfifo ( const char *</b> pathname <i>, mode_t </i> mode <b>);</b>


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>mkfifo</b> cre un fichier spcial FIFO (tube nomm)
 l'emplacement <i>pathname</i>.
<i>mode</i> indique les permissions d'accs. Ces permissions sont modifies
par la valeur d'<b>umask</b> du processus : les permissions d'accs effectivement
adoptes sont <b>(</b><i>mode</i><b> & ~umask)</b>.<br/><br/>
Un fichier spcial FIFO est semblable  un tube (pipe), sauf qu'il est
cr diffrement. Plutot qu'un canal de communication anonyme, un fichier
FIFO est insr dans le systme de fichiers en appelant <b>mkfifo</b>.<br/><br/>
Une fois qu'un fichier FIFO est cr, n'importe quel processus peut
l'ouvrir en lecture ou criture, comme tout fichier ordinaire.
En fait, il faut ouvrir les deux extrmits simultanment avant de
pouvoir effectuer une opration d'criture ou de lecture. L'ouverture
d'un FIFO en lecture est gnralement bloquante, jusqu' ce qu'un
autre processus ouvre le mme FIFO en criture, et inversement. Voir
<b>fifo (4)</b>
pour la gestion non-bloquante d'une FIFO.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La valeur renvoye par <i>mkfifo</i> est <b>0</b> s'il russit, ou -1 s'il
choue, auquel cas <i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EACCES</b> <b></b>  L'un des rpertoires dans <i>pathname</i> ne permet pas la recherche (excution).
<br/><br/>

<b>EEXIST</b> <b></b>  <i>pathname</i> existe dj.
<br/><br/>

<b>ENAMETOOLONG</b> <b></b>  Soit la longueur totale de <i>pathname</i> est suprieure  <b>PATH_MAX</b>,
soit un lment de <i>pathname</i> a une longueur plus grande que <b>NAME_MAX</b>.
Sur les systmes GNU il n'y a pas de limite absolue  la longueur du nom d'un
fichier, mais certains autres systmes en ont une.
<br/><br/>

<b>ENOENT</b> <b></b>  L'un des rpertoire de <i>pathname</i> n'existe pas, ou est un lien symbolique
pointant nulle part.
<br/><br/>

<b>ENOSPC</b> <b></b>  Le rpertoire, ou le systme de fichiers, n'a pas assez de place
pour un nouveau fichier.
<br/><br/>

<b>ENOTDIR</b> <b></b>  Un lment de <i>pathname</i> n'est pas un rpertoire.
<br/><br/>

<b>EROFS</b> <b></b>  <i>pathname</i> est sur un systme de fichiers en lecture-seule.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
POSIX.1
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>mkfifo (1),</b>
<b>read (2),</b>
<b>write (2),</b>
<b>open (2),</b>
<b>close (2),</b>
<b>stat (2), </b>
<b>umask (2),</b>
<b>fifo (4)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
