<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 18:48:48 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 05/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a jour 21/07/1997 -->
<!--  Mise a jour 17/05/1998 (LDP-man-pages-1.19) -->
<!--  Mise a jour 05/05/1999 (LDP-man-pages-1.23) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>MKSTEMP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">note</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
mkstemp - Crr un fichier temporaire unique.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdlib.h&gt;</b> <b></b>  <br/><br/>

<b>int mkstemp (char *</b> template );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>mkstemp()</b> engendre un nom de fichier temporaire unique,
 partir du motif <i>template</i>. Les six derniers caractres de <i>template</i>
doivent tre XXXXXX et ils seront alors remplacs par une chane rendant
ce nom de fichier unique. Le fichier est cr avec les permission 0666 jusqu'
la GlibC 2.0.6, puis 0600 depuis la Glib 2.0.7.
Comme il sera modifi,
<i>template</i> ne doit pas tre une chane constante, mais comme un tableau de caractres.
Le fichier est ouvert avec l'attribut O_EXCL, garantissant que nous
soyons le seul propritaire du fichier.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>mkstemp()</b> renvoie le descripteur du fichier temporaire
cr ou -1 en cas d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EINVAL</b> <b></b>  Les 6 derniers caractres de <i>template</i> ne sont pas XXXXXX.
Dans ce cas, <i>template</i> n'est pas modifi.
<br/><br/>

<b>EEXIST</b> <b></b>  Impossible de crer un nom de fichier unique. Le contenu du
fichier est imprvisible.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
L'ancien comportement (crer les fichiers avec le mode 0666) est un
trou de scurit potentiel, surtout depuis que les autres drivs Unix
utilisent le mode 0600 et quelqu'un risque d'oublier ce dtail en
effectuant un portage de programme.<br/><br/>
Plus gnralement, les spcifications POSIX ne disent rien des modes
des fichiers, ainsi les applications doivent s'assurer que la valeur
d'umask est correcte avant d'appeler
<b>mkstemp . </b>
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
BSD 4.3, POSIX 1003.1-2001
</div><br/><br /><h1 class="TitreSection0" id="L8">note</h1>
<div class="paragraph">
Le prototype se trouve dans
<i>&lt;unistd.h&gt;</i> pour libc4, libc5; glibc1. Glibc2 suit les spcifications Single Unix et
place le prototype dans
<i>&lt;stdlib.h&gt; .</i>
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>mkdtemp (3),</b>
<b>mktemp (3),</b>
<b>tmpnam (3),</b>
<b>tempnam (3),</b>
<b>tmpfile (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
