<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  (c) 2001 by John Levon &lt;moz@compsoc.man.ac.uk&gt; -->
<!--  Based in part on GNU libc documentation. -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  License. -->
<!--  -->
<!--  2001-10-11, aeb, added some details -->
<!--  -->
<!--  Traduction 17/05/2002 par Stphan Rafin (stephan.rafin@laposte.net) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  -->
<br/><h1>POSIX_MEMALIGN</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">historique</a>
<br /><a class="summaryIndent0" href="#L7">conformit</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
posix_memalign, memalign, valloc - Allocation de mmoire aligne.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdlib.h&gt;</b> <b></b>  <br/><br/>

<b>int posix_memalign(void **</b> memptr <i>, size_t </i> alignment <b>, size_t </b> size );
<b>void *memalign(size_t </b> boundary <i>, size_t </i> size );
<b>void *valloc(size_t </b> size );
.nl


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>posix_memalign()</b> <b></b>  alloue
<i>size</i> octets et place l'adresse de la mmoire alloue dans
<i>*memptr</i>.</i>
L'adresse de la mmoire alloue est un multiple de
<i>alignment</i>,</i>
qui doit lui mme tre une puissance de deux et un multiple de
<i>sizeof(void *)</i>.<br/><br/></i>
La fonction obsolte
<b>memalign()</b> <b></b>  alloue
<i>size</i> octets et renvoie un pointeur vers la mmoire alloue.
L'adresse mmoire est alors un multiple de 
<i>boundary</i>,</i>
qui doit tre une puissance de deux.<br/><br/>
La fonction obsolte
<b>valloc()</b> <b></b>  alloue
<i>size</i> octets et renvoie un pointeur vers la mmoire alloue.
L'adresse mmoire est alors un multiple de la taille de page.
Cette fonction est quivalente  
<i>memalign(sysconf(_SC_PAGESIZE),size)</i> .<br/><br/></i>
Pour ces trois routines, la mmoire n'est pas initialise  zro.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>memalign()</b>
et
<b>valloc()</b>
renvoient un pointeur sur la mmoire alloue, ou bien 
<b>NULL</b> <b></b>  si la requte choue.<br/><br/>
<b>posix_memalign()</b>
renvoie zro en cas de succs, ou l'une des valeurs d'erreurs rpertories dans
la section suivante en cas d'chec. Notez que
<i>errno</i>
n'est pas affecte par cette fonction.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EINVAL</b> <b></b>  Le paramtre
<i>alignment</i>
n'est pas une puissance de deux, ou n'est pas un multiple de
<i>sizeof(void *)</i> .</i>
<br/><br/>

<b>ENOMEM</b> <b></b>  Mmoire insuffisante pour raliser la demande d'allocation.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph"><br/><br/>
<b>posix_memalign()</b>
vrifie que
<i>alignment</i>
rpond bien aux exigences dtailles ci dessus.
<b>memalign()</b>
est susceptible de ne pas contrler que le paramtre
<i>boundary</i>
est correct.<br/><br/>
La norme POSIX impose que la mmoire obtenue par un appel 
<b>posix_memalign()</b>
puisse tre libre en utilisant
<i>free ().</i>
Certains systmes ne fournissent aucun moyen afin de librer la
mmoire alloue par
<i>memalign ()</i>
ou
<i>valloc ()</i>
(parce que l'on peut seulement passer comme paramtre  
<i>free ()</i>
un pointeur obtenu via
<i>malloc (),</i>
Alors que e.g.
<i>memalign ()</i>
pourrait appeler 
<i>malloc ()</i>
et aligner par la suite la valeur obtenue).
<!--  Other systems allow passing the result of -->
<!--  <i>valloc () --></i>
<!--  to -->
<!--  <i>free (), --></i>
<!--  but not to -->
<!--  <i>realloc (). --></i>
La libc GNU permet de librer la mmoire obtenue par n'importe laquelle de 
ces trois fonctions par appel 
<i>free ().<br/><br/></i>
La version libc GNU de
<b>malloc()</b></b>
renvoie toujours des adresses mmoire alignes sur 8-octets, ainsi ces 
routines ne sont ncessaires qu'en cas de besoin de valeurs d'alignement plus
grandes.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">historique</h1>
<div class="paragraph">
Les fonctions
<i>memalign ()</i>
et
<i>valloc ()</i>
sont disponibles dans toutes les bibliothques libc de Linux.
La fonction
<i>posix_memalign ()</i>
est disponible depuis la glibc 2.1.91.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">conformit</h1>
<div class="paragraph">
La fonction
<i>valloc ()</i>
est apparue dans BSD 3.0. Elle est qualifie d'obsolte dans BSD 4.3,
et de lgende dans SUSv2. Elle n'apparat plus dans SUSv3.
La fonction
<i>memalign ()</i>
est apparue dans SunOS 4.1.3 mais pas dans BSD 4.4.
La fonction
<b>posix_memalign()</b>
provient de POSIX 1003.1d.
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>malloc (3),</b>
<b>free (3),</b>
<b>getpagesize(2),</b>
<b>brk (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Stphan Rafin, 2002.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
