<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<br/><h1>PTHREAD_ATFORK</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">auteur</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
pthread_atfork - enregistre des gestionnaires  invoquer lors de l'appel  fork(2)<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;pthread.h&gt;<br/><br/></b> <b></b>  <b>int pthread_atfork(void (*</b> prepare <i>)(void), void (*</i> parent <b>)(void), void (*</b> child <i>)(void));</i><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph"><br/><br/>
<b>pthread_atfork"</b> <b></b>  enregistre les fonctions  appeler juste avant et juste aprs la cration d'un
nouveau processus par
<b>fork</b> (2).</b>
Le gestionnaire
<i>prepare</i> est appel par le processus parent juste avant la cration du nouveau
processus. Le gestionnaire
<i>parent</i> est appel par le processus parent juste avant que
<b>fork</b> (2)</b>
finisse. Le gestionnaire
<i>child</i> est appel par le processus fils juste avant la fin de l'appel
<b>fork</b> (2).<br/><br/></b>
L'un ou plusieurs des trois gestionnaires
<i>prepare</i> ,</i>
<i>parent</i> et 
<i>child</i> peut tre affect 
<b>NULL</b> ,</b>
ce qui signifie qu'aucun gestionnaire ne sera appel au moment correspondant.<br/><br/>
<b>pthread_atfork"</b> <b></b>  peut tre appele plusieurs fois pour enregistrer plusieurs ensembles de
gestionnaires. Lors de l'appel 
<b>fork</b> (2),</b>
les gestionnaires
<i>prepare</i> sont appels dans l'orde LIFO (Last In First Out&nbsp;: dans l'ordre
inverse de l'enregistrement)
juste avant
<b>fork</b> ,</b>
alors que les gestionnaires
<i>parent</i> et
<i>child</i> sont appels dans l'ordre FIFO (First In First Out&nbsp;: dans l'ordre
d'enregistrement).<br/><br/>
Pour comprendre l'objectif de
<b>pthread_atfork</b> ,</b>
rappellons que
<b>fork</b> (2)</b>
copie toute l'image mmoire du processus, y compris ses mutex dans leur tat
de bloquage courant, mais seulement le thread couran&nbsp;t: les autres threads ne
s'excutent pas dans le processus fils. Donc, si un mutex est pris par un autre
thread que celui ayant appel 
<b>fork</b> ,</b>
ce mutex restera bloqu pour toujours dans le processus fils. Il est mme
possible que l'excution du processus fils se bloque sur ce mutex. Afin
d'viter ceci, il faut installer des gestionnaires avec
<b>pthread_atfork"</b> <b></b>  comme ceci&nbsp;: le gestionnaire
<i>prepare</i> prend le mutex global et les gestionnaires
<i>parent</i> et 
<i>child</i> le dbloquent (dans l'ordre inverse). Autre possibilit, 
<i>prepare</i> et 
<i>parent</i> peuvent tre initialiss 
<b>NULL"</b> <b></b>  et 
<i>child</i> est une fonction qui appelle
<b>pthread_mutex_init"</b> <b></b>  sur le mutex global.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph"><br/><br/>
<b>pthread_atfork"</b> <b></b>  retourne 0 en cas de succs et un code d'erreur non nul en cas d'erreur.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>ENOMEM"</b> <b></b>  pas assez de mmoire disponible pour enregistrer les gestionnaires.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">auteur</h1>
<div class="paragraph">
Xavier Leroy &lt;Xavier.Leroy@inria.fr&gt;
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>fork</b> (2),</b>
<b>pthread_mutex_lock</b> (3),</b>
<b>pthread_mutex_unlock</b> (3).</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i></i>
<br/>
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
