<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<br/><h1>PTHREAD_CANCEL</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">auteur</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">bogues</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/>
<br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
pthread_cancel, pthread_setcancelstate, pthread_setcanceltype, pthread_testcancel - Annulation de thread.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;pthread.h&gt;<br/><br/></b> <b></b>  <b>int pthread_cancel(pthread_t </b> thread <i>);</i><br/><br/>
<b>int pthread_setcancelstate(int </b> state <i>, int *</i> etat_pred <b>);</b><br/><br/>
<b>int pthread_setcanceltype(int </b> mode <i>, int *</i> ancien_mode <b>);</b><br/><br/>
<b>void pthread_testcancel(void);</b><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
L'annulation est le mcanisme par lequel un thread peut interrompre l'excution
d'un autre thread. C'est l'quivalent pour les threads de la fonction kill()
des processus classiques. Plus prcisment, un thread peut envoyer une requte
d'annulation  un autre thread. Selon sa configuration, le thread vis peut
soit ignorer la requte, soit l'honorer immdiatement, soit enfin retarder son
application jusqu' ce qu'un point d'annulation soit atteint.<br/><br/>
Quand un thread ralise finalement la requte d'annulation, il se comporte
comme si
<b>pthread_exit(PTHREAD_CANCELED)"</b> <b></b>  avait t appel  cet endroit&nbsp;: tous les gestionnaires de nettoyage sont
excuts dans l'ordre inverse de leur enregistrement. Puis les fonctions de
destruction des donnes spcifiques au thread sont appeles. Enfin, le thread
interrompt dfinitivement son excution en retournant la valeur
<b>PTHREAD_CANCELED</b> .</b>
Voir
<b>pthread_exit</b> (3)</b>
pour plus d'information.<br/><br/>
<b>pthread_cancel"</b> <b></b>  envoie une requte d'annulation au thread indiqu par l'argument
<i>thread .<br/><br/></i>
<b>pthread_setcancelstate"</b> <b></b>  modifie l'tat d'annulation pour le thread appelant, c'est  dire si les
requtes d'annulation sont ignores ou non. L'argument
<i>state</i> est le nouvel tat d'annulation&nbsp;: soit
<b>PTHREAD_CANCEL_ENABLE"</b> <b></b>  pour autoriser les annulations, soit
<b>PTHREAD_CANCEL_DISABLE"</b> <b></b>  pour les dsactiver (les requtes d'annulation sont alors ignores). Si
<i>etat_pred</i> est diffrent de
<b>NULL</b> ,</b>
le prcdent tat d'annulation est sauvegard  l'emplacement point par
<i>etat_pred</i> ,</i>
et peut donc tre restaur plus tard par un autre appel 
<b>pthread_setcancelstate</b> .<br/><br/></b>
<b>pthread_setcanceltype"</b> <b></b>  modifie le mode de la rponse  une requte d'annulation pour le thread
appelant&nbsp;: asynchrone (immdiate) ou retarde.
L'argument
<i>type</i> est le nouveau mode d'annulation&nbsp;: soit
<b>PTHREAD_CANCEL_ASYNCHRONOUS"</b> <b></b>  pour annuler le thread appelant ds que possible aprs la rception d'une
requte d'annulation, soit
<b>PTHREAD_CANCEL_DEFERRED"</b> <b></b>  pour mettre en attente la requte jusqu' ce qu'un point d'annulation soit
atteint. Si
<i>ancien_mode</i> n'est pas gal 
<b>NULL</b> ,</b>
alors le prcdent tat d'annulation est sauvegard  l'emplacement point par
<i>ancien_mode</i> ,</i>
et peut donc tre restaur plus tard par un autres appel 
<b>pthread_setcanceltype</b> .<br/><br/></b>
Les threads sont toujours crs par
<b>pthread_create</b> (3)</b>
avec annulation active et retarde. C'est  dire que l'tat initial
d'annulation est
<b>PTHREAD_CANCEL_ENABLE"</b> <b></b>  et que le mode initial est
<b>PTHREAD_CANCEL_DEFERRED</b> .<br/><br/></b>
Les points d'annulation sont les points dans l'excution d'un programme o l'on
teste si des requtes d'annulation ne sont pas en attente de traitement. Si des
requtes sont en attente, alors l'annulation du thread est excute. Les
fonctions suivantes relatives aux threads de la norme POSIX sont des points
d'annulation implicites&nbsp;:<br/><br/>
.RS
<b>pthread_join</b> (3)</b>
<br/>
<b>pthread_cond_wait</b> (3)</b>
<br/>
<b>pthread_cond_timedwait</b> (3)</b>
<br/>
<b>pthread_testcancel</b> (3)</b>
<br/>
<b>sem_wait</b> (3)</b>
<br/>
<b>sigwait</b> (3)</b>
<br/><br/>
Toutes les autres fonctions POSIX relatives aux threads sont garanties ne pas
tre des points d'annulation. C'est--dire qu'elles ne traitent pas les
requtes d'annulation en attente de traitement.<br/><br/>
<b>pthread_testcancel"</b> <b></b>  ne fait rien si ce n'est tester si une requte d'annulation est en attente de
ralisation et la traiter. Sa fonction est d'introduire des tests explicites
pour vrifier ponctuellement qu'aucune requte d'annulation n'a t reue lors
des longues squences de code sans points d'annulation.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph"><br/><br/>
<b>pthread_cancel</b> ,</b>
<b>pthread_setcancelstate"</b> <b></b>  et
<b>pthread_setcanceltype"</b> <b></b>  renvoient 0 en cas de succs et un code d'erreur non nul en cas d'erreur.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<b>pthread_cancel"</b> <b></b>  renvoie l'un des codes d'erreur suivants&nbsp;:
.RS
<br/><br/>

<b>ESRCH"</b> <b></b>  aucun thread correspondant au descripteur
<i>thread</i> n'a pu te trouv.
<br/><br/>
<b>pthread_setcancelstate"</b> <b></b>  renvoie l'un des codes d'erreur suivants&nbsp;:
.RS
<br/><br/>

<b>EINVAL"</b> <b></b>  l'argument
<i>state</i> n'est ni
<b>PTHREAD_CANCEL_ENABLE"</b> <b></b>  ni
<b>PTHREAD_CANCEL_DISABLE"</b> <b></b>  <br/><br/>
<b>pthread_setcanceltype"</b> <b></b>  renvoie l'un des codes d'erreur suivants&nbsp;:
.RS
<br/><br/>

<b>EINVAL"</b> <b></b>  l'argument
<i>type</i> n'est ni
<b>PTHREAD_CANCEL_DEFERRED"</b> <b></b>  ni
<b>PTHREAD_CANCEL_ASYNCHRONOUS"</b> <b></b>  <br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">auteur</h1>
<div class="paragraph">
Xavier Leroy &lt;Xavier.Leroy@inria.fr&gt;<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>pthread_exit</b> (3),</b>
<b>pthread_cleanup_push</b> (3),</b>
<b>pthread_cleanup_pop</b> (3).<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L8">bogues</h1>
<div class="paragraph">
POSIX spcifie qu'un certain nombre d'appels-systme (fondamentalement, tous
les appels-systme pouvant bloquer comme
<b>read</b> (2),</b>
<b>write</b> (2),</b>
<b>wait</b> (2),</b>
etc.) et les fonctions de bibliothques qui invoquent ces appels-systme (par
exemple,
<b>fprintf</b> (3))</b>
sont des points d'annulation. LinuxThreads n'est pas encore assez intgr  la
bibliothque standard C pour implmenter cela&nbsp;; et donc, aucune fonction de la
GlibC n'est un point d'annulation.<br/><br/>
Pour les appels-systme, au moins existe-t'il un moyen dtourn d'y parvenir.
Les requtes d'annulation sont transmises au thread cibl en lui envoyant un
signal. Ce dernier va interrompre tous les appels-systme bloquants, les
faisant renvoyer immdiatement l'erreur <b>EINTR</b>. Aussi, vrifier qu'un
thread n'a pas t annul au cours de l'appel-systme <b>read</b>, par exemple,
peut tre ralis de la manire suivante&nbsp;:<br/><br/>
.RS
.ft 3

<br/><br/>

pthread_testcancel();
retcode = read(fd, tampon, longueur);
pthread_testcancel();
.ft<br/><br/>



</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i></i>
<br/>
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
