<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<br/><h1>PTHREAD_CLEANUP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">auteur</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">exemple</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/>
<br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
pthread_cleanup_push, pthread_cleanup_pop, pthread_cleanup_push_defer_np, pthread_cleanup_pop_restore_np - Installer et enlever des gestionnaires de nettoyage.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;pthread.h&gt;<br/><br/></b> <b></b>  <b>void pthread_cleanup_push(void (*</b> routine <i>) (void *), void *</i> arg <b>);</b><br/><br/>
<b>void pthread_cleanup_pop(int </b> execute <i>);</i><br/><br/>
<b>void pthread_cleanup_push_defer_np(void (*</b> routine <i>) (void *), void *</i> arg <b>);</b><br/><br/>
<b>void pthread_cleanup_pop_restore_np(int </b> execute <i>);</i><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les gestionnaires de nettoyage sont des fonctions qui sont appeles lorsqu'un
thread se termine, soit en appelant
<b>pthread_exit</b> (3)</b>
soit parce qu'il a t annul. Les gestionnaires de nettoyage sont installs et
enlevs  la manire d'une pile.<br/><br/>
Le rle d'un gestionnaire de nettoyage est de librer les ressources acquises par un
thread lorsque son excution s'achve. En particulier, si un thread
se termine ou est annul alors qu'il verrouille un mutex, ce dernier restera
verrouill pour toujours, empchant d'autre threads de s'excuter normalement.
La meilleure manire d'empcher cela est d'installer un gestionnaire de
nettoyage dont la fonction sera de dverrouiller le mutex. Les gestionnaires de
nettoyage peuvent galement tre utiliss pour librer des blocs de mmoire
allous par
<b>malloc</b> (3)</b>
ou fermer des descripteurs de fichiers lorsque le thread se termine.<br/><br/>
<b>pthread_cleanup_push"</b> <b></b>  installe la fonction
<i>routine</i> avec l'argument
<i>arg</i> en tant que gestionnaire de nettoyage. A partir de ce point jusqu' ce qu'un
appel  la fonction
<b>pthread_cleanup_pop</b> ,</b>
la fonction 
<i>routine</i> sera appele avec l'argument
<i>arg</i> quand le thread se terminera, soit par
<b>pthread_exit</b> (3)</b>
soit  la suite d'une annulation. Si plusieurs gestionnaire de nettoyage ont
t enregistrs, ils seront excuts dans l'ordre LIFO (Last In, First Out&nbsp;:
ordre inverse de l'enregistrement).<br/><br/>
<b>pthread_cleanup_pop"</b> <b></b>  dsactive le dernier gestionnaire de nettoyage install. Si l'argument
<i>execute</i> ne vaut pas 0, ce gestionnaire est excut en appelant la fonction
<i>routine</i> avec les arguments
<i>arg</i> .</i>
Si l'argument
<i>execute</i> vaut 0, le gestionnaire est seulement dsactiv mais pas excut.<br/><br/>
Les paires de
<b>pthread_cleanup_push"</b> <b></b>  et 
<b>pthread_cleanup_pop"</b> <b></b>  doivent tre excutes dans le mme bloc lexical, au mme niveau et ne peuvent
pas tre entrelaces avec une autre paire.
En fait, 
<b>pthread_cleanup_push"</b> <b></b>  et 
<b>pthread_cleanup_pop"</b> <b></b>  sont des macros, et l'expansion de
<b>pthread_cleanup_push"</b> <b></b>  introduit une accolade ouvrante
<b>{"</b> <b></b>  que ferme l'accolade
<b>}"</b> <b></b>  introduite par l'expansion de la macro correspondante
<b>pthread_cleanup_pop</b> .<br/><br/></b>
<b>pthread_cleanup_push_defer_np"</b> <b></b>  est une extension non portable qui combine
<b>pthread_cleanup_push"</b> <b></b>  et 
<b>pthread_setcanceltype</b> (3).</b>
Elle enregistre le gestionnaires de nettoyage comme le fait <b>pthread_cleanup_push</b>,
mais sauvegarde galement le mode d'annulation courant et le passe en mode
d'annulation retarde. Cela permet d'assurer que le mcanisme de nettoyage est
efficace mme si le thread fonctionne en mode d'annulation asynchrone.<br/><br/>
<b>pthread_cleanup_pop_restore_np"</b> <b></b>  dpile le dernier gestionnaire de nettoyage enregistr par
<b>pthread_cleanup_push_defer_np</b> ,</b>
et restaure le mode d'annulation  sa valeur lorsque
<b>pthread_cleanup_push_defer_np"</b> <b></b>  a t appele.<br/><br/>
<b>pthread_cleanup_push_defer_np"</b> <b></b>  et 
<b>pthread_cleanup_pop_restore_np"</b> <b></b>  doivent tre excute en paire, dans le mme bloc, au mme niveau et ne peuvent
pas tre entrelacs avec une autre paire.<br/><br/>
La squence suivante<br/><br/>
.RS
.ft 3

<br/><br/>

pthread_cleanup_push_defer_np(routine, arg);
...
pthread_cleanup_pop_defer_np(execute);
.ft<br/><br/>


<br/><br/>
est fonctionnellement quivalente (mais plus compacte et plus efficace) <br/><br/>
.RS
.ft 3

<br/><br/>

{ int oldtype;
  pthread_setcanceltype(PTHREAD_CANCEL_DEFERRED, &oldtype);
  pthread_cleanup_push(routine, arg);
  ...
  pthread_cleanup_pop(execute);
  pthread_setcanceltype(oldtype, NULL);
}
.ft<br/><br/>


<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Aucune.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
Aucune.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">auteur</h1>
<div class="paragraph">
Xavier Leroy &lt;Xavier.Leroy@inria.fr&gt;<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>pthread_exit</b> (3),</b>
<b>pthread_cancel</b> (3),</b>
<b>pthread_setcanceltype</b> (3).<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L8">exemple</h1>
<div class="paragraph"><br/><br/>
Voici comment verrouiller un mutex
<i>mut</i> de telle manire qu'il sera dverrouill si le thread est annul alors que
<i>mut</i> est verrouill&nbsp;:<br/><br/>
.RS
.ft 3

<br/><br/>

pthread_cleanup_push(pthread_mutex_unlock, (void *) &mut);
pthread_mutex_lock(&mut);
/* Faire quelque chose d'utile */
pthread_mutex_unlock(&mut);
pthread_cleanup_pop(0);
.ft<br/><br/>


<br/><br/>
Les deux dernires lignes peuvent tre remplaces par&nbsp;:<br/><br/>
.RS
.ft 3

<br/><br/>

pthread_cleanup_pop(1);
.ft<br/><br/>


<br/><br/>
Remarquez que le code ci-dessus n'est fiable qu'en mode d'annulation retarde
(voir
<b>pthread_setcanceltype</b> (3)).</b>
En mode d'annulation asynchrone, une annulation peut intervenir entre
<b>pthread_cleanup_push"</b> <b></b>  et
<b>pthread_mutex_lock</b> ,</b>
ou entre 
<b>pthread_mutex_unlock"</b> <b></b>  et
<b>pthread_cleanup_pop</b> ,</b>
rsultant dans les deux cas en un thread tentant de dverrouiller un mutex non
verrouill par le thread courant. C'est la principale raison pour laquelle le
mode d'annulation asynchrone est si problmatique  utiliser.<br/><br/>
Afin que ce code fonctionne aussi en mode d'annulation asynchrone, il doit
passer en mode d'annulation retarde pour verrouiller et dverrouiller le mutex:<br/><br/>
.RS
.ft 3

<br/><br/>

pthread_setcanceltype(PTHREAD_CANCEL_DEFERRED, &oldtype);
pthread_cleanup_push(pthread_mutex_unlock, (void *) &mut);
pthread_mutex_lock(&mut);
/* faire quelque chose */
pthread_cleanup_pop(1);
pthread_setcanceltype(oldtype, NULL);
.ft<br/><br/>


<br/><br/>
Le code ci-dessus peut tre r-crit de manire plus compacte et plus efficace
en utilisant les extensions non portables
<b>pthread_cleanup_push_defer_np"</b> <b></b>  et 
<b>pthread_cleanup_pop_restore_np</b>&nbsp;:<br/><br/></b>
.RS
.ft 3

<br/><br/>

pthread_cleanup_push_restore_np(pthread_mutex_unlock, (void *) &mut);
pthread_mutex_lock(&mut);
/* faire quelque chose */
pthread_cleanup_pop_restore_np(1);
.ft<br/><br/>



</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i></i>
<br/>
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
