<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<br/><h1>PTHREAD_COND</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">annulation</a>
<br /><a class="summaryIndent0" href="#L4">fiabilite par rapport aux signaux asynchrones</a>
<br /><a class="summaryIndent0" href="#L5">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L6">erreurs</a>
<br /><a class="summaryIndent0" href="#L7">auteur</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">exemple</a>
<br /><a class="summaryIndent0" href="#L10">traduction</a>
<br/><br/>
<br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
pthread_cond_init, pthread_cond_destroy, pthread_cond_signal, pthread_cond_broadcast, pthread_cond_wait, pthread_cond_timedwait - oprations sur les conditions.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;pthread.h&gt;<br/><br/></b> <b></b>  <b>pthread_cond_t </b> cond <i> = PTHREAD_COND_INITIALIZER;</i><br/><br/>
<b>int pthread_cond_init(pthread_cond_t *</b> cond <i>, pthread_condattr_t *</i> cond_attr <b>);</b><br/><br/>
<b>int pthread_cond_signal(pthread_cond_t *</b> cond <i>);</i><br/><br/>
<b>int pthread_cond_broadcast(pthread_cond_t *</b> cond <i>);</i><br/><br/>
<b>int pthread_cond_wait(pthread_cond_t *</b> cond <i>, pthread_mutex_t *</i> mutex <b>);</b><br/><br/>
<b>int pthread_cond_timedwait(pthread_cond_t *</b> cond <i>, pthread_mutex_t *</i> mutex <b>, const struct timespec *</b> abstime <i>);</i><br/><br/>
<b>int pthread_cond_destroy(pthread_cond_t *</b> cond <i>);</i><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Une condition (abrviation pour variable-condition) est un mcanisme de
syncrhonisation permettant  un thread de suspendre son excution juqu' ce
qu'une certaine condition (un prdicat) soit vrifie. Les oprations
fondamentales sur les conditions sont&nbsp;:
signaler la condition (quand le prdicat devient vrai),
et attendre la condition en suspendant l'excution du thread
jusqu' ce qu'un autre thread signale la condition.<br/><br/>
Une variable condition doit toujours tre associe  un mutex, pour viter les
accs concurrents o un thread se prpare  attendre une
condition et un autre signale la condition juste avant que le premier n'attende
rellement.<br/><br/>
<b>pthread_cond_init"</b> <b></b>  initialise la variable condition
<i>cond</i> ,</i>
en utilisant les attributs de condition spcifis par
<i>cond_attr</i> ,</i>
ou les attributs par dfaut si
<i>cond_attr</i> vaut
<b>NULL</b> .</b>
L'implmentation LinuxThreads ne supporte aucun attribut de conditions, aussi
le paramtre
<i>cond_attr</i> est-il pour l'instant ignor.<br/><br/>
Les variables de type 
<b>pthread_cond_t"</b> <b></b>  peuvent galement tre statiquement initialises, en utilisant la constante
<b>PTHREAD_COND_INITIALIZER</b> .<br/><br/></b>
<b>pthread_cond_signal"</b> <b></b>  relance l'un des threads attendant la variable condition
<i>cond</i> .</i>
S'il n'existe aucun thread rpondant  ce critire, rien ne se produit. Si
plusieurs threads attendent sur
<i>cond</i> ,</i>
seul l'un d'entre eux sera relanc, mais il est impossible de savoir lequel.<br/><br/>
<b>pthread_cond_broadcast"</b> <b></b>  relance tous les threads attendant sur la variable condition 
<i>cond</i> .</i>
Rien ne se passe s'il n'y a aucun thread attendant sur
<i>cond</i> .<br/><br/></i>
<b>pthread_cond_wait"</b> <b></b>  dverrouille atomiquement le 
<i>mutex</i> (comme
<b>pthread_unlock_mutex</b> )</b>
et attend que la variable condition
<i>cond</i> soit signale. L'excution du thread est suspendue et ne consomme pas de temps
CPU jusqu' ce que la variable condition soit signale. Le
<i>mutex</i> doit tre verrouill par le thread appelant  l'entre de
<b>pthread_cond_wait</b> .</b>
Avant de rendre la main au thread appelant,
<b>pthread_cond_wait"</b> <b></b>  reverrouille
<i>mutex</i> (comme 
<b>pthread_lock_mutex</b> ).<br/><br/></b>
Le dverouillage du mutex et la suspension de l'excution sur la variable 
condition sont lis atomiquement. Donc, si tous 
les threads verrouillent le mutex avant de
signaler la condition, il est garanti que la condition ne peut tre signale
(et donc ignore) entre le moment o un thread verrouille le mutex et le moment
o il attend sur la variable condition.<br/><br/>
<b>pthread_cond_timedwait"</b> <b></b>  dverrouille le
<i>mutex</i> et attend sur
<i>cond</i> ,</i>
en liant atomiquement ces deux tapes, comme le fait
<b>pthread_cond_wait</b> ,</b>
cependant l'attente est borne temporellement. Si
<i>cond</i> n'a pas t signale aprs la priode spcifie par
<i>abstime</i> ,</i>
le mutex 
<i>mutex</i> est reverrouill et
<b>pthread_cond_timedwait"</b> <b></b>  rend la main avec l'erreur
<b>ETIMEDOUT</b> .</b>
Le paramtres
<i>abstime</i> spcifie un temps absolu, avec la mme origine que
<b>time</b> (2)</b>
et 
<b>gettimeofday</b> (2):</b>
un 
<i>abstime</i> de 0 correspond  00:00:00 GMT, le 1er Janvier 1970.<br/><br/>
<b>pthread_cond_destroy"</b> <b></b>  dtruit une variable condition, librant les ressources qu'elle possde. Aucun
thread ne doit attendre sur la condition  l'entre de
<b>pthread_cond_destroy</b> .</b>
Dans l'implmentation LinuxThreads, aucune ressource ne peut tre associe 
une variable condition, aussi
<b>pthread_cond_destroy"</b> <b></b>  ne fait en fait rien d'autre que vrifier qu'aucun thread n'attend la
condition.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">annulation</h1>
<div class="paragraph"><br/><br/>
<b>pthread_cond_wait"</b> <b></b>  et 
<b>pthread_cond_timedwait"</b> <b></b>  sont des points d'annulation. Si un thread est annul alors qu'il est suspendu
dans l'une de ces fonctions, son excution reprend immdiatement,
reverrouillant l'argument
<i>mutex</i> 
<b>pthread_cond_wait"</b> <b></b>  et
<b>pthread_cond_timedwait</b> ,</b>
et excute finalement l'annulation. Aussi, les gestionnaires d'annulation sont
assurs d'tre excuts alors que
<i>mutex</i> est verrouill.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">fiabilite par rapport aux signaux asynchrones</h1>
<div class="paragraph">
Ces fonctions ne sont pas fiables par rapport aux signaux asynchrones et ne
doivent donc pas tre utilises dans des gestionnaires de signaux [Ndt:
sous peine de perder leur proprit d'atomicit]. En particulier,
appeler
<b>pthread_cond_signal"</b> <b></b>  ou 
<b>pthread_cond_broadcast"</b> <b></b>  dans un gestionnaire de signal peut placer le thread appelant dans une
situation de blocage dfinitif.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">valeur renvoye</h1>
<div class="paragraph">
Toutes ces fonctions renvoient 0 en cas de succs et un code d'erreur non nul
en cas de problme.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">erreurs</h1>
<div class="paragraph"><br/><br/>
<b>pthread_cond_init</b> ,</b>
<b>pthread_cond_signal</b> ,</b>
<b>pthread_cond_broadcast</b> ,</b>
et 
<b>pthread_cond_wait"</b> <b></b>  ne renvoient jamais de code d'erreur.<br/><br/>
La fonction
<b>pthread_cond_timedwait"</b> <b></b>  renvoie l'un des codes d'erreur suivants en cas de problme&nbsp;:
.RS
<br/><br/>

<b>ETIMEDOUT"</b> <b></b>  La variable-condition n'a pas reu de signal avant le dlai spcifi par
.I "abstime"<br/><br/>
<br/><br/>

<b>EINTR"</b> <b></b>  <b>pthread_cond_timedwait"</b> <b></b>  a t interrompu par un signal
<br/><br/>
La fonction
<b>pthread_cond_destroy"</b> <b></b>  renvoie l'un des codes d'erreur suivants en cas de problme&nbsp;:
.RS
<br/><br/>

<b>EBUSY"</b> <b></b>  il existe des threads attendant 
<i>cond</i> .</i>
<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">auteur</h1>
<div class="paragraph">
Xavier Leroy &lt;Xavier.Leroy@inria.fr&gt;<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>pthread_condattr_init</b> (3),</b>
<b>pthread_mutex_lock</b> (3),</b>
<b>pthread_mutex_unlock</b> (3),</b>
<b>gettimeofday</b> (2),</b>
<b>nanosleep</b> (2).<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L10">exemple</h1>
<div class="paragraph"><br/><br/>
Considrons deux variables globales partages
<i>x</i> et 
<i>y</i> ,</i>
protges par le mutex 
<i>mut</i> ,</i>
et une variable condition 
<i>cond</i> pour signaler que
<i>x</i> devient plus grand que
<i>y</i> .<br/><br/></i>
.RS
.ft 3

<br/><br/>

int x,y;
pthread_mutex_t mut = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond = PTHREAD_COND_INITIALIZER;
.ft<br/><br/>


<br/><br/>
Attendre que 
<i>x</i> devienne plus grand que
<i>y</i> se ralise de la manire suivante:<br/><br/>
.RS
.ft 3

<br/><br/>

pthread_mutex_lock(&mut);
while (x &lt;= y) {
        pthread_cond_wait(&cond, &mut);
}
/* agir sur x et y */
pthread_mutex_unlock(&mut);
.ft<br/><br/>


<br/><br/>
Les modifications de
<i>x</i> et 
<i>y</i> qui peuvent rendre 
<i>x</i> plus grand que
<i>y</i> doivent signaler la condition si ncessaire:<br/><br/>
.RS
.ft 3

<br/><br/>

pthread_mutex_lock(&mut);
/* modifer x et y */
if (x &gt; y) pthread_cond_broadcast(&cond);
pthread_mutex_unlock(&mut);
.ft<br/><br/>


<br/><br/>
S'il peut tre prouv qu'au plus un thread en attente ncessite d'tre rveill
(par exemple, s'il n'y a que deux threads communicant via
<i>x</i> et 
<i>y</i> ),</i>
<b>pthread_cond_signal"</b> <b></b>  peut tre utilis en tant qu'alternative efficace 
<b>pthread_cond_broadcast</b> .</b>
En cas de doute, utilisez
<b>pthread_cond_broadcast</b> .<br/><br/></b>
Pour attendre que
<i>x</i> devienne plus grand que
<i>y</i> avec un timeout de 5 secondes, fates:<br/><br/>
.RS
.ft 3

<br/><br/>

struct timeval now;
struct timespec timeout;
int retcode;<br/><br/>
pthread_mutex_lock(&mut);
gettimeofday(&now);
timeout.tv_sec = now.tv_sec + 5;
timeout.tv_nsec = now.tv_usec * 1000;
retcode = 0;
while (x &lt;= y && retcode != ETIMEDOUT) {
        retcode = pthread_cond_timedwait(&cond, &mut, &timeout);
}
if (retcode == ETIMEDOUT) {
        /* timeout */
} else {
        /* agir sur x et y */
}
pthread_mutex_unlock(&mut);
.ft<br/><br/>



</div><br/><br /><h1 class="TitreSection0" id="L11">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i><br/><br/></i>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
