<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<br/><h1>PTHREAD_JOIN</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">annulation</a>
<br /><a class="summaryIndent0" href="#L4">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L5">erreurs</a>
<br /><a class="summaryIndent0" href="#L6">auteur</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
pthread_join - attend la fin d'un autre thread<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;pthread.h&gt;<br/><br/></b> <b></b>  <b>int pthread_join(pthread_t </b> th <i>, void **</i> thread_return <b>);</b><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>pthread_join"</b> <b></b>  suspend l'excution du thread appelant jusqu' ce que le thread identifi par
<i>th</i> achve son excution, soit en appelant
<b>pthread_exit</b> (3)</b>
soit aprs avoir t annul.<br/><br/>
Si 
<i>thread_return</i> ne vaut pas
<b>NULL</b> ,</b>
la valeur renvoye par
<i>th</i> y sera enregistre.
Cette valeur sera soit l'argument pass 
<b>pthread_exit</b> (3),</b>
soit
<b>PTHREAD_CANCELED"</b> <b></b>  si le thread
<i>th</i> a t annul.<br/><br/>
Le thread rejoint 
<b>th"</b> <b></b>  doit tre dans l'tat joignable&nbsp;: il ne doit pas avoir t dtach par
<b>pthread_detach</b> (3)</b>
ou par l'attribut 
<b>PTHREAD_CREATE_DETACHED"</b> <b></b>  lors de sa cration par
<b>pthread_create</b> (3).<br/><br/></b>
Quand l'excution d'un thread joignable s'achve, ses ressources mmoire
(descripteur de thread et pile) ne sont pas dsalloues jusqu' ce qu'un autre
thread le joigne en utilisant <b>pthread_join</b>. Aussi,
<b>pthread_join"</b> <b></b>  doit tre appele une fois pour chaque thread joignable pour viter des
"fuites" de mmoire.<br/><br/>
Au plus un seul thread peut attendre la mort d'un thread donn. Appeler
<b>pthread_join"</b> <b></b>  sur un thread
<i>th</i> dont un autre thread attend dj la fin renvoie une erreur.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">annulation</h1>
<div class="paragraph"><br/><br/>
<b>pthread_join"</b> <b></b>  est un point d'annulation. Si un thread est annul alors qu'il est suspendu
dans
<b>pthread_join</b> ,</b>
l'excution du thread reprend immdiatement et l'annulation est ralise sans
attendre la fin du thread <i>th</i>.
Si l'annulation intervient durant
<b>pthread_join</b> ,</b>
le thread
<i>th</i> demeure non joint.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">valeur renvoye</h1>
<div class="paragraph">
En cas de succs, le code renvoy par
<i>th</i> est enregistr  l'emplacement point par
<i>thread_return</i> ,</i>
et 0 est renvoy. En cas d'erreur, un code d'erreur non nul est renvoy.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>ESRCH"</b> <b></b>  Aucun thread correspondant 
<i>th</i></i>
n' a pu tre trouv.
<br/><br/>

<b>EINVAL"</b> <b></b>  Le thread
<i>th</i> a t dtach.
<br/><br/>

<b>EINVAL"</b> <b></b>  Un autre thread attend dj la mort de
<i>th</i> .</i>
<br/><br/>

<b>EDEADLK"</b> <b></b>  L'argument
<i>th</i> reprsente le thread appelant.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">auteur</h1>
<div class="paragraph">
Xavier Leroy &lt;Xavier.Leroy@inria.fr&gt;<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>pthread_exit</b> (3),</b>
<b>pthread_detach</b> (3),</b>
<b>pthread_create</b> (3),</b>
<b>pthread_attr_setdetachstate</b> (3),</b>
<b>pthread_cleanup_push</b> (3),</b>
<b>pthread_key_create</b> (3).</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i><br/><br/></i>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
