<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<br/><h1>PTHREAD_SPECIFIC</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">auteur</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">exemple</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
pthread_key_create, pthread_key_delete, pthread_setspecific, pthread_getspecific - gestion de donnes spcifiques  un thread<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;pthread.h&gt;<br/><br/></b> <b></b>  <b>int pthread_key_create(pthread_key_t *</b> cl <i>, void (*</i> destr_function <b>) (void *));</b><br/><br/>
<b>int pthread_key_delete(pthread_key_t </b> cl <i>);</i><br/><br/>
<b>int pthread_setspecific(pthread_key_t </b> cl <i>, const void *</i> pointeur <b>);</b><br/><br/>
<b>void * pthread_getspecific(pthread_key_t </b> cl <i>);</i><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les programmes ont souvent besoin de variables globales ou statiques ayant
diffrentes valeurs dans des threads diffrents. Comme les threads partagent le
mme espace mmoire, cet objectif ne peut tre ralis avec les variables
usuelles. Les donnes spcifiques  un thread de POSIX sont la rponse  ce
problme.<br/><br/>
Chaque thread possde un segment mmoire priv, le TSD (Thred-Specific Data&nbsp;:
Donnes Spcifiques au Thread). Cette zone mmoire est indexe par des cls
TSD. La zone TST associe des valeurs du type
<b>void</b> <b></b>  <b>*"</b> <b></b>  aux cls TST. Ces cls sont communes  tous les threads, mais la valeur
associe  une cl donne est diffrente dans chaque thread.<br/><br/>
Pour concrtiser ce formalisme, les zones TSD peuvent tre vues commes des
tableaux de pointeurs <b>void *</b>, les cls TSD comme des indices entiers pour
ces tableaux, et les valeurs des cls TSD comme les valeurs des entres
correspondantes dans le tableau du thread appelant.<br/><br/>
Quand un thread est cr, sa zone TST est unitialement associe aux cls
<b>NULL</b>.<br/><br/>
<b>pthread_key_create"</b> <b></b>  alloue une nouvelle cl TSD. Cette cl est enregistre  l'emplacement pointe
par
<i>cl</i> .</i>
Il ne peut y avoir plus de
<b>PTHREAD_KEYS_MAX"</b> <b></b>  cls alloues  un instant donn. La valeur initialement associe avec la cl
renvoye est
<b>NULL"</b> <b></b>  dans tous les threads en cours d'excution.<br/><br/>
L'argument <i>destr_function</i>, si diffrent de
<b>NULL</b> ,</b>
spcifie une fonction destructrice associe  une cl. Quand le thread se
termine par
<b>pthread_exit"</b> <b></b>  ou par une annulation,
<i>destr_function</i> est appele avec en argument les valeurs associes aux cls de ce thread. La
fonction
<i>destr_function</i> n'est pas appele si cette valeur est
<b>NULL</b> .</b>
L'ordre dans lequel les fonctions de desctruction sont appeles lors de la fin
du thread n'est pas spcifie.<br/><br/>
Avant que la fonction de destruction soit appele, la valeur
<b>NULL"</b> <b></b>  est associe  la cl dans le thread courant. Une fonction de destruction peut
cependant rassocier une valeur diffrente de
<b>NULL"</b> <b></b>   cette cl ou une autre cl. Pour grer ce cas de figure, si aprs l'appel de
tous les destructeurs pour les valeurs diffrentes de <b>NULL</b>, il existe
toujours des valeurs diffrentes de
<b>NULL"</b> <b></b>  avec des destructeurs associs, alors la procdure est rpte.
L'implmentation de LinuxThreads interrompt cette procdure aprs
<b>PTHREAD_DESTRUCTOR_ITERATIONS"</b> <b></b>  itrations, mme s'il reste des valeurs diffrentes de
<b>NULL"</b> <b></b>  associes  des descripteurs. Les autres implmentations peuvent boucler sans
fin.<br/><br/>
<b>pthread_key_delete"</b> <b></b>  dsalloue une cl TSD. Elle ne vrifie pas si des valeurs diffrentes de
<b>NULL"</b> <b></b>  sont associes avec cette cl dans les threads en cours d'excution, ni
n'appelle la fonction de destruction associe avec cette cl.<br/><br/>
<b>pthread_setspecific"</b> <b></b>  change la valeur associe avec  
<i>cl</i> dans le thread appelant, sauve le paramtre
<i>pointeur</i>  sa place.<br/><br/>
<b>pthread_getspecific"</b> <b></b>  renvoie la valeur actuellement associe avec
<i>cl</i> dans le thread appelant.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph"><br/><br/>
<b>pthread_key_create</b> ,</b>
<b>pthread_key_delete</b> ,</b>
et 
<b>pthread_setspecific"</b> <b></b>  renvoient 0 en cas de succs et un code d'erreur non nul en cas d'chec. En cas
de succs,
<b>pthread_key_create"</b> <b></b>  enregistre la cl rcemment cre  l'emplacement point par son arguement
<i>cl</i>.<br/><br/>
<b>pthread_getspecific"</b> <b></b>  renvoie la valeur associe 
<i>cl</i> en cas de succs et 
<b>NULL"</b> <b></b>  en cas d'erreur.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<b>pthread_key_create"</b> <b></b>  renvoient l'un des codes d'erreur suivants&nbsp;:
.RS
<br/><br/>

<b>EAGAIN"</b> <b></b>  <b>PTHREAD_KEYS_MAX"</b> <b></b>  les cls sont dj alloues
<br/><br/>
<b>pthread_key_delete"</b> <b></b>  et 
<b>pthread_setspecific"</b> <b></b>  renvoient l'un des codes d'erreur suivants&nbsp;:
.RS
<br/><br/>

<b>EINVAL"</b> <b></b>  <i>cl</i> n'est pas une cl valide ou alloue
<br/><br/>
<b>pthread_getspecific"</b> <b></b>  renvoie 
<b>NULL"</b> <b></b>  si la
<i>cl</i> n'est pas associe
 des donnes spcifiques.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">auteur</h1>
<div class="paragraph">
Xavier Leroy &lt;Xavier.Leroy@inria.fr&gt;<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
pthread_create(3), pthread_exit(3), pthread_testcancel(3).<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">exemple</h1>
<div class="paragraph"><br/><br/>
L'extrait de code suivant alloue dans un thread un tableau de 100 caractres,
avec libration de la mmoire automatiquement  la fin de l'excution du
thread.<br/><br/>
.RS
.ft 3

<br/><br/>

/* Cl pour le tampon spcifique au thread */
static pthread_key_t buffer_key;<br/><br/>
/* Initialisation unique de la cl */
static pthread_once_t buffer_key_once = PTHREAD_ONCE_INIT;<br/><br/>
/* Alloue le tampon spcifique au thread */
void buffer_alloc(void)
{
  pthread_once(&buffer_key_once, buffer_key_alloc);
  pthread_setspecific(buffer_key, malloc(100));
}<br/><br/>
/* Renvoie le tampon spcifique au thread */
char * get_buffer(void)
{
  return (char *) pthread_getspecific(buffer_key);
}<br/><br/>
/* Alloue la cle */
static void buffer_key_alloc()
{
  pthread_key_create(&buffer_key, buffer_destroy);
}<br/><br/>
/* Libre le tampon spcifique au thread */
static void buffer_destroy(void * buf)
{
  free(buf);
}
.ft<br/><br/>



</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i></i>
<br/>
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
