<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<br/><h1>PTHREAD_MUTEX</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">annulation</a>
<br /><a class="summaryIndent0" href="#L4">fiabilite par rapport aux signaux asynchrones</a>
<br /><a class="summaryIndent0" href="#L5">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L6">erreurs</a>
<br /><a class="summaryIndent0" href="#L7">auteur</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">exemple</a>
<br /><a class="summaryIndent0" href="#L10">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
pthread_mutex_init, pthread_mutex_lock, pthread_mutex_trylock, pthread_mutex_unlock, pthread_mutex_destroy - oprations sur les mutex<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;pthread.h&gt;<br/><br/></b> <b></b>  <b>pthread_mutex_t </b> fastmutex <i> = PTHREAD_MUTEX_INITIALIZER;</i><br/><br/>
<b>pthread_mutex_t </b> recmutex <i> = PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP;</i><br/><br/>
<b>pthread_mutex_t </b> errchkmutex <i> = PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP;</i><br/><br/>
<b>int pthread_mutex_init(pthread_mutex_t *</b> mutex <i>, const pthread_mutexattr_t *</i> mutexattr <b>);</b><br/><br/>
<b>int pthread_mutex_lock(pthread_mutex_t *</b> mutex <i>));</i><br/><br/>
<b>int pthread_mutex_trylock(pthread_mutex_t *</b> mutex <i>);</i><br/><br/>
<b>int pthread_mutex_unlock(pthread_mutex_t *</b> mutex <i>);</i><br/><br/>
<b>int pthread_mutex_destroy(pthread_mutex_t *</b> mutex <i>);</i><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Un mutex est un objet d'exclusion mutuelle (MUTual EXclusion), et est
trs pratique pour protger des donnes partages de modifications concurrentes
et pour implmenter des sections critiques.<br/><br/>
Un mutex peut te dans deux tats : dverrouill (pris par aucun thread) ou
verrouill (appartenant  un
thread). Un mutex ne peut tre pris que par un seul thread  la fois. Un
thread qui tente de verrouiller un mutex dj verrouill est suspendu jusqu'
ce que le mutex soit dverrouill.<br/><br/>
<b>pthread_mutex_init"</b> <b></b>  initialise le mutex point par
<i>mutex</i> selon les attributs de mutex spcifi par
<i>mutexattr</i> .</i>
Si 
<i>mutexattr</i> vaut
<b>NULL</b> ,</b>
les paramtres par dfaut sont utiliss.<br/><br/>
L'implmentation LinuxThreads ne supporte qu'un seul attribut, le 
<i>type de mutex</i> ,</i>
qui peut tre soit ``rapide'', ``rcursif'' ou  ``vrification d'erreur''. Le
type de mutex dtermine s'il peut tre verrouill plusieurs fois par le mme
thread. Le type par dfaut est ``rapide''. Voir
<b>pthread_mutexattr_init</b> (3)</b>
pour plus d'informations sur les attributs de mutex.<br/><br/>
Les variables de type 
<b>pthread_mutex_t"</b> <b></b>  peuvent aussi tre initialises de manire statique, en utilisant les
constantes
<b>PTHREAD_MUTEX_INITIALIZER"</b> <b></b>  (pour les mutex rapides),
<b>PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP"</b> <b></b>  (pour les mutex rcursifs), et
<b>PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP"</b> <b></b>  (pour les mutex  vrification d'erreur).<br/><br/>
<b>pthread_mutex_lock"</b> <b></b>  verrouille le mutex. Si le mutex est dverrouill, il devient verrouill et est
possd par le thread appelant&nbsp;; et
<b>pthread_mutex_lock"</b> <b></b>  rend la main immdiatement. Si le mutex est dj verrouill par un autre thread,
<b>pthread_mutex_lock"</b> <b></b>  suspend le thread appelant jusqu' ce que le mutex soit dverrouill.<br/><br/>
Si le mutex est dj verrouill par le thread appelant, le comportement de
<b>pthread_mutex_lock"</b> <b></b>  dpend du type de mutex. Si ce dernier est de type ``rapide'', le thread
appelant est suspendu jusqu' ce que le mutex soit dverrouill, donc plaant
le thread appelant en situation de blocage dfinitif. Si le mutex est de type ``
vrification d'erreur'',
<b>pthread_mutex_lock"</b> <b></b>  rend la main immdiatement avec le code d'erreur
<b>EDEADLK</b> .</b>
Si le mutex est de type ``rcursif'',
<b>pthread_mutex_lock"</b> <b></b>  rend la main immdiatement avec un code de retour indiquant le succs,
enregistrant le nombre de fois o le thread appelant a verrouill le mutex. Un
nombre gal d'appel 
<b>pthread_mutex_unlock"</b> <b></b>  doit tre ralis avant que le mutex retourne  l'tat dverrouill.<br/><br/>
<b>pthread_mutex_trylock"</b> <b></b>  se comporte de la mme manire que
<b>pthread_mutex_lock</b> ,</b>
except qu'elle ne bloque pas le thread appelant si le mutex est dj
verrouill par un autre thread (ou par le thread appelant dans le cas d'un
mutex ``rapide''). Au contraire,
<b>pthread_mutex_trylock"</b> <b></b>  rend la main immdiatement avec le code d'erreur
<b>EBUSY</b> .<br/><br/></b>
<b>pthread_mutex_unlock"</b> <b></b>  dverrouille le mutex. Celui-ci est suppos verrouill, et ce par le thread
courant en entrant dans
<b>pthread_mutex_unlock</b> .</b>
Si le mutex est de type ``rapide'',
<b>pthread_mutex_unlock"</b> <b></b>  le rinitialise toujours  l'tat dverrouill. S'il est de type ``rcursif'',
son compteur de verrouillage est dcrment (nombre d'oprations
<b>pthread_mutex_lock"</b> <b></b>  ralises sur le mutex par le thread appelant), et dverrouill seulement quand
ce compteur atteint 0.<br/><br/>
Sur les mutex ``vrification d'erreur'', 
<b>pthread_mutex_unlock"</b> <b></b>  vrifie lors de l'excution que le mutex est verrouill en entrant, et qu'il
est verrouill par le mme thread que celui appelant
<b>pthread_mutex_unlock</b> .</b>
Si ces conditions ne sont pas runies, un code d'erreur est renvoy et le mutex
n'est pas modifi. Les mutex ``rapide'' et ``rcursif'' ne ralisent pas de
tels tests, permettant  un mutex verrouill d'tre dverrouill par un thread
autre que celui l'ayant verrouill. Ce comportement n'est pas portable et l'on
ne doit pas compter dessus.<br/><br/>
<b>pthread_mutex_destroy"</b> <b></b>  dtruit un mutex, librant les ressources qu'il dtient. Le mutex doit tre
dverrouill. Dans l'implmentation LinuxThreads des threads POSIX, aucune
ressource ne peut tre associ  un mutex, aussi
<b>pthread_mutex_destroy"</b> <b></b>  ne fait en fait rien si ce n'est vrifier que le mutex n'est pas verrouill.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">annulation</h1>
<div class="paragraph">
Aucune des primitives relatives aux mutex n'est un point d'annulation, ni mme
<b>pthread_mutex_lock</b> ,</b>
malgr le fait qu'il peut suspendre l'excution du thread pour une longue
dure. De cette manire, le statut des mutex aux points d'annulation est
prvisible, permettant aux gestionnaires d'annulation de dverrouiller
prcisment ces mutex qui ncessitent d'tre dverrouills avant que
l'excution du thread ne s'arrte dfinitivement. Aussi, les threads
travaillant en mode d'annulation retarde ne doivent-t'ils jamais verrouiller
un mutex pour de longues priodes de temps.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">fiabilite par rapport aux signaux asynchrones</h1>
<div class="paragraph">
Les fonctions relatives aux mutex ne sont pas fiables par rapport aux signaux
asynchrones et ne doivent donc pas tre utilises dans des gestionnaires de
signaux. En particulier,
appeler
<b>pthread_mutex_lock"</b> <b></b>  ou 
<b>pthread_mutex_unlock"</b> <b></b>  dans un gestionnaire de signal peut placer le thread appelant dans une
situation de blocage dfinitif.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">valeur renvoye</h1>
<div class="paragraph"><br/><br/>
<b>pthread_mutex_init"</b> <b></b>  retourne toujours 0. Les autres fonctions renvoient 0 en cas succs et un code
d'erreur non nul en cas de problme.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">erreurs</h1>
<div class="paragraph"><br/><br/>
La fonction
<b>pthread_mutex_lock"</b> <b></b>  renvoie l'un des codes d'erreur suivants en cas de problme:
.RS
<br/><br/>

<b>EINVAL"</b> <b></b>  le mutex n'a pas t initialis.<br/><br/>
<br/><br/>

<b>EDEADLK"</b> <b></b>  le mutex est dj verrouill par un thread autre que l'appellant (mutex 
vrification d'erreur seulement).
<br/><br/>
La fonction
<b>pthread_mutex_trylock"</b> <b></b>  renvoie l'un des codes d'erreur suivants en cas de problme&nbsp;:
.RS
<br/><br/>

<b>EBUSY"</b> <b></b>  le mutex ne peut tre verrouill car il l'est dj.<br/><br/>
<br/><br/>

<b>EINVAL"</b> <b></b>  le mutex n'a pas t initialis.
<br/><br/>
La fonction
<b>pthread_mutex_unlock"</b> <b></b>  renvoie le code d'erreur suivant en cas de problme&nbsp;:
.RS
<br/><br/>

<b>EINVAL"</b> <b></b>  le mutex n'a pas t initialis.<br/><br/>
<br/><br/>

<b>EPERM"</b> <b></b>  le thread appelant ne possde pas le mutex (mutex  vrification d'erreur
seulement).
<br/><br/>
La fonction
<b>pthread_mutex_destroy"</b> <b></b>  renvoie le code d'erreur suivant en cas de problme&nbsp;:
.RS
<br/><br/>

<b>EBUSY"</b> <b></b>  le mutex est dj verrouill.
<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">auteur</h1>
<div class="paragraph">
Xavier Leroy &lt;Xavier.Leroy@inria.fr&gt;<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>pthread_mutexattr_init</b> (3),</b>
<b>pthread_mutexattr_setkind_np</b> (3),</b>
<b>pthread_cancel</b> (3).<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L10">exemple</h1>
<div class="paragraph"><br/><br/>
Une variable globale partage
<i>x</i> peut tre protge par un mutex comme suit&nbsp;:<br/><br/>
.RS
.ft 3

<br/><br/>

int x;
pthread_mutex_t mut = PTHREAD_MUTEX_INITIALIZER;
.ft<br/><br/>


<br/><br/>
Tous les accs et modifications de
<i>x</i> doivent tre entours de paires d'appels 
<b>pthread_mutex_lock"</b> <b></b>  et 
<b>pthread_mutex_unlock"</b> <b></b>  comme suit&nbsp;:<br/><br/>
.RS
.ft 3

<br/><br/>

pthread_mutex_lock(&mut);
/* agir sur x */
pthread_mutex_unlock(&mut);
.ft<br/><br/>



</div><br/><br /><h1 class="TitreSection0" id="L11">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i></i>
<br/>
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
