<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<br/><h1>PTHREAD_MUTEXATTR</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">auteur</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/>
<br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
pthread_mutexattr_init, pthread_mutexattr_destroy, pthread_mutexattr_settype_np, pthread_mutexattr_gettype_np - attributs de cration de mutex<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;pthread.h&gt;<br/><br/></b> <b></b>  <b>int pthread_mutexattr_init(pthread_mutexattr_t *</b> attr <i>);</i><br/><br/>
<b>int pthread_mutexattr_destroy(pthread_mutexattr_t *</b> attr <i>);</i><br/><br/>
<b>int pthread_mutexattr_settype_np(pthread_mutexattr_t *</b> attr <i>, int </i> type <b>);</b><br/><br/>
<b>int pthread_mutexattr_gettype_np(const pthread_mutexattr_t *</b> attr <i>, int *</i> type <b>);</b><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les attributs de cration de mutex peuvent tre spcifis lors de leur cration
en les passant en tant que second argument 
<b>pthread_mutex_init</b> (3).</b>
<b>NULL"</b> <b></b>  est quivalent  demander les attributs par dfaut.<br/><br/>
<b>pthread_mutexattr_init"</b> <b></b>  initialise l'objet attributs de mutex
<i>attr</i> et le remplit avec les valeurs par dfaut.<br/><br/>
<b>pthread_mutexattr_destroy"</b> <b></b>  dtruit un objet attributs de mutex qui ne doit plus jamais tre utilis.
<b>pthread_mutexattr_destroy"</b> <b></b>  ne fait rien dans l'implmentation LinuxThreads. <br/><br/>
LinuxThreads supporte seulement un seul attribut de mutex&nbsp;: le type de mutex qui
peut tre soit
<b>PTHREAD_MUTEX_FAST_NP"</b> <b></b>  pour des mutex rapides, soit
<b>PTHREAD_MUTEX_RECURSIVE_NP"</b> <b></b>  pour des mutex rcursifs, soit
<b>PTHREAD_MUTEX_ERREURCHECK_NP"</b> <b></b>  pour des mutex avec vrification d'erreur.
Comme le suffixe
<b>NP"</b> <b></b>  l'indique, ce sont des extensions non-portables aux standard POSIX et ne
devraient donc jamais tre employs dans un programme portable.<br/><br/>
Le type de mutex dtermine ce qui se passe si un thread essaye de verrouiller
un mutex dj verrouill par
<b>pthread_mutex_lock</b> (3).</b>
Si le mutex est de type rapide&nbsp;;
<b>pthread_mutex_lock</b> (3)</b>
suspend simplement le thread appelant. Si le mutex est de type "avec
vrification d'erreur",
<b>pthread_mutex_lock</b> (3)</b>
rend la main immdiatement avec le code d'erreur
<b>EDEADLK</b> .</b>
Si le mutex est de type rcursif, l'appel 
<b>pthread_mutex_lock</b> (3)</b>
rend la main immdiatement avec un code de retour de succs. Le nombre de
verrouillage par le thread possdant le mutex est enregistr dans le mutex. Le
thread possdant le mutex doit appeler
<b>pthread_mutex_unlock</b> (3)</b>
le mme nombre de fois afin que le mutex passe  l'tat dverrouill.<br/><br/>
Le type de mutex par dfaut est rapide, c'est--dire 
<b>PTHREAD_MUTEX_FAST_NP</b> .<br/><br/></b>
<b>pthread_mutexattr_settype_np"</b> <b></b>  modifie l'attribut type_de_mutex dans
<i>attr</i>  la valeur spcifie par
<i>type</i> .<br/><br/></i>
<b>pthread_mutexattr_gettype_np"</b> <b></b>  rcupre la valeur courante de l'attribut type de mutex dans
<i>attr</i> et l'enregistre  l'emplacement point par
<i>type</i> .<br/><br/></i>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>pthread_mutexattr_init</b> ,</b>
<b>pthread_mutexattr_destroy"</b> <b></b>  et
<b>pthread_mutexattr_gettype_np"</b> <b></b>  renvoient toujours 0.<br/><br/>
<b>pthread_mutexattr_settype_np"</b> <b></b>  renvoient 0 en cas de succs et un code d'erreur non nul en cas d'erreur.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph"><br/><br/>
En cas d'erreur,
<b>pthread_mutexattr_settype_np"</b> <b></b>  renvoie l'un des codes d'erreur suivants&nbsp;:
<br/><br/>

<b>EINVAL"</b> <b></b>  <i>type</i> n'est ni
<b>PTHREAD_MUTEX_FAST_NP"</b> <b></b>  ni 
<b>PTHREAD_MUTEX_RECURSIVE_NP"</b> <b></b>  ni 
<b>PTHREAD_MUTEX_ERREURCHECK_NP"<br/><br/></b> <b></b>  </div><br/><br /><h1 class="TitreSection0" id="L6">auteur</h1>
<div class="paragraph">
Xavier Leroy &lt;Xavier.Leroy@inria.fr&gt;<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>pthread_mutex_init</b> (3),</b>
<b>pthread_mutex_lock</b> (3),</b>
<b>pthread_mutex_unlock</b> (3).</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i><br/><br/></i>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
