<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<br/><h1>PTHREAD_SETSCHEDPARAM</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">auteur</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/>
<br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
pthread_setschedparam, pthread_getschedparam - paramtres d'ordonnancement du thread<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;pthread.h&gt;<br/><br/></b> <b></b>  <b>int pthread_setschedparam(pthread_t </b> target_thread <i>, int </i> politique <b>, const struct sched_param *</b> param <i>);</i><br/><br/>
<b>int pthread_getschedparam(pthread_t </b> target_thread <i>, int *</i> politique <b>, struct sched_param *</b> param <i>);</i><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph"><br/><br/>
<b>pthread_setschedparam"</b> <b></b>  change la politique et les paramtres d'ordonnancement pour le thread
<i>target_thread</i> tels qu'indiqus par
<i>politique</i> et 
<i>param</i> .</i>
<i>politique</i> peut tre soit
<b>SCHED_OTHER"</b> <b></b>  (processus normal non temps-rel), 
<b>SCHED_RR"</b> <b></b>  (temps rel round-robin) ou 
<b>SCHED_FIFO"</b> <b></b>  (temps-rl fifo).
<i>param</i> change les paramtres d'ordonnancement pour les deux politiques temps rel. Voir
<b>sched_setpolicy</b> (2)</b>
pour plus d'information sur ces politiques.<br/><br/>
Les politiques d'ordonnancement temps rel
<b>SCHED_RR"</b> <b></b>  et 
<b>SCHED_FIFO"</b> <b></b>  ne sont disponibles que pour les processus possdant les privilges du
super-utilisateur.<br/><br/>
<b>pthread_getschedparam"</b> <b></b>  rcupre la politique  et les paramtres d'ordonnancement du thread
<i>target_thread</i> et les enregistre aux emplacements mmoire points respectivement par
<i>politique</i> et 
<i>param</i> .<br/><br/></i>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>pthread_setschedparam"</b> <b></b>  et 
<b>pthread_getschedparam"</b> <b></b>  renvoient 0 en cas de succs et un code d'erreur non nul en cas d'erreur.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
En cas d'erreur,
<b>pthread_setschedparam"</b> <b></b>  renvoie l'un des codes d'erreurs suivants&nbsp;:
.RS
<br/><br/>

<b>EINVAL"</b> <b></b>  <i>politique</i> n'est pas parmi&nbsp;:
<b>SCHED_OTHER</b> ,</b>
<b>SCHED_RR</b> ,</b>
<b>SCHED_FIFO"<br/><br/></b> <b></b>  <br/><br/>

<b>EINVAL"</b> <b></b>  la valeur de la priorit indique par
<i>param</i> n'est pas valide pour la politique choisie.<br/><br/>
<br/><br/>

<b>EPERM"</b> <b></b>  le thread appelant ne possde pas les droits du super-utilisateur.<br/><br/>
<br/><br/>

<b>ESRCH"</b> <b></b>  <i>target_thread</i> n'est pas valide ou est dj termin.<br/><br/>
<br/><br/>

<b>EFAULT"</b> <b></b>  <i>param</i> pointe en dehors de l'espace mmoire du processus.
<br/><br/>
En cas d'erreur,
<b>pthread_getschedparam"</b> <b></b>  renvoie l'un des codes d'erreurs suivants&nbsp;:
.RS
<br/><br/>

<b>ESRCH"</b> <b></b>  <i>target_thread</i> n'est pas valide ou est dj termin.<br/><br/>
<br/><br/>

<b>EFAULT"</b> <b></b>  <i>politique</i> ou 
<i>param</i> pointe en dehors de l'espace mmoire du processus.
<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">auteur</h1>
<div class="paragraph">
Xavier Leroy &lt;Xavier.Leroy@inria.fr&gt;<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>sched_setscheduler</b> (2),</b>
<b>sched_getscheduler</b> (2),</b>
<b>sched_getparam</b> (2),</b>
<b>pthread_attr_setschedpolicy</b> (3),</b>
<b>pthread_attr_setschedparam</b> (3).</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i><br/><br/></i>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
