<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<br/><h1>PTHREAD_SIGNAL</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">annullation</a>
<br /><a class="summaryIndent0" href="#L4">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L5">erreurs</a>
<br /><a class="summaryIndent0" href="#L6">auteur</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">notes</a>
<br /><a class="summaryIndent0" href="#L9">bogues</a>
<br /><a class="summaryIndent0" href="#L10">traduction</a>
<br/><br/>
<br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
pthread_sigmask, pthread_kill, sigwait - gestion des signaux dans les threads<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;pthread.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;signal.h&gt;<br/><br/></b> <b></b>  <b>int pthread_sigmask(int </b> how <i>, const sigset_t *</i> newmask <b>, sigset_t *</b> oldmask <i>);</i><br/><br/>
<b>int pthread_kill(pthread_t </b> thread <i>, int </i> signo <b>);</b><br/><br/>
<b>int sigwait(const sigset_t *</b> set <i>, int *</i> sig <b>);</b><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph"><br/><br/>
<b>pthread_sigmask"</b> <b></b>  change le masque des signaux pour le thread appelant tel que dcrit par les
arguments
<i>how</i> et <i>newmask</i>. Si
<i>oldmask</i> ne vaut pas
<b>NULL</b> ,</b>
le prcdent masque de signaux est sauvegard dans l'emplacement point par
<i>oldmask</i> .<br/><br/></i>
La signification des arguments
<i>how</i> et 
<i>newmask</i> est la mme que pour
<b>sigprocmask</b> (2).</b>
Si 
<i>how</i> vaut
<b>SIG_SETMASK</b> ,</b>
le masque de signal est positionn 
<i>newmask</i> .</i>
Si 
<i>how</i> vaut
<b>SIG_BLOCK</b> ,</b>
les signaux indiqus par
<i>newmask</i> sont ajouts au masque de signaux courant. Si
<i>how</i> vaut
<b>SIG_UNBLOCK</b> ,</b>
les signaux indiqus par
<i>newmask</i> sont retirs du masque courant.<br/><br/>
N.B. : Les masques de signaux sont dfinis par thread, mais la gestion des
signaux et les gestionnaires associs, tels que mis en place par
<b>sigaction</b> (2),</b>
sont partags par tous les threads.<br/><br/>
<b>pthread_kill"</b> <b></b>  envoie le signal numro
<i>signo</i> au thread
<i>thread</i> .</i>
Le signal est reu et gr tel que dcrit dans
<b>kill</b> (2).<br/><br/></b>
<b>sigwait"</b> <b></b>  suspend le thread appelant jusqu' ce que l'un des signaux dfinis dans 
<i>set</i> soit envoy au thread appelant. Le numro du signal reu est alors sauvegard
dans l'emplacement point par
<i>sig</i> et la fonction rend la main. Les signaux dfinis dans
<i>set</i> doivent tre bloqus et non ignors lorsque l'on entre dans
<b>sigwait</b> .</b>
Si l'un des signaux reus possde un gestionnaire de signal, cette fonction
<i>n'est pas</i> appele.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">annullation</h1>
<div class="paragraph"><br/><br/>
<b>sigwait"</b> <b></b>  est un point d'annulation.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">valeur renvoye</h1>
<div class="paragraph">
En cas de succs, 0 est renvoy. En cas d'chec, un code d'erreur non nul est
renvoy.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">erreurs</h1>
<div class="paragraph"><br/><br/>
La fonction
<b>pthread_sigmask"</b> <b></b>  renvoie l'un des codes d'erreur suivants en cas de problme&nbsp;:
.RS
<br/><br/>

<b>EINVAL"</b> <b></b>  <i>how</i> n'est ni 
<b>SIG_SETMASK</b> ,</b>
ni
<b>SIG_BLOCK</b> ,</b>
ni 
<b>SIG_UNBLOCK"<br/><br/></b> <b></b>  <br/><br/>

<b>EFAULT"</b> <b></b>  <i>newmask</i> ou 
<i>oldmask</i> pointe en dehors de l'espace mmoire du processus.
<br/><br/>
La fonction
<b>pthread_kill"</b> <b></b>  renvoiz l'un des codes d'erreur suivants en cas de problme&nbsp;:
.RS
<br/><br/>

<b>EINVAL"</b> <b></b>  <i>signo</i> n'est pas un masque de signaux valide.<br/><br/>
<br/><br/>

<b>ESRCH"</b> <b></b>  le thread 
<i>thread</i> n'existe pas (par exemple, il s'est dj achev)
<br/><br/>
La fonction
<b>sigwait"</b> <b></b>  ne renvoie jamais de code d'erreur.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">auteur</h1>
<div class="paragraph">
Xavier Leroy &lt;Xavier.Leroy@inria.fr&gt;<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>sigprocmask</b> (2),</b>
<b>kill</b> (2),</b>
<b>sigaction</b> (2),</b>
<b>sigsuspend</b> (2).<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L9">notes</h1>
<div class="paragraph"><br/><br/>
Afin que
<b>sigwait"</b> <b></b>  fonctionne de manire fiable, les signaux que l'on attend doivent tre bloqus
dans tous les threads, pas seulement le thread appelant, sinon les smantiques
de POSIX concernant le traitement du signal ne garantissent pas que le thread
appelant
<b>sigwait"</b> <b></b>  sera celui recevant le signal. La meilleur manire d'assurer cela est de
bloquer ces signals avant de crer les threads puis de ne jamais dbloquer ces
signaux dans aucun de ces threads sauf en appelant
<b>sigwait</b> .<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L10">bogues</h1>
<div class="paragraph">
La gestion des signaux dans LinuxThreads ne respecte pas celle dfinie par le
standard POSIX. Selon le standard, un signal "asynchrone" (externe) doit tre
drout vers le processus tout entier (c'est  dire vers tous les threads le
composant) mais seul l'un d'eux doit le grer. Celui-ci peut tre n'importe
lequel des threads ne bloquant pas le signal.<br/><br/>
Dans LinuxThreads, chaque thread est un processus par rapport au noyau,
possdant son propre PID, aussi les signaux extrieurs sont toujours envoys
vers un thread particulier. Si, par exemple, un autre thread est bloqu dans
<b>sigwait"</b> <b></b>  sur ce signal, il ne sera pas relanc.<br/><br/>
L'implmentation de
<b>sigwait"</b> <b></b>  par LinuxThreads installe un gestionnaire de signaux vide pour les signaux
dfinis dans
<i>set</i> durant l'attente. Comme les gestionnaires de signaux sont partags
par tous les threads, les autres threads ne doivent pas attacher leurs propres
gestionnaires sur ces signaux, mais doivent bloquer ces signaux (ce qui est
de toute faon recommand -- voir la rubrique NOTES).
</div><br/><br /><h1 class="TitreSection0" id="L11">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i></i>
<br/>
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
