<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Thu Apr  8 15:00:12 1993, David Metcalfe -->
<!--  Modified Sat Jul 24 18:44:45 1993, Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 05/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!-- 	mise a jour 25/01/97 -->
<!--  Mise  jour 07/06/2001 - LDP-man-pages-1.37 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>PUTENV</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
putenv - Ajouter ou modifier une variable d'environnement.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdlib.h&gt;</b> <b></b>  <br/><br/>

<b>int putenv (char *</b> string );
<!--  Not: const char *  -->


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>putenv()</b> ajoute ou modifie la valeur d'une variable
d'environnement. L'argument <i>string</i> est une chane de caractres
de la forme <i>nom</i>=<i>valeur</i>.
Si <i>nom</i> n'existe pas dans l'environnement, la variable est ajoute.
Si <i>nom</i> existe, alors la valeur de la variable d'environnement
<i>nom</i> est remplace par <i>valeur</i>.
La chane pointe par <i>string</i> devient partie intgrante de
l'environnement, ainsi une modification de cette chane change
l'environnement.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>putenv()</b> renvoie 0 si elle russit, ou -1 si elle choue,
auquel cas <i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>ENOMEM</b> <b></b>  Pas assez de mmoire.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
La fonction <b>putenv</b>() n'a pas besoin d'tre rentrante, celles des
bibliothques libc4, libc5, et GlibC 2.0 ne le sont pas, contrairement
 celle de la GlibC 2.1.<br/><br/>
Description pour libc4, libc5 et GlibC&nbsp;:
Si la chane <i>string</i> est de la forme <i>nom</i>, sans contenir
de signe `=', la variable du <i>nom</i> indiqu est supprime de 
l'environnement.
Si <b>putenv</b>() doit allouer un nouveau tableau <i>environ</i>,
et si le tableau prcdent avait dj t allou par <b>putenv</b>(),
alors il sera libr. En aucun cas, l'espace correspondant aux chanes
d'environnement proprement dites ne sera libr.<br/><br/>
Les versions des bibliothques libc4, lib5 et GlibC 2.1.2 se conforment
aux spcifications SUSv2&nbsp;:
le pointeur <i>string</i> transmis  <b>putenv</b>() est utilis. En
particulier la chane devient partie intgrante de l'environnement, si
on la modifie par la suite, l'environnement est modifi.
(C'est donc une erreur d'appeler <b>putenv</b>() avec une
variable automatique en argument puis de revenir de la fonction alors
que la chane est toujours dans l'environnement).
Toutefois, les GlibC 2.0 - 2.1.1 diffrent : une copie de la chane
est effectue. D'une part cela cre une fuite mmoire, d'autre
part on viole les spcifications SUSv2. Ceci a donc t corrig dans la
Glib 2.1.2.<br/><br/>
La version BSD 4.4 effectue aussi une copie.<br/><br/>
Dans les specifications SUSv2, le `const' a t supprim du prototype. C'est
aussi le cas dans GlibC 2.1.3.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SVID 3, POSIX, BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>clearenv (3),</b>
<b>getenv (3),</b>
<b>setenv (3),</b>
<b>unsetenv (3),</b>
<b>environ (5)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
