<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  (c) 1993 by Thomas Koenig (ig25@rz.uni-karlsruhe.de) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  License. -->
<!--  Modified Sat Jul 24 18:42:59 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 05/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  mj 25/04/98 (LDP man-pages 1.19) -->
<!--  -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>PUTS</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">conformit</a>
<br /><a class="summaryIndent0" href="#L5">bogues</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
puts, fputc, fputs, putc, putchar - Ecriture de caractres et de chanes.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdio.h&gt;</b> <b></b>  <br/><br/>

<b>int fputc (int </b> c <i>, FILE *</i> stream );
.nl
<b>int fputs (const char *</b> <i>s</i> <b>, FILE *</b> <i>stream</i> );
.nl
<b>int putc (int </b> c <i>, FILE *</i> stream );
.nl
<b>int putchar (int </b> c );
.nl
<b>int puts (const char * </b> s );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>fputc()</b> <b></b>  crit le caractre
<i>c ,</i>
transform en
<b>unsigned char</b> ,</b>
dans le flux
<i>stream .<br/><br/></i>
<b>fputs()</b> <b></b>  crit la chane de caractres
<i>s</i> dans le flux
<i>stream ,</i>
sans crire le
<b>'\e0'</b> <b></b>  final.<br/><br/>
<b>putc()</b> <b></b>  est quivalent 
<b>fputc()</b> <b></b>  sauf qu'il peut tre implment comme une macro valuant plusieurs fois
son argument
<i>stream .<br/><br/></i>
<b>putchar(</b> c );
est quivalent 
<b>putc(</b> c , stdout ).<br/><br/>
<b>puts() </b>
crit la chane de caractres
<i>s</i> et un retour-chariot final sur
<i>stdout .<br/><br/></i>
Les appels de ces fonctions peuvent tre utiliss conjointement, ainsi qu'avec
les autres fonctions d'criture de la bibliotheque
<b>stdio .<br/><br/></b>
Pour des versions de ces fonctions ignorant les verrouillages, voir
<b>unlocked_stdio (3).</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>fputc() , </b> putc() <b> et </b> putchar()<b></b>
renvoient le caractre crit en tant qu'<b>unsigned char</b>, converti en
<b>int</b> <b></b>  ou
<b>EOF</b> <b></b>  en cas d'erreur.<br/><br/>
<b>puts() </b> et <b> fputs()</b>
renvoient un nombre non ngatif s'ils russissent et
<b>EOF</b> <b></b>  s'ils chouent.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">conformit</h1>
<div class="paragraph">
ANSI - C, POSIX.1
</div><br/><br /><h1 class="TitreSection0" id="L6">bogues</h1>
<div class="paragraph">
Il est fortement dconseill de mler les fonctions d'criture de
<b>stdio</b> <b></b>  avec les appels bas-niveau
<b>write()</b> <b></b>  sur le descripteur du fichier associ au flux. Les rsultats sont imprvisibles.
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>write (2),</b>
<b>ferror (3),</b>
<b>fopen (3),</b>
<b>fseek (3),</b>
<b>fwrite (3),</b>
<b>gets (3),</b>
<b>scanf (3),</b>
<b>unlocked_stdio (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
