<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Mon Mar 29 22:48:44 1993, David Metcalfe -->
<!--  Modified Wed Apr 28 01:35:00 1993, Lars Wirzenius -->
<!--  Modified Sat Jul 24 18:39:41 1993, Rik Faith (faith@cs.unc.edu) -->
<!--  Modified Thu May 18 10:10:13 1995, Rik Faith (faith@cs.unc.edu) to add -->
<!--           better discussion of problems with rand on other systems. -->
<!--           (Thanks to Esa Hyyti{ (ehyytia@snakemail.hut
).) -->
<!--  " -->
<!--  -->
<!--  Traduction 05/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  -->
<br/><h1>RAND</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">notes</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
rand, srand - Gnrateur de nombres alatoires.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdlib.h&gt;</b> <b></b>  <br/><br/>

<b>int</b> <b></b>  <b>rand</b> <b></b>  <b>(void);</b> <b></b>  <br/><br/>

<b>void srand (unsigned int </b> seed );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>rand()</b> renvoie un entier pseudo-alatoire entre 0 et
<b>RAND_MAX</b>.<br/><br/>
La fonction <b>srand()</b> utilise son argument comme "graine" pour la gnration
d'une nouvelle squence de nombres pseudo-alatoires, qui seront fournis
par <b>rand()</b>.
Ces squences sont reproductibles en appelant <b>srand()</b> avec la
mme valeur de graine.<br/><br/>
Si aucune graine originale n'est fournie, la fonction <b>rand()</b> commence en
utilisant la valeur 1.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>rand()</b> renvoie un nombre entier entre 0 et RAND_MAX.
La fonction <b>srand()</b> ne renvoie aucune valeur.
</div><br/><br /><h1 class="TitreSection0" id="L5">notes</h1>
<div class="paragraph">
Les versions de <b>rand()</b> et <b>srand()</b> de la bibliothque C de Linux
utilisent le mme gnrateur de nombres alatoires que <b>random()</b> et
<b>srandom()</b>, ainsi les bits de poids faibles sont tout aussi imprvisibles
que les bits de poids forts.
Ceci n'est pas le cas avec les anciennes implmentations de
<b>rand() ,</b>
o les bits de poids faibles n'taient pas "aussi alatoires" que ceux
de poids forts.<br/><br/>
Dans
<i>Numerical Recipes in C: The Art of Scientific Computing</i> (William H. Press, Brian P. Flannery, Saul A. Teukolsky, William
T. Vetterling; New York: Cambridge University Press, 1990 (1st ed,
p. 207)), le commentaire suivant apparat&nbsp;:
.RS
"Si vous dsirez engendrer un entier alatoire entre 1 et 10, vous devez
toujours procder en utilisant les bits de poids forts, comme dans&nbsp;:
.RS
<br/><br/>

j=1+(int) (10.0*rand()/(RAND_MAX+1.0));
<br/><br/>


et jamais ainsi&nbsp;:
.RS
<br/><br/>

j=1+(rand() % 10);
<br/><br/>


(car cette derniere version utilise les bits de poids faibles)."
<br/><br/>
La gnration de nombres alatoires est un domaine complexe. Le livre
<i>Numerical Recipes in C</i> (rfrence ci-dessus)
fournit une excellente prsentation pratique d'un gnrateur alatoire 
dans le chapitre 1 (Random Numbers).<br/><br/>
Pour une discussion plus thorique, qui aborde galement en profondeur
d'autres domaines, voir le chapitre 3 (Random Numbers) du livre de
Donald E. Knuth
<i>The Art of Computer Programming</i> ,</i>
volume 2 (Seminumerical Algorithms), 2nd ed.; Reading, Massachusetts:
Addison-Wesley Publishing Company, 1981.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
SVID 3, BSD 4.3, ISO 9899
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>random (3),</b>
<b>srandom (3),</b>
<b>initstate (3),</b>
<b>setstate (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
