<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sun Mar 28 00:25:51 1993, David Metcalfe -->
<!--  Modified Sat Jul 24 18:13:39 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 07/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>RANDOM</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
random, srandom, initstate, setstate - Gnrateur de nombres alatoires.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdlib.h&gt;</b> <b></b>  <br/><br/>

<b>long</b> <b></b>  <b>int</b> <b></b>  <b>random</b> <b></b>  <b>(void);</b> <b></b>  .nl
<b>void srandom (unsigned int </b> seed );
.nl
<b>char *initstate (unsigned int </b> seed <i>, char *</i> state <b>, size_t </b> n );
.nl
<b>char *setstate (char *</b> state );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>random()</b> utilise une fonction non-linaire pour engendrer
des nombres pseudo-alatoires entre 0 et <b>RAND_MAX</b>.
La priode de ce gnrateur est trs grande, approximativement
16*((2**31)-1).<br/><br/>
La fonction <b>srandom()</b> utilise son argument comme "graine" pour engendrer
une nouvelle squence de nombre pseudo-alatoires qui seront fournis
lors des appels  <b>random()</b>.
Ces squences sont reproductibles en invoquant <b>srandom()</b> avec la
mme graine. Si aucune graine n'est fournie, La fonction <b>random()</b>
utilise automatiquement une graine originale de valeur 1.<br/><br/>
La fonction <b>initstate()</b> permet d'initialiser une table d'tats
<i>state</i> pour l'utiliser avec <b>random()</b>.  La taille <i>n</i> de la
table est utilise par <b>initstate()</b> pour dterminer le
niveau de sophistication du gnrateur de nombre alatoires.
Plus grande est la table d'tat, meilleurs seront les nombres alatoires.
<i>seed</i> est la graine utilise pour l'initialisation, indiquant un
point de dpart pour la squence de nombres, et permet de redmarrer
au mme endroit.<br/><br/>
La fonction <b>setstate()</b> modifie la table d'tats utilise par la
fonction <b>random()</b>. La table d'tat <i>state</i> est alors utilise
comme gnrateur de nombres alatoires jusqu'au prochain appel de
<b>initstate()</b> ou <b>setstate()</b>.
<i>state</i> doit d'abord tre initialise avec <b>initstate()</b> ou tre le
rsultat d'un appel prcdent  <b>setstate()</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>random()</b> renvoie une valeur entre 0 et RAND_MAX.
La fonction <b>srandom()</b> ne renvoie pas de valeur. Les fonctions
<b>initstate()</b> et <b>setstate()</b> renvoient un pointeur sur
la table d'tats prcdente, ou NULL en cas d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EINVAL</b> <b></b>  Une table d'tats plus courte que 8 octets a t fournie 
<b>initstate()</b>.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Actuellement, les valeurs optimales <i>n</i>, pour la taille de la table d'tats
sont 8, 32, 64, 128, et 256 octets. Les autres valeurs seront arrondies
 la taille la plus proche. Essayer d'utiliser moins de 8 octets dclenche
une erreur.
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>rand (3), </b>
<b>srand (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
