<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  @(#)rpc.3n	2.4 88/08/08 4.0 RPCSRC; from 1.19 88/06/24 SMI -->
<!--  Traduction 31/08/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.31 -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  Mise  jour 26/01/2002 - LDP-man-pages-1.47 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>RPC</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis et description</a>
<br /><a class="summaryIndent0" href="#L2">voir aussi</a>
<br /><a class="summaryIndent0" href="#L3">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
rpc - Bibliothque de fonctions pour les appels de procdures  distance.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis et description</h1>
<div class="paragraph"><br/><br/>
[NDT] RPC = Remote Procedure Call.<br/><br/>
Ces routines permettent  des programmes C de faire des appels de procdures vers d'autres machines
 travers le rseau.  D'abord le client invoque une procdure pour envoyer un paquet
de donnes vers le serveur.   la rception du paquet, le serveur appelle une routine de distribution
pour excuter le service demand, et renvoyer une rponse.
Finalement, l'appel de procdure revient au client.<br/><br/>
Les routines qui utilisent les RPC scurises (authentification DES) sont dcrites dans
<b>rpc_secure (3N).</b>
Les RPC scurises ne sont possibles que si le cryptage DES est disponible.<br/><br/>
.ft B

<br/><br/>
 .5
#include &lt;rpc/rpc.h&gt;


.ft R
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
void
auth_destroy(auth)
\s-1AUTH\s0 *auth;


.ft R
.IP
Cette macro dtruit les informations d'authentification associe avec
<i>auth .</i>
La destruction implique gnralement la dsallocation de donnes prives.
Le comportement est indfini si on essaye d'utiliser
<i>auth</i> aprs avoir invoqu
<b>auth_destroy() .</b>
<br/>
.if t .ne 6<br/><br/>
.ft B

<br/><br/>
 .5
\s-1AUTH\s0 *
authnone_create()


.ft R
.IP
Cre et renvoie un descripteur d'authentification
.SM RPC
transmettant avec chaque appel de procdure une information
d'authentification nulle. C'est le comportement
par dfaut pour les
.SM RPC.
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
\s-1AUTH\s0 *
authunix_create(host, uid, gid, len, aup_gids)
char *host;
int uid, gid, len, *aup.gids;


.ft R
.IP
Cre et renvoie un descripteur d'authentification
.SM RPC
Unix, contenant des
.UX
informations d'identification.
L'argument
<i>host</i> est le nom de la machine sur laquelle l'information
est cre.
<i>uid</i> est l'identification de
l'utilisateur
<i>gid</i> est l'identification du
groupe de l'utilisateur
<i>len</i> et
<i>aup_gids</i> concernent la table des groupes supplmentaires auxquels l'utilisateur appartient.
On peut facilement se faire passer pour quelqu'un d'autre.
<br/>
.if t .ne 5<br/><br/>
.ft B

<br/><br/>
 .5
\s-1AUTH\s0 *
authunix_create_default()


.ft R
.IP
Appelle
<b>authunix_create()</b> <b></b>  avec les arguments appropris.
<br/>
.if t .ne 13<br/><br/>
.ft B

<br/><br/>
 .5
callrpc(host, prognum, versnum, procnum, inproc, in, outproc, out)
char *host;
u_long prognum, versnum, procnum;
char *in, *out;
xdrproc_t inproc, outproc;


.ft R
.IP
Appelle la procdure distante associe aux arguments
<i>prognum ,</i>
<i>versnum ,</i>
et 
<i>procnum</i> sur la machine,
<i>host .</i>
L'argument
<i>in</i> est l'adresse du ou des arguments d'entre de la procdure,
<i>out</i> celle de l'emplacement o stocker le ou les rsultats,
<i>inproc</i> sert  encoder les paramtres d'entre de la procdure, et
<i>outproc</i>  dcoder les rsultats de la procdure.
Cette routine renvoie zro si elle russit, ou la valeur de
<b>enum</b> <b></b>  <b>clnt_stat"</b> <b></b>  transpose en un nombre entier si elle choue
La routine
<b>clnt_perrno()</b> <b></b>  permet de traduire les codes d'chec en messages.
.IP
Attention : l'appel d'une procdure distante avec cette
routine emploie le protocole
.SM UDP/IP
pour le transport, voir
<b>clntudp_create()</b> <b></b>  pour certaines restrictions.
Vous n'avez aucun contrle sur le dlai maximal ou sur l'authentification
avec cette routine.
<br/>
.if t .ne 16<br/><br/>
.ft B

<br/><br/>
 .5
enum clnt_stat
clnt_broadcast(prognum, versnum, procnum, inproc, in, outproc, out, eachresult)
u_long prognum, versnum, procnum;
char *in, *out;
xdrproc_t inproc, outproc;
resultproc_t eachresult;


.ft R
.IP
Comme
<b>callrpc() ,</b>
sauf que le message d'appel est diffus sur tous les rseaux
connects.  chaque rception d'une rponse, cette
routine appelle la fonction
<b>eachresult() ,</b>
dont la forme est :
.IP
.RS 1i
.ft B

eachresult(out, addr)
char *out;
struct sockaddr_in *addr;
.ft R



.IP
o 
<i>out</i> est du mme type que le
<i>out</i> pass 
<b>clnt_broadcast() ,</b>
avec la diffrence que la sortie de la procdure distante est dcode ici.
<i>addr</i> pointe vers l'adresse de la machine qui a envoy le rsultat.
Si
<b>eachresult()</b> <b></b>  renvoie zro,
<b>clnt_broadcast()</b> <b></b>  attend d'autres rponses. Sinon elle revient avec le code de 
retour appropri.
.IP
Attention : les socket broadcast sont limites en ce qui
concerne la taille maximale des donnes. Pour l'Ethernet
cette valeur (MTU) vaut 1500 octets.
<br/>
.if t .ne 13<br/><br/>
.ft B

<br/><br/>
 .5
enum clnt_stat
clnt_call(clnt, procnum, inproc, in, outproc, out, tout)
\s-1CLIENT\s0 *clnt;
u_long
procnum;
xdrproc_t inproc, outproc;
char *in, *out;
struct timeval tout;


.ft R
.IP
Une macro qui appelle la procdure distante
<i>procnum</i> associe avec le descripteur de client
<i>clnt ,</i>
qui est obtenu grce  une routine de cration de client
.SM RPC
comme
<b>clnt_create() .</b>
L'argument
<i>in</i> est l'adresse du ou des arguments d'entre de la procdure,
<i>out</i> celle de l'emplacement o stocker le ou les rsultats,
<i>inproc</i> sert  encoder les paramtres d'entre de la procdure, et
<i>outproc</i>  dcoder les rsultats de la procdure.
<i>tout</i> est le dlai maximal accord pour la ralisation de la procdure.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
clnt_destroy(clnt)
\s-1CLIENT\s0 *clnt;


.ft R
.IP
Une macro qui dtruit le descripteur de client
.SM RPC
ce qui implique gnralement la libration
de structures de donnes prives, y compris
<i>clnt</i> lui mme. Le comportement est indfini si on tente d'utiliser
<i>clnt</i> aprs avoir appel
<b>clnt_destroy() .</b>
Si la bibliothque
.SM RPC
avait ouvert la socket associe, elle sera galement ferme.
Sinon, la socket reste ouverte.
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
\s-1CLIENT\s0 *
clnt_create(host, prog, vers, proto)
char *host;
u_long prog, vers;
char *proto;


.ft R
.IP
Routine gnrique de cration de client.
<i>host</i> identifie le nom de l'hte distant o se
trouve le serveur.
<i>proto</i> indique le type de protocole de transport  employer. Les
valeurs actuellement supportes pour ce champ sont \(lqudp\(rq
et \(lqtcp\(rq.
Des valeurs par dfaut sont configures pour les dlais, mais peuvent tre modifie  l'aide de
<b>clnt_control() .</b>
.IP
Attention : l'utilisation du protocole
.SM UDP
a des inconvnients. Comme les messages
.SM RPC
bass sur
.SM UDP
ne peuvent contenir que 8 Ko de donnes encodes, ce protocole ne peut pas tre utilis
pour des procdures ncessitant de gros arguments, ou renvoyant d'normes rsultats.
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
bool_t
clnt_control(cl, req, info)
\s-1CLIENT\s0 *cl;
char *info;


.ft R
.IP
Une macro employe pour modifier ou rcuprer des informations diverses
 propose d'un objet client.
<i>req</i> indique le type d'opration, et
<i>info</i> est un pointeur sur l'information. Pour
.SM UDP
comme pour
.SM TCP\s0,
les valeurs autorises pour
<i>req</i> et le type des arguments sont :
.IP

.ta +2.0i +2.0i +2.0i
.SM CLSET_TIMEOUT\s0	struct timeval	fixer le dlai total
.SM CLGET_TIMEOUT\s0	struct timeval	lire le dlai total


.IP
Note: Si vous fixez le dlai avec
<b>clnt_control() ,</b>
le dernier argument de
<b>clnt_call()</b> <b></b>  sera ignor lors des appels ultrieurs.
.IP

.SM CLGET_SERVER_ADDR\s0	struct sockaddr_in 	get servers address


<br/>
.IP
Les oprations suivantes sont valides pour le protocole
.SM UDP
seulement :
.IP

.ta +2.0i  +2.0i  +2.0i
.SM CLSET_RETRY_TIMEOUT\s0	struct timeval	fixer le dlai de rptition
.SM CLGET_RETRY_TIMEOUT\s0	struct timeval	lire le dlai de rptition


<br/>
.IP
Le dlai de rptition est le temps pendant lequel les
.SM "RPC UDP"
attendent une rponse du serveur avant
retransmettre la requte.
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
clnt_freeres(clnt, outproc, out)
\s-1CLIENT\s0 *clnt;
xdrproc_t outproc;
char *out;


.ft R
.IP
Une macro qui libre toutes les donnes alloues par le systme
.SM RPC/XDR
lorsqu'il a dcod les rsultats d'un appel
.SM RPC
L'argument
<i>out</i> est l'adresse des rsultats,
et
<i>outproc</i> est la routine
.SM XDR
dcodant les rsultats.
Cette fonction renvoie 1 si les rsultats ont t
correctement librs,
et zro sinon.
<br/>
.if t .ne 6<br/><br/>
.ft B

<br/><br/>
 .5
void
clnt_geterr(clnt, errp)
\s-1CLIENT\s0 *clnt;
struct rpc_err *errp;


.ft R
.IP
Une macro qui copie la structure d'erreur depuis
le descripteur de client vers la
structure se trouvant  l'adresse
<i>errp .</i>
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
void
clnt_pcreateerror(s)
char *s;


.ft R
.IP
Affiche un message sur la sortie d'erreur standard, indiquant
pourquoi un descripteur de client
.SM RPC
ne peut pas tre cr.
Ce message est prfix avec la chane
<i>s</i> et un deux-points est insr.
 utiliser lorsque les appels
<b>clnt_create() ,</b>
<b>clntraw_create() ,</b>
<b>clnttcp_create() ,</b>
ou
<b>clntudp_create()</b> <b></b>  chouent.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
void
clnt_perrno(stat)
enum clnt_stat stat;


.ft R
.IP
Affiche un message sur la sortie d'erreur standard, correspondant
 la condition indique par
<i>stat .</i>
 utiliser aprs
<b>callrpc() .</b>
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
clnt_perror(clnt, s)
\s-1CLIENT\s0 *clnt;
char *s;


.ft R
.IP
Affiche un message sur la sortie d'erreur standard indiquant pourquoi un appel
.SM RPC
a chou.
<i>clnt</i> est le descripteur utilis pour l'appel.
Ce message est prfix avec la chane
<i>s</i> et un deux-points est insr.
 utiliser aprs
<b>clnt_call() .</b>
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
char *
clnt_spcreateerror
char *s;


.ft R
.IP
Comme
<b>clnt_pcreateerror() ,</b>
sauf qu'il renvoie une chane
au lieu d'crire sur la sortie d'erreur standard.
.IP
Danger : renvoie un pointeur vers une zone de donne statique,
crase  chaque appel.
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
char *
clnt_sperrno(stat)
enum clnt_stat stat;


.ft R
.IP
Emploie les mme arguments que
<b>clnt_perrno() ,</b>
mais au lien d'envoyer un message sur la sortie d'erreur standard
indiquant pourquoi un appel
.SM RPC
a chou, renvoie un pointeur sur une chane contenant
le message.  La chane se termine par un
.SM NEWLINE\s0.
.IP
<b>clnt_sperrno()</b> <b></b>  est utilis  la place de
<b>clnt_perrno()</b> <b></b>  si le programme n'a pas de sortie d'erreur standard (un serveur par
exemple n'en a gnralement pas), ou si le
programmeur
ne veut pas que le message soit affich avec
<b>printf ,</b>
ou si un format de message diffrent de celui fourni par
<b>clnt_perrno()</b> <b></b>  doit tre utilis.
Note : contrairement 
<b>clnt_sperror()</b> <b></b>  et
<b>clnt_spcreaterror() ,</b>
<b>clnt_sperrno()</b> <b></b>  renvoie un pointeur sur une zone de donne statique, mais le rsultat
ne sera pas cras  chaque appel.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
char *
clnt_sperror(rpch, s)
\s-1CLIENT\s0 *rpch;
char *s;


.ft R
.IP
Comme
<b>clnt_perror() ,</b>
sauf que (comme
<b>clnt_sperrno() )</b>
il renvoie une chane au lieu d'crire sur la sortie d'erreur standard.
.IP
Danger : renvoie un pointeur vers une zone de donne statique,
crase  chaque appel.
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
\s-1CLIENT\s0 *
clntraw_create(prognum, versnum)
u_long prognum, versnum;


.ft R
.IP
Cette routine cre un simili client
.SM RPC
pour le programme distant
<i>prognum ,</i>
de version
<i>versnum .</i>
Le mcanisme de transport pour les message est en ralit 
un buffer dans l'espace d'adresse du processus, ainsi le
serveur
.SM RPC
doit se trouver dans le mme espace d'adresse. Voir
<b>svcraw_create() .</b>
Cela permet de simuler une
.SM RPC
et de mesurer la surcharge des procdures
.SM RPC
comme les temps d'aller-retour sans interfrence
due au noyau. Cette routine renvoie
.SM NULL
si elle choue.
<br/>
.if t .ne 15<br/><br/>
.ft B

<br/><br/>
 .5
\s-1CLIENT\s0 *
clnttcp_create(addr, prognum, versnum, sockp, sendsz, recvsz)
struct sockaddr_in *addr;
u_long prognum, versnum;
int *sockp;
u_int sendsz, recvsz;


.ft R
.IP
Cette routine cre un client
.SM RPC
pour le programme distant
<i>prognum ,</i>
de version
<i>versnum ;</i>
Le client utilise
.SM TCP/IP
pour le transport. Le programme distant se trouve 
l'adresse Internet
<i>*addr .</i>
Si
<!-- The following in-line font conversion is necessary for the hyphen indicator -->
<b>\%addr-&gt;sin_port</b>
vaut zro, alors il est rempli avec le numro de port sur lequel le
programme distant est en coute (on consulte le service
<b>portmap</b> <b></b>  distant pour obtenir cette information). L'argument
<i>sockp</i> est une socket; si c'est
<b>\s-1RPC_ANYSOCK\s0 ,</b>
alors la routine ouvre une nouvelle socket et remplit
<i>sockp .</i>
Comme les
.SM RPC
bases sur
.SM TCP
utilisent des entres-sorties avec buffers,
l'utilisateur peut spcifier la taille des buffers d'entre et 
de sortie avec les paramtres
<i>sendsz</i> et 
<i>recvsz .</i>
Des valeurs nulles rclament l'utilisation de buffers de tailles optimales.
Cette routine renvoie
.SM NULL
si elle choue.
<br/>
.if t .ne 15<br/><br/>
.ft B

<br/><br/>
 .5
\s-1CLIENT\s0 *
clntudp_create(addr, prognum, versnum, wait, sockp)
struct sockaddr_in *addr;
u_long prognum, versnum;
struct timeval wait;
int *sockp;


.ft R
.IP
Cette routine cre un client
.SM RPC
pour le programme distant
<i>prognum ,</i>
de version
<i>versnum ;</i>
Le client utilise
.SM UDP/IP
pour le transport. Le programme distant se trouve 
l'adresse Internet
<i>*addr .</i>
Si
<b>\%addr-&gt;sin_port</b>
vaut zro, alors il est rempli avec le numro de port sur lequel le
programme distant est en coute (on consulte le service
<b>portmap</b> <b></b>  distant pour obtenir cette information). L'argument
<i>sockp</i> est une socket; si c'est
<b>\s-1RPC_ANYSOCK\s0 ,</b>
alors la routine ouvre une nouvelle socket et remplit
<i>sockp .</i>
Le protocole de transport
.SM UDP
renvoie le message d'appel avec un intervalle de temps indiqu par
<b>wait</b> <b></b>  jusqu' la rception d'une rponse ou jusqu'au dpassement
du temps maximal.
Ce dlai total pour l'appel est spcifi par la fonction
<b>clnt_call() .</b>
.IP
Attention : comme les messages des
.SM RPC
bases sur
.SM UDP
ne peuvent contenir que 8 Ko de donnes encodes, ce protocole ne peut pas tre utilis
pour des procdures ncessitant de gros arguments, ou renvoyant d'normes rsultats.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
\s-1CLIENT\s0 *
clntudp_bufcreate(addr, prognum, versnum, wait, sockp, sendsize, recosize)
struct sockaddr_in *addr;
u_long prognum, versnum;
struct timeval wait;
int *sockp;
unsigned int sendsize;
unsigned int recosize;


.ft R
.IP
Cette routine cre un client
.SM RPC
pour le programme distant
<i>prognum ,</i>
de version
<i>versnum ;</i>
Le client utilise
.SM UDP/IP
pour le transport. Le programme distant se trouve 
l'adresse Internet
<i>*addr .</i>
Si
<b>\%addr-&gt;sin_port</b>
vaut zro, alors il est rempli avec le numro de port sur lequel le
programme distant est en coute (on consulte le service
<b>portmap</b> <b></b>  distant pour obtenir cette information). L'argument
<i>sockp</i> est une socket; si c'est
<b>\s-1RPC_ANYSOCK\s0 ,</b>
alors la routine ouvre une nouvelle socket et remplit
<i>sockp .</i>
Le protocole de transport
.SM UDP
renvoie le message d'appel avec un intervalle de temps indiqu par
<b>wait</b> <b></b>  jusqu' la rception d'une rponse ou jusqu'au dpassement
du temps maximal.
Ce dlai total pour l'appel est spcifi par la fonction
<b>clnt_call() .</b>
.IP
Cette routine permet au programmeur de prciser la taille maximale des buffers en mission et rception pour les messages
.SM RPC
bass sur
.SM UDP.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
void
get_myaddress(addr)
struct sockaddr_in *addr;


.ft R
.IP
Fournit l'adresse
.SM IP
de la machine dans la structure
<i>*addr ,</i>
sans consulter les routines de bibliothques qui manipulent
<b>/etc/hosts .</b>
Le numro de port est toujours rempli avec
<b>htons(\s-1PMAPPORT\s0) .</b>
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
struct pmaplist *
pmap_getmaps(addr)
struct sockaddr_in *addr;


.ft R
.IP
Une interface utilisateur pour le service
<b>portmap</b> <b></b>  renvoyant une liste des associations en cours entre programmes
.SM RPC
et ports
sur l'hte situ  l'adresse
.SM IP
indique dans
<i>*addr .</i>
Cette routine peut renvoyer
<b>NULL .</b>
La commande 
 <b>rpcinfo -p</b> </b>
utilise cette fonction
<br/>
.if t .ne 12<br/><br/>
.ft B

<br/><br/>
 .5
u_short
pmap_getport(addr, prognum, versnum, protocol)
struct sockaddr_in *addr;
u_long prognum, versnum, protocol;


.ft R
.IP
Une interface utilisateur pour le service
<b>portmap</b> <b></b>  qui renvoie le numro de port sur lequel est en coute
le service associ au programme numro
<i>prognum ,</i>
de version
<i>versnum ,</i>
en utilisant le protocole de transport associ avec
<i>protocol .</i>
La valeur de l'argument
<i>protocol</i> est normalement
.B
.SM IPPROTO_UDP
ou 
<b>\s-1IPPROTO_TCP\s0 .</b>
Une valeur de retour nulle signifie qu'aucune association
n'existe ou
qu'une erreur du systme
.SM RPC
s'est produite en tentant de contacter le service
<b>portmap</b> <b></b>  distant. Dans ce cas, la variable globale
<b>rpc_createerr()</b> <b></b>  contient le code
.SM RPC
de l'erreur.
<br/>
.if t .ne 15<br/><br/>
.ft B

<br/><br/>
 .5
enum clnt_stat
pmap_rmtcall(addr, prognum, versnum, procnum, inproc, in, outproc, out, tout, portp)
struct sockaddr_in *addr;
u_long prognum, versnum, procnum;
char *in, *out;
xdrproc_t inproc, outproc;
struct timeval tout;
u_long *portp;


.ft R
.IP
Une interface utilisateur pour le service
<b>portmap</b> <b></b>  qui demande au programme
<b>portmap</b> <b></b>  sur l'hte se trouvant  l'adresse
.SM IP
indique dans
<i>*addr</i> de faire en notre nom un appel
.SM RPC
pour une procdure se trouvant sur cet hte.
Le paramtre
<i>*portp</i> sera modifi pour contenir le numro de port du programme si
la procdure
russit. Les dfinitions des autres arguments sont prsentes
 propos de
<b>callrpc()</b> <b></b>  et de
<b>clnt_call() .</b>
Cette procdure devrait tre utilise pour faire un \(lqping\(rq 
et rien d'autre.
Voir aussi
<b>clnt_broadcast() .</b>
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
pmap_set(prognum, versnum, protocol, port)
u_long prognum, versnum, protocol;
u_short port;


.ft R
.IP
Une interface utilisateur pour le service
<b>portmap</b> <b></b>  qui tablit une association entre le triplet
[ prognum <i>, </i> versnum <i>, </i> protocol\fR]</i>
et le
<i>port</i> sur la machine du service
<b>portmap</b> <b></b>  La valeur du
<i>protocol</i> est normalement
.B
.SM IPPROTO_UDP
ou 
<b>\s-1IPPROTO_TCP\s0 .</b>
Cette routine renvoie 1 si elle russit, et zro sinon.
Elle est automatiquement invoque par
<b>svc_register() .</b>
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
pmap_unset(prognum, versnum)
u_long prognum, versnum;


.ft R
.IP
Une interface utilisateur vers le service
<b>portmap</b> <b></b>  qui dtruit toute association entre le triplet
[ prognum <i>, </i> versnum <i>, </i> *\fR]</i>
et les
<b>ports</b> <b></b>  de la machine o se trouve le service
<b>portmap .</b>
Cette routine renvoie 1 si elle russit,
et zro sinon.
<br/>
.if t .ne 15<br/><br/>
.ft B

<br/><br/>
 .5
registerrpc(prognum, versnum, procnum, procname, inproc, outproc)
u_long prognum, versnum, procnum;
char *(*procname) () ;
xdrproc_t inproc, outproc;


.ft R
.IP
Enregistre la procdure
<i>procname</i> avec le service
.SM RPC.
Si une requte arrive pour le programme
<i>prognum ,</i>
de version
<i>versnum ,</i>
et pour la procdure
<i>procnum ,</i>
<i>procname</i> sera appele avec un pointeur vers ses paramtres d'entre.
<i>progname</i> doit renvoyer un pointeur vers ses rsultats statiques.
<i>inproc</i> est utilise pour dcoder les paramtres d'entre alors que
<i>outproc</i> sert  encode les rsultats.
Cette routine renvoie zro si l'enregistrement  russi, et -1
sinon.
.IP
Attention : les procdures enregistres de cette manire sont
accessibles avec le protocole de transport
.SM UDP/IP.
Voir
<b>svcudp_create()</b> <b></b>  pour ses restrictions.
<br/>
.if t .ne 5<br/><br/>
.ft B

<br/><br/>
 .5
struct rpc_createerr     rpc_createerr;


.ft R
.IP
Une variable globale dont la valeur est fixe par toute routine
.SM RPC
de cration de client
qui choue. Utilisez la routine
<b>clnt_pcreateerror()</b> <b></b>  pour afficher la raison de l'chec.
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
svc_destroy(xprt)
\s-1SVCXPRT\s0 *
xprt;


.ft R
.IP
Une macro qui dtruit le descripteur de transport
.SM RPC
<i>xprt .</i>
La destruction implique normalement la libration
de structures de donnes prives, y compris
<i>xprt</i> lui-mme. Le comportement est indfini si on essaye d'utiliser
<i>xprt</i> aprs avoir appel cette routine.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
fd_set svc_fdset;


.ft R
.IP
Une variable globale reprsentant le masque de bits
des descripteurs de fichier en lecture du ct serveur
.SM RPC.
Elle est utilisable avec
l'appel-systme
<b>select .</b>
Ce n'est intressant que si l'implmentation
d'un service n'appelle pas
<b>svc_run() ,</b>
mais assure son propre traitement d'vnements asynchrones.
Cette variable est en lecture seule (ne passez pas son adresse 
<b>select() </b> !),<b></b>
et elle peut changer aprs un appel
<b>svc_getreqset()</b> <b></b>  ou une routine de cration.
<br/>
.if t .ne 6<br/><br/>
.ft B

<br/><br/>
 .5
int svc_fds;


.ft R
.IP
Similaire 
<b>svc_fdset ,</b>
mais limite  32 descripteurs.
Cette interface est rendue obsolte par
<b>svc_fdset .</b>
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
svc_freeargs(xprt, inproc, in)
\s-1SVCXPRT\s0 *xprt;
xdrproc_t inproc;
char *in;


.ft R
.IP
Une macro qui libre toutes les donnes alloues par le systme
.SM RPC/XDR
lorsqu'il dcode les arguments d'une
procdure de service avec
<b>svc_getargs() .</b>
Cette routine renvoie 1 si les arguments ont t correctement
librs,
et zro sinon.
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
svc_getargs(xprt, inproc, in)
\s-1SVCXPRT\s0 *xprt;
xdrproc_t inproc;
char *in;


.ft R
.IP
Une macro qui dcode les arguments d'une requte
.SM RPC
associe avec
le descripteur
de transport
.SM RPC
<i>xprt .</i>
L'argument
<i>in</i> est l'adresse o les arguments seront stocks,
<i>inproc</i> est la routine
.SM XDR
pour dcoder les arguments.
Cette routine renvoie 1 si le dcodage russit, et zro
sinon.
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
struct sockaddr_in *
svc_getcaller(xprt)
\s-1SVCXPRT\s0 *xprt;


.ft R
.IP
La manire correcte d'obtenir l'adresse rseau de l'appelant
d'une procdure associe avec le descripteur 
de transport
.SM RPC
<i>xprt .</i>
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
svc_getreqset(rdfds)
fd_set *rdfds;


.ft R
.IP
Cette routine n'est intressante que si l'implmentation
d'un service n'appelle pas
<b>svc_run() ,</b>
mais emploie  la place un traitement personnalis des vnements asynchrones.
On l'invoque lorsque l'appel-systme
<b>select</b> <b></b>  a dtermin qu'une requte
.SM RPC
est arrive sur l'une des sockets RPC.
<i>rdfds</i> est le masque de bits des descripteurs de fichiers
en rsultant. La routine
revient lorsque toutes les sockets associes avec
les valeurs de
<i>rdfds</i> ont t servies.
<br/>
.if t .ne 6<br/><br/>
.ft B

<br/><br/>
 .5
svc_getreq(rdfds)
int rdfds;


.ft R
.IP
Similaire 
<b>svc_getreqset() ,</b>
mais limite  32 descripteurs. Cette interface est rendue obsolte par
<b>svc_getreqset() .</b>
<br/>
.if t .ne 17<br/><br/>
.ft B

<br/><br/>
 .5
svc_register(xprt, prognum, versnum, dispatch, protocol)
\s-1SVCXPRT\s0 *xprt;
u_long prognum, versnum;
void (*dispatch) ();
u_long protocol;


.ft R
.IP
Associer
<i>prognum</i> et
<i>versnum</i> avec la procdure de distribution
<i>dispatch .</i>
Si
<i>protocol</i> vaut zro, le service n'est pas enregistr avec le service
<b>portmap .</b>
Si
<i>protocol</i> est non-nul, alors l'association entre le triplet
[ prognum , versnum , protocol\fR]</i>
et
<b>\%xprt-&gt;xp_port</b>
est tablie par l'intermdiaire du service
<b>portmap</b> <b></b>  local (en gnral
<i>protocol</i> vaut zro,
.B
.SM IPPROTO_UDP
ou 
.B
.SM IPPROTO_TCP
).
La procdure
<i>dispatch</i> a la forme suivante
.RS 1i
.ft B

dispatch(request, xprt)
struct svc_req *request;
\s-1SVCXPRT\s0 *xprt;
.ft R



.IP
La routine
<b>svc_register()</b> <b></b>  renvoie 1 si elle russit et 0 sinon.
<br/>
.if t .ne 6<br/><br/>
.ft B

<br/><br/>
 .5
svc_run()


.ft R
.IP
Cette routine ne revient jamais. Elle attend l'arrive de requtes
.SM RPC
et appelle les procdures de service appropries
en utilisant
<b>svc_getreq() .</b>
Cette procdure est la plupart du temps en attente autour
d'un appel-systme
<b>select() .</b>
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
svc_sendreply(xprt, outproc, out)
\s-1SVCXPRT\s0 *xprt;
xdrproc_t outproc;
char *out;


.ft R
.IP
Appele par une routine de distribution de services
.SM RPC
pour envoyer le rsultat d'un appel de procdure
distante. L'argument
<i>xprt</i> est le descripteur de transport associ  la requte,
<i>outproc</i> est la routine
.SM XDR
utilise pour encoder les rsultats, et
<i>out</i> est l'adresse des rsultats.
Cette routine renvoie 1 si elle russit, et 0 sinon.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
void
svc_unregister(prognum, versnum)
u_long prognum, versnum;


.ft R
.IP
Supprimer toute association du doublet
[ prognum <i>, </i> versnum ]</i>
vers les routines de distribution, et du triplet
[ prognum <i>, </i> versnum <i>, </i> *\fR]</i>
vers le numro de port.
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
void
svcerr_auth(xprt, why)
\s-1SVCXPRT\s0 *xprt;
enum auth_stat why;


.ft R
.IP
Appele par une routine de distribution de service qui refuse
d'excuter un appel de procdure distante  cause d'une erreur d'authentification.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
void
svcerr_decode(xprt)
\s-1SVCXPRT\s0 *xprt;


.ft R
.IP
Appele par une routine de distribution de service qui n'arrive pas  dcoder
ses arguments. Voir aussi
<b>svc_getargs() .</b>
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
void
svcerr_noproc(xprt)
\s-1SVCXPRT\s0 *xprt;


.ft R
.IP
Appele par une routine de distribution de service qui n'implmente
pas le numro de procdure que l'appelant rclame.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
void
svcerr_noprog(xprt)
\s-1SVCXPRT\s0 *xprt;


.ft R
.IP
Appele quand le programme dsir n'est pas enregistr dans le service
.SM RPC.
L'implmentation d'un service n'a normalement pas besoin de cette routine.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
void
svcerr_progvers(xprt)
\s-1SVCXPRT\s0 *xprt;


.ft R
.IP
Appele quand le numro de version du programme dsir n'est pas enregistr
dans le service
.SM RPC.
L'implmentation d'un service n'a normalement pas besoin de cette routine.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
void
svcerr_systemerr(xprt)
\s-1SVCXPRT\s0 *xprt;


.ft R
.IP
Appele par une routine de distribution de service lorsqu'elle
dtecte une erreur systme
non couverte par un protocole.
Par exemple si un service ne peut plus allouer de place, il
peut appeler cette routine.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
void
svcerr_weakauth(xprt)
\s-1SVCXPRT\s0 *xprt;


.ft R
.IP
Appele par une routine de distribution de service qui refuse
d'excuter un appel de procdure distante  cause d'un manque
de paramtres d'authentification. La routine appelle
<b>svcerr_auth(xprt, \s-1AUTH_TOOWEAK\s0)</b> .</b>
<br/>
.if t .ne 11<br/><br/>
.ft B

<br/><br/>
 .5
\s-1SVCXPRT\s0 *
svcfd_create(fd, sendsize, recvsize)
int fd;
u_int sendsize;
u_int recvsize;


.ft R
.IP
Crer un service au-dessus de n'importe quel descripteur ouvert. 
Typiquement ces descripteurs sont des sockets 
pour un protocole connect
comme
.SM TCP\s0.
<i>sendsize</i> et
<i>recvsize</i> indiquent les tailles pour les buffers d'mission et de rception.
Si ces tailles valent zro, une valeur optimale est choisie.
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
\s-1SVCXPRT\s0 *
svcraw_create()


.ft R
.IP
Cette routine cre un simili transport de service
.SM RPC
vers lequel il renvoie un pointeur. 
Le transport
est en fait un buffer au sein de l'espace d'adressage du processus.
Le client
.SM RPC
correspondant doit donc rsider
dans le mme espace d'adresse.
Voir
<b>clntraw_create() .</b>
Cela permet de simuler une
.SM RPC
et de mesurer la surcharge des procdures
.SM RPC
comme les temps d'aller-retour sans interfrence
due au noyau. Cette routine renvoie
.SM NULL
si elle choue.
<br/>
.if t .ne 11<br/><br/>
.ft B

<br/><br/>
 .5
\s-1SVCXPRT\s0 *
svctcp_create(sock, send_buf_size, recv_buf_size)
int sock;
u_int send_buf_size, recv_buf_size;


.ft R
.IP
Cette routine cre un transport de service
.SM RPC
bas sur
.SM TCP/IP
sur lequel elle renvoie un pointeur. Il est associ avec la socket
<i>sock ,</i>
qui peut tre
<b>\s-1RPC_ANYSOCK\s0 ,</b>
auquel cas une nouvelle socket est cre.
Si la socket n'est pas associe  un port
.SM TCP
local, cette routine l'associe  un port quelconque.
Aprs russite,
<b>\%xprt-&gt;xp_sock</b>
est le descripteur de la socket de transport, et
<b>\%xprt-&gt;xp_port</b>
est le numro de port.
Cette routine renvoie
.SM NULL
si elle choue. Comme les
.SM RPC
base sur
.SM TCP
utilisent des entres-sorties avec buffer,
les utilisateurs peuvent fixer la taille des buffers. Une taille nulle
implique l'allocation automatique de buffers de tailles optimales.
<br/>
.if t .ne 11<br/><br/>
.ft B

<br/><br/>
 .5
\s-1SVCXPRT\s0 *
svcudp_bufcreate(sock, sendsize, recosize)
int sock;


.ft R
.IP
Cette routine cre un transport de service
.SM RPC
bas sur
.SM UDP/IP
et renvoie un pointeur dessus. Le transport est associ avec la socket
<i>sock ,</i>
qui peut tre
<b>\s-1RPC_ANYSOCK\s0 ,</b>
auquel cas une nouvelle socket est cre.
Si la socket n'est pas associe  un port
.SM UDP
local, cette routine l'associe  un port quelconque.
Aprs russite,
<b>\%xprt-&gt;xp_sock</b>
est le descripteur de transport, et
<b>\%xprt-&gt;xp_port</b>
est le numro de port.
Cette routine renvoie
.SM NULL
si elle choue.
.IP
Ceci permet  l'utilisateur de prciser la taille maximale d'un
paquet
.SM UDP
en mission ou en rception de messages
.SM RPC.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
\s-1SVCXPRT\s0 *
svcudp_create(sock)
int sock;


.ft R
.IP
Cet appel est quivalent 
<i>svcudp_bufcreate(sock,SZ,SZ)</i>
avec une taille <i>SZ</i> par dfaut.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_accepted_reply(xdrs, ar)
\s-1XDR\s0 *xdrs;
struct accepted_reply *ar;


.ft R
.IP
Utilise pour encoder les messages de rponse
.SM RPC.
Cette routine est utile pour les programmeurs qui
dsirent engendrer des messages de style
\s-1RPC\s0
sans employer le service
.SM RPC
complet.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_authunix_parms(xdrs, aupp)
\s-1XDR\s0 *xdrs;
struct authunix_parms *aupp;


.ft R
.IP
Utilise pour dcrire les identits
.SM UNIX.
Cette routine est utile pour les programmeurs
qui veulent engendrer ces identits sans utiliser le systme
.SM RPC
d'authentification.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
void
xdr_callhdr(xdrs, chdr)
\s-1XDR\s0 *xdrs;
struct rpc_msg *chdr;


.ft R
.IP
Utilise pour crer les enttes de message
.SM RPC.
Cette routine est utile pour les programmeurs qui
dsirent engendrer des messages de style
.SM RPC
sans employer le service
.SM RPC
complet.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_callmsg(xdrs, cmsg)
\s-1XDR\s0 *xdrs;
struct rpc_msg *cmsg;


.ft R
.IP
Utilise pour crer les messages d'appel
.SM RPC.
Cette routine est utile pour les programmeurs qui
dsirent engendrer des messages de style
.SM RPC
sans employer le service
.SM RPC
complet.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_opaque_auth(xdrs, ap)
\s-1XDR\s0 *xdrs;
struct opaque_auth *ap;


.ft R
.IP
Utilise pour crer les informations d'authentification
.SM RPC.
Cette routine est utile pour les programmeurs qui
dsirent engendrer des messages de style
.SM RPC
sans employer le service
.SM RPC
complet.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_pmap(xdrs, regs)
\s-1XDR\s0 *xdrs;
struct pmap *regs;


.ft R
.IP
Utilise pour crer les paramtres des divers procdures
<b>portmap .</b>
Cette routine est utile pour les programmeurs qui
dsirent crer ces paramtres sans utiliser
l'interface
<b>pmap .</b>
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_pmaplist(xdrs, rp)
\s-1XDR\s0 *xdrs;
struct pmaplist **rp;


.ft R
.IP
Utilise pour crer la liste des associations des ports.
Cette routine est utile pour les programmeurs qui
dsirent crer ces paramtres sans utiliser
l'interface
<b>pmap .</b>
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_rejected_reply(xdrs, rr)
\s-1XDR\s0 *xdrs;
struct rejected_reply *rr;


.ft R
.IP
Utilise pour crer les messages de rejet
.SM RPC.
Cette routine est utile pour les programmeurs qui
dsirent engendrer des messages de style
.SM RPC
sans employer le service
.SM RPC
complet.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
xdr_replymsg(xdrs, rmsg)
\s-1XDR\s0 *xdrs;
struct rpc_msg *rmsg;


.ft R
.IP
Utilise pour crer les messages de rponse
.SM RPC.
Cette routine est utile pour les programmeurs qui
dsirent engendrer des messages de style
.SM RPC
sans employer le service
.SM RPC
complet.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
void
xprt_register(xprt)
\s-1SVCXPRT\s0 *xprt;


.ft R
.IP
Aprs la cration d'un descripteur
.SM RPC
de transport, il doit tre
enregistr dans le service
.SM RPC.
Cette routine modifie
la variable globale
<b>svc_fds() .</b>
L'implmentation d'un service ne ncessite pas cette routine habituellement.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
void
xprt_unregister(xprt)
\s-1SVCXPRT\s0 *xprt;


.ft R
.IP
Avant qu'un descripteur
.SM RPC
de transport soit dtruit,
il doit se dsinscrire du service
.SM RPC.
Cette routine modifie
la variable globale
<b>svc_fds() .</b>
L'implmentation d'un service ne ncessite pas cette routine habituellement.
</div><br/><br /><h1 class="TitreSection0" id="L3">voir aussi</h1>
<div class="paragraph">
<b>rpc_secure (3N),</b>
<b>xdr (3N)</b>
<br/>
Les manuels suivants :
.RS
.ft I
Remote Procedure Calls: Protocol Specification
<br/>
Remote Procedure Call Programming Guide
<br/>
rpcgen Programming Guide
<br/>
.ft R

<i>\s-1RPC\s0: Remote Procedure Call Protocol Specification</i> ,</i>
.SM RFC1050, Sun Microsystems, Inc.,
.SM USC-ISI\s0.
</div><br/><br /><h1 class="TitreSection0" id="L4">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
