<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 2003 walter harms (walter.harms@informatik.uni-oldenburg.de) -->
<!--  Distributed under GPL -->
<!--  Modified 2003-04-04 Walter Harms -->
<!--  &lt;walter.harms@informatik.uni-oldenburg.de&gt; -->
<!--  -->
<!--  Slightly polished, aeb, 2003-04-06 -->
<!--  Traduction Christophe Blaess -->
<!--  MJ 21/07/2003 LDP-1.57 -->
<br/><h1>RTIME</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">exemple</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">bogues</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
rtime - Lire l'heure sur un serveur distant.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<br/><br/>

<b>#include</b> <b></b>  <b>&lt;rpc/des_crypt.h&gt;"</b> <b></b>  <br/><br/>

<b>int rtime(struct sockaddr_in *</b> addrp ,
<b>struct rpc_timeval *</b> timep ,
<b>struct rpc_timeval *</b> timeout );
<br/><br/>

</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette fonction utilise le protocole Time Serveur dcrit dans la
RFC 868 pour lire l'heure sur une machine distante.<br/><br/>
Le protocole Time Serveur donne l'heure en secondes coules depuis le 1er janvier
1900  minuit, et cette fonction soustrait la constante ncessaire pour convertir
le rsultat en secondes coules depuis l're Unix (01/01/1970  minuit).<br/><br/>
Si
<i>timeout</i> est non-NULL, le port UDP/time (37) est utilis, sinon
le port TCP/time (37) est utilis.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Si elle russit, cette fonction renvoie zro et la valeur 32-bits obtenue est
stocke dans
<i>timep-&gt;tv_sec .</i>
En cas d'chec, elle renvoie -1 et
<i>errno</i> contient le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
Toutes les erreurs pour les fonctions sous-jacentes(sendto, poll, recvfrom,
connect, read) peuvent se produite, avec en outre&nbsp;:
<br/><br/>

<b>ETIMEDOUT</b> <b></b>  Le dlai indiqu en second argument a expir.
<br/><br/>

<b>EIO</b> <b></b>  Le nombre d'octets reus n'est pas 4.
</div><br/><br /><h1 class="TitreSection0" id="L6">exemple</h1>
<div class="paragraph">
Cet exemple demande que le port 37 soit ouvert et actif. Vrifiez que
l'entre time dans
<i>/etc/inetd.conf</i> ne soit pas commente.
<br/>
Le programme se connecte sur un hte nomm 'linux'.
Utiliser 'localhost' ne fonctionne pas.
Le rsultat est l'heure locale de l'ordinateur 'linux'.
<br/><br/>
 

#include &lt;stdio.h&gt;
#include &lt;errno.h&gt;
#include &lt;string.h&gt;
#include &lt;time.h&gt;
#include &lt;rpc/auth_des.h&gt;
#include &lt;netdb.h&gt;<br/><br/>
int use_tcp = 0;
char *servername = "linux";<br/><br/>
int main() {
  struct sockaddr_in name;
  struct rpc_timeval time1 = {0,0};
  struct rpc_timeval timeout = {1,0};
  struct hostent *hent;
  int ret;<br/><br/>
  memset((char *)&name, 0, sizeof(name));
  sethostent(1);
  hent = gethostbyname(servername);
  memcpy((char *)&name.sin_addr, hent-&gt;h_addr, hent-&gt;h_length); <br/><br/>
  ret = rtime(&name, &time1, use_tcp ? NULL : &timeout);
  if (ret &lt; 0)
    perror("rtime error");
  else
    printf("%s", ctime((time_t *)&time1.tv_sec));<br/><br/>
  return 0;
}


</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
Seul IPV4 est support.<br/><br/>
Certaines versions de
<i>in.timed</i> supportent uniquement TCP. Essayez l'exemple prcdent avec
<i>use_tcp</i> fix  1.<br/><br/>
La libc5 utilise le prototype
<br/>
int rtime(struct sockaddr_in *, struct timeval *, struct timeval *);
<br/>
et requiert
<i>&lt;sys/time.h&gt;</i>  la place de
<i>&lt;rpc/auth_des.h&gt; .<br/><br/></i>
</div><br/><br /><h1 class="TitreSection0" id="L8">bogues</h1>
<div class="paragraph">
rtime() dans les GlibC &lt;= 2.2.5 ne fonctionne pas correctement
sur les machines 64-bits.
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>netdate (1),</b>
<b>ntpdate (1),</b>
<b>rdate (1),</b>
<b>inetd (8)</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
