<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  This man page is Copyright (C) 1999 Andi Kleen &lt;ak@muc.de&gt;. -->
<!--  Permission is granted to distribute possibly modified copies -->
<!--  of this page provided the header is included verbatim, -->
<!--  and in case of nontrivial modification author and date -->
<!--  of the modification is added to the header. -->
<!--  $Id: rtnetlink.3,v 1.2 1999/05/18 10:35:10 freitag Exp $ -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>RTNETLINK</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">exemple</a>
<br /><a class="summaryIndent0" href="#L4">bogues</a>
<br /><a class="summaryIndent0" href="#L5">voir aussi</a>
<br /><a class="summaryIndent0" href="#L6">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
rtnetlink - Macros manipulant des messages rtnetlink.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;asm/types.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;linux/netlink.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;linux/rtnetlink.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;<br/><br/></b> <b></b>  <b>rtnetlink_socket = socket(PF_NETLINK, int </b> socket_type <i>, NETLINK_ROUTE);</i>
<br/>
<b>int</b> <b></b>  <b>RTA_OK(struct</b> <b></b>  <b>rtattr</b> <b></b>  <b>*rta</b> <b></b> ,<b></b>  <b>int</b> <b></b>  <b>rtabuflen);</b> <b></b>  <b></b>  <br/>
<b>void</b> <b></b>  <b>*RTA_DATA(struct</b> <b></b>  <b>rtattr</b> <b></b>  <b>*rta);</b> <b></b>  <b></b>  <br/>
<b>unsigned</b> <b></b>  <b>int</b> <b></b>  <b>RTA_PAYLOAD(struct</b> <b></b>  <b>rtattr</b> <b></b>  <b>*rta);</b> <b></b>  <b></b>  <br/>
<b>struct</b> <b></b>  <b>rtattr</b> <b></b>  <b>*RTA_NEXT(struct</b> <b></b>  <b>rtattr</b> <b></b>  <b>*rta</b> <b></b> ,<b></b>  <b>unsigned</b> <b></b>  <b>int</b> <b></b>  <b>rtabuflen);</b> <b></b>  <br/>
<b>unsigned</b> <b></b>  <b>int</b> <b></b>  <b>RTA_LENGTH(unsigned</b> <b></b>  <b>int</b> <b></b>  <b>length);</b> <b></b>  <br/>
<b>unsigned</b> <b></b>  <b>int</b> <b></b>  <b>RTA_SPACE(unsigned</b> <b></b>  <b>int</b> <b></b>  <b>length);</b> <b></b>  <br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Tous les messages
<b>rtnetlink (7)</b>
consistent en un en-tte de message
<b>netlink (7)</b>
et des attributs. Ceux-ci ne devraient tre manipuls que par les macros
fournies ici.<br/><br/><br/><br/>
RTA_OK( rta <b>, </b> attrlen )
renvoie vrai si
<i>rta</i> pointe sur un attribut de routage valide;
<i>attrlen</i> est la longueur courante du tampon d'attributs. Si elle renvoie 0, vous
devez supposer qu'il n'y a pas d'autre attributs dans le message, mme si
<i>attrlen</i> n'est pas nulle.
<br/>
RTA_DATA( rta )
renvoie un pointeur sur le dbut des donnes de cet attribut.
<br/>
RTA_PAYLOAD( rta )
renvoie la longueur des donnes de cet attribut.
<br/>
RTA_NEXT( rta <b>, </b> attrlen )
renvoie le premier attribut aprs
<i>rta .</i>
Un appel  cet macro met  jour
<i>attrlen .</i>
Vous devriez utiliser
<b>RTA_OK</b> <b></b>  pour vrifier la validit du pointeur retourn.
<br/>
RTA_LENGTH( len )
renvoie la longueur requise pour
<i>len</i> octets de donnes plus l'en-tte.
<br/>
RTA_SPACE( len )
renvoie la quantite de mmoire ncessaire pour un message compos de
<i>len</i> octets de donnes.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">exemple</h1>
<div class="paragraph">
<!--  XXX would be better to use libnetlink here --><br/><br/>
Crer un message rtnetlink pour choisir le MTU d'un priphrique.

	struct {
	       struct nlmsghdr nh;
	       struct ifinfomsg   if;
	       char	       attrbuf[512];
	} req;
	struct rtattr *rta;
	unsigned int mtu = 1000; 
	int rtnetlink_sk = socket(PF_NETLINK, SOCK_DGRAM, NETLINK_ROUTE); <br/><br/>
	memset(&req, 0, sizeof(req));
	req.nh.nlmsg_len = NLMSG_LENGTH(sizeof(struct ifinfomsg)); 
	req.nh.nlmsg_flags = NLM_F_REQUEST; 
	req.nh.nlmsg_type = RTML_NEWLINK;
	req.if.ifi_family = AF_UNSPEC;
	req.if.ifi_index = INTERFACE_INDEX; 
	req.if.ifi_change = 0xffffffff; /* ???*/
	rta = (struct rtattr *)(((char *) &req) + 
			NLMSG_ALIGN(n-&gt;nlmsg_len));
	rta-&gt;rta_type = IFLA_MTU;
	rta-&gt;rta_len = sizeof(unsigned int);
	req.n.nlmsg_longueurr = NLMSG_ALIGN(req.n.nlmsg_len) + 
			RTA_LENGTH(sizeof(mtu)); 
	memcpy(RTA_DATA(rta), &mtu, sizeof (mtu));
	send(rtnetlink_sk, &req, req.n.nlmsg_len);

<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">bogues</h1>
<div class="paragraph">
Cette page de manuel est incomplte.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">voir aussi</h1>
<div class="paragraph">
<b>rtnetlink (7),</b>
<b>netlink (7),</b>
<b>netlink (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i></i>
<br/>
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
