<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<br/><h1>SEMAPHORES</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">annulation</a>
<br /><a class="summaryIndent0" href="#L4">signaux asynchrone</a>
<br /><a class="summaryIndent0" href="#L5">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L6">erreurs</a>
<br /><a class="summaryIndent0" href="#L7">auteur</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/>
<br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
sem_init, sem_wait, sem_trywait, sem_post, sem_getvalue, sem_destroy - oprations sur les smaphores.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;semaphore.h&gt;<br/><br/></b> <b></b>  <b>int sem_init(sem_t *</b> sem <i>, int </i> pshared <b>, unsigned int </b> valeur <i>);</i><br/><br/>
<b>int sem_wait(sem_t * </b> sem <i>);</i><br/><br/>
<b>int sem_trywait(sem_t * </b> sem <i>);</i><br/><br/>
<b>int sem_post(sem_t * </b> sem <i>);</i><br/><br/>
<b>int sem_getvalue(sem_t * </b> sem <i>, int * </i> sval <b>);</b><br/><br/>
<b>int sem_destroy(sem_t * </b> sem <i>);</i><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette page de manuel documente les smaphores du standard POSIX 1003.1b,  ne
pas confondre avec ceux des IPC Systme V tels que dcrits par
<b>ipc</b> (5),</b>
<b>semctl</b> (2)</b>
et 
<b>semop</b> (2).<br/><br/></b>
Les smaphores sont des compteurs pour les ressources partages par plusieurs
threads. Les oprations de base sur les smaphores sont :
.RS
<br/><br/>

incrmenter le compteur de manire atomique
<br/><br/>

attendre que le compteur soit non-nul et dcrmenter le compteur de manire atomique.
<br/><br/>
<b>sem_init"</b> <b></b>  initialise le smaphore point par
<i>sem</i> .</i>
Le compteur associ au smaphore est initialis 
<i>valeur</i> .</i>
L'argument
<i>pshared</i> indique si le smaphore est local au processus courrant (<i>pshared</i> est zro)
ou partag entre plusieurs processus (<i>pshared</i> n'est pas nulle).
LinuxThreads ne gre actuellement pas les smaphores partags entre plusieurs
processus, donc
<b>sem_init"</b> <b></b>  renvoie toujours l'erreur
<b>ENOSYS"</b> <b></b>  si 
<i>pshared</i> n'est pas nul.<br/><br/>
<b>sem_wait"</b> <b></b>  suspend le thread appelant jusqu' ce que le smaphore point par
<i>sem</i> ait un compteur non nul. Alors, le compteur du smaphore est atomiquement
dcrment.<br/><br/>
<b>sem_trywait"</b> <b></b>  est une variante non bloquante de
<b>sem_wait</b> .</b>
Si le smaphore point par 
<i>sem</i> a une valeur non nulle, le compteur est atomiquement dcrment et
<b>sem_trywait"</b> <b></b>  retourne immdiatement 0. Si le compteur du smaphore est zro,
<b>sem_trywait"</b> <b></b>  retourne immdiatement en indiquant l'erreur
<b>EAGAIN</b> .<br/><br/></b>
<b>sem_post"</b> <b></b>  incrmente atomiquement le compteur du smaphore point par
<i>sem</i> .</i>
Cetts fonction ne bloque jamais et peut tre utilise de manire fiable dans un
gestionnaire de signaux.<br/><br/>
<b>sem_getvalue"</b> <b></b>  sauvegarde  l'emplacement point par
<i>sval</i> la valeur courrante du compteur du smaphore 
<i>sem</i> .<br/><br/></i>
<b>sem_destroy"</b> <b></b>  dtruit un smaphore, librant toutes les ressources qu'il possdait. Aucun
thread ne doit tre bloqu sur ce smaphore quand
<b>sem_destroy"</b> <b></b>  est appele. Dans l'implmentation LinuxThreads, aucune ressource ne peut
tre associe  un smaphore, donc
<b>sem_destroy"</b> <b></b>  ne fait actuellement rien si ce n'est vrifier qu'aucun thread n'est
bloqu sur ce smaphore.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">annulation</h1>
<div class="paragraph"><br/><br/>
<b>sem_wait"</b> <b></b>  est un point d'annulation.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">signaux asynchrone</h1>
<div class="paragraph"><br/><br/>
Sur les processeurs proposant une opration test_et_change (Intel 486,
Pentium+, Alpha, PowerPC, MIPS II, Motorola 68k), la fonction
<b>sem_post"</b> <b></b>  est atomique en ce qui concerne le traitement ds signaux asynchrones. Elle peut
donc tre appele par un gestionnaire de signal. C'est la seule fonction de
synchronisation de threads dfinie par POSIX qui soit rentrante vis--vis des
signaux asynchrones.<br/><br/>
Sur les Intel 386 et les Sparc, l'implmentation courante de
<b>sem_post"</b> <b></b>  par LinuxThreads n'est pas atomique car le langage machine ne fournit pas
d'instructions atomiques. L'utilisation de sem_post dans un gestionnaire de
signal n'est donc pas fiable, deux signaux simultans pouvant amener 
n'enregistrer qu'une seule action.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">valeur renvoye</h1>
<div class="paragraph"><br/><br/>
Les fonctions
<b>sem_wait"</b> <b></b>  et 
<b>sem_getvalue"</b> <b></b>  renvoient toujours 0. Toutes les autres fonctions relatives aux smaphores
renvoient zro en cas de succs et -1 en cas d'erreur. Dans ce dernier cas, la
variable
<b>errno</b></b>
est positionn au code d'erreur correspondant.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">erreurs</h1>
<div class="paragraph"><br/><br/>
La fonction
<b>sem_init"</b> <b></b>  remplit
<b>errno"</b> <b></b>  avec l'un des codes d'erreur suivants&nbsp;:
.RS
<br/><br/>

<b>EINVAL"</b> <b></b>  <i>valeur</i> dpasse la valeur maximale du compteur.
<b>SEM_VALUE_MAX"</b> <b></b>  <br/><br/>

<b>ENOSYS"</b> <b></b>  <i>pshared</i> n'est pas zro.
<br/><br/>
La fonction
<b>sem_trywait"</b> <b></b>  remplit 
<b>errno"</b> <b></b>  avc l'un des codes d'erreur suivants&nbsp;:
.RS
<br/><br/>

<b>EAGAIN"</b> <b></b>  le compteur du smaphore vaut actuellement 0.
<br/><br/>
La fonction
<b>sem_post"</b> <b></b>  remplit 
<b>errno"</b> <b></b>  avec l'un des codes d'erreur suivants&nbsp;:
.RS
<br/><br/>

<b>ERANGE"</b> <b></b>  aprs l'incrmentation, la valeur du smaphore aurait dpass
<b>SEM_VALUE_MAX"</b> <b></b>  (Le compteur du smaphore n'est pas modifi dans ce cas)
<br/><br/>
La fonction
<b>sem_destroy"</b> <b></b>  remplit 
<b>errno"</b> <b></b>  avec l'un des codes d'erreur suivants&nbsp;:
.RS
<br/><br/>

<b>EBUSY"</b> <b></b>  certains threads sont actuellement bloqus en attente sur le smaphore.
<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">auteur</h1>
<div class="paragraph">
Xavier Leroy &lt;Xavier.Leroy@inria.fr&gt;<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>pthread_mutex_init</b> (3),</b>
<b>pthread_cond_init</b> (3),</b>
<b>pthread_cancel</b> (3),</b>
<b>ipc</b> (5).<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
<i>Thierry Vignaud &lt;</i> tvignaud@mandrakesoft.com <i>&gt;, 2000</i><br/><br/></i>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
