<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  (c) 1993 by Thomas Koenig (ig25@rz.uni-karlsruhe.de) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  License. -->
<!--  Modified Sat Jul 24 18:20:12 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 07/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise a jour 21/07/1997 -->
<!--  mj 14/12/1998 - LDP man-pages 1.21  -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>SETLOCALE</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">conformit</a>
<br /><a class="summaryIndent0" href="#L5">voir aussi</a>
<br /><a class="summaryIndent0" href="#L6">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
setlocale - Fixe la localisation courante.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;locale.h&gt;</b> <b></b>  <br/><br/>

<b>char *setlocale (int </b> categorie <i>, const char * </i> locale );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>setlocale()</b> <b></b>  est utilise pour indiquer ou demander la localisation courante du programme.
Si 
<i>locale</i> n'est pas
<b>NULL ,</b>
la localisation courante du programme est modifie en fonction des arguments.
L'argument
<i>categorie</i> dtermine quelle partie de la localisation sera concerne par la modification :
<br/><br/>

<b>LC_ALL</b> <b></b>  toute la localisation,
<br/><br/>

<b>LC_COLLATE</b> <b></b>  la mise en correspondance des expressions rationnelles (classes d'quivalence
et intervalles), et le classement des chanes de caractres,
<br/><br/>

<b>LC_CTYPE</b> <b></b>  la classification de caractre, et les routines de conversions.
<br/><br/>

<b>LC_MESSAGES</b> <b></b>  les messages en langue naturelle
<br/><br/>

<b>LC_MONETARY</b> <b></b>  l'affichage des valeurs montaires.
<br/><br/>

<b>LC_NUMERIC</b> <b></b>  le symbole dcimal (point, virgule, ...)
<br/><br/>

<b>LC_TIME</b> <b></b>  la forme de la date et l'heure.
L'argument
<i>locale</i> est un pointeur sur une chane de caractres contenant la configuration de la
<i>categorie .</i>
Une telle chane peut tre une constante bien connue, comme "C" ou "fr_FR"
(voir plus bas) ou une chane opaque renvoye par un autre appel prcdent
<b>setlocale .<br/><br/></b>
Si
<i>locale</i> est
<b></b><b></b><b></b> ,</b>
chaque partie de la localisation doit tre modifie en fonction des variables
d'environnement. Les dtails d'implmentation varient.
Pour la GlibC, d'abord
<!--  [This is false on my system - must check which library versions do this] -->
<!--  if -->
<!--  <i>category --></i> <!--  is LC_MESSAGES, the environment variable LANGUAGE is inspected, -->
<!--  then -->
(quelque soit la
<i>catgorie )</i>
la variable d'environnement LC_ALL est examine, puis la variable 
d'environnement avec le mme nom que la catgorie (LC_COLLATE, LC_CTYPE,
LC_MESSAGES, LC_MONETARY, LC_NUMERIC, LC_TIME) et finalement la variable
LANG.
La premire variable d'environnement existant est utilise. Si sa valeur
est n'est pas une spcification de localication valide, la localisation n'est
pas modifie, et
<b>setlocale</b> <b></b>  renvoie NULL.
<!--  The environment variable LANGUAGE may contain several, colon-separated, -->
<!--  locale names. --><br/><br/>
Les localisations
<b>""C"""</b> <b></b>  et
<b>"""POSIX"""</b> <b></b>  sont portables, leur partie LC_CTYPE correspond au jeu de caractres ASCII
7 bits.<br/><br/>
Un nom de localisation est typiquement de la forme
<i>langue </i>[_<i> territoire </i>][.<i> codeset </i>][@<i> modificateur </i>]<i>,</i>
o la 
<i>langue</i> est un code linguistique ISO 639, le
<i>territoire</i> un code de pays ISO 3166, et
<i>codeset</i> un jeu de caractres ou un identificateur d'encodage, comme
<b>ISO-8859-1"</b> <b></b>  ou
<b>UTF-8</b> .</b>
Pour voir une liste de toutes les localisations disponibles, essayez
"locale -a", cf.
<b>locale (1).<br/><br/></b>
Si 
<i>locale</i> est 
<b>NULL ,</b>
la localisation courante est consulte, mais pas modifie.<br/><br/>
Au dmarrage, la localisation portable
<b>""C"""</b> <b></b>  est slectionne par dfaut.
Un programme peut tre rendu portable en appelant
<b>setlocale(LC_ALL</b> <b></b> ,<b></b>  <b>""""")</b> <b></b>  lors de son initialisation, en utilisant les valeurs renvoyes par
<b>localeconv()</b> <b></b>  pour les valeurs dpendant de la localisation, en utilisation les fonctions
multioctets et caractres larges pour traiter les chaines si
<b>MB_CUR_MAX &gt; 1</b> ,</b>
et en utilisant
<b>strcoll() </b>, <b> wcscoll()</b>
ou
<b>strxfrm() </b>, <b> wcsxfrm()</b>
pour comparer les chanes de caractres.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Un appel reussi 
<b>setlocale()</b> <b></b>  renvoie une chaine correspondant  la localisation.
Cette chane peut tre alloue dans une zone statique.
La chaine est renvoye de telle manire qu'un appel ultrieur avec
cette chane et la catgorie associe restituera cette partie de
la localisation du processus. La valeur renovye est
<b>NULL</b> <b></b>  si la demande ne peut pas tre honore.
</div><br/><br /><h1 class="TitreSection0" id="L5">conformit</h1>
<div class="paragraph">
ANSI C, POSIX.1<br/><br/>
Linux (c'est  dire la libc) supporte les localisations portables
<b></b><b>C</b><b></b> <b> et </b> <b></b><b>POSIX</b><b></b> .</b>
Il y avait auparavant un support pour le Latin-1 europen
<b></b><b>ISO-8859-1</b><b></b> </b>
(par exemple dans la libc-4.5.21 et libc-4.6.27), ainsi que
et le
<b>""KOI-8"""</b> <b></b>  russe (plus prcisement "koi-8r" dans la libc-4.6.27).
Il suffisait alors d'initialiser la variable d'environnement
LC_TYPE=ISO-8859-1 pour que isprint() fonctionne correctement.
Dsormais les europens non-anglicistes doivent peiner un peu
plus pour installer les vritables fichiers de localisation.
</div><br/><br /><h1 class="TitreSection0" id="L6">voir aussi</h1>
<div class="paragraph">
<b>locale (1),</b>
<b>localedef (1),</b>
<b>strcoll (3),</b>
<b>isalpha (3),</b>
<b>localeconv (3),</b>
<b>strftime (3),</b>
<b>charsets (4),</b>
<b>locale (7)</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
