<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  -->
<!--  Copyright (C) 2002 Michael Kerrisk (mtk16@ext.canterbury.ac.nz) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.   -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction Christophe Blaess (ccb@club-internet.fr) -->
<!--  MJ 21/07/2003 LDP-1.57 -->
<br/><h1>SHM_OPEN</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
shm_open, shm_unlink - Crer/ouvrir et supprimer des objets de mmoire partags POSIX.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/types.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;sys/mman.h&gt;</b> <b></b>  <br/><br/>

<b>int shm_open(const char *</b> nom <i>, int </i> oflag <b>, mode_t </b> mode );
<br/><br/>

<b>int shm_unlink(const char *</b> nom );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>shm_open</b> <b></b>  cre et ouvre un nouvel objet de mmoire partag POSIX, ou ouvre un objet
existant. Il s'agit d'un descripteur utilisable par d'autres processus avec
<b>mmap (2)</b>
pour projeter la mme rgion mmoire. La fonction
<b>shm_unlink</b> <b></b>  ralise l'opration complmentaire
en supprimant l'objet cr prcdement par
<b>shm_open .<br/><br/></b>
Le fonctionnement de
<b>shm_open</b> <b></b>  est analogue  celui de
<b>open (2).</b>
On indique le
<i>nom</i> d'un segment mmoire  crer ou ouvrir.
Pour un fonctionnement portable, le
<i>nom</i> doit commencer par un slash (/) et ne pas en contenir d'autres.
<!--  The names used may or may not live in a file system, and may or may not -->
<!--  survive a reboot. Names starting with a slash are also visible to other -->
<!--  processes. Other names have implementation-defined effect. --><br/><br/>
<i>oflag</i> est un masque de bit associant l'une des deux constantes
<b>O_RDONLY</b> <b></b>  <b></b>  ou
<b>O_RWDR</b> <b></b>  et un ou plusieurs des attributs dcrits ci-aprs.
<br/><br/>
 
<b>O_RDONLY</b> <b></b>  Ouvrir l'objet en lecture seule. Un tel objet
ne pourra tre projet en mmoire avec
<b>mmap (2)</b>
qu'avec l'accs (<b>PROT_READ</b>).
<br/><br/>

<b>O_RDWR</b> <b></b>  Ouvrir l'objet en lecture et criture.
<br/><br/>

<b>O_CREAT</b> <b></b>  Crer l'objet de mmoire partage s'il n'existe pas. L'utilisateur et le groupe
propritaires de l'objet sont fixs comme avec l'appel
<b>open (2),</b>
et les bits de permission sont fixs en fonction des 9 bits de poids faible de
<i>mode ,</i>
hormis les bits qui sont fix dans
le masque de cration du processus (voir
<b>umask (2))</b>
et qui sont effacs.
Un jeu de constantes utilisables pour dfinir le
<i>mode</i> est dcrit dans
<b>open (2).</b>
<br/><br/>

Un nouvel objet de mmoire partag a une taille initiale nulle - on la
fixe en utilisant.
<b>ftruncate (2).</b>
Les octets d'un objet mmoire partag nouvellement cr
sont automatiquement initialiss  zro.
<br/><br/>
 
<b>O_EXCL</b> <b></b>  Si
<b>O_CREAT</b> <b></b>  tait prcis et si un objet de mmoire partage avec le mme
<i>nom</i> existait dj, renvoyer une erreur. La vrification et l'existence et
la cration ventuelle sont ralises de manire atomique.
<br/><br/>

<b>O_TRUNC</b> <b></b>  Si l'objet de mmoire partage existait, tronquer sa taille  zro.<br/><br/>
Si elle russit, la fonction
<b>shm_open</b> <b></b>  renvoie un nouveau descripteur dcrivant l'objet de mmoire partage.
Le descripteur est assur d'tre le plus petit numro disponible dans la table
des descripteurs du processus.  
L'attribut
<b>FD_CLOEXEC</b> <b></b>  (voir
<b>fcntl (2))</b>
sera activ sur le descripteur de fichier.<br/><br/>
Le descripteur est utilis normalement pour les appels ultrieurs
 
<b>ftruncate (2)</b>
(pour un objet nouvellement cr) et
<b>mmap (2).</b>
Aprs un appel 
<b>mmap (2)</b>
le descripteur peut tre ferm sans affecter la projection mmoire.<br/><br/>
Le fonctionnement
de 
<b>shm_unlink</b> <b></b>  est analogue  celui de
<b>unlink </b>(2) :<b></b>
il supprime le nom d'un objet de mmoire partage, et, une fois que tous les
processus ont supprim leur projection en mmoire, libre et dtruit
le contenu de la portion de mmoire.
Aprs un appel russi 
<b>shm_unlink ,</b>
les tentatives d'appeler
<b>shm_open</b> <b></b>  <b></b>  avec le mme 
<i>nom</i> choueront (sauf si
<b>O_CREAT</b> <b></b>  est spcifi, auquel cas un nouvel objet distinc est cr).
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
S'il russit, l'appel
<b>shm_open</b> <b></b>  renvoir un descripteur de fichier non-ngatif. S'il choue,
<b>shm_open</b> <b></b>  renvoie -1.
<b>shm_unlink</b> <b></b>  renvoie 0 s'il russit ou -1 en cas d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
Lors d'un chec,
<i>errno</i> indique la cause de l'erreur. Les codes possibles dans 
<i>errno</i> sont les suivants&nbsp;:
<br/><br/>

<b>EACCES</b> <b></b>  <b>shm_open</b> <b></b>  refus pour le
<i>nom</i> dans le
<i>mode</i>
indiqu, ou 
<b>O_TRUNC</b> <b></b>  a t rclam et l'appelant n'a pas les permissions d'criture sur l'objet.
<br/><br/>
 
<b>EACCES</b> <b></b>  Interdicton d'utiliser
<b>shm_unlink</b> <b></b>  sur l'objet de mmoire partage.
<br/><br/>
 
<b>EEXIST</b> <b></b>  <b>O_CREAT</b> <b></b>  et
<b>O_EXCL</b> <b></b>  <b></b>  taient rclams dans
<b>shm_open</b> <b></b>  et un objet de mmoire partage du mme
<i>nom</i> existait dj.
<br/><br/>

<b>EINVAL</b> <b></b>  L'argument
<i>nom</i> dans le 
<b>shm_open</b> <b></b>  tait invalide.
<br/><br/>

<b>EMFILE</b> <b></b>  Le provessus a dj ouvert son nombre maximal de fichiers.
<br/><br/>

<b>ENAMETOOLONG</b> <b></b>  La longueur du
<i>nom</i> dpasse 
<b>PATH_MAX .</b>
<br/><br/>

<b>ENFILE</b> <b></b>  La limite du nombre total de fichiers ouverts sur le systme a t
atteinte.
<br/><br/>

<b>ENOENT</b> <b></b>  Tentative d'ouvrir avec
<b>shm_open</b> <b></b>  un
<i>non </i> qui n'existe pas, sans
attribut
<b>O_CREAT .</b>
<br/><br/>

<b>ENOENT</b> <b></b>  Tentative d'utiliser
<b>shm_unlink</b> <b></b>  sur un 
<i>nom </i> qui n'existe pas.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Ces fonctions sont fournies depuis la GlibC 2.2. Les programmes qui les
invoquent doivent fournir l'argument
<b>-lrt</b> <b></b>  lors de la compilation avec
<b>cc</b> <b></b>  afin d'avoir l'dition des liens avec la bibliothque ncessaire (temps-rel).<br/><br/>
POSIX ne prcise pas le comportement de la combinaison
<b>O_RDONLY</b> <b></b>  et
<b>O_TRUNC .</b>
Sous Linux, la troncature aura lieu- cela
n'est pas ncessairement le cas sous d'autres Unix.<br/><br/>
L'implmentation sous Linux 2.4 des objets de mmoire partage POSIX utilise
un systme de fichiers ddis, mont en principe
sous
<b>/dev/shm .</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
POSIX 1003.1 (2001).
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>mmap (2),</b>
<b>open (2),</b>
<b>close (2),</b>
<b>ftruncate (2),</b>
<b>fstat (2),</b>
<b>fchown (2),</b>
<b>fchmod (2),</b>
<b>umask (2),</b>
<b>fcntl (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
