<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  From dholland@burgundy.eecs.harvard.edu Tue Mar 24 18:08:15 1998 -->
<!--  -->
<!--  This man page was written in 1998 by David A. Holland -->
<!--  and placed in the Public Domain. Polished a bit by aeb. -->
<!--  -->
<!--  Traduction 30/04/1998 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  (LDP-man-pages-1.19) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>STDIN</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">notes</a>
<br /><a class="summaryIndent0" href="#L4">conformit</a>
<br /><a class="summaryIndent0" href="#L5">voir aussi</a>
<br /><a class="summaryIndent0" href="#L6">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
stdin, stdout, stderr - Flux d'entres / sorties standards.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdio.h&gt;</b> <b></b>  <br/><br/>

<b>extern FILE *</b> stdin ;
<b>extern FILE *</b> stdout ;
<b>extern FILE *</b> stderr ;
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Normalement, tout programme Unix dmarre avec 3 flux dj ouverts, l'un
pour l'entre des donnes, un autre pour la sortie des donnes, et un
troisime pour l'affichage des messages de diagnostique ou d'erreur.
Ces trois flux sont typiquement attachs au terminal de l'utilisateur
(voir <b>tty</b>(4)), mais peuvent galement tre redirigs vers des
fichiers ou vers d'autres priphriques suivant les choix du processus
parent. (Voir le paragraphe "Redirection" dans <b>sh</b>(1)).<br/><br/>
Le flux d'entre est appel "entre standard" (standard input), le flux
de sortie, "sortie standard" (standard output), et le flux d'erreur est
souvent appel "erreur standard" (standard error).
Ces noms sont abrgs dans les dnominations symboliques de ces fichiers :
<i>stdin</i>, <i>stdout</i>, et <i>stderr</i>.<br/><br/>
Chacun des ces symboles est une macro de <b>stdio</b>(3) de type pointeur
sur un FILE, et peut tre utilis dans des fonctions comme
<b>fprintf</b>(3) ou <b>fread</b>(3).<br/><br/>
Comme les FILEs sont simplement des coquilles entourant les descripteurs
de fichiers en ajoutant une mmoire tampon, il est galement possible
d'accder aux fichiers Unix "bruts", avec des fonctions comme
<b>read</b>(2) ou <b>lseek</b>(2).
Les descripteurs des fichiers associs aux flux
<i>stdin</i>, <i>stdout</i>, et <i>stderr</i> sont respectivement
0, 1, et 2.
Les constantes symboliques STDIN_FILENO, STDOUT_FILENO, et STDERR_FILENO
sont dfinies avec ces valeurs dans &lt;unistd.h&gt;.<br/><br/>
Notez que l'utilisation conjointe des FILEs et des descripteurs bruts
risque de produire des rsultats inattendus, et doit tre gnralement
vite.
Pour les plus masochistes d'entre-vous, POSIX.1 dcrit en dtail, dans son
paragraphe 8.2.3, comment ces interactions sont censes fonctionner.<br/><br/>
Une rgle gnrale est que les descripteurs de fichiers sont manipuls
par le noyau, alors que <b>stdio</b> est simplement une bibliothque.
Ceci signifie par exemple qu'aprs un <b>exec</b>, le processus fils
hrite de tous les descripteurs de fichiers ouverts, mais que les flux
deviennent inaccessibles.<br/><br/>
Comme les symboles <i>stdin</i>, <i>stdout</i>, et <i>stderr</i>
sont dfinis comme des macros, il est interdit de leur assigner
une valeur.
On peut utiliser la fonction de bibliothque <b>freopen</b>(3)
pour rassigner les fluux standars de manire portable.<br/><br/>
Les flux standards sont ferms lors d'un appel  <b>exit</b>(3), ou
lors d'une fin normale de programme.
</div><br/><br /><h1 class="TitreSection0" id="L4">notes</h1>
<div class="paragraph">
Le flux
<b>stderr</b>
n'a pas de buffer. Le flux
<b>stdout</b>
a un buffer de ligne lorsqu'il est dirig vers un terminal. Les lignes
partielles n'apparatront pas avant que
<b>fflush</b>(3) ou <b>exit</b>(3) ne soient invoqus, ou qu'un
retour-chariot soit crit.<br/><br/>
Ceci a parfois des effets inattendus, principalement lors du debugging
des programmes. 
La gestion des buffers des flux standards (et des autres flux galement)
peut tre modifie en utilisant
<b>setbuf</b>(3) ou <b>setvbuf</b>(3).<br/><br/>
Remarquez que dans le cas o <i>stdin</i> est associ  un terminal,
il peut galement y avoir un buffer d'entre dans le pilote de terminal, 
sans aucune relation avec le buffer de stdio. En fait, normalement,
la saisie depuis un terminal est gre avec un buffer de ligne dans
le noyau. Cette gestion par le noyau peut tre configure en utilisant
des appels systmes comme <b>tcsetattr</b>(3). Voir galement <b>stty</b>(1)
ou <b>termios</b>(3).
</div><br/><br /><h1 class="TitreSection0" id="L5">conformit</h1>
<div class="paragraph">
Les macros <i>stdin</i>, <i>stdout</i>, et <i>stderr</i>
sont conformes au standard
<b>Ansi C</b> ,</b>
et celui-ci stipule galement que ces trois flux doivent tre
ouverts au dmarrage du programme.
</div><br/><br /><h1 class="TitreSection0" id="L6">voir aussi</h1>
<div class="paragraph">
<b>sh (1),</b>
<b>csh (1),</b>
<b>open (2),</b>
<b>fopen (3),</b>
<b>stdio (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1998-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
