<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 2001 Andries Brouwer &lt;aeb@cwi.nl&gt;. -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction 22/04/2002 par Stphan Rafin (stephan.rafin@laposte.net) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  -->
<br/><h1>STDIO_EXT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">voir aussi</a>
<br /><a class="summaryIndent0" href="#L4">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
__fbufsize, __flbf, __fpending, __fpurge, __freadable, __freading, __fsetlocking, __fwritable, __fwriting, _flushlbf - Interfaces pour la structure FILE (stdio)
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;stdio.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;stdio_ext.h&gt;</b> <b></b>  <br/><br/>

<b>size_t __fbufsize(FILE *</b> stream );
<br/>
<b>size_t __fpending(FILE *</b> stream );
<br/>
<b>int __flbf(FILE *</b> stream );
<br/>
<b>int __freadable(FILE *</b> stream );
<br/>
<b>int __fwritable(FILE *</b> stream );
<br/>
<b>int __freading(FILE *</b> stream );
<br/>
<b>int __fwriting(FILE *</b> stream );
<br/>
<b>int __fsetlocking(FILE *</b> stream <i>, int </i> type );
<br/>
<b>void _flushlbf(void);
<br/>
<b>void __fpurge(FILE *</b> stream );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Solaris a introduit des routines afin de permettre des accs portables
aux composants internes de la structure FILE. La glibc a galement implant
ces routines.<br/><br/>
La fonction
<b>__fbufsize()</b> <b></b>  renvoie la taille du tampon actuellement utilis par 
le flux considr.<br/><br/>
La fonction 
<b>__fpending()</b> <b></b>  renvoie le nombre d'octets du tampon de sortie.
Pour les flux orient caractres larges, l'unit est le
caractre large. Cette fonction n'est pas dfinie pour
les tampons en mode lecture, ou bien ouverts en lecture seule.<br/><br/>
La fonction 
<b>__flbf()</b> <b></b>  renvoie une valeur diffrente de zro si le flux a un buffer de ligne, 
sinon, elle renvoie zro.<br/><br/>
La fonction 
<b>__freadable()</b> <b></b>  renvoie une valeur diffrente de zro si le flux peut tre lu, 
sinon, elle renvoie zro.<br/><br/>
La fonction 
<b>__fwritable()</b> <b></b>  renvoie une valeur diffrente de zro si l'on peut crire dans le flux, 
sinon, elle renvoie zro.<br/><br/>
La fonction 
<b>__freading()</b> <b></b>  renvoie une valeur diffrente de zro si le flux est en lecture seule,
ou bien si la dernire opration sur le flux tait une lecture,
sinon, elle renvoie zro.<br/><br/>
La fonction 
<b>__fwriting()</b> <b></b>  renvoie une valeur diffrente de zro si le flux est en criture seule,
ou bien si la dernire opration sur le flux tait une criture,
sinon, elle renvoie zro.<br/><br/>
La fonction
<b>__fsetlocking()</b> <b></b>  peut tre utilise afin de slectionner le type de verrouillage 
souhait sur le flux.
Elle renvoie le type courant. Le paramtre 
<i>type</i> peut prendre les trois valeurs suivantes :
<br/><br/>

<b>FSETLOCKING_INTERNAL</b> <b></b>  ralise un verrouillage implicite sur toutes les oprations affectant 
le flux considr ( l'exception de fonctions nommes *_unlocked).
Il s'agit du comportement par dfaut.
<br/><br/>

<b>FSETLOCKING_BYCALLER</b> <b></b>  l'appelant prendra en charge le verrouillage (en utilisant 
potentiellement 
<b>flockfile (3)</b>
dans le cas o il y a plusieurs threads), et les routines d'entres
sorties standards n'effectueront plus aucun verrouillage jusqu'
ce que l'tat soit rtabli   FSETLOCKING_INTERNAL.
<br/><br/>

<b>FSETLOCKING_QUERY</b> <b></b>  ne change pas le type de verrouillage. (le renvoie seulement.)<br/><br/>
La fonction 
<b>_flushlbf()</b> <b></b>  vide tous les flux  buffer de ligne. (Sans doute de sorte que
la sortie d'un terminal soit crite. Par exemple, avant de lire une entre 
sur le clavier.)<br/><br/>
La fonction 
<b>__fpurge()</b> <b></b>  permet de se dbarrasser du contenu du tampon de flux.
</div><br/><br /><h1 class="TitreSection0" id="L4">voir aussi</h1>
<div class="paragraph">
<b>flockfile (3),</b>
<b>fpurge (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L5">traduction</h1>
<div class="paragraph">
Stphan Rafin, 2002.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
