<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 1996 Andries Brouwer (aeb@cwi.nl) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Rewritten old page, 960210, aeb@cwi.nl -->
<!--  -->
<!--  Traduction 10/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise  jour 11/07/2000 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>STRTOK</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">bogues</a>
<br /><a class="summaryIndent0" href="#L4">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
strtok, strtok_r - Extraire des mots d'une chane.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;string.h&gt;</b> <b></b>  <br/><br/>

<b>char *strtok (char *</b> s <i>, const char *</i> delim );
<br/><br/>

<b>char *strtok_r (char *</b> s <i>, const char *</i> delim <b>, char **</b> ptrptr);


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Un lment lexical (token) est une chane non vide de caractres qui
n'appartiennent
pas  la chane <i>delim</i>, suivie de \e0 ou d'un caractre appartenant
 <i>delim</i>.<br/><br/>
La fonction <b>strtok()</b> peut tre utilise pour scinder <i>s</i>
en lments lexicaux. Le premier appel  <b>strtok()</b> doit fournir <i>s</i>
comme premier argument. Les appels ultrieurs doivent fournir NULL
comme premier argument. Chaque appel renvoie un pointeur sur l'lment
lexical suivant, ou NULL quand il n'y en a plus.<br/><br/>
Si un token se termine par un dlimiteur, le caractre de dlimitation est
surcharg par un \e0 et un pointeur sur le caractre suivant est 
mmoris pour l'appel suivant  <b>strtok()</b>.
La chane de sparateurs <i>delim</i> peut tre diffrente  chaque appel.<br/><br/>
La fonction
<b>strtok_r ()</b>
est identique 
<b>strtok ()</b>
mais au lieu d'utiliser un buffer statique, elle emploie un pointeur sur
un buffer "char *" allou par l'utilisateur. Ce pointeur transmis comme
paramtre
<i>ptrptr</i> doit tre toujours le mme durant l'analyse d'une chane.
</div><br/><br /><h1 class="TitreSection0" id="L4">bogues</h1>
<div class="paragraph">
vitez au maximum d'utiliser cette fonction. Sinon, prenez note des informations
suivantes&nbsp;:<br/><br/>
.RS
Cette fonction modifie son premier argument.<br/><br/>
Les caractres de sparation sont surchargs, leur identit est donc perdue.<br/><br/>
Cette fonction ne doit pas tre invoque sur une chane constante.<br/><br/>
La fonction
<b>strtok ()</b>
utilise un buffer statique et n'est donc pas sre dans un contexte
multithread. Dans ce cas il vaut mieux utiliser
<b>strtok_r ().</b>
</div><br/><br /><h1 class="TitreSection0" id="L5">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>strtok()</b> renvoie un pointeur sur l'lment lexical suivant,
ou NULL s'il n'y en a plus.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
<br/><br/>

strtok ()
SVID 3, POSIX, BSD 4.3, ISO 9899
<br/><br/>

strtok_r ()
POSIX.1c
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>index (3),</b>
<b>memchr (3),</b>
<b>rindex (3),</b>
<b>strchr (3),</b>
<b>strpbrk (3),</b>
<b>strsep (3),</b>
<b>strspn (3),</b>
<b>strstr (3)<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
