<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sun Jul 25 10:53:39 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  Added correction due to nsd@bbc.com (Nick Duffek) - aeb, 950610 -->
<!--  -->
<!--  Traduction 10/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise  jour 26/10/1999 -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>STRTOL</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
strtol, strtoll, strtoq - Convertir une chane en un entier long.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdlib.h&gt;</b> <b></b>  <br/><br/>

<b>long int strtol (const char *</b> nptr <i>, char **</i> endptr <b>, int </b> base );
<br/><br/>

<b>long long int</b>
<b>strtoll(const char *</b> nptr <i>, char **</i> endptr <b>, int </b> base );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>strtol()</b> convertit la chane <i>nptr</i> en un entier
long en fonction de l'argument <i>base</i>, qui doit tre dans l'intervalle
2 a 36 (bornes comprises), ou avoir la valeur spciale 0.<br/><br/>
La chane peut commencer par un nombre quelconque d'espaces ou de 
caractres interprts comme tels par
<b>isspace (3) .</b>
Un signe ventuel `+' ou `-' peut suivre.
Si <i>base</i> vaut 0 ou 16, la chane peut inclure un prfixe
`0x' et le nombre sera interprt en base 16. Sinon, une <i>base</i>
valant zro est interprte comme 10 (dcimale) sauf si le caractre
suivant est `0', auquel cas la base est 8 (octale).<br/><br/>
Le reste de la chane est converti en une valeur entire longue, en
s'arrtant au premier caractre qui ne soit pas un chiffre valide.
Dans les bases suprieures a 10, la lettre `A' (majuscule ou minuscule)
reprsente 10, `B' represente 11, et ainsi de suite jusqu' `Z'
representant 35.<br/><br/>
Si <i>endptr</i> n'est pas NULL, <b>strtol()</b> stocke l'adresse du premier
caractre invalide dans <i>*endptr</i>.  S'il n'y avait aucun chiffre valide,
<b>strtol()</b> stocke la valeur originale de <i>nptr</i> dans
<i>*endptr</i> (et renvoie 0).
En particulier, si <i>*nptr</i> n'est pas `\\0' et si <i>**endptr</i>
vaut `\\0' en retour, la chane entire est valide.<br/><br/>
La fonction
<b>strtoll()</b> <b></b>  travaille comme
<b>strtol()</b> <b></b>  mais renvoie une valeur entire de type "long long".
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>strtol()</b> renvoie le rsultat de la conversion,  moins
qu'un dbordement superieur (overflow) ou infrieur (underflow) se produise.
Si un dpassement infrieur se produit, <b>strtol()</b> renvoie LONG_MIN.
Si un dpassement suprieur se produit, <b>strtol()</b> renvoie LONG_MAX.
Dans les deux cas, <i>errno</i> contient le code d'erreur ERANGE.
La mme chose est vraie pour
<b>strtoll ()</b>
avec LLONG_MIN et LLONG_MAX  la place de LONG_MIN et LONG_MAX.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>ERANGE</b> <b></b>  La chane n'tait pas dans l'intervalle acceptable, la valeur a t
arrondie.
<br/><br/>

<b>EINVAL</b> <b></b>  (pas dans C99)
La
<i>base</i> donne n'est pas supporte.<br/><br/>
L'implmentation peut aussi mettre <i>errno</i>  <b>EINVAL</b> si aucune
conversion n'a t ralise (pas de chiffres trouvs, et renvoy zro).
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Dans des localisations autre que "C", d'autres chanes peuvent tre
acceptes. (Par exemple, un signe sparateur de milliers peut tre
accept).<br/><br/>
BSD a aussi
<br/><br/>

.in +4n

<b>quad_t</b>
<b>strtoq(const char *</b> nptr <i>, char **</i> endptr <b>, int </b> base );
<br/><br/>

.in -4n


avec une dfinition exactement analogue. Suivant l'architecture, cela peut
tre quivalent 
<b>strtoll()</b> <b></b>  ou
<b>strtol() .</b>
</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
<b>strol() </b> :<b></b>
SVID 3, BSD 4.3, ISO 9899 (C99), POSIX.
<b>strtoll() </b> :<b></b>
ISO 9899 (C99) et POSIX-2001.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>atof (3), </b>
<b>atoi (3), </b>
<b>atol (3),</b>
<b>strtod (3), </b>
<b>strtoul (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
