<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 2002 Andries Brouwer &lt;aeb@cwi.nl&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 21/07/2003 LDP-1.57 -->
<br/><h1>TCGETPGRP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">historique</a>
<br /><a class="summaryIndent0" href="#L7">conformit</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
tcgetpgrp, tcsetpgrp - Lire/crire le processus d'avant-plan d'un terminal.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<br/><br/>

<b>#include &lt;unistd.h&gt;</b></b>
<br/><br/>

<b>pid_t tcgetpgrp(int </b> fd );
<br/><br/>

<b>int tcsetpgrp(int </b> fd <i>, pid_t </i> pgrp );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction
<b>tcgetpgrp()</b> <b></b>  renvoie l'ID du groupe de processus  l'avant-plan sur le terminal
associ
<i>fd ,</i>
qui doit tre le terminal de contrle du processus appelant.
<!--  The process itself may be a background process. --><br/><br/>
La fonction
<b>tcsetpgrp()</b> <b></b>  fait du groupe de procesus <i>pgrp</i> le groupe en avant-plan
sur le terminal associ 
<i>fd ,</i>
qui doit tre le terminal de contrle du processus appelant,
et tre toujours associ  sa session.
En outre, <i>pgrp</i> doit tre un groupe (non vide) de processus appartenant
 la mme session que le processus appelant.<br/><br/>
Si
<b>tcsetpgrp()</b> <b></b>  est appel par un membe d'un groupe de processus en arrire plan dans sa session,
et si le processus appelant ne bloque ni n'ignore SIGTTOU,
une signal SIGTTOU est envoy  tous les membre du groupe en arrire-plan.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Quand
<i>fd</i> identifie le terminal de contrle du processus appelant,
la fonction
<b>tcgetpgrp()</b> <b></b>  renverra l'ID du groupe de processus en avant-plan sur ce terminal s'il y en a,
et une valeur suprieure  1 autre qu'un ID de groupe de
processus existant sinon.
Si
<i>fd</i> ne correspon pas au terminal de contrle du processus,
-1 est renvoy et
<i>errno</i> est rempli.<br/><br/>
Lorqu'elle russit, la fonction
<b>tcsetpgrp()</b> <b></b>  renvoie 0. Sinon, elle renvoie -1, et remplit
<i>errno</i> avec le code d'erreur.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EBADF</b> <b></b>  <i>fd</i> n'est pas un descripteur valide.
<br/><br/>

<b>EINVAL</b> <b></b>  <i>pgrp</i> a une valeur illgale.
<br/><br/>

<b>EPERM</b> <b></b>  <i>pgrp</i> a une valeur lgale, mais ce n'est pas l'ID d'un groupe de processus
dans la mme session que le processus appelant.
<br/><br/>

<b>ENOTTY</b> <b></b>  Le processus appelant n'a pas de terminal de contrle, ou
il en a un mais ce n'est pas celui dcrit par
<i>fd ,</i>
ou, pour
<b>tcsetpgrp() ,</b>
ce terminal de contrle n'est plus associ avec la session du processus
appelant.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Ces fonctions sont implmentes via les ioctls TIOCGPGRP et
TIOCSPGRP.
</div><br/><br /><h1 class="TitreSection0" id="L7">historique</h1>
<div class="paragraph">
Les ioctls sont apparus dans 4.2 BSD. Ces fonctions sont des inventions POSIX.
</div><br/><br /><h1 class="TitreSection0" id="L8">conformit</h1>
<div class="paragraph">
POSIX.1
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>setpgid (2),</b>
<b>setsid (2)</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
