<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 17:47:26 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 10/11/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mj 25/10/02 - LDP 1.53 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>TEMPNAM</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">bogues</a>
<br /><a class="summaryIndent0" href="#L7">conformit</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
tempnam - Crer un nom de fichier temporaire.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdio.h&gt;</b> <b></b>  <br/><br/>

<b>char *tempnam (const char *</b> rep <i>, const char *</i> prfixe );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>tempnam()</b> renvoie un pointeur sur un nom de fichier
valide, en s'assurant qu'aucun fichier de ce nom n'existe au moment de
son invocation.
Le nom du fichier commencera par le
<i>prfixe</i> si celui-ci n'est pas nul et contient jusqu' cinq caractres.
Le chemin d'accs devant le nom du fichier sera obligatoirement "appropri"
(ce qui implique au minimum qu'on puisse y crire).
L'ordre de recherche du rpertoire pour placer 
le fichier est le suivant :
(i) le rpertoire indiqu par la variable d'environnement <i>TMPDIR</i>,
s'il est accessible en criture,
(ii) le rpertoire indiqu par l'argument <i>rep</i>, s'il n'est pas NULL,
(iii)le rpertoire dfini par <i>P_tmpdir</i> (dans
<i>&lt;stdio.h&gt; )</i>
(iv) finalement, un rpertoire dpendant de l'implmentation (<i>/tmp</i> par exemple).
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>tempnam()</b> renvoie un pointeur sur un nom de fichier
unique, ou NULL si ce nom n'a pas pu tre engendr.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>ENOMEM</b> <b></b>  Pas assez de mmoire libre.
<br/><br/>

<b>EEXIST</b> <b></b>  Impossible de crer un nom de fichier unique.
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
SUSv2 ne mentionne pas l'utilisation de TMPDIR, la GlibC ne l'emploiera que
si le programme n'est pas Set-UID.
SVID2 indique que le rpertoire pour le cas (iv) est 
<i>/tmp .</i>
SVID2 prcise que la chane renvoye par
<b>tempnam()</b> <b></b>  est alloue avec
<b>malloc (3)</b>
et doit donc tre libre avec
<b>free (3).<br/><br/></b>
La fonction
<b>tempnam()</b> <b></b>  cre une chane diffrente  chaque fois qu'elle est appele,
jusqu' TMP_MAX (dfinie dans
<i>&lt;stdio.h&gt; )</i>
fois. Si on l'appelle plus de TMP_MAX fois,
le comportement dpend de l'implmentation.<br/><br/>
Dans le cas o l'argument
<i>prfixe</i> est plus long que cinq caractres, la GlibC n'utilisera que
les cinq premiers octets.
En cas d'chec pour crer un nom de fichier inexistant, la GlibC renverra l'erreur EEXIST.
</div><br/><br /><h1 class="TitreSection0" id="L7">bogues</h1>
<div class="paragraph">
La signification prcise de "appropri" est indfinie, la dtermination des
conditions d'accessibilit  un rpertoire n'est pas spcifie.
N'utilisez pas cette fonction, utilisez
<b>mkstemp (3)</b>
 la place.
</div><br/><br /><h1 class="TitreSection0" id="L8">conformit</h1>
<div class="paragraph">
SVID 3, BSD 4.3
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>mktemp (3),</b>
<b>mkstemp (3),</b>
<b>tmpnam (3),</b>
<b>tmpfile (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
