<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 2001 Andries Brouwer &lt;aeb@cwi.nl&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction 20/05/2002 par Stphan Rafin (stephan.rafin@laposte.net) -->
<!--  -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>TIMEGM</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">notes</a>
<br /><a class="summaryIndent0" href="#L4">voir aussi</a>
<br /><a class="summaryIndent0" href="#L5">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
timegm, timelocal - Fonctions rciproques de gmtime and localtime.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;time.h&gt;</b> <b></b>  <br/><br/>

<b>time_t timelocal (struct tm *</b> tm );
<br/><br/>

<b>time_t timegm (struct tm *</b> tm );
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les fonctions 
<b>timelocal()</b> <b></b>  et
<b>timegm()</b> <b></b>  sont les rciproques de
<b>localtime (3)</b>
et
<b>gmtime (3).</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">notes</h1>
<div class="paragraph">
Ces fonctions sont des extensions GNU.
La fonction 
<b>timelocal()</b> <b></b>  est quivalente  la fonction standard POSIX
<b>mktime (3).</b>
Il n'y a aucune raison de l'utiliser.<br/><br/>
Afin d'obtenir une version portable de
<b>timegm() ,</b>
positionnez la variable d'environnement
<b>TZ</b> <b></b>   UTC, appelez
<b>mktime()</b> <b></b>  et restaurez la valeur de 
<b>TZ .</b>
Soit un code similaire  <br/><br/>
.RS

#include &lt;time.h&gt;
#include &lt;stdlib.h&gt;<br/><br/>
time_t my_timegm (struct tm *tm) {
    time_t ret;
    char *tz;<br/><br/>
    tz = getenv("TZ");
    setenv("TZ", "", 1);
    tzset();
    ret = mktime(tm);
    if (tz)
        setenv("TZ", tz, 1);
    else
        unsetenv("TZ");
    tzset();
    return ret;
}



</div><br/><br /><h1 class="TitreSection0" id="L5">voir aussi</h1>
<div class="paragraph">
<b>gmtime (3),</b>
<b>localtime (3),</b>
<b>mktime (3),</b>
<b>tzset (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">traduction</h1>
<div class="paragraph">
Stphan Rafin, 2002.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
