<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Hey Emacs! This file is -*- nroff -*- source. -->
<!--  Copyright 1995 by Jim Van Zandt &lt;jrv@vanzandt.mv.com&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one. -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  -->
<!--  Traduction 11/12/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise  jour 26/01/2002 - LDP-man-pages-1.47 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>TSEARCH</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">attention</a>
<br /><a class="summaryIndent0" href="#L5">exemple</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
tsearch, tfind, tdelete, twalk - Manipulation d'arbre binaire.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;search.h&gt;</b> <b></b>  <br/><br/>

<b>void *tsearch (const void *</b> key <i>, void **</i> rootp ,
<b>                int (*</b> compar <i>)(const void *, const void *));</i>
<br/><br/>

<b>void *tfind (const void *</b> key <i>, const void **</i> rootp ,
<b>                int (*</b> compar <i>)(const void *, const void *));</i>
<br/><br/>

<b>void *tdelete (const void *</b> key <i>, void **</i> rootp ,
<b>                int (*</b> compar <i>)(const void *, const void *));</i>
<br/><br/>

<b>void twalk (const void *</b> root <i>, void (*</i> action <b>) (const void *</b> nodep ,
<b>                                   const VISIT </b> which ,
<b>                                   const int </b> depth <i>));</i>
<br/><br/>

<b>#define</b> <b></b>  <b>_GNU_SOURCE</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;search.h&gt;</b> <b></b>  <br/><br/>

<b>void tdestroy (void *</b> root <i>, void (*</i> free_node <b>)(void *</b> nodep ));


 
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
<b>tsearch</b>, <b>tfind</b>, <b>twalk</b>, et <b>tdelete</b> permettent
de manipuler un arbre binaire. Ces fonctions implmentent une gnralisation
de l'algorithme T de Knuth (6.2.2).
Le premier membre de chaque noeud de l'arbre est un pointeur vers la donne
elle-mme (le programme appelant doit prendre en charge le stockage de
ces donnes). <i>compar</i> pointe sur une routine de comparaison prenant en
argument deux pointeurs sur ces donnes. Elle doit renvoyer un entier ngatif,
nul, ou positif suivant que le premier lment est infrieur, gal ou suprieur
au second.<br/><br/>
<b>tsearch</b> recherche un lment dans l'arbre.  <i>key</i> pointe sur l'lment
 chercher. Si l'arbre est vide, alors <i>rootp</i> doit pointer sur une variable
pointant sur <b>NULL</b>.
Si l'lment est trouv dans l'arbre, <b>tsearch</b> renvoie un pointeur sur celui-ci.
Sinon <b>tsearch</b> ajoute l'lment dans l'arbre et renvoie un pointeur sur lui.<br/><br/>
<b>tfind</b> fonctionne comme <b>tsearch</b>, sauf que si l'lment n'est pas trouv,
alors la fonction <b>tfind</b> renvoie <b>NULL</b>.<br/><br/>
<b>tdelete</b> supprime un lment de l'arbre. Ses arguments sont les mmes que
ceux de <b>tsearch</b>.  <br/><br/>
<b>twalk</b> excute un balayage en profondeur d'abord, de gauche  droite,
de l'arbre binaire. <i>root</i> pointe sur le noeud de dpart du balayage.
S'il ne s'agit pas de la vraie racine de l'arbre, seule une partie de celui-ci
sera balaye.
<b>twalk</b> appelle la fonction <i>action</i> chaque fois qu'un noeud est
rencontr (c'est  dire trois fois pour un noeud interne et une seule fois
pour une feuille de l'arbre).
<i>action</i>, doit accepter trois arguments.  Le premier est un pointeur sur
le noeud rencontr. Le second est un entier prenant l'une des valeurs suivantes :
<b>preorder</b>, <b>postorder</b>, et <b>endorder</b> suivant qu'il s'agisse de
la premire, deuxime ou troisime rencontre du noeud, ou encore <b>leaf</b>
s'il s'agit d'un noeud feuille.
(Ces symboles sont dfinis dans <i>&lt;search.h&gt;</i>.)
Le troisime argument est la profondeur du noeud dans l'arbre, zro correspondant
 la racine.<br/><br/>
(Plus gnralement, <b>preorder</b>, <b>postorder</b>, et <b>endorder</b>
sont vus comme <b>preorder</b>, <b>inorder</b>, et <b>postorder</b>:
avant de visiter le noeud fils, aprs le premier et avant le second, aprs avoir
visit les enfants. Ainsi, le choix du nom <b>post\%order</b>
est un peu droutant.)<br/><br/>
<b>tdestroy</b> supprime tous l'arbre point par <i>root</i>,
librant toutes les ressources alloues par la fonction <b>tsearch</b>. Pour
librer les donnes de chaque noeud, la fonction <i>free_node</i> est invoque.
Le pointeur sur les donnes est pass en argument  cette fonction. Si
aucune libration n'est ncessaire, <i>free_node</i> doit pointer vers une fonction
ne faisant rien.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
<b>tsearch</b> renvoie un pointeur sur un lment correspondant de l'arbre,
sur l'lment nouvellement ajout, ou <b>NULL</b> s'il n'y avait pas assez de mmoire
pour ajouter le noeud.
<b>tfind</b> renvoie un pointeur sur l'lment recherch ou <b>NULL</b> si aucune
correspondance n'a t trouve. Si plusieurs lments correspondent  la cl,
celui renvoy n'est pas spcifi.<br/><br/>
<b>tdelete</b> renvoie un pointeur sur le noeud pre de celui dtruit, ou
<b>NULL</b> si l'lment n'a pas t trouv.<br/><br/>
<b>tsearch</b>, <b>tfind</b>, et <b>tdelete</b> renvoient galement <b>NULL</b> si <i>rootp</i>
valait <b>NULL</b>.
</div><br/><br /><h1 class="TitreSection0" id="L5">attention</h1>
<div class="paragraph">
<b>twalk</b> utilise un pointeur sur la racine, alors que les autres fonctions utilisent
un pointeur sur une variable pointant sur la racine.<br/><br/>
Pour <b>twalk</b>, <b>postorder</b> signifie "aprs le sous-arbre de gauche, mais
avant le sous-arbre de droite". Certains prfreraient appeler ceci "inorder", et
rserver "postorder" pour indiquer "aprs les deux sous-arbres".<br/><br/>
<b>tdelete</b> libre la mmoire ncessaire au stockage du noeud dans l'arbre.
Le programme appelant est responsable de la libration de la mmoire occupe
par l'lment de donne correspondant.<br/><br/>
Le programme d'exemple s'appuie sur le fait que <b>twalk</b> ne fait plus jamais
rfrence  un noeud aprs avoir appel la fonction utilisateur avec
l'argument "endorder" ou "leaf".  Ceci fonctionne avec l'implmentation de la
bibliothque GNU, mais n'est pas spcifi sous SysV.
</div><br/><br /><h1 class="TitreSection0" id="L6">exemple</h1>
<div class="paragraph">
Le programme suivant insre douze nombres alatoires dans un arbre
binaire, o les doublons sont regroups, puis affiche les nombres classs.
<br/><br/>


    #include &lt;search.h&gt;
    #include &lt;stdlib.h&gt;
    #include &lt;stdio.h&gt;
    #include &lt;time.h&gt;
    
    void *root=NULL;
    
    void *xmalloc(unsigned n)
    {
      void *p;
      p = malloc(n);
      if(p) return p;
      fprintf(stderr, "pas assez de mmoire\\n");
      exit(1);
    }
    
    int compare(const void *pa, const void *pb)
    {
      if(*(int *)pa &lt; *(int *)pb) return -1;
      if(*(int *)pa &gt; *(int *)pb) return 1;
      return 0;
    }
    
    void action(const void *nodep, const VISIT which, const int depth)
    {
      int *datap;
      void *val;
    
      switch(which)
        {
        case preorder:
          break;
        case postorder:
          datap = *(int **)nodep;
          printf("%6d\\n", *datap);
          break;
        case endorder:
          break;
        case leaf:
          datap = *(int **)nodep;
          printf("%6d\\n", *datap);
          break;
        }
      return;
    }
    
    int main()
    {
      int i, *ptr;
      void *val;
    
      for (i = 0; i &lt; 12; i++)
        {
          ptr = (int *)xmalloc(sizeof(int));
          *ptr = rand()&0xff;
          val = tsearch((void *)ptr, &root, compare);
          if(val == NULL) exit(1);
        }
      twalk(root, action);
      return 0;
    }


</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
SVID.
La fonction
<b>tdestroy()</b> <b></b>  est une extension GNU.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>qsort (3),</b>
<b>bsearch (3),</b>
<b>hsearch (3),</b>
<b>lsearch (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
