<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) 2003 Andries Brouwer (aeb@cwi.nl) -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  The GNU General Public License's references to "object code" -->
<!--  and "executables" are to be interpreted as the output of any -->
<!--  document formatting or typesetting system, including -->
<!--  intermediate and printed output. -->
<!--  -->
<!--  This manual is distributed in the hope that it will be useful, -->
<!--  but WITHOUT ANY WARRANTY; without even the implied warranty of -->
<!--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the -->
<!--  GNU General Public License for more details. -->
<!--  -->
<!--  You should have received a copy of the GNU General Public -->
<!--  License along with this manual; if not, write to the Free -->
<!--  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, -->
<!--  USA. -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  30/07/2003 LDP-1.58 -->
<br/><h1>UALARM</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
ualarm - Programme un signal aprs un nombre donn de microsecondes.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

/* version BSD */
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;"</b> <b></b>  <br/><br/>

<b>unsigned int</b>
<br/>
<b>ualarm(unsigned int </b> usecs <i>, unsigned int </i> interval );
<br/><br/>

/* version SUSv2 */
<b>#define</b> <b></b>  <b>_XOPEN_SOURCE</b> <b></b>  <b>500"</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;"</b> <b></b>  <br/><br/>

<b>useconds_t ualarm(useconds_t </b> usecs <i>, useconds_t </i> interval );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>ualarm()</b> programme le signal SIGALRM pour qu'il soit
envoy au processus appelant aprs (au moins)
<i>usecs</i> micro-secondes.
Le dlai peut tre along lgrement par la charge systme, par le temps
pass  traiter l'appel-systme, ou par la granularit des
timers systme.<br/><br/>
 moins d'tre captur ou ignoe, ce signal terminera le processus.<br/><br/>
Si l'argument
<i>interval</i> est non-nul, d'autres signaux SIGALR seront envoys toutes les
<i>interval</i> micro-secondes aprs le premier.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
Cette fonction renvoie le nombre de micro-secondes restant de l'appel
prcdent, ou zro si aucune alarme n'est en attente.
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

EINTR
Interruption par un signal.
<br/><br/>

EINVAL
<i>usecs</i> ou <i>interval</i> est plus grand que 1000000 (1 seconde)
(sur les systmes qui considrent qu'il s'agit d'une erreur).
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
BSD 4.3.
BSD 4.3 et SUSv2 ne dfinissent pas d'erreurs.
</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
Le type
<b>useconds_t</b> <b></b>  est un entier non sign capable de contenir des entiers dans 
l'intervalle [0,1000000].
Ce type est dfini dans
<i>&lt;sys/types.h&gt;</i> inclu par
<i>&lt;unistd.h&gt;</i> mais GlibC ne le dfinit que si _XOPEN_SOURCE a une valeur suprieure ou
gale  500, ou si _XOPEN_SOURCE et _XOPEN_SOURCE_EXTENDED sont toutes deux
dfinies.
<!--  useconds_t also gives problems on HPUX 10. -->
Les programmes seront plus portables s'ils vitent d'utiliser ce type.<br/><br/>
Les interactions entre cette fonction et les autres temporisations
comme
<i>alarm (),</i>
<i>sleep (),</i>
<i>nanosleep (),</i>
<i>setitimer (),</i>
<i>timer_create (),</i>
<i>timer_delete (),</i>
<i>timer_getoverrun (),</i>
<i>timer_gettime (),</i>
<i>timer_settime (),</i>
<i>usleep ()</i>
n'est pas spcifie.<br/><br/>
Cette fonction est obsolte, utilisez
<b>nanosleep (2)</b>
ou
<b>setitimer (2)</b>
 sa place.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>alarm (2),</b>
<b>getitimer (2),</b>
<b>nanosleep (2),</b>
<b>select (2),</b>
<b>setitimer (2),</b>
<b>usleep (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
