<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 2001 Andries Brouwer &lt;aeb@cwi.nl&gt;. -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction 20/05/2002 par Stphan Rafin (stephan.rafin@laposte.net) -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  -->
<br/><h1>UNLOCKED_STDIO</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">conformit</a>
<br /><a class="summaryIndent0" href="#L4">voir aussi</a>
<br /><a class="summaryIndent0" href="#L5">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
*_unlocked - Fonctions stdio non bloquantes.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;stdio.h&gt;</b> <b></b>  <br/><br/>

<b>int getc_unlocked(FILE *</b> stream );
<b>int getchar_unlocked(void);</b>
<b>int putc_unlocked(int </b> c <i>, FILE *</i> stream );
<b>int putchar_unlocked(int </b> c );
<br/><br/>

<b>#define _BSD_SOURCE</b> <b> /* or _SVID_SOURCE or _GNU_SOURCE */</b>
<b>#include</b> <b></b>  <b>&lt;stdio.h&gt;</b> <b></b>  <br/><br/>

<b>void clearerr_unlocked(FILE *</b> stream );
<b>int feof_unlocked(FILE *</b> stream );
<b>int ferror_unlocked(FILE *</b> stream );
<b>int fileno_unlocked(FILE *</b> stream );
<b>int fflush_unlocked(FILE *</b> stream );
<b>int fgetc_unlocked(FILE *</b> stream );
<b>int fputc_unlocked(int </b> c <i>, FILE *</i> stream );
<b>size_t fread_unlocked(void *</b> ptr <i>, size_t </i> size <b>, size_t </b> n ,
<b>  FILE *</b> stream );
<b>size_t fwrite_unlocked(const void *</b> ptr <i>, size_t </i> size <b>, size_t </b> n ,
<b>  FILE *</b> stream );
<br/><br/>

<b>#define</b> <b></b>  <b>_GNU_SOURCE</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;stdio.h&gt;</b> <b></b>  <br/><br/>

<b>char *fgets_unlocked(char *</b> s <i>, int </i> n <b>, FILE *</b> stream );
<b>int fputs_unlocked(const char *</b> s <i>, FILE *</i> stream );
<br/><br/>

<b>#define</b> <b></b>  <b>_GNU_SOURCE</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;wchar.h&gt;</b> <b></b>  <br/><br/>

<b>wint_t getwc_unlocked(FILE *</b> stream );
<b>wint_t getwchar_unlocked(void);</b>
<b>wint_t fgetwc_unlocked(FILE *</b> stream );
<b>wint_t fputwc_unlocked(wchar_t </b> wc <i>, FILE *</i> stream );
<b>wint_t putwc_unlocked(wchar_t </b> wc <i>, FILE *</i> stream );
<b>wint_t putwchar_unlocked(wchar_t </b> wc );
<b>wchar_t *fgetws_unlocked(wchar_t *</b> ws <i>, int </i> n <b>, FILE *</b> stream );
<b>int fputws_unlocked(const wchar_t *</b> ws <i>, FILE *</i> stream );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Toutes ces fonctions se comportent de la mme faon que leurs homonymes sans
le suffixe `_unlocked', si ce n'est qu'elles n'utilisent pas de verrouillage
(elles ne positionnent pas les verrous elles-mmes, et ne testent pas la
prsence ventuelle de verrous positionns par les autres)
et ne sont donc pas adaptes  une contexte multi-threads
Voir
<b>flockfile (3).</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">conformit</h1>
<div class="paragraph">
Les quatre fonctions <i>getc_unlocked</i>(), <i>getchar_unlocked</i>(),
<i>putc_unlocked</i>(), <i>putchar_unlocked</i>() apparaissent dans POSIX.1.
Les variantes 
<b>*_unlocked()</b>
non standards sont prsentes sur quelques systmes Unix et sont disponibles 
dans les versions rcentes de la glibc.
<!--  E.g., in HPUX 10.0. In HPUX 10.30 they are called obsolescent, and -->
<!--  moved to a compatibility library. -->
<!--  Available in HPUX 10.0: clearerr_unlocked, fclose_unlocked, -->
<!--  feof_unlocked, ferror_unlocked, fflush_unlocked, fgets_unlocked, -->
<!--  fgetwc_unlocked, fgetws_unlocked, fileno_unlocked, fputs_unlocked, -->
<!--  fputwc_unlocked, fputws_unlocked, fread_unlocked, fseek_unlocked, -->
<!--  ftell_unlocked, fwrite_unlocked, getc_unlocked, getchar_unlocked, -->
<!--  getw_unlocked, getwc_unlocked, getwchar_unlocked, putc_unlocked, -->
<!--  putchar_unlocked, puts_unlocked, putws_unlocked, putw_unlocked, -->
<!--  putwc_unlocked, putwchar_unlocked, rewind_unlocked, setvbuf_unlocked, -->
<!--  ungetc_unlocked, ungetwc_unlocked. -->
Elles ne devraient sans doute pas tre utilises.
</div><br/><br /><h1 class="TitreSection0" id="L5">voir aussi</h1>
<div class="paragraph">
<b>flockfile (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">traduction</h1>
<div class="paragraph">
Stphan Rafin, 2002.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
