<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 David Metcalfe (david@prism.demon.co.uk) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  References consulted: -->
<!--      Linux libc source code -->
<!--      Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991) -->
<!--      386BSD man pages -->
<!--  Modified Sat Jul 24 17:43:05 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 11/12/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<!--  MJ 30/07/2003 LDP-1.58 -->
<br/><h1>USLEEP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">return value</a>
<br /><a class="summaryIndent0" href="#L4">erreurs</a>
<br /><a class="summaryIndent0" href="#L5">conformit</a>
<br /><a class="summaryIndent0" href="#L6">notes</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
usleep - Interrompre le programme durant un nombre donn de microsecondes.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

/* version BSD */
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;"</b> <b></b>  <br/><br/>

<b>void usleep (unsigned long </b> usec );
<br/><br/>

/* SUSv2 version */
<b>#define</b> <b></b>  <b>_XOPEN_SOURCE</b> <b></b>  <b>500"</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;unistd.h&gt;"</b> <b></b>  <br/><br/>

<b>int usleep(unsigned long </b> usec <i>);


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>usleep()</b> suspend l'excution du programme appelant durant
(au moins) <i>usec</i> microsecondes.  La priode de sommeil peut tre
allonge par la charge systme, par le temps pass  traiter l'appel de
fonction, ou par la granularit des temporisations systme.
</div><br/><br /><h1 class="TitreSection0" id="L4">return value</h1>
<div class="paragraph">
Aucune (BSD). En succs : zro, en erreur -1 (SUSv2).
</div><br/><br /><h1 class="TitreSection0" id="L5">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EINTR</b> <b></b>  Sommeil interrompu par un signal.
<br/><br/>

<b>EINVAL</b> <b></b>  <i>usec</i> est plus grand que 1.000.000 (sur les systmes o cela
reprsente une erreur.
</div><br/><br /><h1 class="TitreSection0" id="L6">conformit</h1>
<div class="paragraph">
BSD 4.3.
La version SUSv2 renvoie un int, et c'est galement le prototype de la
GlibC 2.2.2.
Seule l'erreur EINVAL est doncumente par SUSv2.
</div><br/><br /><h1 class="TitreSection0" id="L7">notes</h1>
<div class="paragraph">
Le type
<b>useconds_t</b> <b></b>  est un entier non-sign capable de contenir des entiers
dans l'intervalle [0,1000000]. Les programmes gagneront en portabiblit en
vitant de mentionner ce type explicitement. Utilisez
.RS 

.ta 8
<br/><br/>

#include &lt;unistd.h&gt;
...
        unsigned int usecs;
...
        usleep(usecs);
<br/><br/>
 

 
 
Ce type est dfini dans
<i>&lt;sys/types.h&gt;</i> inclus par
<i>&lt;unistd.h&gt;</i> mais la GlibC ne le dfinit que si _XOPEN_SOURCE a une valeur suprieure ou
gale  500, ou si _XOPEN_SOURCE et _XOPEN_SOURCE_EXTENDED sont dfinies.
<!--  useconds_t also gives problems on HPUX 10. --><br/><br/>
L'interaction entre cette fonction et SIGALRM, ou d'autres fonctions comme
<i>alarm (),</i>
<i>sleep (),</i>
<i>nanosleep (),</i>
<i>setitimer (),</i>
<i>timer_create (),</i>
<i>timer_delete (),</i>
<i>timer_getoverrun (),</i>
<i>timer_gettime (),</i>
<i>timer_settime (),</i>
<i>ualarm ()</i>
est indfinie.<br/><br/>
Cette fonction est obsolte. Utilisez
<b>nanosleep (2)</b>
ou
<b>setitimer (2)</b>
 la place.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>alarm (2), </b>
<b>getitimer (2), </b>
<b>nanosleep (2),</b>
<b>select (2),</b>
<b>setitimer (2), </b>
<b>sleep (3) </b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
