<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) Bruno Haible &lt;haible@clisp.cons.org&gt; -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  References consulted: -->
<!--    GNU glibc-2 source code and manual -->
<!--    Dinkumware C library reference http://www.dinkumware.com/ -->
<!--    OpenGroup's Single Unix specification http://www.UNIX-systems.org/online.html -->
<!--    ISO/IEC 9899:1999 -->
<!--  -->
<!--  Traduction 29/08/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.30 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>WCSTOK</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">valeur renvoye</a>
<br /><a class="summaryIndent0" href="#L4">notes</a>
<br /><a class="summaryIndent0" href="#L5">exemple</a>
<br /><a class="summaryIndent0" href="#L6">conformit</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
wcstok - Extraire des mots d'une chane de caractres larges.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;wchar.h&gt;</b> <b></b>  <br/><br/>

<b>wchar_t *wcstok (wchar_t *</b> wcs <i>, const wchar_t *</i> delim <b>, wchar_t **</b> ptr );


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La fonction <b>wcstok</b> est l'quivalent pour les caractres larges de la fonction <b>strtok</b>,
avec un argument supplmentaire permettant de l'employer dans un contexte multithreads.
On peut l'utiliser pour dcouper la chane de caractres larges <i>wcs</i> en lments syntaxiques (tokens),
dfinis comme des sous-chane ne contenant aucun caractre large contenu dans la chane <i>delim</i>.<br/><br/>
La recherche dmarre en <i>wcs</i>, si <i>wcs</i> n'est pas NULL, ou en <i>*ptr</i> si <i>wcs</i> est NULL.
D'abord tous les caractres larges dlimiteurs sont ignors, c'est  dire que le pointeur est plac au-del
de tous les caractres se trouvant dans <i>delim</i>.
Si la fin de la chane est atteinte, <b>wcstok</b> renvoie NULL pour indiquer qu'aucun mot n'a t trouv, et stocke 
dans <i>*ptr</i> une valeur qui forcera les ventuels appels suivants de <b>wcstok</b>  renvoyer NULL.
Sinon, la fonction considre avoir atteint le dbut d'un mot, et renvoie un pointeur dessus aprs l'avoir fait suivre
par un L'\\0' (en remplaant le premier caractre se trouvant dans <i>delim</i>). Elle met  jour le pointeur <i>*ptr</i> pour
qu'un nouvel appel de <b>wcstok</b> continue la recherche  la suite du mot trouv.
</div><br/><br /><h1 class="TitreSection0" id="L4">valeur renvoye</h1>
<div class="paragraph">
La fonction <b>wcstok</b> renvoie un pointeur sur le mot suivant, ou NULL si aucun mot n'a t trouv.
</div><br/><br /><h1 class="TitreSection0" id="L5">notes</h1>
<div class="paragraph">
La chane de caractres larges <i>wcs</i> originale est modifie de manire destructrice durant l'opration.
</div><br/><br /><h1 class="TitreSection0" id="L6">exemple</h1>
<div class="paragraph">
Le code suivant parcourt les mots contenus dans la chane de caractres larges.
<br/><br/>


wchar_t * wcs = ...;
wchar_t * token;
wchar_t * etat;
for (token = wcstok (wcs, " \\t\\n", & etat);
     token != NULL;
     token = wcstok (NULL, " \\t\\n", & etat)) {
  ...
}


</div><br/><br /><h1 class="TitreSection0" id="L7">conformit</h1>
<div class="paragraph">
ISO/ANSI C, UNIX98
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>strtok (3),</b>
<b>wcschr (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.<br/><br/>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
