<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  @(#)xdr.3n	2.2 88/08/03 4.0 RPCSRC; from 1.16 88/03/14 SMI -->
<!--  Traduction 04/09/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP 1.31 -->
<!--  MJ 21/07/2003 LDP-1.56 -->
<br/><h1>XDR</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis et description</a>
<br /><a class="summaryIndent0" href="#L2">voir aussi</a>
<br /><a class="summaryIndent0" href="#L3">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
xdr - Bibliothque de fonctions pour transmission externe de donnes.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis et description</h1>
<div class="paragraph"><br/><br/>
Ces routines permettent aux programmeurs C de dcrire des structures de donnes
arbitraires de manire indpendante de la machine.
Les donnes pour les appels de routines distantes (<b>RPC</b>) sont transmises
de cette manire.<br/><br/>
.ft B

<br/><br/>
 .5
xdr_array(xdrs, arrp, sizep, maxsize, elsize, elproc)
\s-1XDR\s0 *xdrs;
char **arrp;
u_int *sizep, maxsize, elsize;
xdrproc_t elproc;


.ft R
.IP
Une primitive de filtrage qui traduit les tables de longueur variable
en leur reprsentations externes correspondantes. Le 
paramtre
<i>arrp</i> est l'adresse d'un pointeur sur la chane, tandis que
<i>sizep</i> est l'adresse du nombre d'lments dans la table.
Ce nombre d'lments ne peut pas excder
<i>maxsize .</i>
Le paramtre 
<i>elsize</i> est la taille
( sizeof )</i>
de chaque lment de la table, et
<i>elproc</i> est un filtre
.SM XDR
de traduction entre la forme C des
lments de la table, et sa reprsentation
externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
xdr_bool(xdrs, bp)
\s-1XDR\s0 *xdrs;
bool_t *bp;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre les boolens 
(entiers C)
et leur reprsentation externe. Durant l'encodage des donnes, ce filtre
produit soit un 1 soit un 0.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
xdr_bytes(xdrs, sp, sizep, maxsize)
\s-1XDR\s0 *xdrs;
char **sp;
u_int *sizep, maxsize;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre des tables
caractres de longueurs donnes et leur reprsentation externe.
Le paramtre 
<i>sp</i> est l'adresse du pointeur sur la chane. La longueur de la chane
est situe  l'adresse
<i>sizep .</i>
Le chanes ne peuvent pas tre plus longues que
<i>maxsize .</i>
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_char(xdrs, cp)
\s-1XDR\s0 *xdrs;
char *cp;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre les caractres C
et leur reprsentation externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
Note: Les caractres encods ne sont pas accols, et occupent quatre octets chacun.
Pour les tables de caractres, il vaut mieux
se tourner vers
<b>xdr_bytes() ,</b>
<b>xdr_opaque()</b> <b></b>  ou
<b>xdr_string() .</b>
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
void
xdr_destroy(xdrs)
\s-1XDR\s0 *xdrs;


.ft R
.IP
Une macro invoquant la routine de destruction associe avec le flux
.SM XDR
<i>xdrs .</i>
La destruction entrane habituellement la libration de structures de donnes
prives associes avec le flux. Le comportement est indfini si on essaye d'utiliser
<i>xdrs</i> aprs avoir invoqu
<b>xdr_destroy ().</b>
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_double(xdrs, dp)
\s-1XDR\s0 *xdrs;
double *dp;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre
les nombres C en
<b>double</b> <b></b>  precision et leur reprsentation externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_enum(xdrs, ep)
\s-1XDR\s0 *xdrs;
enum_t *ep;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre les numrs C
<b>enum s</b>
(en ralit des entiers) et leur reprsentation externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
xdr_float(xdrs, fp)
\s-1XDR\s0 *xdrs;
float *fp;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre les nombres
<b>float s</b>
C et leur reprsentation externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
void
xdr_free(proc, objp)
xdrproc_t proc;
char *objp;


.ft R
.IP
Routine gnrique de libration. Le premier argument est la routine
.SM XDR
de l'objet  librer. Le second argument est un pointeur vers l'objet lui-mme.
Note : le pointeur transmis  cette routine n'est
<i>pas</i> libr, mais l'endroit o il pointe
<i>est</i> libr (rcursivement).
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
u_int
xdr_getpos(xdrs)
\s-1XDR\s0 *xdrs;


.ft R
.IP
Une macro invoquant la routine de lecture de position
associe avec le flux
.SM XDR
<i>xdrs .</i>
Cette fonction renvoie un entier non-sign, qui
indique la position dans le flux
.SM XDR .
Une fonctionnalit apprciable 
serait que l'arithmtique usuelle fonctionne avec ce nombre,
mais tous les flux
.SM XDR
ne le garantissent pas.
<br/>
.if t .ne 4<br/><br/>
.ft B

<br/><br/>
 .5
<br/>
long *
xdr_inline(xdrs, len)
\s-1XDR\s0 *xdrs;
int len;


.ft R
.IP
Une macro qui invoque la routine en-ligne associe avec le flux
.SM XDR
<i>xdrs .</i>
Cette routine renvoie un pointeur vers une portion
continue du buffer du flux.
<i>len</i> est la longueur en octets du buffer dsir 
Note: Le pointeur est converti en
<b>long *</b> .</b>
.IP
Attention :
<b>xdr_inline()</b> <b></b>  peut renvoyer
.SM NULL
(0)
si elle ne peut allouer une portion continue de buffer de la taille rclame.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_int(xdrs, ip)
\s-1XDR\s0 *xdrs;
int *ip;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre les entiers C
et leur reprsentation externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_long(xdrs, lp)
\s-1XDR\s0 *xdrs;
long *lp;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre les entiers
<b>long</b> <b></b>  C et leur reprsentation externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 12<br/><br/>
.ft B

<br/><br/>
 .5
void
xdrmem_create(xdrs, addr, size, op)
\s-1XDR\s0 *xdrs;
char *addr;
u_int size;
enum xdr_op op;


.ft R
.IP
Cette routine initialise l'objet flux
.SM XDR
point par
<i>xdrs .</i>
Les donnes du flux sont lues ou crites dans le bloc
mmoire situ en
<i>addr</i> et dont la longueur ne dpasse pas
<i>size</i> octets. L'argument
<i>op</i> dtermine la direction du flux
.SM XDR
( \s-1XDR_ENCODE\s0 ,</b>
<b>\s-1XDR_DECODE\s0 ,</b>
ou
<b>\s-1XDR_FREE\s0 ).</b>
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
xdr_opaque(xdrs, cp, cnt)
\s-1XDR\s0 *xdrs;
char *cp;
u_int cnt;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre
des donnes opaques de taille fixe
et leur reprsentation externe.
Le paramtre
<i>cp</i> est l'adresse de l'objet opaque, et
<i>cnt</i> est sa taille en octets.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
xdr_pointer(xdrs, objpp, objsize, xdrobj)
\s-1XDR\s0 *xdrs;
char **objpp;
u_int objsize;
xdrproc_t xdrobj;


.ft R
.IP
Comme
<b>xdr_reference()</b> <b></b>  sauf qu'elle met bout  bout les pointeurs
.SM NULL
alors que 
<b>xdr_reference()</b> <b></b>  ne le fait pas. Ainsi
<b>xdr_pointer()</b> <b></b>  peut reprsenter
des structures de donnes rcursives, comme les arbres binaires
ou les listes chanes.
<br/>
.if t .ne 15<br/><br/>
.ft B

<br/><br/>
 .5
void
xdrrec_create(xdrs, sendsize, recvsize, handle, readit, writeit)
\s-1XDR\s0 *xdrs;
u_int sendsize, recvsize;
char *handle;
int (*readit) (), (*writeit) ();


.ft R
.IP
Cette routine initialise le flux
.SM XDR
point par
<i>xdrs .</i>
Les donnes du flux sont crites dans un buffer de taille
<i>sendsize .</i>
Une valeur nulle indique que le systme choisira une taille adquate.
Les donnes du flux sont lues depuis un buffer de taille
<i>recvsize .</i>
De mme le systme choisira une taille adquate en transmettant une
valeur nulle.
Lorsque le buffer de sortie du flux est plein, la fonction
<i>writeit</i> est appel. Symtriquement, lorsque le buffer d'entre est vide, la fonction
<i>readit</i> est invoque. Le comportement de ces routines est similaire
aux deux
appels-systme
<b>read</b> <b></b>  et
<b>write ,</b>
sauf que le descripteur
<i>handle</i> est pass aux routines en tant que premier paramtres.
Note: L'attribut
<i>op</i> du flux
.SM XDR
doit tre fix par l'appelant.
.IP
Attention : ce flux
.SM XDR
implmente un flux d'enregistrement intermdiaire.
Il y a donc des octets supplmentaires dans le flux
afin de sparer les enregistrements.
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
xdrrec_endofrecord(xdrs, sendnow)
\s-1XDR\s0 *xdrs;
int sendnow;


.ft R
.IP
Cette routine ne peut tre invoque que
sur des flux cr par
<b>xdrrec_create() .</b>
Les donnes dans le buffer de sortie sont considres 
comme un enregistrement complet, 
et le buffer de sortie est ventuellement crit si
<i>sendnow</i> est non-nul. 
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
xdrrec_eof(xdrs)
\s-1XDR\s0 *xdrs;
int empty;


.ft R
.IP
Cette routine ne peut tre invoqu que sur
des flux crs par 
<b>xdrrec_create() .</b>
Aprs avoir rempli le reste de l'enregistrement avec les donnes du flux,
cette routine renvoie 1 si le flux n'a plus de donnes d'entre,
et 0 sinon.
<br/>
.if t .ne 3<br/><br/>
.ft B

<br/><br/>
 .5
xdrrec_skiprecord(xdrs)
\s-1XDR\s0 *xdrs;


.ft R
.IP
Cette routine ne peut tre invoqu que sur
des flux crs par 
<b>xdrrec_create() .</b>
Elle indique  l'implmentation
.SM XDR
que le reste de l'enregistrement en cours dans le 
buffer d'entre doit tre limin.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 11<br/><br/>
.ft B

<br/><br/>
 .5
xdr_reference(xdrs, pp, size, proc)
\s-1XDR\s0 *xdrs;
char **pp;
u_int size;
xdrproc_t proc;


.ft R
.IP
Une primitive qui gre les pointeurs sur les structures.
Le paramtre
<i>pp</i> est l'adresse du pointeur, 
<i>size</i> est la taille
( sizeof )</i>
de la structure pointe par
<i>*pp ,</i>
et
<i>proc</i> est la procdure
.SM XDR
qui filtre la structure entre sa forme C
et sa reprsentation externe.
Cette routine renvoie 1 si elle russit, et 0 sinon.
.IP
Attention : cette routine ne comprend pas les pointeurs
<b>NULL .</b>
Utilisez
<b>xdr_pointer()</b> <b></b>   sa place.
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
xdr_setpos(xdrs, pos)
\s-1XDR\s0 *xdrs;
u_int pos;


.ft R
.IP
Une macro qui invoque la routine de positionnement associe au flux
.SM XDR
<i>xdrs .</i>
Le paramtre
<i>pos</i> est une valeur de position obtenue avec
<b>xdr_getpos() .</b>
Cette routine renvoie 1 si le flux
.SM XDR
peut tre repositionn, et
zro sinon.
.IP
Attention : il est difficile de repositionner certains types de flux
.SM XDR
ce qui peut faire chouer cette routine avec certains
flux, et russir avec d'autres.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
xdr_short(xdrs, sp)
\s-1XDR\s0 *xdrs;
short *sp;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre les entiers
<b>short</b> <b></b>  et leur reprsentation externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
void
xdrstdio_create(xdrs, file, op)
\s-1XDR\s0 *xdrs;
\s-1FILE\s0 *file;
enum xdr_op op;


.ft R
.IP
Cette routine initialise l'objet flux
.SM XDR
point par
<i>xdrs .</i>
Les donnes du flux
.SM XDR
sont crites dans - ou lues depuis - le flux d'entre/sortie standard
<i>file .</i>
Le paramtre
<i>op</i> dtermine la direction du flux
.SM XDR
( \s-1XDR_ENCODE\s0 ,</b>
<b>\s-1XDR_DECODE\s0 ,</b>
ou
<b>\s-1XDR_FREE\s0 ).</b>
.IP
Attention : la routine de destruction associe avec un tel flux
.SM XDR
appelle
<b>fflush()</b> <b></b>  sur le flux
<i>file ,</i>
mais pas
<b>fclose() .</b>
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
xdr_string(xdrs, sp, maxsize)
\s-1XDR\s0
*xdrs;
char **sp;
u_int maxsize;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre
les chanes de caractres C
et leur reprsentation externe.
Les chane ne peuvent pas tre plus longues que
<i>maxsize .</i>
Note: 
<i>sp</i> est l'adresse du pointeur sur la chane.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 8<br/><br/>
.ft B

<br/><br/>
 .5
xdr_u_char(xdrs, ucp)
\s-1XDR\s0 *xdrs;
unsigned char *ucp;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre les caractres
<b>unsigned</b> <b></b>  du C et leur reprsentation externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 9<br/><br/>
.ft B

<br/><br/>
 .5
xdr_u_int(xdrs, up)
\s-1XDR\s0 *xdrs;
unsigned *up;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre les entiers
<b>unsigned</b> <b></b>  du C et leur reprsentation externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_u_long(xdrs, ulp)
\s-1XDR\s0 *xdrs;
unsigned long *ulp;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre les entiers
<b>unsigned</b> <b></b>  <b>long"</b> <b></b>  du C et leur reprsentation externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 7<br/><br/>
.ft B

<br/><br/>
 .5
xdr_u_short(xdrs, usp)
\s-1XDR\s0 *xdrs;
unsigned short *usp;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre les entiers
<b>unsigned</b> <b></b>  <b>short"</b> <b></b>  du C et leur reprsentation externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 16<br/><br/>
.ft B

<br/><br/>
 .5
xdr_union(xdrs, dscmp, unp, choices, dfault)
\s-1XDR\s0 *xdrs;
int *dscmp;
char *unp;
struct xdr_discrim *choices;
bool_t (*defaultarm) ();  /* may equal \s-1NULL\s0 */


.ft R
.IP
Une primitive de filtrage assurant la traduction entre une
<b>union</b> <b></b>  C avec discriminant et la reprsentation externe correspondante. Elle traduit
d'abord le discriminant de l'union, situ en
<i>dscmp .</i>
Le discriminant doit toujours tre du type
<b>enum_t .</b>
Ensuite, l'union situe en
<i>unp</i> est traduite. Le paramtre
<i>choices</i> est un pointeur sur une table de structures
<b>xdr_discrim() .</b>
Chaque structure contient une paire ordonne
[ valeur <i>, </i> procdure ].</i>
Si le discriminant de l'union est gal  une
<i>valeur ,</i>
alors la 
<i>procdure</i> associe est invoque pour traduire l'union. La fin de la table de structures
<b>xdr_discrim()</b> <b></b>  est indique par une routine de valeur
.SM NULL\s0.
Si le discriminant n'est pas trouv dans la table
<i>choices ,</i>
alors la procdure
<i>defaultarm</i> est invoque (si elle ne vaut pas
.SM NULL\s0).
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 6<br/><br/>
.ft B

<br/><br/>
 .5
xdr_vector(xdrs, arrp, size, elsize, elproc)
\s-1XDR\s0 *xdrs;
char *arrp;
u_int size, elsize;
xdrproc_t elproc;


.ft R
.IP
Une primitive de filtrage assurant la traduction entre
les tables de longueur fixe,
et leur reprsentation externe.
Le
paramtre
<i>arrp</i> est l'adresse du pointeur sur la table, tandis que
<i>size</i> est le nombre d'lments dans la table. Le paramtre
<i>elsize</i> est la taille
( sizeof )</i>
d'un lment de la table, et
<i>elproc</i> est un filtre
.SM XDR
assurant la traduction entre la forme C des
lments de la table et leur reprsentation
externe.
Cette routine renvoie 1 si elle russit, 0 sinon.
<br/>
.if t .ne 5<br/><br/>
.ft B

<br/><br/>
 .5
xdr_void()


.ft R
.IP
Cette routine renvoie toujours 1.
Elle peut tre passe aux routines
.SM RPC
qui ont besoin d'une fonction en argument alors
que rien ne doit tre fait.
<br/>
.if t .ne 10<br/><br/>
.ft B

<br/><br/>
 .5
xdr_wrapstring(xdrs, sp)
\s-1XDR\s0 *xdrs;
char **sp;


.ft R
.IP
Une primitive qui appelle
<b>xdr_string(xdrs</b> <b></b> ,<b></b>  <b>sp</b> <b></b> ,<b>1MAXUN.UNSIGNED);"</b> <b></b>  o
.B
.SM MAXUN.UNSIGNED
est la valeur maximale d'un entier non sign.
<b>xdr_wrapstring()</b> <b></b>  est pratique car la bibliothque
.SM RPC
passe un maximum de deux routines
.SM XDR
comme paramtres, et
<b>xdr_string() ,</b>
l'une des primitives les plus frquemment utilises en requiert trois.
Cette routine renvoie 1 si elle russit, 0 sinon.
</div><br/><br /><h1 class="TitreSection0" id="L3">voir aussi</h1>
<div class="paragraph">
<b>rpc (3N)<br/><br/></b>
Les manuels suivants :
.RS
.ft I
eXternal Data Representation Standard: Protocol Specification
<br/>
eXternal Data Representation: Sun Technical Notes
.ft R
<br/>
<i>\s-1XDR\s0: External Data Representation Standard</i> ,</i>
.SM RFC1014, Sun Microsystems, Inc.,
.SM USC-ISI\s0.
</div><br/><br /><h1 class="TitreSection0" id="L4">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
