<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  This manpage has been automatically generated by docbook2man  -->
<!--  from a DocBook document.  This tool can be found at: -->
<!--  &lt;http://shell.ipoline.com/~elmert/comp/docbook2X/&gt;  -->
<!--  Please send any bug reports, improvements, comments, patches,  -->
<!--  etc. to Steve Cheng &lt;steve@ggi-project.org&gt;. -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>"FUTEX"</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">smantique</a>
<br /><a class="summaryIndent0" href="#L4">notes</a>
<br /><a class="summaryIndent0" href="#L5">auteurs</a>
<br /><a class="summaryIndent0" href="#L6">versions</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
futex - Verrous rapide dans l'espace utilisateur.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph"><br/><br/>

#include &lt;linux/futex.h&gt;


</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph"><br/><br/>
Le noyau Linux propose des Futex (Fast Userpace muTex) en guise de blocs
de base pour des verrous et smaphores dans l'espace utilisateur. Ils sont trs
simples et servent  implmenter des abstration de plus haut niveau comme les mutex Posix.<br/><br/>
Cette page ne documente pas toutes les dcisions de conception mais se contente des informations
ncessaires pour le dveloppeur d'application ou de bibliothque. La plupart des programmeurs n'utiliseront jamais
les futex directement mais s'appuieront sur des bibliothques les utilisant, comme l'implmentation NPTL des threads.<br/><br/>
Un futex est identifi par une portion de mmoire qui peut tre partage entre processus. Dans chacun d'eux,
il peut avoir une adresse diffrente. Dans sa forme brute, un futex se comporte comme un smaphore&nbsp;;
il a un compteur que l'on incrmente et dcrmente atomiquement, et les
processus peuvent attendre que sa valeur soit positive.<br/><br/>
Les oprations sur les Futex se font entirement dans l'espace utilisateur lorsqu'il n'y a pas de conflits.
Le noyau n'est impliqu que pour arbitrer les conflits. Comme toute conception sense essayera d'viter les conflits,
les futex sont optimiss pour cette situation.<br/><br/>
Dans sa forme la plus simple, un futex est un entier align, manipul uniquement par des
oprations assembleur atomiques. Les processus peuvent les partager par des projection mmap ou des segments de mmoire
partage, ce qui correspond au cas des applications multi-threads.
</div><br/><br /><h1 class="TitreSection0" id="L4">smantique</h1>
<div class="paragraph"><br/><br/>
Toute opration sur les futex dbute dans l'espace utilisateur, mais il peut
tre ncessaire d'invoquer
le noyau avec l'appel-systme <b>futex</b>(2).<br/><br/>
Pour augmenter un futex, excutez l'opration assembleur qui permet au CPU
hte d'incrmenter atomiquement
un entier. Aprs, vrifiez s'il est pass de zro  un, auquel cas il n'y
avait pas d'attente et l'opration est termine. C'est le cas sans conflit,
rapide et courant.<br/><br/>
S'il y avait un blocage, l'incrmentation atomique part d'un compteur  -1
(ou une autre valeur ngative). Si c'est le cas, il y a des processus en attente.
Il faut  prsent mettre le compteur  1 et demander au noyau de rveiller
tous les processus en attente,  l'aide de l'opration FUTEX_WAKE.<br/><br/>
Attendre sur un futex pour le dcrmenter est l'opration inverse. Dcrmentez le compteur et
vrifiez s'il est descendu  zro, auquel cas l'opration est termine car le
futex tait libre.
Dans tous les autres cas, le processus doit mettre le compteur  -1 et demander au noyau d'attendre
qu'un autre processus libre le futex. Ceci est ralis avec l'opration FUTEX_WAIT.<br/><br/>
L'appel-systme futex peut aussi recevoir un dlai maximal d'attente pour que le futex
soit incrment. Dans ce cas la smantique est plus complexe et le programmeur doit se reporter 
<b>futex</b>(2) pour plus de dtail. Idem pour les attentes asynchrones.
</div><br/><br /><h1 class="TitreSection0" id="L5">notes</h1>
<div class="paragraph"><br/><br/>
Rpetons-le, les futex bruts ne sont pas conus pour tre utiliss facilement. Les implmenteurs
sont supposs connatre l'assembleur et avoir lu les sources de la bibliothque
futex en espace utilisateur dcrite plus bas.<br/><br/>
Cette page illustre l'utilisation la plus courante des primitives <b>futex</b>(2)&nbsp;: ce n'est pas la seule.
</div><br/><br /><h1 class="TitreSection0" id="L6">auteurs</h1>
<div class="paragraph"><br/><br/>
Les futex ont t conus et crits par Hubertus Franke (IBM Thomas J. Watson Research Center), 
Matthew Kirkwood, Ingo Molnar (Red Hat) et Rusty Russell (IBM Linux Technology Center). Cette page a t crite 
par bert hubert.
</div><br/><br /><h1 class="TitreSection0" id="L7">versions</h1>
<div class="paragraph"><br/><br/>
Le support initial des futex a t introduit dans Linux 2.5.7 avec une smantique diffrente de celle dcrite ci-dessus.
La smantique actuelle est disponible depuis Linux 2.5.40.
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph"><br/><br/>
<b>futex</b>(2),
`Fuss, Futexes and Furwocks: Fast Userlevel Locking in Linux' (proceedings of the Ottawa Linux 
Symposium 2002), 
futex example library, futex-*.tar.bz2 &lt;URL:ftp://ftp.kernel.org:/pub/linux/kernel/people/rusty/&gt;.
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
