<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (c) 1997 John S. Kallal (kallal@voicenet.com) -->
<!--  -->
<!--  This is free documentation; you can redistribute it and/or -->
<!--  modify it under the terms of the GNU General Public License as -->
<!--  published by the Free Software Foundation; either version 2 of -->
<!--  the License, or (at your option) any later version. -->
<!--  -->
<!--  Some changes by tytso and aeb. -->
<!--  -->
<!--  Traduction 14/09/1998 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP-man-pages-1.19 -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<!--  MJ 27/08/2003 LDP-1.60 -->
<br/><h1>RANDOM</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">description</a>
<br /><a class="summaryIndent0" href="#L2">configuration</a>
<br /><a class="summaryIndent0" href="#L3">fichiers</a>
<br /><a class="summaryIndent0" href="#L4">auteur</a>
<br /><a class="summaryIndent0" href="#L5">voir aussi</a>
<br /><a class="summaryIndent0" href="#L6">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
random, urandom - Priphriques gnrateurs alatoires du noyau.
</div><br/><br /><h1 class="TitreSection0" id="L2">description</h1>
<div class="paragraph">
Les fichiers spciaux caractres <b>/dev/random</b> et <b>/dev/urandom</b>
(existants depuis Linux 1.3.30) fournissent une interface avec le gnrateur
de nombres alatoires du noyau.<br/><br/>
Le fichier <b>/dev/random</b> a un numro de priphrique majeur gal  1, et
un numro mineur gal  8. Les numros du priphrique <b>/dev/urandom</b> 
sont 1 pour le majeur, et 9 pour le mineur.<br/><br/>
Le gnrateur de nombres alatoires regroupe du bruit provenant de son
environnement par l'intermdiaire des pilotes de priphriques et d'autres
sources, et le stocke dans un rservoir d'entropie.
Le gnrateur mmorise galement une estimation du nombre de bits de bruit
dans son rservoir d'entropie, et utilise son contenu pour crer des nombres
alatoires.<br/><br/> 
Lors d'une lecture, le priphrique <b>/dev/random</b> sera limit au nombre de
bits de bruit contenus dans le rservoir d'entropie.<br/><br/>
<b>/dev/random</b> est particulirement adapt pour des cas o l'on a ponctuellement
besoin de nombres hautement alatoires (cration de cls par exemple).
Lorsque le rservoir d'entropie est vide, les lectures depuis le priphrique
<b>/dev/random</b> seront bloquantes jusqu' l'obtention de suffisamment de bruits
en provenance de l'environnement.<br/><br/> 
Lors d'une lecture, <b>/dev/urandom</b> renverra autant d'octets qu'on en demande.
Toutefois, s'il n'y a plus assez de bits disponibles dans le rservoir d'entropie,
les valeurs renvoyes pourraient tre thoriquement vulnrables  une cryptanalyse
base sur l'algorithme employ par le pilote.
Il n'existe pas de documentation sur ce type d'attaque dans la littrature publique
actuelle, mais cela n'limine pas le risque thorique.
Si ce risque est important pour votre application, utilisez plutt <b>/dev/random</b>
 la place.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">configuration</h1>
<div class="paragraph">
Si votre systme ne dispose pas des fichiers <b>/dev/random</b> et <b>/dev/urandom</b>
vous pouvez les crer avec les commandes suivantes :<br/><br/>

        mknod -m 644 /dev/random c 1 8
        mknod -m 644 /dev/urandom c 1 9
        chown root:root /dev/random /dev/urandom

<br/><br/>
Lorsqu'un systme Linux dmarre sans interaction avec un oprateur humain,
le rservoir d'entropie peut se trouver dans un tat relativement prdictible. 
La vritable quantit de bruit dans le rservoir d'entropie est donc en-dessous
de son estimation. Afin de contrer ce problme, il est utile de sauvegarder
l'tat du rservoir entropique lors des arrts et redmarrages du systme.
Il est possible ainsi d'ajouter les lignes suivantes dans les scripts 
de dmarrage appropris :<br/><br/>

	echo "Initialisation du gnrateur de nombre alatoires"
	# Initialiser le gnrateur de nombre alatoire avec une racine
	# mmorise lors du dernier arrt (ou redmarrage) du systme
	# On charge jusqu' 512 octets (taille du rservoir d'entropie).
 	if [ -f /var/random-seed ]; then
		cat /var/random-seed &gt;/dev/urandom
 	fi
	dd if=/dev/urandom of=/var/random-seed count=1

<br/><br/>
galement, il faut ajouter les lignes suivantes dans un script excut
lors de l'arrt du systme.
 

	# Sauver une racine alatoire pour pouvoir redmarrer le
	# gnrateur au prochain boot. On sauve 512 octets.
 	echo "Sauvegarde de la racine du gnrateur alatoire..."
 	dd if=/dev/urandom of=/var/random-seed count=1


</div><br/><br /><h1 class="TitreSection0" id="L4">fichiers</h1>
<div class="paragraph">
/dev/random
<br/>
/dev/urandom
</div><br/><br /><h1 class="TitreSection0" id="L5">auteur</h1>
<div class="paragraph">
Le gnrateur de nombre alatoires du noyau a t crit par
Theodore Ts'o (tytso@athena.mit.edu).
</div><br/><br /><h1 class="TitreSection0" id="L6">voir aussi</h1>
<div class="paragraph">
mknod (1)
<br/>
RFC 1750, "Randomness Recommendations for Security"
</div><br/><br /><h1 class="TitreSection0" id="L7">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1998-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
