<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 2002 Walter Harms (walter.harms@informatik.uni-oldenburg.de) -->
<!--  Distributed under GPL -->
<!--  Traduction Christophe Blaess, &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>complex</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">exemple</a>
<br /><a class="summaryIndent0" href="#L4">voir aussi</a>
<br /><a class="summaryIndent0" href="#L5">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
complex - Base des mathmatiques complexes.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;complex.h&gt;</b> <b></b>  </div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les nombres complexes sont des nombres de la forme a+i*b, o a et b sont
des rels et i est la racine carre de -1, ainsi i*i=-1.
<br/>
Il y a d'autres manires de reprsenter ce nombre. Comme le point z=(a,b)
est sur un plan, vous pouvez aussi dcrire ce point avec une distance et un
angle (r, phi). Le nombre z=r*(cos(phi)+i*sin(phi)) peut aussi tre crit
sous forme exponentielle z=r*exp(i*phi) comme l'a montr Euler.<br/><br/>
Les oprations de base dfinies pour z = a+i*b et w = c+i*d ainsi&nbsp;:
<br/><br/>

<b>addition:</b> <b></b>  <b>z+w</b> <b></b>  <b>=</b> <b></b>  <b>(a+c)</b> <b></b>  <b>+</b> <b></b>  <b>(b+d)*i</b> <b></b>  <br/><br/>

<b>multiplication:</b> <b></b>  <b>z*w</b> <b></b>  <b>=</b> <b></b>  <b>(a*c</b> <b></b>  <b>-</b> <b></b>  <b>b*d)</b> <b></b>  <b>+</b> <b></b>  <b>(a*d</b> <b></b>  <b>+</b> <b></b>  <b>b*c)*i</b> <b></b>  <br/><br/>

<b>division:</b> <b></b>  <b>z/w</b> <b></b>  <b>=</b> <b></b>  <b>((a*c</b> <b></b>  <b>+</b> <b></b>  <b>b*d)/(c*c</b> <b></b>  <b>+</b> <b></b>  <b>d*d))</b> <b></b>  <b>+</b> <b></b>  <b>((b*c</b> <b></b>  <b>-</b> <b></b>  <b>a*d)/(c*c</b> <b></b>  <b>+</b> <b></b>  <b>d*d))*i<br/><br/></b> <b></b>  Presque toutes les fonctions mathmatiques ont un quivalent sous
forme de fonctions complexes.
</div><br/><br /><h1 class="TitreSection0" id="L4">exemple</h1>
<div class="paragraph">
Le compilateur C peut travailler avec les nombres complexes s'il supporte
le C99. Il faut faire l'dition des liens avec -lm. L'unit imaginaire
pure est reprsente par I.
<br/><br/>


/* vrifions que (i*pi) == -1 */
#include &lt;math.h&gt;	/* pour atan */
#include &lt;complex.h&gt;
int main() 
{
	double pi = 4*atan(1);
	complex z = cexp(I*pi);
	printf("%f+%f*i\\n", creal(z), cimag(z));
	return (0);
}


</div><br/><br /><h1 class="TitreSection0" id="L5">voir aussi</h1>
<div class="paragraph">
<b>cabs (3),</b>
<b>carg (3),</b>
<b>cexp (3),</b>
<b>cimag (3),</b>
<b>creal (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
