<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright 1993 Giorgio Ciucci (giorgio@crcc.it) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction 18/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>IPC</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">voir aussi</a>
<br /><a class="summaryIndent0" href="#L4">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
ipc - Mcanisme Systme V de communication entre processus.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

.B
# include &lt;sys/types.h&gt;
.B
# include &lt;sys/ipc.h&gt;
.B
# include &lt;sys/msg.h&gt;
.B
# include &lt;sys/sem.h&gt;
.B
# include &lt;sys/shm.h&gt;
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette page de manuel documente l'implmentation sous Linux des
mcanismes Systme V de communication entre processus&nbsp;:
les files de messages, les ensembles de smaphores, et les
segments de mmoire partage.
Par la suite, le mot
<b>ressource</b> <b></b>  se rapportera  l'un de ces mcanismes.
</div><br/><h2 class="TitreSection1" id="L6">Autorisations d'accs aux ressources.</h2>
<div class="paragraph">
Pour chaque ressource, le systme utilise une structure commune, de type
<b>struct ipc_perm</b> ,</b>
pour enregistrer les informations permettant de dterminer les autorisations
concernant les oprations ipc.
la structure
<b>ipc_perm</b> <b></b>  dfinie dans le fichier
<i>&lt;sys/ipc.h&gt;</i> inclut les membres suivants :
<br/><br/>


<br/><br/>

    ushort cuid;   /* UID du crateur     */
    ushort cgid;   /* GID du crateur     */
    ushort uid;    /* UID du propritaire */
    ushort gid;    /* GID du propritaire */
    ushort mode;   /* Autorisations r/w   */

<br/><br/>
Le membre
<b>mode</b> <b></b>  de la structure
<b>ipc_perm</b> <b></b>  dfinit, sur ses 9 bits de poids faibles, les permissions d'accs  la ressource,
pour un processus effectuant un appel systme ipc.
Les permissions sont interprtes ainsi (nombres en octal) :
<br/><br/>


	0400	Lecture par le propritaire.
	0200	criture par le propritaire.
<br/><br/>
 .5
	0040	Lecture par le groupe.
	0020	criture par le groupe.
<br/><br/>
 .5
	0004	Lecture par les autres.
	0002	criture par les autres.

<br/><br/>
Les bits 0100, 0010 et 0001 (bits excution) ne sont pas utiliss par ces appels 
systmes.
De plus,
"criture"
a la signification
"modification"
pour un ensemble de smaphores.<br/><br/>
Le mme fichier d'en-tte dfinit galement les constantes symboliques suivantes :
<br/><br/>
 14
<b>IPC_CREAT</b> <b></b>  Crer une entre si la cl n'existe pas.
<br/><br/>

<b>IPC_EXCL</b> <b></b>  chouer si la cl existe.
<br/><br/>

<b>IPC_NOWAIT</b> <b></b>  Retourner une erreur ventuellement, mais ne pas attendre.
<br/><br/>

<b>IPC_PRIVATE</b> <b></b>  Cl prive.
<br/><br/>

<b>IPC_RMID</b> <b></b>  Supprimer la ressource.
<br/><br/>

<b>IPC_SET</b> <b></b>  Positionner une option concernant la ressource.
<br/><br/>

<b>IPC_STAT</b> <b></b>  Obtenir les options concernant la ressource.<br/><br/>
Notez que
<b>IPC_PRIVATE</b> <b></b>  est du type
<b>key_t</b> <b></b>  alors que les autres constantes symboliques sont des options que l'on regroupe
avec un OU binaire (|) dans une variable de type
<b>int .</b>
</div><br/><h2 class="TitreSection1" id="L6">Files de messages.</h2>
<div class="paragraph">
Une file de message est dfinie par un entier positif unique
<i>(son </i> msqid )</i>
et dispose d'une structure associe de type
<b>struct msquid_ds</b> ,</b>
dfinie dans
<i>&lt;sys/msg.h&gt; ,</i>
qui contient les membres suivants :
<br/><br/>


  struct ipc_perm msg_perm;
  ushort msg_qnum;   /* nb messages dans la file    */
  ushort msg_qbytes; /* octets maxi dans la file    */
  ushort msg_lspid;  /* PID dernier appel msgsnd    */
  ushort msg_lrpid;  /* PID dernier appel msgrcv    */
  time_t msg_stime;  /* heure dernier appel msgsnd  */
  time_t msg_rtime;  /* heure dernier appel msgrcv  */
  time_t msg_ctime;  /* heure dernire modification */


<br/><br/>
 11
<b>msg_perm</b> <b></b>  est la structure
<b>ipc_perm</b> <b></b>  qui indique les permissions d'accs sur la file de messages.
<br/><br/>

<b>msg_qnum</b> <b></b>  est le nombre de messages actuellement dans la file.
<br/><br/>

<b>msg_qbytes</b> <b></b>  Nombre maximal d'octets pour le contenu d'un message de la file.
<br/><br/>

<b>msg_lspid</b> <b></b>  PID du processus qui a effectu le dernier appel systme
<b>msgsnd .</b>
<br/><br/>

<b>msg_lrpid</b> <b></b>  PID du processus qui a effectu le dernier appel systme
<b>msgrcv .</b>
<br/><br/>

<b>msg_stime</b> <b></b>  heure du dernier appel systme
<b>msgsnd .</b>
<br/><br/>

<b>msg_rtime</b> <b></b>  heure du dernier appel systme
<b> msgcv .</b>
<br/><br/>

<b>msg_ctime</b> <b></b>  heure du dernier appel systme qui a modifi un membre de la structure
<b>msqid_ds .</b>
</div><br/><h2 class="TitreSection1" id="L6">Jeux de smaphores.</h2>
<div class="paragraph">
Un ensemble de smaphores est dfini par un entier positif unique
<i>(son </i> semid )</i>
et dispose d'une structure associe de type
<b>struct semid_ds</b> ,</b>
dfinie dans
<i>&lt;sys/sem.h&gt; ,</i>
qui contient les membres suivants :
<br/><br/>


  struct ipc_perm sem_perm;
  time_t sem_otime;  /* heure dernire opration    */
  time_t sem_ctime;  /* heure dernire modification */
  ushort sem_nsems;  /* nb smaphores dans le jeu   */


<br/><br/>
 11
<b>sem_perm</b> <b></b>  est la structure
<b>ipc_perm</b> <b></b>  qui indique les permissions d'accs sur l'ensemble de smaphores.
<br/><br/>

<b>sem_otime</b> <b></b>  Heure du dernier appel systme
<b>semop .</b>
<br/><br/>

<b>sem_ctime</b> <b></b>  Heure du dernier appel systme
<b>semctl ,</b>
qui a modifi un membre de la structure ci-dessus ou l'tat d'un
smaphore de l'ensemble.
<br/><br/>

<b>sem_nsems</b> <b></b>  Nombre de smaphores dans l'ensemble.
Chaque smaphore est rfrenc par un nombre positif ou nul dans l'intervalle
<b>0</b> <b></b>  a
<b>sem_nsems-1 .<br/><br/></b>
Un smaphore est une structure
<b>struct</b> <b></b>  <b>sem"</b> <b></b>  contenant les membres suivants :
<br/><br/>


ushort semval;  /* Valeur du smaphore                  */
ushort sempid;  /* PID dernire opration               */
ushort semncnt; /* Nb proc. en attente incrment semval */
ushort semzcnt; /* Nb proc. en attente de semval = 0    */


<br/><br/>
 11
<b>semval</b> <b></b>  Valeur du smaphore : entier positif ou nul.
<br/><br/>

<b>sempid</b> <b></b>  PID du dernier processus ayant effectu une opration sur
le smaphore.
<br/><br/>

<b>semncnt</b> <b></b>  Nombre de processus bloqus en attente de l'incrmentation de
<b>semval .</b>
<br/><br/>

<b>semznt</b> <b></b>  Nombre de processus bloqus en attente de la nullit de
<b>semval .</b>
</div><br/><h2 class="TitreSection1" id="L6">Segments de mmoire partage.</h2>
<div class="paragraph">
Un segment de mmoire partage est dfini par un entier positif unique
<i>(son </i> shmid )</i>
et dispose d'une structure associe de type
<b>struct shmid_ds</b> ,</b>
dfinie dans
<i>&lt;sys/shm.h&gt; ,</i>
qui contient les membres suivants :
<br/><br/>


    struct ipc_perm shm_perm;
    int    shm_segsz;  /* taille segment              */
    ushort shm_cpid;   /* PID crateur segment        */
    ushort shm_lpid;   /* PID dernire opration      */
    short  shm_nattch; /* Nombre d'attachements       */
    time_t shm_atime;  /* Heure dernier attachement   */
    time_t shm_dtime;  /* Heure dernier dtachement   */
    time_t shm_ctime;  /* Heure dernire modification */


<br/><br/>
 11
<b>shm_perm</b> <b></b>  est la structure
<b>ipc_perm</b> <b></b>  qui indique les permissions d'accs sur le segment de mmoire partage.
<br/><br/>

<b>shm_segsz</b> <b></b>  Taille en octets du segment.
<br/><br/>

<b>shm_cpid</b> <b></b>  PID du processus ayant cr le segment.
<br/><br/>

<b>shm_lpid</b> <b></b>  PID du processus ayant effectu le dernier appel systme
<b>shmat</b> <b></b>  ou
<b>shmdt .</b>
<br/><br/>

<b>shm_nattch</b> <b></b>  Nombre d'attachements en cours pour ce segment.
<br/><br/>

<b>shm_atime</b> <b></b>  Heure du dernier appel systme
<b>shmat .</b>
<br/><br/>

<b>shm_dtime</b> <b></b>  Heure du dernier appel systme
<b>shmdt .</b>
<br/><br/>

<b>shm_ctime</b> <b></b>  Heure du dernier appel systme
<b>shmctl</b> <b></b>  qui a modifi la structure
<b>shmid_ds .</b>
</div><br/><br /><h1 class="TitreSection0" id="L4">voir aussi</h1>
<div class="paragraph">
<b>ftok (3),</b>
<b>msgctl (2),</b>
<b>msgget (2),</b>
<b>msgrcv (2),</b>
<b>msgsnd (2),</b>
<b>semctl (2),</b>
<b>semget (2),</b>
<b>semop (2),</b>
<b>shmat (2),</b>
<b>shmctl (2),</b>
<b>shmget (2),</b>
<b>shmdt</b> <b></b>  <b>(2).<br/><br/></b> <b></b>  </div><br/><br /><h1 class="TitreSection0" id="L5">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.<br/><br/>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
