<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  This man page is Copyright (C) 1999 Matthew Wilcox &lt;willy@bofh.ai&gt;. -->
<!--  Permission is granted to distribute possibly modified copies -->
<!--  of this page provided the header is included verbatim, -->
<!--  and in case of nontrivial modification author and date -->
<!--  of the modification is added to the header. -->
<!--  Traduction 04/01/2000 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  LDP-man_pages 1.28 -->
<!--  Mise  jour 06/06/2001 - LDP-man-pages-1.36 -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>ARP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">description</a>
<br /><a class="summaryIndent0" href="#L2">ioctls</a>
<br /><a class="summaryIndent0" href="#L3">sysctls</a>
<br /><a class="summaryIndent0" href="#L4">bogues</a>
<br /><a class="summaryIndent0" href="#L5">versions</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
arp - Module ARP du noyau Linux.
</div><br/><br /><h1 class="TitreSection0" id="L2">description</h1>
<div class="paragraph">
Ce module du noyau implmente le protocole de rsolution d'adresse
ARP tel qu'il est dcrit dans le document RFC 826.
Il sert  la conversion entre les adresses matrielles de niveau 2 et
les adresses du protocole IPv4 sur les rseaux connects en direct.
L'utilisateur n'a normalement pas d'interactions avec ce module sauf
pour le configurer. En fait ce module fournit des services aux autres
protocoles du noyau.<br/><br/>
Un processus utilisateur peut recevoir les paquets ARP en utilisant
les sockets de type
<b>packet (7).</b>
Il y a aussi un mcanisme pour grer le cache ARP dans l'espace
utilisateur avec des sockets
<b>netlink (7).</b>
La table ARP peut tre contrle par le biais d'un
<b>ioctl</b> <b></b>  <b>(2)</b> <b></b>  <b></b>  sur n'importe quelle socket
<b>PF_INET .<br/><br/></b>
Le module ARP maintient un cache des correspondances entre les adresses
matrielles et les adresses logiques. Le cache a une taille limite, ainsi
les entres anciennes et utilises moins frquemment sont rcupres.
Les entres qui sont marques comme permanentes ne sont jamais effaces.
Le cache peut tre manipul directement par l'intermdiaire des <b>ioctl</b>s et
son comportement peut tre ajust  l'aide des <b>sysctl</b>s dcrits plus bas.<br/><br/>
Lorsqu'il n'y a pas de retour positif pour une correspondance existante aprs
un certain temps (voir les <b>sysctl</b>s ci dessous), l'entre est considre
comme gele. Un retour positif peut tre obtenu d'un niveau suprieur, par
exemple un ACK TCP russi. D'autres protocoles peuvent signaler des avances
en utilisant l'attribut 
<b>MSG_CONFIRM</b> <b></b>  de 
<b>sendmsg (2).</b>
Pour envoyer  nouveau des donnes  cette cible, l'ARP essaye
d'abord d'interroger un dmon arp local au maximum
<b>app_solicit</b> <b></b>  <b></b>  fois, afin d'obtenir une adresse MAC  jour. Si ceci choue, et si une
ancienne adresse MAC est connue, une tentative unicast est envoye
<b>ucast_solicit</b> <b></b>  fois. Si on choue encore, il enverra une requte ARP en broadcast sur le
rseau. Les requtes ne sont envoyes que s'il y a des donnes en attente
d'mission.<br/><br/>
Linux ajoutera automatiquement une entre arp proxy non-permanente lorsqu'il
reoit une requte pour une adresse  laquelle il envoie des donnes, et si
l'arp proxy est valid sur l'interface rceptrice. Aucune entre n'est
ajoute s'il y a une route de rejet.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">ioctls</h1>
<div class="paragraph">
Trois ioctls sont disponibles pour les sockets
<b>PF_INET .</b>
Elles prennent un pointeur 
sur une
<b>struct</b> <b></b>  <b>arpreq</b> <b></b>  comme paramtre.<br/><br/>

.ta 4 20 33
struct arpreq
{
    struct sockaddr   arp_pa;       /* adresse protocole          */
    struct sockaddr   arp_ha;       /* adresse matrielle         */ 
    int               arp_flags;    /* attributs                  */
    struct sockaddr   arp_netmask;  /* masque rseau du protocole */
    char              arp_dev[16];
};

<br/><br/>
<b>SIOCSARP </b>, <b> SIOCDARP </b> et <b> SIOCGARP</b>
ajoute, supprime, et consulte respectivement une correspondance ARP.
L'ajout et la suppression de correspondance ARP sont des oprations
privilgies ne pouvant tre raliss que par un processus avec la capacit
<b>CAP_NET_ADMIN</b> <b></b>  ou un UID effectif nul.<br/><br/>
<i>arp_pa</i> doit tre une socket
<b>AF_INET</b> <b></b>  et
<i>arp_ha</i> doit tre du mme type que le priphrique indiqu dans
<i>arp_dev .</i>
<i>arp_dev</i> est une chane termine par un caractre nul, contenant le nom d'un priphrique.<br/><br/>
.TS
tab(:) allbox;
c s
l l.
<i>arp_flags</i>
attribut:signification
ATF_COM:Recherche complte
ATF_PERM:Entre permanente
ATF_PUBL:Entre publique
ATF_USETRAILERS:Demande trailer
ATF_NETMASK:Utiliser le masque rseau
ATF_DONTPUB:Ne pas rpondre
.TE<br/><br/><br/><br/>
Si l'attribut
<b>ATF_NETMASK</b> <b></b>  est activ, alors le membre
<i>arp_netmask</i> doit tre valide.
Linux 2.2 ne supporte pas les entres ARP proxy rseau, ainsi il doit
tre configur avec 0xFFFFFFFF ou 0 pour supprimer une entre arp proxy existante.
<b>ATF_USETRAILERS</b> <b></b>  est obsolte et ne doit pas tre utilis<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">sysctls</h1>
<div class="paragraph">
ARP supporte une interface <b>sysctl</b> pour configurer les paramtres
sur une base globale ou interface par interface.
Les sysctls peuvent tre accessibles en lisant ou en crivant dans le fichier
<b>/proc/sys/net/ipv4/neigh/*/*</b> <b></b>  ou en utilisant l'interface
<b>sysctl (2).</b>
Chaque interface dans le systme a son propre rpertoire dans
/proc/sys/net/ipv4/neigh/.
La configuration dans le rpertoire <b>default</b> sert pour tous les nouveaux
priphriques. Sauf mention contraire, les dures sont en secondes.
<br/><br/>

<b>anycast_delay</b> <b></b>  Le nombre maximum de jiffies  attendre avant de rpondre  un message de
sollicitation IPv6 du voisinage.
Le support Anycast n'est pas encore implment.
Par dfaut, le dlai est 1 seconde.
<br/><br/>

<b>app_solicit</b> <b></b>  Le nombre maximum d'essai d'envoi au dmon ARP de l'espace utilisateur par
netlink avant de basculer en tentatives multicast (voir
<i>mcast_solicit ).</i>
La valeur par dfaut est 0.
<br/><br/>

<b>base_reachable_time</b> <b></b>  Une fois qu'un voisin a t trouv, l'entre est considre comme valide
pendant, au moins, une dure alatoire entre
<i>base_reachable_time </i>/2 et 3*<i> base_reachable_time /2.</i>
La validit d'une entre sera tendue si on reoit un retour positif
des protocoles de plus haut niveau.
La valeur par dfaut est 30 secondes.
<br/><br/>

<b>delay_first_probe_time</b> <b></b>  Dlai avant la premire tentative multicast aprs avoir dcid qu'un
voisin est gel.
Par dfaut 5 secondes.
<br/><br/>

<b>gc_interval</b> <b></b>  Frquence avec laquelle on
vrifie les entres valides. Par dfaut
30 secondes.
<br/><br/>

<b>gc_stale_time</b> <b></b>  Frquence avec laquelle on vrifie une entre de voisinage gele. Lorsqu'une
correspondance est considre comme gele, elle sera  nouveau
redtermine avant d'y envoyer des donnes.
Par dfaut la dure est de 60 secondes.
<br/><br/>

<b>gc_thresh1</b> <b></b>  Le nombre minimal d'entres  conserver dans le cache ARP. Le rcuprateur
ne sera pas dclench
si il y a moins d'entres que cette valeur
(par dfaut 128).
<br/><br/>

<b>gc_thresh2</b> <b></b>  La limite maximale souple d'entres  conserver dans le cache ARP. Le rcuprateur
autorisera un dpassement de cette valeur pendant 5 secondes avant de lancer une
vritable rcupration.
Par dfaut 512 entres.
<br/><br/>

<b>gc_thresh3</b> <b></b>  La limite maximale d'entres  conserver dans le cache ARP. Le rcuprateur
sera immdiatement dclench
si cette valeur est dpasse
(par dfaut 1024).
<br/><br/>

<b>locktime</b> <b></b>  Le nombre minimum de jiffies pendant lesquels on conserve une entre ARP
dans le cache. Ceci vite la dgradation du cache si il y a plusieurs
correspondances possibles (gnralement  cause d'une mauvaise configuration
du rseau). Par dfaut 1 seconde.
<br/><br/>

<b>mcast_solicit</b> <b></b>  Le nombre maximal de tentatives de rsolution d'une adresse par le multicast et
le broadcast avant de marquer l'entre comme inaccessible.
Par dfaut 3.
<br/><br/>

<b>proxy_delay</b> <b></b>  Lorsqu'une requte arrive pour une adresse proxy-ARP, on attend 
<i>proxy_delay</i> jiffies avant de rpondre.
Ceci permet d'viter des saturations du rseau dans certains cas. La
valeur par dfaut correspond  0.8 secondes.
<br/><br/>

<b>proxy_qlen</b> <b></b>  Le nombre maximal de paquets qui peuvent tre conservs pour des adresses
proxy-ARP. Par dfaut 64.
<br/><br/>

<b>retrans_time</b> <b></b>  Le nombre de jiffies  attendre avant de retransmettre une requte. Par
dfaut 1 seconde.
<br/><br/>

<b>ucast_solicit</b> <b></b>  Le nombre maximal de tentatives d'envoi unicast avant d'interroger le
dmon ARP (voir
<i>app_solicit ).</i>
Par dfaut 3.
<br/><br/>

<b>unres_qlen</b> <b></b>  Le nombre maximal de paquets conservs pour chaque adresse non rsolue
par les autres couches rseau.
Par dfaut 3.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">bogues</h1>
<div class="paragraph">
Certaines temporisations sont exprimes en jiffies qui dpendent de l'architecture.
Sur Alpha, un jiffy correspond  1/1024 seconde, sur la plupart des autres
il correspond  1/100 seconde.<br/><br/>
Il n'y a pas de moyen d'envoyer une rponse positive de l'espace utilisateur.
Ceci signifie que les protocoles orients connexion implments dans l'espace
utilisateur engendreront un trafic ARP excessif, car ndisc revrifiera
rgulirement les adresses MAC. Le mme problme se pose pour certains
protocoles du noyau (par exemple NFS sur UDP).
Cette page de manuel mlange les spcificits IPv4 et les fonctionnalits
communes  IPv4 et IPv6.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">versions</h1>
<div class="paragraph">
La structure
<b>arpreq</b> <b></b>  a chang dans Linux 2.0 pour inclure le membre
<i>arp_dev</i> et les numros d'ioctl ont chang en mme temps.
Le support pour les anciens ioctl a t abandonn dans Linux 2.2.<br/><br/>
Le support pour les entres proxy ARP concernant des rseaux
(netmask diffrent de 0xFFFFFFF) a t supprim de Linux 2.2.
Il est remplac par une configuration proxy ARP automatique dans le
noyau pour tous les htes accessibles sur les autres interfaces
(lorsque l'on fait du forwarding et que le proxy ARP est activ sur l'interface).<br/><br/>
Les requtes sysctl neigh/* n'existaient pas avant Linux 2.2.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>ip (7)<br/><br/></b>
RFC826 pour une description de l'ARP.
<br/>
RFC2461 pour une description de l'exploration du voisinage IPv6 et des
algorithmes de base employs.<br/><br/>
L'ARP IPv4 de Linux 2.2 et ultrieurs emploie l'algorithme IPv6 si possible.
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2000-2003.<br/><br/>

								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
