<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  This man page is Copyright (C) 2000 Andi Kleen &lt;ak@muc.de&gt;. -->
<!--  Permission is granted to distribute possibly modified copies -->
<!--  of this page provided the header is included verbatim, -->
<!--  and in case of nontrivial modification author and date -->
<!--  of the modification is added to the header. -->
<!--  $Id: ipv6.7,v 1.3 2000/12/20 18:10:31 ak Exp $ -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt;  -->
<!--  11/06/2001 - LDP-man-pages-1.37 -->
<!--  MJ - LDP-man-pages-1.53 -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>IPV6</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">format d'adresse</a>
<br /><a class="summaryIndent0" href="#L4">options des sockets</a>
<br /><a class="summaryIndent0" href="#L5">versions</a>
<br /><a class="summaryIndent0" href="#L6">notes de portabilit</a>
<br /><a class="summaryIndent0" href="#L7">bogues</a>
<br /><a class="summaryIndent0" href="#L8">voir aussi</a>
<br /><a class="summaryIndent0" href="#L9">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
ipv6, PF_INET6 - Implmentation Linux du protocole IPv6
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;netinet/in.h&gt;</b> <b></b>  <b></b>  <br/><br/>

<br/><br/>

tcp6_socket <i> = socket(PF_INET6, SOCK_STREAM, 0);</i>
<br/> 
raw6_socket <i> = socket(PF_INET6, SOCK_RAW, </i> protocol <b>);</b>
<br/>
udp6_socket <i> = socket(PF_INET6, SOCK_DGRAM, </i> protocol <b>);</b>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Linux 2.2 implmente en option le protocole internet version 6 (IPv6).
Cette page de manuel contient la description de l'API IPv6 de base, telle
qu'implmente dans le noyau Linux et la GlibC 2.1 L'interface est 
base sur l'interface des sockets BSD. Voir
<b>socket (7). <br/><br/></b>
L'API IPv6 est conue pour tre essentiellement compatible avec l'API
<b>ip (7) </b>
v4. Seules les diffrences sont dcrites dans cette page de manuel.<br/><br/>
pour attacher une socket
<i>AF_INET6 ,</i>
l'adresse locale doit tre copie dans une variable
<b>in6addr_any</b> <b></b>  qui a le
type
<i>in6_addr .</i>
Dans les initialisations statiques,
<b>IN6ADDR_ANY_INIT</b> <b></b>  peut servir aussi et se dveloppe en une expression constante.
Toutes les valeurs sont dans l'ordre des octets du rseau.<br/><br/>
L'adresse de boucle IPv6 (::1) est disponible dans la variable globale
<b>in6addr_loopback .</b>
Pour les initialisation, on doit
utiliser
<b>IN6ADDR_LOOPBACK_INIT .<br/><br/></b>
Les connexions IPv4 peuvent tre traite avec l'API v6 en utilisant le type d'adresse
v4-projet-dans-v6. Ainsi un programme n'a qu'un seul type d'API  utiliser pour
supporter les deux protocoles. Ceci est gr de manire transparente par les fonctions
d'adressage de la LibC.<br/><br/>
IPv4 et IPv6 partagent l'espace des ports locaux. Lorsqu'une connexion IPv4 ou un paquet 
est obtenu sur une socket IPv6, son adresse source sera projete
en v6.
</div><br/><br /><h1 class="TitreSection0" id="L4">format d'adresse</h1>
<div class="paragraph">
<br/><br/>

.RS

.ta 4n 5n 20n
struct sockaddr_in6 {
	u_int16_t	sin6_family;	/* AF_INET6 */
	u_int16_t	sin6_port;	/* numro port */
	u_int32_t	sin6_flowinfo;	/* information flux IPv6 */
	struct in6_addr	sin6_addr;	/* adresse IPv6 */
	u_int32_t   sin6_scope_id;  /* Scope id (nouveaut 2.4) */ 
};<br/><br/>
struct in6_addr {
	unsigned char	s6_addr[16];	/* adresse IPv6 */
};
.ta



<br/><br/>

<b>sin6_family</b> <b></b>  <b></b>  est toujours rempli avec 
<b>AF_INET6 </b> ;<b></b>
<b>sin6_port</b> <b></b>  <b></b>  est le port du protocole (voir
<b>sin_port</b> <b></b>  dans
<b>ip (7));</b>
<b>sin6_flowinfo</b> <b></b>  est l'identificateur de flux IPv6,
<b>sin6_addr</b> <b></b>  est l'adresse IPv6 sur 128 bits.
<b>sin6_scope_id</b> <b></b>  <b></b>  est un identificateur qui dpend de la porte de l'adresse. C'est une nouveaut Linux 2.4.
Linux ne le supporte que pour les adresse ayant une porte liaison, dans ce cas
<i>sin6_scope_id</i> contient le numro d'interface (voir
<b>netdevice (7))<br/><br/></b>
IPv6 supporte plusieurs types d'adresses : unicast pour reprsenter un hte unique,
multicast pour un groupe d'htes, anycast pour indiquer le membre le plus proche d'un
groupe d'htes (non implment sous Linux), IPv4-on-IPv6 pour un hte
IPv4, et d'autres types d'adresse rservs.<br/><br/>
La notation d'adresse pour l'IPv6 est un groupe de 16 nombres hexadcimaux sur 2 chiffres,
spars par un deux-points `:'. Un `::' reprsente une chane de zros. Les adresses spciales
sont ::1 pour le bouclage loopback et ::FFFF:&lt;adresse IPv4&gt; pour les projections d'adresses IPv4
sur l'IPv6.<br/><br/>
L'espace des ports de l'IPv6 est partag avec l'IPv4.
</div><br/><br /><h1 class="TitreSection0" id="L5">options des sockets</h1>
<div class="paragraph">
IPv6 supporte quelques options des sockets spcifiques du protocole, qui peuvent tre fixes avec
<b>setsockopt (2)</b>
et consultes avec
<b>getsockopt (2).</b>
Le niveau d'option de socket pour l'IPv6 est
<b>IPPROTO_IPV6 .</b>
Un entier boolen est faux quand il est nul et vrai sinon.
<br/><br/>

<b>IPV6_UNICAST_HOPS</b> <b></b>  Fixe la limite du nombre de sauts (hops) unicast. L'argument est un pointeur sur un entier.
La valeur -1 correspond  la valeur par dfaut de routage, sinon il doit s'agir
d'un entier entre 0 et 255.
<br/><br/>

<b>IPV6_MULTICAST_HOPS</b> <b></b>  Fixe la limite du nombre de sauts (hops) multicast. L'argument est un pointeur sur un entier.
La valeur -1 correspond  la valeur par dfaut de routage, sinon il doit s'agir
d'un entier entre 0 et 255.
<br/><br/>
 
<b>IPV6_MULTICAST_IF</b> <b></b>  Fixe le priphrique pour les paquets multicasts sortants de la socket.
Ceci n'est permis
que pour les
sockets
<i>SOCK_DGRAM</i> et
<i>SOCK_RAW .</i>
L'argument est un pointeur sur un numro d'interface (voir
<b>netdevice (7))</b>
dans un entier.
<br/><br/>

<b>IPV6_ADDRFORM</b> <b></b>  Transformer une socket
<i>AF_INET6</i> en une socket d'une famille d'adresse diffrente. Seul
<i>AF_INET</i> est actuellement support pour cela. Cela n'est autoris que pour les sockets
IPv6 connectes et attaches  une adresse v4-sur-v6. L'argument est un pointeur
sur un entier contenant
<b>AF_INET.</b> <b></b>  <b></b>  Cela est utile pour passer des sockets projetes en v4 comme descripteurs  des
programmes ne sachant pas manipuler l'API IPv6.
<br/><br/>
 
<b>IPV6_PKTINFO</b> <b></b>  Fixe la distribution des messages de contrle
<b>IPV6_PKTINFO</b> <b></b>  <b></b>  des datagrammes entrants. Uniquement autoris pour les sockets
<b>SOCK_DGRAM</b> <b></b>  ou
<b>SOCK_RAW .</b>
L'argument est un pointeur sur une valeur boolenne dans un entier.
<br/><br/>

.nh
<b>IPV6_RTHDR</b> <b></b> ,<b></b>  <b>IPV6_AUTHHDR</b> <b></b> ,<b></b>  <b>IPV6_DSTOPS</b> <b></b> ,<b></b>  <b>IPV6_HOPOPTS</b> <b></b> ,<b></b>  <b>IPV6_FLOWINFO</b> <b></b> ,<b></b>  <b>IPV6_HOPLIMIT</b> <b></b>  .hy
Fixe la distribution des messages de contrle des datagrammes entrants contenant les
en-ttes d'extensions.
<i>IPV6_RTHDR</i> dlivre l'en-tte de routage,
<i>IPV6_AUTHHDR</i> dlivre l'en-tte d'authentification,
<i>IPV6_DSTOPTS</i> dlivre les options de destination,
<i>IPV6_HOPOPTS</i> dlivre les options de saut,
<i>IPV6_FLOWINFO</i> dlivre un entier contenant l'identificateur de flux,
<i>IPV6_HOPLIMIT</i> dlivre un entier contenant le nombre de sauts du paquet.
Les messages de contrle ont le mme type que l'option de socket. Toutes ces options
d'en-tte peuvent aussi tre fixes pour les paquets sortants en mettant le message
de contrle appropri dans le buffer de
<b>sendmsg (2).</b>
Uniquement autoris pour les sockets
<b>SOCK_DGRAM</b> <b></b>  ou
<b>SOCK_RAW</b> <b></b>  L'argument est un pointeur sur une valeur boolenne.
<br/><br/>

<b>IPV6_MULTICAST_LOOP</b> <b></b>  Dtermine si la socket voit les paquets multicast qu'elle a elle-mme mis.
L'argument est un pointeur sur une valeur boolenne.
<br/><br/>

<b>IPV6_ADD_MEMBERSHIP</b> <b></b> ,<b></b>  <b>IPV6_DROP_MEMBERSHIP</b> <b></b>  Dtermine l'appartenance aux groupes multicast. L'argument est un pointeur sur
une structure
<b>struct ipv6_mreq .</b>
<br/><br/>

<b>IPV6_MTU</b> <b></b>  Fixe le MTU  utiliser pour la socket. Le MTU est limit par celui du priphrique
ou celui du chemin lorsque la recherche du MTU par chemin est active.
L'argument est un pointeur sur un entier.
<br/><br/>

<b>IPV6_MTU_DISCOVER</b> <b></b>  Commander la recherche du MTU par chemin sur la socket. Voir l'option
<i>IP_MTU_DISCOVER</i> dans
<b>ip (7)</b>
pour plus de prcisions.
<br/><br/>

<b>IPV6_RECVERR</b> <b></b>  Commande la rception des erreurs asynchrones. Voir
<i>IP_RECVERR</i> dans
<b>ip (7)</b>
pour plus de prcisions.
L'argument est un pointeur sur un boolen.
<br/><br/>

<b>IPV6_ROUTER_ALERT</b> <b></b>  Passer sur cette socket tous les paquets redirigs (forwarded) contenant une option d'alerte du routeur.
Uniquement autoris pour les sockets datagrammes, et pour root. L'argument est un pointeur
vers un boolen.
<!--  FLOWLABEL_MGR, FLOWINFO_SEND -->
</div><br/><br /><h1 class="TitreSection0" id="L6">versions</h1>
<div class="paragraph">
L'ancienne implmentation IPv6 pour Linux base sur
<i>libinet6</i> de la LibC5 n'est pas dcrite ici, et peut tre lgrement
diffrente.<br/><br/>
Linux 2.4 rompt la compatibilit binaire pour la structure sockaddr_in6
des htes sur 64 bits, en modifiant l'alignement de
<i>in6_addr </i> et en ajoutant un champ
<i>sin6_scope_id</i> supplmentaire. Les interfaces du noyau restent compatible, mais un programme contenant
des sockaddr_in6 ou des in6_addr dans d'autres structures ne l'est peut tre pas. Ce n'est
pas un problme pour les htes sur 32 bits comme les i386.<br/><br/>
Le champ
<b>sin6_flowinfo</b> <b></b>  est une nouveaut Linux 2.4. Il est crit/lu de manire transparente par le noyau
quand la longueur de l'adresse passe le contient. Certains programmes qui passent
un buffer d'adresse plus long et vrifient ensuite la longueur de l'adresse renvoye peuvent chouer.
</div><br/><br /><h1 class="TitreSection0" id="L7">notes de portabilit</h1>
<div class="paragraph">
La structure
<b>sockaddr_in6</b> <b></b>  est plus grande que la structure
<b>sockaddr</b> <b></b>  gnrique. Les programmes qui supposent que tous les types d'adresses peuvent tre stocks dans une
<b>struct</b> <b></b>  <b>sockaddr</b> <b></b>  doivent tre modifis pour utiliser
<b>struct</b> <b></b>  <b>sockaddr_storage</b> <b></b>   la place.
</div><br/><br /><h1 class="TitreSection0" id="L8">bogues</h1>
<div class="paragraph">
L'API IPv6 tendue, telle que dans la RFC 2292, n'est encore que partiellement implmente.
Bien que les noyaux 2.2 ont un support pratiquement complet pour les options de rception,
les macros dclarant les options IPv6 manquent dans la GlibC 2.1.<br/><br/>
Le support IPSec pour les en-ttes EH et AH est manquant.<br/><br/>
La gestion des tiquettes de flux n'est pas complte, ni documente ici.<br/><br/>
Cette page de manuel n'est pas complte.
</div><br/><br /><h1 class="TitreSection0" id="L9">voir aussi</h1>
<div class="paragraph">
<b>ip (7),</b>
<b>cmsg (3)<br/><br/></b>
RFC2553: API IPv6 de base, avec laquelle Linux essaye d'tre compatible.<br/><br/>
RFC2460: Spcifications IPv6
</div><br/><br /><h1 class="TitreSection0" id="L10">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2001-2003.<br/><br/>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
