<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  (c) 1993 by Thomas Koenig (ig25@rz.uni-karlsruhe.de) -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  License. -->
<!--  Modified Sat Jul 24 17:28:34 1993 by Rik Faith (faith@cs.unc.edu) -->
<!--  -->
<!--  Traduction 20/10/1996 par Christophe Blaess (ccb@club-internet.fr) -->
<!--  MJ LDP 1.53 -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>LOCALE</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">conformit</a>
<br /><a class="summaryIndent0" href="#L4">voir ausi</a>
<br /><a class="summaryIndent0" href="#L5">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
locale - Description du support multilingue.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<b>#include</b> <b></b>  <b>&lt;locale.h&gt;</b> <b></b>  

</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Une localisation est un ensemble de rgles linguistiques et culturelles.
Ceci couvre des aspects tels que la langue utilise pour les messages,
le jeu de caractres, les conventions lexicographiques etc...
Un programme doit tre capable de dterminer sa localisation et
d'agir en consquence pour tre portable dans divers environnements
culturels.<br/><br/>
Le fichier d'en-tte
<b>&lt;locale.h&gt;</b> <b></b>  dclare les types de donnes, les fonctions et les macros utiliss
pour ces tches.<br/><br/>
Les fonctions qu'il dclare sont
<b>setlocale()</b> <b></b>  pour indiquer la localisation et
<b>localeconv()</b> <b></b>  pour obtenir des informations sur la mise en forme des nombres.<br/><br/>
Il existe diffrentes catgories d'informations locales qui peuvent
tre utiles  un programme. Elles sont dclares en tant que macros.
En les utilisant comme premier argument de la fonction
<b>setlocale() ,</b>
il devient possible de fixer l'une de ces informations :
<br/><br/>

<b>LC_COLLATE</b> <b></b>  est utilis pour modifier le comportement des fonctions
<b>strcoll()</b> <b></b>  et
<b>strxfrm() ,</b>
qui permettent les comparaisons de chanes dans l'alphabet local.
Par exemple le double-s allemand, est ordonn comme 'ss'.
<br/><br/>

<b>LC_TYPE</b> <b></b>  permet de modifier les manipulations et classifications de caractres,
comme celles des fonctions
<b>isupper()</b> <b></b>  et
<b>toupper() ,</b>
et celles des fonctions travaillant sur des caractres multi-octets
comme
<b>mblen()</b> <b></b>  ou
<b>wctomb() .</b>
<br/><br/>

<b>LC_MONETARY</b> <b></b>  modifie les informations renvoyes par
<b>localeconv()</b> <b></b>  pour dcrire la mise en forme habituelle des nombres, en accord avec des
dtails comme le point dcimal ou la virgule dcimale. Ces informations
sont utilises par les fonctions
<b>strfmon() .</b>
<br/><br/>

<b>LC_MESSAGES</b> <b></b>  configure la langue utilise pour afficher les messages, et la saisie de
rponses affirmatives ou ngatives. La bibliothque C GNU contient les
fonctions
<b>gettext() ,</b>
<b>ngettext() ,</b>
et
<b>rpmatch()</b> <b></b>  pour aider  utiliser ces donnes. Les fonctions de la famille Gettext
obissent aussi  la variable d'environnement
<b>LANGUAGE .</b>
<br/><br/>

<b>LC_NUMERIC</b> <b></b>  modifie les informations utilises par les fonctions des familles
<b>printf()</b> <b></b>  et
<b>scanf() ,</b>
lorsqu'elles doivent utiliser la configuration locale. Ces donnes
peuvent galement tre obtenues avec la fonction
<b>localeconv() .</b>
<br/><br/>

<b>LC_TIME</b> <b></b>  modifie le comportement de la fonction
<b>strftime()</b> <b></b>  affichant l'heure dans un format local. Par exemple la plupart de
l'Europe utilise un format horaire sur 24 heures, alors que les
USA utilisent un format sur 12 heures.
<br/><br/>

<b>LC_ALL</b> <b></b>  regroupe toutes les catgories ci-dessus.<br/><br/>
Si le second argument de la fonction
<b>setlocale()</b> <b></b>  est une chane de caractres vide,
<b></b><b></b><b></b> ,</b>
ceci correspond  la localisation par dfaut, dtermine avec les
tapes suivantes :
.IP 1.
Si une variable d'environnement 
<b>LC_ALL </b>
n'est pas nulle, sa valeur est utilise.
.IP 2.
Si une variable d'environnement ayant le mme nom que les catgories
mentionnes ci-dessus est non nulle, sa valeur est utilise pour
la catgorie en question.
.IP 3.
Si une variable d'environnement 
<b>LANG </b>
est non nulle, sa valeur est utilise.<br/><br/>
Les valeurs concernant la mise en forme numrique sont disponibles
dans une structure
<b>struct lconv</b> ,</b>
renvoye par la fonction
<b>localeconv() ,</b>
dclare ainsi :

struct lconv
{
  /* -------- Informations numriques (non-montaires) ------- */<br/><br/>
  char *decimal_point;    /* Sparateur dcimal                 */
  char *thousands_sep;    /* Sparateur des milliers            */
  /* 
   * Chaque lment  indique  un  nombre de chiffres  dans  chaque
   * groupe.
   * Les lments d'indice les plus levs correspondent aux grou-
   * pes les plus  gauche.
   * Un lment de valeur CHAR_MAX signifie l'arrt du groupement.
   * Un lment de valeur 0  signifie que l'lment prcdent est
   * utilis pour tous les groupes plus  gauche.
   *
   * NDT : c'est pas clair ? ben, la V.O. non plus !  ;-)
   */
  char *grouping;<br/><br/>
  /* ----------------- Informations montaires ---------------- */<br/><br/>
  /* Les trois premiers caractres correspondent au symbole     */
  /* montaire d'aprs ISO 4217. Le quatrime symbole est le    */
  /* sparateur, le cinquime est '\\0'.                         */
  char *int_curr_symbol;
  char *currency_symbol;	/* Symbole montaire local.     */
  char *mon_decimal_point;	/* Caractre sparateur dcimal */
  char *mon_thousands_sep;	/* Caract. sparateur milliers  */
  char *mon_grouping;		/* Comme 'grouping' (ci-dessus) */
  char *positive_sign;		/* Signe pour valeurs positives */
  char *negative_sign;		/* Signe pour valeurs ngatives */
  char int_frac_digits;		/* Int'l fractional digits.     */
  char frac_digits;		/* Local fractional digits.     */
  /* 1 : le symbole montaire prcde les valeurs positives,    */
  /* 0 : le symbole montaire suit les valeurs positives.       */
  char p_cs_precedes;
  /* 1 si un espace spare le symbole montaire d'une valeur +  */
  char p_sep_by_space;
  /* 1 : le symbole montaire prcde les valeurs ngatives,    */
  /* 0 : le symbole montaire suit les valeurs ngatives.       */
  char n_cs_precedes;
  /* 1 si un espace spare le symbole montaire d'une valeur -  */
  char n_sep_by_space;
  /* Positions des signes plus et moins :
   * 0 Parenthses autour de la valeur et du symbole montaire.
   * 1 Le signe prcde la valeur et le symbole montaire.
   * 2 Le signe suit la valeur et le symbole montaire.
   * 3 Le signe prcde immdiatement le symbole montaire.
   * 4 Le signe suit immdiatement le symbole montaire.
   */
  char p_sign_posn;
  char n_sign_posn;
};


</div><br/><br /><h1 class="TitreSection0" id="L4">conformit</h1>
<div class="paragraph">

POSIX.1


Les fonctions de la bibliothque Gnu Gettext sont dcrites dans le
document LI18NUX2000.
</div><br/><br /><h1 class="TitreSection0" id="L5">voir ausi</h1>
<div class="paragraph">
<b>setlocale (3),</b>
<b>localeconv (3),</b>
<b>locale (1),</b>
<b>localedef (1),</b>
<b>nl_langinfo (3),</b>
<b>gettext (3),</b>
<b>ngettext (3),</b>
<b>rpmatch (3),</b>
<b>strfmon (3),</b>
<b>strcoll (3),</b>
<b>strxfrm (3),</b>
<b>strftime (3)<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L6">traduction</h1>
<div class="paragraph">
Christophe Blaess, 1996-2003.<br/><br/>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
