<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Don't change the first line, it tells man that tbl is needed. -->
<!--  This man page is Copyright (C) 1999 Andi Kleen &lt;ak@muc.de&gt;. -->
<!--  Permission is granted to distribute possibly modified copies -->
<!--  of this page provided the header is included verbatim, -->
<!--  and in case of nontrivial modification author and date -->
<!--  of the modification is added to the header. -->
<!--  $Id: netdevice.7,v 1.10 2000/08/17 10:09:54 ak Exp $ -->
<!--  Traduction Christophe Blaess, &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>NETDEVICE</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">ioctls</a>
<br /><a class="summaryIndent0" href="#L4">notes</a>
<br /><a class="summaryIndent0" href="#L5">bogues</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
netdevice - Accs bas-niveau aux priphriques rseau sous Linux.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/ioctl.h&gt;"</b> <b></b>  <b>#include</b> <b></b>  <b>&lt;net/if.h&gt;"<br/><br/></b> <b></b>  </div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Cette page de manuel dcrit l'interface des socket permettant de configurer
les priphriques rseau.<br/><br/>
Linux support des ioctls standard pour configurer les priphriques rseau. Il servent
sur n'importe quel descripteur de socket, quelqu'en soit la famille ou le type.
Ils utilisent une
structure
<b>ifreq </b> :<b><br/><br/></b>

.ta 4 12 20
struct ifreq {
	char	ifr_name[IFNAMSIZ];	/* nom interface */
	union {
		struct sockaddr	ifr_addr;
		struct sockaddr	ifr_dstaddr;
		struct sockaddr	ifr_broadaddr;
		struct sockaddr	ifr_netmask;
		struct sockaddr	ifr_hwaddr;
		short	ifr_flags;
		int	ifr_ifindex;
		int	ifr_metric;
		int	ifr_mtu;
		struct ifmap	ifr_map;
		char	ifr_slave[IFNAMSIZ];
		char	ifr_newname[IFNAMSIZ];
		char *	ifr_data;
	};
};<br/><br/>
struct ifconf { 
  	int ifc_len;		/* taille buffer */
	union {            
		char *	ifc_buf; /* adresse buffer */ 
		struct ifreq *ifc_req; /* table de structures */
	};  
}; 	   
.ta

<br/><br/>
Normalement, l'utilisateur indique le priphrique concern en remplissant
<b>ifr_name</b> <b></b>  avec le nom de l'interface. Tous les autres membres de la structure peuvent
partager la mmoire.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">ioctls</h1>
<div class="paragraph">
Si un ioctl est indiqu comme privilgi, alors il ncessite un UID effectif
nul ou la capacit.
<b>CAP_NET_ADMIN</b> <b></b>  Sinon, il renverra
l'erreur
<b>EPERM .<br/><br/></b>
<br/><br/>

<b>SIOCGIFNAME</b> <b></b>  En utilisant
<b>ifr_ifindex ,</b>
renvoie le nom de l'interface dans
<b>ifr_name .</b>
C'est le seul ioctl qui renvoie un rsultant dans
<b>ifr_name .<br/><br/></b>
<br/><br/>

<b>SIOCGIFINDEX</b> <b></b>  Retrouve le numro d'interface et le place dans
<b>ifr_ifindex .<br/><br/></b>
<br/><br/>

<b>SIOCGIFFLAGS </b>, <b> SIOCSIFFLAGS</b>
Lire ou crire les attributs actifs du priphrique.
<b>ifr_flags</b> <b></b>  est un mot contenant un masque de bits combinant les valeurs suivantes&nbsp;:<br/><br/>
.TS
tab(:);
c s
l l.
Device flags
IFF_UP:Interface fonctionne.
IFF_BROADCAST:Adresse de broadcast valide.
IFF_DEBUG:Attribut interne de dbogage.
IFF_LOOPBACK:Interface de type loopback.
IFF_POINTOPOINT:Interface de type point--point.
IFF_RUNNING:Resources alloues.
IFF_NOARP:Pas de protocole Arp, adresse de destination L2 absente.
IFF_PROMISC:Interface en mode promiscuous.
IFF_NOTRAILERS:N'utilise pas les postambules.
IFF_ALLMULTI:Accepte tous les paquets multicast.
IFF_MASTER:Matre d'un systme de rpartition de charge.
IFF_SLAVE:Esclave d'un systme de rpartition de charge.
IFF_MULTICAST:Support multicast.
IFF_PORTSEL:Capable de slectionner le mdia via ifmap.
IFF_AUTOMEDIA:Slection automatique du mdia.
IFF_DYNAMIC:T{
Adresse perdue quand l'interfac est arrte.
T}
.TE <br/><br/>
crire les attributs est une opration privilgie, mais tout
processus peut les lire.
<br/><br/>

<b>SIOCGIFMETRIC </b>, <b> SIOCSIFMETRIC</b>
Lire ou crire la mtrique du priphrique en utilisant
<b>ifr_metric .</b>
Ceci n'est pas encore implment, il renvoie dans
<b>ifr_metric</b> <b></b>  la valeur 0 si on essaye de lire, et renvoie l'erreur
<b>EOPNOTSUPP</b> <b></b>  si on essaye d'crire.
<br/><br/>

<b>SIOCGIFMTU </b>, <b> SIOCSIFMTU</b>
Lire ou crire le MTU (Maximum Transfer Unit) du priphrique avec
<b>ifr_mtu .</b>
Fixer le MTU est une opration privilgie. Fixer un MTU trop petit
peut faire planter le noyau.
<br/><br/>

<b>SIOCGIFHWADDR </b>, <b> SIOCSIFHWADDR</b>
Lire ou crire l'adresse matrielle du priphrique en utilisant
<b>ifr_hwaddr .</b>
Cette adresse matrielle est indique dans une structure
<i>sockaddr .</i>
<i>sa_family </i> contien le type de priphrique ARPHRD_*,
<i>sa_data</i> est l'adresse matrielle L2 commenant par l'octet 0.
crire l'adresse matrielle est une opration privilgie.
<br/><br/>

<b>SIOCSIFHWBROADCAST</b> <b></b>  Fixer l'adresse de broadcast du priphrique  partir de
<b>ifr_hwaddr .</b>
C'est une opration privilgie.
<br/><br/>

<b>SIOCGIFMAP </b>, <b> SIOCSIFMAP</b>
Lire ou crire les paramtres matriels de l'interface en utilisant
<b>ifr_map .</b>
L'criture des paramtres est une opration privilgie.<br/><br/>

.ta 4 20 42
struct ifmap 
{
	unsigned long	mem_start;
	unsigned long	mem_end;
	unsigned short	base_addr; 
	unsigned char	irq;	
	unsigned char	dma; 
	unsigned char	port; 
};
.ta

<br/><br/>
L'interprtation de la structure ifmap dpend du pilote de priphrique
et de l'architecture.
<br/><br/>

<b>SIOCADDMULTI </b>, <b> SIOCDELMULTI</b>
Ajouter ou supprimer une adresse des filtres multicast du niveau liaison
du priphrique en utilisant
<b>ifr_hwaddr .</b>
Ce sont des oprations privilgies.
Voir aussi
<b>packet (7)</b>
pour une autre possibilit.
<br/><br/>

<b>SIOCGIFTXQLEN </b>, <b> SIOCSIFTXQLEN</b>
Lire ou crire la taille de la file d'mission du priphrique avec
<b>ifr_qlen .</b>
L'criture de la taille de la file est une oprtation privilgie.
<br/><br/>

<b>SIOCSIFNAME</b> <b></b>  Changer le nom de l'interface indique dans 
<b>ifr_name</b>
pour
<b>ifr_newname .</b>
C'est une opration privilgie. Elle n'est possible que si l'interface
n'est pas en fonctionnement.
<br/><br/>

<b>SIOCGIFCONF</b> <b></b>  Renvoie une liste des adresses (couche de transport) des interfaces. Ceci
ne marche actuellement qu'avec les adresses AF_INET (IPv4) pour des raisons
de compatibilit. L'utilisateur passe une structure
<b>ifconf</b> <b></b>  en argument  l'ioctl. Elle contient un pointeur sur une table de structures
<i>ifreq</i> dans son membre
<b>ifc_req</b> <b></b>  et la longueur en octets dans
<b>ifc_len.</b> <b></b>  Le noyau remplit les ifreqs avec toutes les adresses L3 des interfaces
en fonctionnement&nbsp;:
<i>ifr_name </i> contient le nom de l'interfacez (eth0:1 etc.), et
<i>ifr_addr</i> l'adresse.
Le noyau renvoie la longueur relle dans 
<i>ifc_len .</i>
Si 
<i>ifc_len</i> est gal  la longueur originale du buffer, on a probablement atteint la
limite, et il est conseill de recommencer avec un buffer plus grand.
S'il russit, l'ioctl renvoie 0, sinon il renvoie -1.
Atteindre la limite du buffer n'est pas considr comme une erreur.
\" XXX Slaving isn't supported in 2.2
<!--  <br/><br/>
 -->
<!--  <b>SIOCGIFSLAVE </b>, <b> SIOCSIFSLAVE --></b>
<!--  Get or set the slave device using -->
<!--  <b>ifr_slave . --></b>
<!--  Setting the slave device is a privileged operation. -->
<!--  .PP -->
<!--  XXX add amateur radio stuff. --><br/><br/>
La plupart des protocoles supportent leurs propres ioctls pour configurer
les options d'interface spcifiques aux protocoles. Voir les pages de manuel
correspondante. Pour configurer les adresses IP, voir
<b>ip (7).<br/><br/></b>
De plus, certains priphriques supportent des ioctls privs, non dcrits ici.
</div><br/><br /><h1 class="TitreSection0" id="L5">notes</h1>
<div class="paragraph">
Strictement parlant,
<b>SIOCGIFCONF</b> <b></b>  <b></b>  est spcifique  IP et devrait se trouver dans
<b>ip (7).<br/><br/></b>
Les noms des interfaces sans adresses, ou celles qui n'ont pas l'attribut
<b>IFF_RUNNING</b> <b></b>  <b></b>  peuvent tre trouvs dans
<i>/proc/net/dev .<br/><br/></i>
Les adresses IPv6 locales se trouvent dans /proc/net ou grce 
<b>rtnetlink (7).</b>
</div><br/><br /><h1 class="TitreSection0" id="L6">bogues</h1>
<div class="paragraph">
Dans la GlibC 2.1 il manque la maco
<i>ifr_newname </i> dans net/if.h. Ajoutez les lignes suivantes dans votre programme&nbsp;:
<br/><br/>

.RS

.ta 4 20 42
#ifndef ifr_newname
#define ifr_newname     ifr_ifru.ifru_slave
#endif
.ta



</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>ip (7),</b>
<b>proc (7),</b>
<b>rtnetlink (7)</b>
</div><br/><br /><h1 class="TitreSection0" id="L8">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
