<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
'\" t
<!--  Don't change the first line, it tells man that tbl is needed. -->
<!--  This man page copyright 1998 by Andi Kleen. Subject to the GPL. -->
<!--  This manpage copyright 1998 by Andi Kleen. Subject to the GPL. -->
<!--  Based on the original comments from Alexey Kuznetsov -->
<!--  $Id: netlink.7,v 1.8 2000/06/22 13:23:00 ak Exp $ -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>NETLINK</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">format d'adresse</a>
<br /><a class="summaryIndent0" href="#L4">bogues</a>
<br /><a class="summaryIndent0" href="#L5">notes</a>
<br /><a class="summaryIndent0" href="#L6">versions</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
netlink, PF_NETLINK - Communication entre noyau et utilisateur.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">

<!--  XXX -->
<b>#include</b> <b></b>  <b>&lt;asm/types.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;linux/netlink.h&gt;</b> <b></b>  <b></b>  <br/><br/><br/>
<b>netlink_socket = socket(PF_NETLINK, </b> socket_type <i>, </i> netlink_family ); 
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Netlink sert  transfrer des informations entre les modules du noyau et les
processus de l'espace utilisateur. Il consiste en une interface base sur 
les sockets standards pour les processus utilisateur et d'une API interne
pour les modules du noyau. Cette interface n'est pas documente dans cette
page de manuel. Il existe aussi une interface obsolte via un priphrique
caractre netlink, rserve pour compatibilit et non documente ici.<br/><br/>
Netlink est un service orient datagramme. Les deux types
<b>SOCK_RAW</b> <b></b>  <b></b>  et
<b>SOCK_DGRAM</b> <b></b>  sont des valeurs possibles pour
<i>socket_type </i> ;<i></i>
toutefois, le protocole netlink ne distingue pas les sockets raw et
datagrammes.<br/><br/>
<i>netlink_family</i> slectionne le module du noyau ou le groupe netlink avec qui communiquer.
Les familles netlink actuellement affecte sont&nbsp;:
<br/><br/>

<b>NETLINK_ROUTE</b> <b></b>  Reoit les modifications de routage et peut tre utilis pour mettre
 jour les tables de routage IPv4 (voir
<b>rtnetlink (7)).</b>
<br/><br/>

<b>NETLINK_FIREWALL</b> <b></b>  <b></b>  Reoit les paquets envoys par le code du firewall IPv4.
<br/><br/>

<b>NETLINK_ARPD</b> <b></b>  Pour grer la table Arp dans l'espace utilisateur.
<br/><br/>

<b>NETLINK_ROUTE6</b> <b></b>  Reoit et envoie les mise  jour de la table de routage IPv6.
<br/><br/>

<b>NETLINK_IP6_FW</b> <b></b>  Pour recevoir les paquets rejets par le firewall IPv6 (pas encore
implment).
<br/><br/>

<b>NETLINK_TAPBASE ... NETLINK_TAPBASE+15</b>
sont les instances du priphrique
<b>ethertap .</b>
Ce priphrique est un tunnel pour pseudo-rseau qui permet de simuler
un pilote Ethernet depuis l'espace utilisateur.
<br/><br/>

<b>NETLINK_SKIP</b> <b></b>  Rserv pour ENskip.
<br/><br/>

<b>NETLINK_USERSOCK</b> <b></b>  Rserv pour les futurs protocoles dans l'espace utilisateur.<br/><br/>
Les messages netlink consistent en un flux d'octets avec un ou plusieurs
en-ttes
<b>nlmsghdr</b> <b></b>  et les contenus associs. Pour les messages multi-parties, tous les en-ttes
ont l'attribut
<b>NLM_F_MULTI</b> <b></b>  actif, sauf le dernier en-tte qui a le type
<b>NLMSG_DONE .</b>
Le flux d'octets ne doit tre accd qu' travers les macros standards
<b>NLMSG_*</b> <b></b>  voir
<b>netlink (3). <br/><br/></b>
Netlink n'est pas un protocole fiable. Il fait de son mieux pour conduire
les messages  destination, mais peut abandonner des messages s'il n'a pas
assez de mmoire ou si une erreur se produit. Pour un transfert fiable,
l'metteur peut demander un acquittement du rcepteur en activant l'attribut
<b>NLM_F_ACK .</b>
Un acquittement est un paquet
<b>NLMSG_ERROR</b> <b></b>  <b></b>  avec le champ erreur  zro. L'application doit envoyer des acquittements
pour les messages eux-mme. Le noyau essaye d'envoyer un message
<b>NLMSG_ERROR</b> <b></b>  pour chaque paquet chou. Le processus utilisateur devrait suivre aussi
cette convention.<br/><br/>
Chaque famille netlink a un ensemble de 32 groupes multicast.
Quand on appelle
<b>bind (2)</b>
sur la socket, le champ
<b>nl_groups</b> <b></b>  de la structure
<b>sockaddr_nl</b> <b></b>  doit contenir un masque de bits des groupes que l'on dsire couter.
La valeur par dfaut pour ce champ est zro, ce qui signifie qu'aucun
groupe multicast ne sera reu.
Une socket peut envoyer un message sur n'importe quel groupe multicast
en remplissant le champ
<b>nl_groups</b> <b></b>  avec un masque de bit des groupes viss, lors de l'appel
<b>sendmsg (2) </b>
ou lors du
<b>connect (2).</b>
Seul les processus avec un UID effectif nul ou la capacit
<b>CAP_NET_ADMIN</b> <b></b>  peuvent envoyer ou recevoir sur un
groupe multicast netlink.
Toute rponse pour un message reu sur un groupe multicast
doit tre renvoye au PID metteur et au groupe multicast. <br/><br/>
.RS

.ta 4 13 25
struct nlmsghdr
{
	__u32	nlmsg_len;	/* Longueur y compris en-tte */
	__u16	nlmsg_type;	/* Contenu message            */
	__u16	nlmsg_flags;	/* Attributs supplmentaires  */
	__u32	nlmsg_seq;	/* Numro de squence         */
	__u32	nlmsg_pid;	/* PID du crateur socket     */
};<br/><br/>

struct nlmsgerr
{
	int	error;	/* errno ngatif ou 0 pour acquit. */
	struct nlmsghdr msg;	/* en-tte message causant l'erreur */ 
};
.ta


<br/><br/>
Aprs chaque
<b>nlmsghdr</b> <b></b>  le contenu du message suit.
<b>nlmsg_type</b> <b></b>  peut tre l'un des types standards de message&nbsp;:
<b>NLMSG_NOOP</b> <b></b>  message  ignorer,
<b>NLMSG_ERROR</b> <b></b>  message indiquant une erreur, son contenu est une
structure
<i>nlmsgerr ,</i>
<b>NLMSG_DONE</b> <b></b>  message final d'un ensemble multiparties.
<!--  2.1.130 does not seem to use it. -->
<!--  <b>NLMSG_OVERRUN</b> <b></b>  <b>--></b> <b></b>  <!--  data was lost.  --><br/><br/>
Une famille netlink contient des types supplmentaires de message, voir
la page de manuel apprprie, par exemple
<b>rtnetlink (7)</b>
pour
<i>NETLINK_ROUTE .<br/><br/></i>
.TS 
tab(:); 
l s 
l l.
Attribut standards dans nlmsg_flags
NLM_F_REQUEST:pour toutes les requtes
NLM_F_MULTI:T{
le message est multi-parties, temrine par 
<b></b>  NLMSG_DONE
<!--  XXX describe that -->
T}
NLM_F_ACK:envoyer un acquittement de russite
NLM_F_ECHO:renvoyer cette requte
.TE<br/><br/>
.TS
tab(:);
l s 
l l.
Attributs supplmentaires pour requtes GET
NLM_F_ROOT:Renvoyer toute la table plutt qu'une seule entre.
NLM_F_MATCH:Pas encore implment.
NLM_F_ATOMIC:Renvoyer une image instantane de la table.
NLM_F_DUMP:Pas encore document.
.TE<br/><br/>
.TS
tab(:);
l s
l l.
Attributs supplmentaires pour requtes NEW
NLM_F_REPLACE:Ecraser l'objet existant.
NLM_F_EXCL:Ne pas remplacer l'objet s'il existe dj.
NLM_F_CREATE:Crer un objet s'il n'existe pas.
NLM_F_APPEND:Ajouter  la fin de la liste d'objets.
.TE<br/><br/>
Notez que NLM_F_ATOMIC ncessite la capacit CAP_NET_ADMIN ou les droits root.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">format d'adresse</h1>
<div class="paragraph">
La structure
<b>sockaddr_nl</b> <b></b>  dcrit un client netlink dans l'espace utilisateur ou dans le noyau.
une sockaddr_nl peut tre soit unicast (un seul destinataire) ou dcrire
un groupe netlink (nl_groups diffrent de 0). <br/><br/>
.RS

struct sockaddr_nl
{
    sa_family_t nl_family;    /* AF_NETLINK               */
    unsigned short nl_pad;    /* zro                     */
    pid_t       nl_pid;       /* PID                      */
    __u32       nl_groups;    /* masque groupes multicast */
};


<br/><br/>
<b>nl_pid</b> <b></b>  est le PID du processus propritaire de la socket de destination ou zro
si la destination est dans le noyau.
<b>nl_groups</b> <b></b>  <b></b>  est un masque de bits reprsentant les groupes netlink.
<!--  XXX describe what that is.  --><br/><br/>

</div><br/><br /><h1 class="TitreSection0" id="L5">bogues</h1>
<div class="paragraph">
Cette page de manuel n'est pas complte.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">notes</h1>
<div class="paragraph">
Il est souvent plus facile d'utiliser netlink  travers la bibliothque
<b>libnetlink</b> <b></b>  que vial l'interface bas-niveau du noyau.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">versions</h1>
<div class="paragraph">
L'interface par socket de netlink est une nouveaut dans Linux 2.2.<br/><br/>
Linux 2.0 supporte une interface plus primitive, base sur un priphrique
caractre (toujours valable pour compatibilit). Cette interface obsolte
n'est pas dcrite ici.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>cmsg (3),</b>
<b>rtnetlink (7),</b>
<b>netlink (3)<br/><br/></b>
ftp://ftp.inr.ac.ru/ip-routing/iproute2* 
pour libnetlink
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
