<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
'\" t
<!--  Don't remove the line above, it tells man that tbl is needed. -->
<!--  This man page is Copyright (C) 1999 Andi Kleen &lt;ak@muc.de&gt;. -->
<!--  Permission is granted to distribute possibly modified copies -->
<!--  of this page provided the header is included verbatim, -->
<!--  and in case of nontrivial modification author and date -->
<!--  of the modification is added to the header. -->
<!--  Based on the original comments from Alexey Kuznetsov, written with -->
<!--  help from Matthew Wilcox.  -->
<!--  $Id: rtnetlink.7,v 1.8 2000/01/22 01:55:04 freitag Exp $ -->
<!--  Traduction Christophe Blaess, &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>RTNETLINK</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">attributs de routage</a>
<br /><a class="summaryIndent0" href="#L4">messages</a>
<br /><a class="summaryIndent0" href="#L5">versions</a>
<br /><a class="summaryIndent0" href="#L6">bogues</a>
<br /><a class="summaryIndent0" href="#L7">voir aussi</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
rtnetlink, NETLINK_ROUTE - Socket de routage Linux IPv4.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;asm/types.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;linux/netlink.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;linux/rtnetlink.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;<br/><br/></b> <b></b>  <b>rtnetlink_socket = socket(PF_NETLINK, int </b> socket_type <i>, NETLINK_ROUTE);</i><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Rtnetlink permet de lire et modifier les tables de routage du noyau.
Cela permet des communications entre divers sous-systmes du noyau, bien que
cette utilisation en soit pas documente ici, et pour les communications
avec les programmes de l'espace utilisateur.
Les routes rseau, les adresses IP, les paramtres de liaison, 
la configuration du voisinage, les files, les classes de trafic et les
classes de paquets peuvent tre configurs par le biais des sockets
<b>NETLINK_ROUTE .</b>
Elles sont bases sur des messages netlink, voir
<b>netlink (7)</b>
pour plus d'informations.<br/><br/>
<!--  XXX: all these macros could be moved to rtnetlink(3)  --><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">attributs de routage</h1>
<div class="paragraph">
Certains messages netlink ont des attributs supplmentaires aprs l'en-tte
initial&nbsp;:<br/><br/>

.ta 4 19 32
struct rtattr
{
	unsigned short	rta_len;	/* Longueur option */
	unsigned short	rta_type;	/* Type d'option   */
	/* Les donnes suivent... */
};

<br/><br/>
Ces attributs ne doivent tre manipuls qu'en utilisant les macros RTA_* ou
libnetlink, voir
<b>rtnetlink (3).<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L5">messages</h1>
<div class="paragraph">
Rtnetlink est constitu de trois types de messages (en plus des messages
netlink standards)&nbsp;:
<br/><br/>

<b>RTM_NEWLINK </b>, <b> RTM_DELLINK </b>, <b> RTM_GETLINK</b>
Crer, supprimer, ou obtenir des informations   propos d'une interface
rseau spcifique. Ces messages contiennent une structure
<b>ifinfomsg</b> <b></b>  suivie d'une srie de
structures
<b>rtattr .<br/><br/></b>

.ta 4 19 32
struct ifinfomsg
{
	unsigned char	ifi_family;	/* AF_UNSPEC         */
	unsigned short	ifi_type;	/* Type priphrique */
	int	ifi_index;		/* Index Interface   */
	unsigned int	ifi_flags;	/* Attributs priph. */
	unsigned int	ifi_change;	/* Masque modificat */
};

<br/><br/>
<!--  XXX ifi_type -->
<b>ifi_flags</b> <b></b>  <b></b>  contient les attributs du priphrique, voir
<b>netdevice </b>(7) ;<b></b>
<b>ifi_index</b> <b></b>  est l'index unique de l'interface&nbsp;;
<b>ifi_change</b> <b></b>  est rserv pour un usage ultrieur et doit toujours valoir 0xFFFFFFFF. <br/><br/>

.TS
tab(:);
c
l l l.
Attributs de routage
rta_type:type valeur:description
_
IFLA_UNSPEC:-:non-spcifi.
IFLA_ADDRESS:adresse matrielle:Adresse L2 interface.
IFLA_BROADCAST:adresse matrielle:Adresse L2 Broadcast.
IFLA_IFNAME:chane AsciiZ:Nom priphrique.
IFLA_MTU:unsigned int:MTU du priphrique.
IFLA_LINK:int:Type liaison.
IFLA_QDISC:chane AsciiZ:Mcanismes files.
IFLA_STATS:T{
struct net_device_stats
T}:Statistiques interface.
.TE
<br/><br/>
	
<b>RTM_NEWADDR </b>, <b> RTM_DELADDR </b>, <b> RTM_GETADDR</b>
Ajouter, supprimer ou obtenir des informations sur une adresse IP associe
 une interface. Sous Linux 2.2. une interface peut grer plusieurs adresses
IP, ce qui remplace le concept d'alias de Linux 2.0. Dans Linux 2.2., ces
messages supportent les adresses IPv4 et IPv6. Ils contiennent une structure
<b>ifaddrmsg ,</b>
suivie ventullement par des 
attributs de routage
<b>rtaddr .<br/><br/></b>

.ta 4 19 32
struct ifaddrmsg
{
	unsigned char	ifa_family;	/* Type adresse       */
	unsigned char	ifa_prefixlen;	/* Lg prfixe adresse */
	unsigned char	ifa_flags;	/* Attributs adresse  */
	unsigned char	ifa_scope;	/* Porte adresse     */
	int	ifa_index;		/* Index interface    */
};

<br/><br/>
<b>ifa_family</b> <b></b>  est le type de famille d'adresse (actuellement
<b>AF_INET</b> <b></b>  ou
<b>AF_INET6)</b> <b></b> ,<b></b>  <b></b>  <b>ifa_prefixlen</b> <b></b>  est la longueur du masque d'adresse, s'il est dfini pour la
famille (comme avec IPv4),
<b>ifa_scope</b> <b></b>  est la porte de l'adresse,
<b>ifa_index</b> <b></b>  est l'index de l'interface associe  l'adresse.
<b>ifa_flags</b> <b></b>  est un attribut compos de
<b>IFA_F_SECONDARY</b> <b></b>  pour une adresse secondaire (les anciens alias d'interface),
<b>IFA_F_PERMANENT</b> <b></b>  pour une adresse fixe par l'utilisateur, et d'autres attribut non documents.<br/><br/>
.TS
tab(:);
c
l l l.
Attributes
rta_type:type valeur:description
_
IFA_UNSPEC:-:non-spcifi.
IFA_ADDRESS:Adresse protocole raw:Adresse interface.
IFA_LOCAL:Adresse protocole raw:Adresse locale.
IFA_LABEL:Chane AsciiZ:Nom de l'interface.
IFA_BROADCAST:Adresse protocole raw:Adresse broadcast.
IFA_ANYCAST:Adresse protocole raw:Adresse anycast.
IFA_CACHEINFO:struct ifa_cacheinfo:Informations adresse.
.TE<br/><br/>
<!--  XXX struct ifa_cacheinfo -->
<br/><br/>
	
<b>RTM_NEWROUTE </b>, <b> RTM_DELROUTE </b>, <b> RTM_GETROUTE</b>
Crer, supprimer ou obtenir des informations  propos d'une route rseau.
Ces messages contiennent une structure
<b>rtmsg</b> <b></b>  suivie d'une squence ventuelle de structures
<b>rtattr .</b>
Pour
<b>RTM_GETROUTE</b> <b></b>  mettre 
<b>rtm_dst_len</b> <b></b>  <b></b>  et 
<b>rtm_src_len</b> <b></b>  <b></b>   0 signifie obtenir toutes les entres pour la table de routage indique.
Pour les autres champs, sauf
<b>rtm_table</b> <b></b>  <b></b>  et 
<b>rtm_protocol ,</b>
0 est le symbole gnrique signifiant "toutes valeurs".<br/><br/>

.ta 4 19 32
struct rtmsg
{
	unsigned char	rtm_family;	/* Famille d'adresse de la route */
	unsigned char	rtm_dst_len;	/* Longueur source               */
	unsigned char	rtm_src_len;	/* Longueur destination          */ 
	unsigned char	rtm_tos;	/* Filtre TOS                    */<br/><br/>
	unsigned char	rtm_table;	/* ID table routage              */
	unsigned char	rtm_protocol;	/* Protocole route, cf plus bas  */
	unsigned char	rtm_scope;	/* Cf plus bas                   */	
	unsigned char	rtm_type;	/* Cf plus bas                   */<br/><br/>
	unsigned int	rtm_flags;
};

<br/><br/>
.TS
tab(:);
l l
l l.
rtm_type:Type route
_
RTN_UNSPEC:Route inconnue
RTN_UNICAST:Passerelle ou route directe
RTN_LOCAL:Route interface locale
RTN_BROADCAST:T{
Route broadcast locale (envoi en broadcast)
T}
RTN_ANYCAST:T{
Route broadcast locale (envoi en unicast)
T}
RTN_MULTICAST:Route multicast
RTN_BLACKHOLE:Route d'abandon de paquets
RTN_UNREACHABLE:Destination unaccessible
RTN_PROHIBIT:Route de rejet de paquets
RTN_THROW:Routage prolong dans une autre table
RTN_NAT:Route de traduction d'adresse
RTN_XRESOLVE:T{
Rfrence  une rsolution externe (non implment)
T}
.TE<br/><br/>
.TS
tab(:);
l l.
rtm_protocol:Origine de la route.
_
RTPROT_UNSPEC:inconnue
RTPROT_REDIRECT:T{
redirection ICMP (inutilis actuellement)
T}
RTPROT_KERNEL:fixe par le noyau
RTPROT_BOOT:obtenue pendant le boot
RTPROT_STATIC:fixe par l'administrateur
.TE<br/><br/>
Les valeurs plus grande que
<b>RTPROT_STATIC</b> <b></b>  ne sont pas interprtes par le noyau, et servent d'information utilisateur.
Elles permettent de marquer la source de la route ou de faire une distinction
entre plusieurs dmons de routage. Voir
<b>&lt;linux/rtnetlink.h&gt;</b>
pour les identificateurs de dmons de routage dj affects.<br/><br/>
<b>rtm_scope</b> <b></b>  <b></b>  est la distance  la destination&nbsp;:<br/><br/>
.TS
tab(:);
l l.
RT_SCOPE_UNIVERSE:route globale
RT_SCOPE_SITE:T{
route locale interne au systme autonome
T}
RT_SCOPE_LINK:route sur ce lien
RT_SCOPE_HOST:route sur l'hte local
RT_SCOPE_NOWHERE:destination inexistante
.TE<br/><br/>
Les valeurs entre
<b>RT_SCOPE_UNIVERSE</b> <b></b>  et
<b>RT_SCOPE_SITE</b> <b></b>  sont disponibles pour l'utilisateur.<br/><br/>
Le champ
<b>rtm_flags</b> <b></b>  prend les significations suivantes&nbsp;:<br/><br/>
.TS
tab(:);
l l.
RTM_F_NOTIFY:T{
si la route change, notifier l'utilisateur via rtnetlink
T}
RTM_F_CLONED:la route est clone depuis une autre route
RTM_F_EQUALIZE:rpartiteur multicast (pas encore implment)
.TE<br/><br/>
<b>rtm_table</b> <b></b>  indique la table de routage<br/><br/>
.TS
tab(:);
l l.
RT_TABLE_UNSPEC:table de routage non spcifie
RT_TABLE_DEFAULT:la table par dfaut
RT_TABLE_MAIN:la table principale
RT_TABLE_LOCAL:la table locale
.TE<br/><br/>
L'utilisateur peut affecter  son gr les valeurs entre
<b>RT_TABLE_UNSPEC</b> <b></b>  et
<b>RT_TABLE_DEFAULT .<br/><br/></b>
.TS
tab(:);
c
l l l.
Attributes
rta_type:type de valeur:description
_
RTA_UNSPEC:-:ignor.
RTA_DST:Adresse protocole:Adresse de la route destination.
RTA_SRC:Adresse protocole:Adresse de la route source.
RTA_IIF:int:Index interface d'entre.
RTA_OIF:int:Index interface de sortie.
RTA_GATEWAY:Adresse protocole:Passerelle de la route.
RTA_PRIORITY:int:Priorit de la route.
RTA_PREFSRC::
RTA_METRICS:int:Mtrique de la route.
RTA_MULTIPATH::
RTA_PROTOINFO::
RTA_FLOW::
RTA_CACHEINFO::
.TE<br/><br/>
<!-- <b>Fill</b> <b></b>  <b>these</b> <b></b>  <b>values</b> <b></b>  <b>in!</b> <b></b>  <b>--></b> <b></b>  <br/><br/>
	
<b>RTM_NEWNEIGH </b>, <b> RTM_DELNEIGH  </b>, <b> RTM_GETNEIGH	</b>
Ajouter, supprimer ou obtenir des informations sur les voisinage d'un
lment de table (ex : entre ARP). Le message contient une
structure
<b>ndmsg .<br/><br/></b>

.ta 4 19 32
struct ndmsg
{
	unsigned char	ndm_family;
	int	ndm_ifindex;	/* Index interface */
	__u16	ndm_state;	/* tats */ 
	__u8	ndm_flags;	/* Attributs */
	__u8	ndm_type;   
};<br/><br/>
struct nda_cacheinfo
{
	__u32	ndm_confirmed;
	__u32	ndm_used;
	__u32	ndm_updated;
	__u32	ndm_refcnt;
};

<br/><br/>
<b>ndm_state</b> <b></b>  est un masque contenant les bits suivants&nbsp;:<br/><br/>
.TS
tab(:);
l l.
NUD_INCOMPLETE:une entre de cache non rsolue.
NUD_REACHABLE:une entre de cache confirme correcte.
NUD_STALE:une entre de cache expire.
NUD_DELAY:une entre de cache en attente de timer.
NUD_PROBE:une entre de cache en vrification.
NUD_FAILED:une entre de cache invalide.
NUD_NOARP:un priphrique sans cache de destination.
NUD_PERMANENT:une entre statique.
.TE<br/><br/>
Les valeurs valides pour
<b>ndm_flags</b> <b></b>  sont&nbsp;:<br/><br/>
.TS
tab(:);
l l.
NTF_PROXY:nne entre proxy Arp.
NTF_ROUTER:un routeur IPv6.
.TE<br/><br/>
<!-- <b>document</b> <b></b>  <b>the</b> <b></b>  <b>members</b> <b></b>  <b>of</b> <b></b>  <b>the</b> <b></b>  <b>struct</b> <b></b>  <b>better</b> <b></b>  <b>--><br/><br/></b> <b></b>  La structure
<b>rtaddr</b> <b></b>  prend les significations suivantes pour
le champ
<b>rta_type </b> :<b><br/><br/></b>
.TS
tab(:);
l l.
NDA_UNSPEC:type inconnu
NDA_DST:une adresse niveau rseau dans le cache de voisinage.
NDA_LLADDR:une adresse niveau liaison dans le cache voisinage.
NDA_CACHEINFO:statistiques sur le cache.
.TE<br/><br/>
Si le champ
<b>rta_type</b> <b></b>  vaut
<b>NDA_CACHEINFO</b> <b></b>  alors un en-tte
<b>struct</b> <b></b>  <b>nda_cacheinfo</b> <b></b>  suit.
<br/><br/>

<b>RTM_NEWRULE </b>, <b> RTM_DELRULE </b>, <b> RTM_GETRULE</b>
Ajouter, supprimer ou rechercher une rgle de routage. Utilise une
<b>struct rtmsg .</b>
<br/><br/>

<b>RTM_NEWQDISC </b>, <b> RTM_DELQDISC </b>, <b> RTM_GETQDISC</b>
Ajouter, supprimer ou rechercher une displine de file d'attente. Le message
contient une structure
<b>struct</b> <b></b>  <b>tcmsg</b> <b></b>  et peut tre suivi par une srie d'attributs.<br/><br/>

.ta 4 19 32
struct tcmsg
{
	unsigned char	tcm_family;
	int	tcm_ifindex;	/* Index interface */
	__u32	tcm_handle;	/* Handle Qdisc    */ 
	__u32	tcm_parent;	/* Parent Qdisc    */
	__u32	tcm_info;
};

<br/><br/>
.TS
tab(:);
c
l l l.
Attributes
rta_type:Type valeur:Description
_
TCA_UNSPEC:-:unspecified
TCA_KIND:Chane AsciiZ:Nom de la discipline de file
TCA_OPTIONS:Squence octets:Options spcifiques Qdisc suivent
TCA_STATS:struct tc_stats:Statistiques Qdisc
TCA_XSTATS:Spcifique Qdisc:Statistiques spcifiques module
TCA_RATE:struct tc_estimator:Limitation taux
.TE<br/><br/>
De plus d'autres attributs spcifiques au module Qdisc sont possibles.
Pour plus d'information, voir les fichiers d'en-tte appropris.
<br/><br/>

<b>RTM_NEWTCLASS </b>, <b> RTM_DELTCLASS </b>, <b> RTM_GETTCLASS</b>
Ajouter, supprimer ou rechercher une classe de trafic. Ces messages
contiennent une
<b>struct</b> <b></b>  <b>tcmsg</b> <b></b>  dcrite plus haut.
<br/><br/>

<b>RTM_NEWTFILTER </b>, <b> RTM_DELTFILTER </b>, <b> RTM_GETTFILTER</b>
Ajouter, supprimer ou obtenir des informations sur un flitre de trafic.
Ces messages contiennent une
<b>struct</b> <b></b>  <b>tcmsg</b> <b></b>  dcrite plus haut.
</div><br/><br /><h1 class="TitreSection0" id="L6">versions</h1>
<div class="paragraph">
<b>rtnetlink</b> <b></b>  <b></b>  est une nouveaut Linux 2.2.
</div><br/><br /><h1 class="TitreSection0" id="L7">bogues</h1>
<div class="paragraph">
Cette page de manuel est trs incomplte.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">voir aussi</h1>
<div class="paragraph">
<b>netlink (7),</b>
<b>cmsg (3),</b>
<b>ip (7),</b>
<b>rtnetlink (3)</b>
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
