<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  This man page is Copyright (C) 1999 Andi Kleen &lt;ak@muc.de&gt;. -->
<!--  Permission is granted to distribute possibly modified copies -->
<!--  of this page provided the header is included verbatim, -->
<!--  and in case of nontrivial modification author and date -->
<!--  of the modification is added to the header. -->
<!--  $Id: tcp.7,v 1.10 2000/01/22 01:55:04 freitag Exp $ -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt;  -->
<!--  11/06/2001 - LDP-man-pages-1.37 -->
<!--  MJ LDP-1.47 -->
<br/><h1>TCP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">formats d'adresse</a>
<br /><a class="summaryIndent0" href="#L4">sysctls</a>
<br /><a class="summaryIndent0" href="#L5">options des sockets</a>
<br /><a class="summaryIndent0" href="#L6">ioctls</a>
<br /><a class="summaryIndent0" href="#L7">gestion d'erreur</a>
<br /><a class="summaryIndent0" href="#L8">notes</a>
<br /><a class="summaryIndent0" href="#L9">erreurs</a>
<br /><a class="summaryIndent0" href="#L10">bogues</a>
<br /><a class="summaryIndent0" href="#L11">versions</a>
<br /><a class="summaryIndent0" href="#L12">auteurs</a>
<br /><a class="summaryIndent0" href="#L13">voir aussi</a>
<br /><a class="summaryIndent0" href="#L14">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
tcp - Protocole TCP.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;netinet/in.h&gt;</b> <b></b>  <br/>
<b>tcp_socket</b> <b></b>  <b>=</b> <b></b>  <b>socket(PF_INET</b> <b></b> ,<b></b>  <b>SOCK_STREAM</b> <b></b> ,<b></b>  <b>0);</b> <b></b>  <b></b>  </div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Il s'agit d'une implmentation du protocole TCP dfini dans les
RFC 793, RFC 1122 et RFC 2001
avec les extensions SACK et NewReno.
Cela fournit un connexion full-duplex fiable oriente flux entre
deux sockets au-dessus de
<b>ip (7).</b>
TCP garantit que les donnes arrivent dans l'ordre et assure la retransmission
des paquets perdus. Il calcule et vrifie une somme de contrle par paquet pour
dtecter les erreurs de transmission. TCP ne prserve pas les limites des enregistrements.<br/><br/>
Une socket TCP neuve n'a pas d'adresse locale ou distante et n'est pas compltement dfinie.
Pour crer une connexion TCP sortante, utilisez
<b>connect (2)</b>
pour tablir la connexion sur une autre socket TCP.
Pour recevoir les connexions entrantes, attachez d'abord la socket avec
<b>bind (2) </b>
 une adresse locale et un port, puis appelez
<b>listen (2)</b>
pour mettre la socket dans un tat d'attente. Aprs cela, une nouvelle
socket peut tre obtenue pour chaque connexion entrante
en utilisant
<b>accept (2).</b>
Une socket sur laquelle on a appel
<b>accept</b> <b></b>  ou
<b>connect</b> <b></b>  avec succs est compltement dfinie et peut transmettre des donnes.
Les donnes ne peuvent pas circuler sur les socket en attente ou non connectes.<br/><br/>
Linux 2.2 supporte les extensions TCP  hautes performances RFC 1323. Cela inclue
les fentres TCP larges pour supporter les liaisons avec une latence ou une
bande passante leves.
Pour les utiliser, les tailles des buffers d'mission et de rception doivent tre augmentes.
On peut les fixer globalement avec les sysctls
<b>net.ipv4.tcp_wmem</b> <b></b>  et
<b>net.ipv4.tcp_rmem</b> <b></b>  ou individuellement sur les sockets avec les options
<b>SO_SNDBUF</b> <b></b>  <b></b>  et
<b>SO_RCVBUF</b>
de l'appel-systme
<b>setsockopt (2).<br/><br/></b>
Les tailles maximales pour les buffers dclars via
<b>SO_SNDBUF</b> <b></b>  et
<b>SO_RCVBUF</b> <b></b>  sont limites par les sysctls gnraux
<b>net.core.rmem_max</b> <b></b>  et
<b>net.core.wmem_max</b> <b></b>  Notez que TCP alloue en fait deux fois plus de place que la taille
demande avec l'appel
<b>setsockopt (2),</b>
et qu'un appel
<b>getsockopt (2)</b>
russi ne renverra pas la mme taille de buffer que celle
rclame dans le
<b>setsockopt (2).</b>
TCP les utilise  des fins administratives et pour des structures internes
du noyau, et les variables sysctls renvoient des tailles suprieures 
 celle des vritables fentres TCP.
Pour les connexions individuelles, la taille du buffer doit tre
fixe avant les appels
<b>listen ()</b>
ou
<b>connect ()</b>
pour qu'elle soit prise en compte. Voir
<b>socket (7)</b>
pour plus de dtails.<br/><br/> 
TCP supporte les donnes urgentes. Elles signalent au rcepteur qu'un message
important est dans le flux de donnes et qu'il doit tre trait
le plus tt possible.
Pour envoyer des donnes urgentes, indiquez l'option
<b>MSG_OOB</b> <b></b>  de
<b>send (2).</b>
Quand des donnes urgentes sont reues, le noyau envoie un signal
<b>SIGURG</b> <b></b>  au processus lecture ou au groupe de processus qui a t indiqu
pour la socket avec les ioctls
<b>FIOCSPGRP</b> <b></b>  ou
<b>FIOCSETOWN .</b>
Quand l'option de socket
<b>SO_OOBINLINE</b> <b></b>  est valide, les donnes urgentes sont mises dans le flux de donnes normal
(et peuvent tre dtectes avec l'ioctl
<b>SIOCATMARK ),</b>
sinon, on ne peut
les recevoir que lorsque l'attribut
<b>MSG_OOB</b> <b></b>  et positionn pour
<b>sendmsg (2). <br/><br/></b>
Linux 2.4 a introduit un certain nombre de changements pour amliorer le
dbit et l'extensibilit, ainsi que des fonctionnalits amliores.
Certaines de ces fonctions incluent le support pour l'mission sans copie avec
<b>sendfil (2),</b>
la notification de congestion explicitie, la nouvelle gestion des sockets
TIME_WAIT, les options "keep-alive" et le support des extensions SACK dupliqus.
</div><br/><br /><h1 class="TitreSection0" id="L4">formats d'adresse</h1>
<div class="paragraph">
TCP est construit au-dessus de IP (voir
<b>ip (7)).</b>
Les formats d'adresse dfinis pour
<b>ip (7)</b>
s'appliquent pour TCP. TCP ne supporte que les communications point--point.
Le broadcast et le multicast ne sont pas supports.
</div><br/><br /><h1 class="TitreSection0" id="L5">sysctls</h1>
<div class="paragraph">
Ces variables sont accessibles avec les fichiers
<b>/proc/sys/net/ipv4/*</b> <b></b>  <b></b>  ou avec l'interface
<b>sysctl (2).</b>
De plus, la plupart des sysctls d'IP s'appliquent  TCP. Voir
<b>ip (7). </b>
<br/><br/>

<b>tcp_abort_on_overflow</b> <b></b>  Valide la rinitialisation des connexions si le service en coute est trop
lent et incapable de les traiter et les accepter. Ceci n'est pas valid par
dfaut. Ce qui signifie que si un dborderment se produit  cause d'une surcharge
temporaire, la connexion va se rattraper. N'activez cette option que si vous
tes SRS que le dmon en coute ne peut pas tre configur pour accepter
les connexions plus vite. Cette option peut dsorienter les clients
de votre serveur.
<br/><br/>

<b>tcp_adv_win_scale</b> <b></b>  Calculer le surplus du buffer comme 1/2^tcp_adv_win_scale
(si tcp_adv_win_scale &gt; 0) ou 1&nbsp;-&nbsp;1/2^(-tcp_adv_win_scale)
(si tcp_adv_win_scal &lt;= 0). La valeur par dfaut est 2.<br/><br/>
L'espace du buffer de rception de la socket est partag entre l'application
et le noyau. TCP conserve une portion du buffer en tant que fentre TCP, c'est
la taille de la fentre de rception indique au correspondant. Le reste
de cet espace est utilis comme buffer d'"application", pour isoler le
rseau des latences de l'ordonnanceur et de l'application.
La valeur par dfaut de
<b>tcp_adv_win_scale</b> <b></b>  (2) indique que l'espace utilis
pour le buffer d'application est un quart
de l'espace total.
<br/><br/>
 
<b>tcp_app_win</b> <b></b>  <b></b>  Cette variable dfinit combien d'octets
de la fentre TCP sont rservs pour
le surplus de buffer.<br/><br/>
Un maximum de (fenetre/2^tcp_app_win, mss) octets de la fentre
est rserv pour le buffer d'application. Une valeur nulle indique
qu'aucune portion n'est rserve. La valeur par dfaut est 31.
<br/><br/>

<b>tcp_dsack</b> <b></b>  Valide le support TCP SACK dupliqu, de la RFC2883.
Valid par dfaut.
<br/><br/>

<b>tcp_ecn</b> <b></b>  Valide la notification explicite de congestion de la RFC2884. Elles n'est pas
active par dfaut. Lorsqu'elle est en service, la connectivit avec certaines
destinations peut tre affecte  cause de vieux routeurs mal configurs le
long du trajet, et les connexions peuvent tre rompues.
<br/><br/>

<b>tcp_fack</b> <b></b>  Valide le support TCP Forward Acknoledgement. Valid
par dfaut.
<br/><br/>

<b>tcp_fin_timeout</b> <b></b>  Nombre de secondes  attendre un paquet final FIN avant que la socket soit
ferme de force. Strictement parlant, ceci est une violation des spcifications TCP,
mais est ncessaire pour empcher les attaques par dni de service.
La valeur par dfaut dans les noyaux 2.4 est 60, elle tait 180 dans les 2.2.
<br/><br/>

<b>tcp_keepalive_intvl</b> <b></b>  L'intervalle en secondes entre deux messages TCP keep-alive.
La valeur par dfaut est 75 secondes.
<br/><br/>

<b>tcp_keepalive_probes</b> <b></b>  Nombre maximal de tentatives TCP keep-alive  envoyer
avant d'abandonner et de tuer la connexion si aucune
rponse n'est obtenue de l'autre partie.
La valeur par dfaut est 9.
<br/><br/>

<b>tcp_keepalive_time</b> <b></b>  Nombre de secondes durant lesquelles aucune donne n'est transmise
sur la connexion avant d'envoyer un message keep-alive.
Ces messages ne sont envoys que si l'option
<b>SO_KEEPALIVE</b> <b></b>  <b></b>  de la socket est valide.
La valeur par dfaut est 7200 secondes (2 heures).
Une connexion inactive est coupe environ 11 minutes plus tard
(9 tentatives  75 secondes d'cart).<br/><br/>
Notez que les dlais de la couche de transport sous-jacente, ou
de l'application peuvent tre bien plus courts.
<br/><br/>

<b>tcp_max_orphans</b> <b></b>  Le nombre maximal de sockets TCP orphelines (attaches  aucun descripteur
utilisateur) sur le systme. Quand ce nombre est dpass, la connexion
orpheline est rinitialise et un message d'avertissement est affich.
Cette limite n'existe que pour viter les attaques par dni de service&nbsp;;
la diminuer n'est pas recommand. Certaines situations peuvent rclamer
d'augmenter cette limite, mais notez que chaque connexion orpheline peut
consommer jusqu' 64&nbsp;ko de mmoire non-swappable. La valeur par dfaut
est gale au paramtre NR_FILE du noyau. Elle est ajuste en fonction
de la mmoire disponible sur
le systme.
<br/><br/>

<b>tcp_max_syn_backlog</b> <b></b>  Le nombre maximal de requtes de connexions en attente, qui n'ont pas
encore reu d'acquittement de la part du client se connectant.
Si ce nombre est atteint, le noyau commencera  abandonner des requtes.
La valeur par dfaut, 256, est augmente jusqu' 1024 si la
mmoire prsente est suffisante (&gt;= 128&nbsp;Mo) et peut tre
diminue  128 sur les systmes avec trs peu de mmoire (&lt;= 32&nbsp;Mo).
Il est recommand, s'il faut augmenter cette valeur au dessus
de 1024, de modifier TCP_SYNQ_HSIZE dans
include/net/tcp.h pour conserver
TCP_SYNQ_HSIZE * 16 &lt;= tcp_max_syn_backlog et de recompiler le
noyau.
<br/><br/>

<b>tcp_max_tw_buckets</b> <b></b>  Le nombre maximal de sockets dans l'tat TIME_WAIT autorises sur
le systme. Cette limite n'existe que pour viter les attaques par
dni de service. La valeur par dfaut est NR_FILE*2, ajuste en
fonction de la mmoire disponible. Si ce nombre est atteint,
la socket est ferme et un avertissement est affich.
<br/><br/>

<b>tcp_mem</b> <b></b>  Il s'agit d'un vecteur de trois entiers&nbsp;: [bas, charge, haut]. Ces
limites sont utilises par TCP pour surveiller sa consommation mmoire. Les
valeurs par dfaut sont calcules au moment du boot  partir de la mmoire
disponible.<br/><br/>
<i>bas</i> - TCP ne cherche pas  rguler ses allocations mmoire quand le nombre de
pages qu'il a allou est en-dessous de ce nombre<br/><br/>
<i>charge</i> - lorsque la taille mmoire alloue par TCP dpasse ce nombre
de pages, TCP modre sa consommation mmoire. L'tat de mmoire charge
se termine lorsque le nombre de pages alloues descend
en dessous
de la
marque
<b>bas .<br/><br/></b>
<i>haut</i> - le nombre global maximal de pages que TCP allouera. Cette valeur surcharge
tout autre limite
impose par le noyau.
<br/><br/>

<b>tcp_orphan_retries</b> <b></b>  Le nombre maximal de tentatives pour accder  l'autre extrmit d'une
connexion dont notre ct a t ferm.
La valeur par dfaut est 8.
<br/><br/>

<b>tcp_reordering</b> <b></b>  Le nombre de rorganisations dans un flux TCP avant de supposer
qu'un paquet est perdu et reprendre au dbut.
La valeur par dfaut est 3. Il n'est pas conseill de modifier cette valeur.
C'est une mtrique sur la dtection des rordonnancements de paquets
conue pour minimiser les retransmissions inutiles provoques par
la rorganisation des paquets dans une connexion.
<br/><br/>

<b>tcp_retrans_collapse</b> <b></b>  Essayer d'envoyer des paquets de tailles compltes durant les rmissions.
C'est valid par dfaut.
<br/><br/>

<b>tcp_retries1</b> <b></b>  Le nombre de fois que TCP essayera de retransmettre un paquet sur
une connexion tablie normalement, sans demander de
contribution supplmentaire de la couche
rseau concerne. Une fois ce nombre atteint, on
demande au niveau rseau de remettre  jour son
routage, si possible avant chaque nouvelle transmission.
La valeur par dfaut, 3, est le minimum indiqu dans la RFC.
<br/><br/>

<b>tcp_retries2</b> <b></b>  Le nombre de fois qu'un paquet TCP est restransmis sur une connexion
tablie avant d'abandonner. La valeur par dfaut est 15,
ce qui correspond  une dure entre
13 et 3 minutes suivant le dlai maximal de
retransmission. La limite minimal de 100 secondes spcifie par la RFC 1122
est typiquement considre comme trop
courte.
.T
<b>tcp_rfc1337</b> <b></b>  Activer le comportement TCP conformment  la RFC 1337.
Ceci n'est pas actif par dfaut. Lorsqu'il n'est pas activ,
si un RST est reu en tat TIME_WAIT, on ferme la socket
immdiatement sans attendre la fin de la
priode TIME_WAIT.
<br/><br/>

<b>tcp_rmem</b> <b></b>  Il s'agit d'un vecteur de trois entiers&nbsp;: [min, dfaut, max].
Ces paramtres sont utiliss par TCP pour rgler la taille du
buffer de rception. TCP ajuste dynamiquement la taille  partir
de la valeur par dfaut, dans l'intervalle
de ces variables sysctls, en fonction de la mmoire
disponible sur le systme.<br/><br/>
<i>min</i> - taille minimale du buffer de rception utilise par chaque socket TCP.
La valeur par dfaut 4&nbsp;Ko et descend 
PAGE_SIZE octets sur les systmes avec peu de mmoire. Cette valeur
assure qu'en mode de mmoire charge, les allocations
en-dessous de cette taille russiront. Elle n'est pas utilise pour
limiter la taille du buffer de rception,
dclare en utilisant l'option
<b>SO_RCVBUF</b> <b></b>  sur la socket.<br/><br/>
<i>dfaut</i> - la taille par dfaut du buffer de rceptiion pour une socket TCP.
Cette valeur crase la taille par dfaut dans
la valeur globale
<b>net.core.rmem_defautl</b> <b></b>  dfinie pour tous les protocoles. La valeur par dfaut est 87380 octets,
et descend  43689 sur les systmes avec peu de mmoire. Si une taille
plus grande est dsire, il faut augmenter cette valeur (pour affecter
toutes les sockets). Pour utiliser une grande fentre TCP,
l'option
<b>net.ipv4.tcp_window_scaling</b> <b></b>  doit tre activ (par dfaut).<br/><br/>
<i>max</i> - la taille maximale du buffer de rception utilis par chaque socket TCP.
Cette valeur ne surcharge pas la valeur globale
<b>net.core.rmem_max .</b>
Elle ne permet pas de limiter la taille du buffer
de rception dclare avec l'option
<b>SO_RCVBUF</b> <b></b>  sur la socket.
La valeur par dfaut est 87380*2 octets et peut descendre  87380
sur les systmes avec peu de mmoire.
<br/><br/>

<b>tcp_sack</b> <b></b>  Activer l'acquittement TCP slectif (RFC 2018).
Actif par dfaut.
<br/><br/>

<b>tcp_stdurg</b> <b></b>  Activation de l'interprtation RFC 793 stricte du champ TCP Urgent-Pointer.
Par dfaut on utilise une interprtation compatible BSD de ce champ, qui
pointe vers le premier octet des donnes urgentes.
L'interprtation RFC 793
le fait pointer vers le dernier octet des donnes urgentes. Valider cette option
peut poser des problmes d'interactions
entre systmes.
<br/><br/>

<b>tcp_synack_retries</b> <b></b>  Le nombre maximal de fois o un segment SYN/ACK sera retransmis sur une
connection TCP passive. 
Ce nombre ne doit pas dpasser 255.
La valeur par dfaut est 5.
<br/><br/>

<b>tcp_syncookies</b> <b></b>  Valider les syncookies TCP. Le noyau doit tre compil avec l'option
<b>CONFIG_SYN_COOKIES .</b>
Envoie des syncookies lorsque la file d'attente des connexions sur une socket
dborde. Ceci est utilis pour se protger d'une attaque de type "SYN flood".
On ne doit l'utiliser qu'en
dernier ressort. C'est une violation du protocole TCP,
et entre en conflit avec d'autres fonctions comme les extensions TCP.
Cela peut poser des problmes avec les clients ou les relais.
Ce mcanisme n'est pas considr comme un moyen de rglage sur un serveur
trs charg ou mal configur.
Pour des alternatives acceptables, voyez
<b>tcp_max_syn_backlog ,</b>
<b>tcp_synack_retries ,</b>
<b>tcp_abort_on_overflow .</b>
<br/><br/>

<b>tcp_syn_retries</b> <b></b>  Le nombre maximal de fois o un paquet SYN initial sera retransmis pour
une tentative de connexion TCP active. Cette valeur ne doit pas dpasser
255. La valeur par dfaut est 5, ce qui correspond approximativement 
180 secondes. 
<br/><br/>

<b>tcp_timestamps</b> <b></b>  Activer les horodatages TCP (RFC 1323).
Ceci est actif par dfaut.
<br/><br/>

<b>tcp_tw_recycle</b> <b></b>  Activer le recyclage rapide des sockets TIME-WAIT. Ceci n'est pas
actif par dfaut. Cette option n'est pas recommande
car elle peut poser des problmes avec les
redirections NAT (Network Address Translation).
<br/><br/>

<b>tcp_window_scaling</b> <b></b>  Activer le dimensionnement de la fentre TCP (RFC 1323). Ceci est actif
par dfaut. Cette fonctionnalit permet d'utiliser une grande fentre
(&gt; 64&nbsp;Ko) sur une connexion TCP si le correspondant le supporte.
Normalement, les 16 bits du champ de longueur de fentre dans l'en-tte TCP
limitent la taille  64&nbsp;Ko. Si on dsire une fentre plus grande,
l'application peut augmenter la taille du buffer le
la socket et activer l'option tcp_window_scaling.
Si
<b>tcp_window_scaling</b> <b></b>  est inhibe, TCP ne ngotiera pas l'utilisation du dimensionnement
des fentres avec le correspondant lors de l'initialisation de la connexion.
<br/><br/>

<b>tcp_wmem</b> <b></b>  Il s'agit d'un vecteur de trois entiers&nbsp;: [min, dfaut, max]. Ces
paramtres servent  TCP pour rguler la taille du buffer d'mission.
La taille est ajuste dynamiquement  partir de la valeur par dfaut,
dans l'intervalle des variables sysctl, en fonction
de la mmoire disponible.<br/><br/>
<i>min</i> - taille minimale du buffer d'mission utilis par chaque socket TCP.
La valeur par dfaut est 4&nbsp;Ko.
Cette valeur assure qu'en mode de mmoire charge, les allocations
en-dessous de cette taille russiront. Elle n'est pas utilise pour
limiter la taille du buffer de rception,
dclare en utilisant l'option
<b>SO_SNDBUF</b> <b></b>  sur la socket.<br/><br/>
<i>dfaut</i> - la taille par dfaut du buffer d'mission pour une socket TCP.
Cette valeur crase la taille par dfaut dans
la valeur globale
<b>net.core.wmem_defautl</b> <b></b>  dfinie pour tous les protocoles. La valeur par dfaut est 16&nbsp;Ko.
Si une taille plus grande est dsire, 
il faut augmenter cette valeur (pour affecter
toutes les sockets). Pour utiliser une grande fentre TCP, la variable
<b>net.ipv4.tcp_window_scaling</b> <b></b>  doit tre activ (par dfaut).<br/><br/>
<i>max</i> - la taille maximale du buffer d'mission utilis par chaque socket TCP.
Cette valeur ne surcharge pas la valeur globale
<b>net.core.rmem_max .</b>
Elle ne permet pas de limiter la taille du buffer
de rception dclare avec l'option
<b>SO_SNDBUF</b> <b></b>  sur la socket.
La valeur par dfaut est 128&nbsp;Ko et peut descendre  64&nbsp;Ko
sur les systmes avec peu de mmoire.
</div><br/><br /><h1 class="TitreSection0" id="L6">options des sockets</h1>
<div class="paragraph">
Pour lire ou crire une option de socket TCP, appeler 
<b>getsockopt (2)</b>
pour la lecture ou
<b>setsockopt (2)</b>
pour l'criture, avec l'argument famille de socket valant
<b>SOL_TCP .</b>
De plus, la plupart des
options de socket
<b>SOL_IP</b> <b></b>  <b></b>  sont valides sur les sockets TCP. Pour plus de dtails,
voir
<b>ip (7).</b>
<br/><br/>

<b>TCP_CORK</b> <b></b>  Ne pas envoyer de trames partielles. Toutes les trames partielles
en attente sont envoyes lorsque cette option est efface  nouveau.
Ceci permet de prparer les en-ttes avant d'appeler
<b>sendfile (2),</b>
ou pour optimiser le dbit. Cette option ne peut pas tre
combine avec
<b>TCP_NODELAY .</b>
Cette option ne doit pas tre utilise dans du code conu pour
tre portable.
<br/><br/>

<b>TCP_DEFER_ACCEPT</b> <b></b>  Permettre  un processus en coute de n'tre rveill que si des donnes
arrivent sur la socket. Prend une valeur entire (en secondes), correspondant
au nombre maximal de tentatives que TCP fera pour terminer la connexion.
Cette option ne doit pas tre utilise dans du code conu pour
tre portable.
<br/><br/>

<b>TCP_INFO</b> <b></b>  Fournit des informations sur la socket. Le noyau renvoie une
structure tcp_info comme dfinie dans le fichier
/usr/include/linux/tcp.h. Cette option ne doit pas tre utilise dans du
code conu pour tre portable.
<br/><br/>

<b>TCP_KEEPCNT</b> <b></b>  Le nombre maximal de messages keepalive envoys par TCP avant d'abandonner
une connexion. Cette option ne doit pas tre utilise dans du code
conu pour tre portable.
<br/><br/>

.N TCP_KEEPIDLE
La dure (en secondes) d'inactivit sur une connexion avant que TCP
commence  envoyer les messages keepalive, si l'option
SO_KEEPALIVE a t active sur la socket. Cette option ne doit pas tre
employe dans du code conu pour tre portable.
<br/><br/>

<b>TCP_KEEPINTVL</b> <b></b>  Dlai (en seconde) entre deux messages keepalive. Cette
option ne doit pas tre utilise dans du code conu pour
tre portable.
<br/><br/>

<b>TCP_LINGER2</b> <b></b>  La dure des sockets orphelines dans l'tat FIN_WAIT2. Cette option peut
servir  surcharger la valeur de la variable sysctl (globale pour le systme)
<b>tcp_fin_timeout</b> <b></b>  spcialement pour la socket.  ne pas confondre avec l'option
<b>SO_LINGER</b> <b></b>  du niveau
<b>socket (7).</b>
Cette option ne doit pas tre utilise dans du code conu pour
tre portable.
<br/><br/>

<b>TCP_MAXSEG</b> <b></b>  <b></b>  La taille maximale de segment pour les paquets TCP sortants. Si cette options
est fixe avant d'tablir la connexion, elle
change galement la valeur MSS annonce  l'autre extrmit,
dans le paquet initial. Les valeurs suprieures
au MTU de l'interface sont ignores et n'ont pas d'effet. TCP imposera
ses limites minimales et maximales plutt que les valeurs fournies.
<br/><br/>

<b>TCP_NODELAY</b> <b></b>  Dsactiver l'algorithme Nagle. Ceci signifie que les paquets
seront envoys ds que possible, mme s'il n'y a que trs
peu de donnes. Sinon, les donnes sont conserves jusqu' ce qu'il
y en ait un nombre suffisant, pour viter d'envoyer de frquents
petits paquets, au dtriment du
rseau. Cette option ne peut pas tre utilise
en mme temps que l'option
<b>TCP_CORK .</b>
<br/><br/>

<b>TCP_QUICKACK</b> <b></b>  Valider le mode quickack, ou l'inhiber si l'option est nulle.
En mode quickack, les acquitements sont envoys immdiatement
plutt que retards si besoin par rapport au fonctionnement
normal de TCP. Cet attribut n'est pas permanent, il s'agit
seulement d'un basculement vers ou depuis le mode quickack.
Les oprations ultrieures du protocole TCP feront  nouveau
entrer/quitter le mode quickack en fonction des traitements
internes du protocole et de facteurs tels que les dlais
d'acquittements retards, ou les tranferts de donnes.
Cette option ne doit pas tre utilise dans du code conu
pour tre portable.
<br/><br/>

<b>TCP_SYNCNT</b> <b></b>  Indique le nombre de retransmissions de SYN que TCP doit envoyer avant
d'annuler la tentative de connexion. Ne doit pas dpasser 255.
Cette option ne doit pas tre utilise dans du code conu pour
tre portable.
<br/><br/>

<b>TCP_WINDOW_CLAMP</b> <b></b>  Limite la taille de la fentre. Le noyau impose
une taille minimale de SOCK_MIN_RCVBUF/2.
Cette option ne doit pas tre employe dans du code conu
pour tre portable.
</div><br/><br /><h1 class="TitreSection0" id="L7">ioctls</h1>
<div class="paragraph">
Ces ioctls sont accessibles  travers l'appel-systme
<b>ioctl (2).</b>
La syntaxe correcte est&nbsp;:<br/><br/>
.RS

int <b> value</b>;
error <i> = ioctl(</i> tcp_socket <b>, </b> ioctl_type <i>, &</i> value <b>);</b>



<br/><br/>

<b>SIOCINQ</b>
Renvoie la quantit de donnes non lues en attente dans le
buffer de rception. L'argument est un pointeur sur un entier.
La socket ne doit pas tre dans l'tat LISTEN, sinon l'erreur EINVAL
est renvoye.
<br/><br/>

<b>SIOCATMARK</b> <b></b>  Renvoie vrai si toutes les donnes urgentes ont dj t reues par
le programme utilisateur. On l'utilise conjointement 
<b>SO_OOBINLINE .</b>
L'argument est un pointeur sur un entier contenant le rsultat.
<br/><br/>

<b>SIOCOUTQ</b> <b></b>  Renvoie la quantit de donnes non lues en attente dans le buffer d'mission.
La valeur est crite dans l'entier sur lequel on passe un pointeur.
La socket ne doit pas tre dans l'tat LISTEN, sinon l'erreur EINVAL
est renvoye.
</div><br/><br /><h1 class="TitreSection0" id="L8">gestion d'erreur</h1>
<div class="paragraph">
Quand une erreur rseau se produit, TCP tente de renvoyer le paquet. S'il ne russit
pas aprs un certain temps, soit
<b>ETIMEDOUT</b> <b></b>  <b></b>  soit la dernire erreur reue sur la connexion est renvoye.<br/><br/>
Certaines application demande une notification d'erreur plus rapide.
Ceci peut tre valid avec l'option de socket
<b>IP_RECVERR</b> <b></b>  <b></b>  de niveau
<b>SOL_IP .</b>
Quand cette option est active, toutes les erreurs arrivant sont immdiatement
passes au programme utilisateur. Employez cette option avec prcaution,
elle rend TCP moins tolrant envers les modifications de routage
et autres conditions rseau normales.
</div><br/><br /><h1 class="TitreSection0" id="L9">notes</h1>
<div class="paragraph">
Lorsqu'une erreur se produit due  une criture durant l'tablissement
de la connexion, le signal
<b>SIGPIPE</b> <b></b>  n'est envoy que lorsque l'option
<b>SO_KEEPALIVE</b> <b></b>  de la socket est active.<br/><br/>
TCP n'a pas de vritables donnes hors-bande&nbsp;; il a des donnes urgentes.
Sous Linux cela signifie que si l'autre ct envoie de nouvelles donnes
hors-bande, les donnes urgentes plus anciennes sont insres comme des
donnes normales dans le flux (mme quand
<b>SO_OOBINLINE</b> <b></b>  n'est pas actif). Cela diffre des piles bases sur BSD.<br/><br/>
Linux utilise par dfaut une interprtation compatible BSD du champ
Urgent-Pointer. Ceci viole la RFC 1122, mais est indispensable pour
l'interoprabilit avec les autres piles. On peut modifier ce
comportement avec le
sysctl
<b>tcp_stdurg .</b>
</div><br/><br /><h1 class="TitreSection0" id="L10">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>EPIPE</b> <b></b>  L'autre extrmit a ferm inopinment la socket, ou une lecture est tent
sur une socket termine.
<br/><br/>

<b>ETIMEDOUT</b> <b></b>  L'autre cte n'a pas acquitt les donnes retransmises aprs un certain
dlai.
<br/><br/>

<b>EAFNOTSUPPORT</b> <b></b>  Le type d'adresse de la socket passe dans
<i>sin_family </i> n'tait pas
<b>AF_INET .<br/><br/></b>
Toutes les erreurs dfinies dans
<b>ip (7)</b>
ou au niveau gnrique des sockets peuvent aussi se produire avec TCP.
</div><br/><br /><h1 class="TitreSection0" id="L11">bogues</h1>
<div class="paragraph">
Toutes les erreurs ne sont pas documentes.
<br/>
IPv6 n'est pas dcrit.<br/><br/>
<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L12">versions</h1>
<div class="paragraph">
Le support pour la notification explicite de congestion, l'mission de fichiers
dsans copie, le rordonnancement et certaines extensions SACK (DSACK)
ont t introduits dans Linux 2.4.
Le support du Forward Acknowledgement (FACK), le recyclage de TIME_WAIT
les options des messages keepalive et les variables sysctls
ont t introduits dans Linux 2.3.<br/><br/>
Les valeurs par dfaut et les descriptions des variables sysctls
dcrites ci-dessus sont applicables pour les noyaux 2.4.
</div><br/><br /><h1 class="TitreSection0" id="L13">auteurs</h1>
<div class="paragraph">
Cette page de manuel a t crite  l'origine par Andi Kleen.
Elle a t mise  jour pour le 2.4 par Nivedita Singhvi en se basant sur
le fichier Documentation/networking/ip-sysctls.txt
d'Alexey Kuznetsov.
</div><br/><br /><h1 class="TitreSection0" id="L14">voir aussi</h1>
<div class="paragraph">
<b>socket (7),</b>
<b>socket (2),</b>
<b>ip (7),</b>
<b>bind (2),</b>
<b>listen (2),</b>
<b>accept (2),</b>
<b>connect (2),</b>
<b>sendmsg (2),</b>
<b>recvmsg (2),</b>
<b>sendfile (2),</b>
<b>sysctl (2),</b>
<b>getsockopt (2).</b>
<br/><br/>

RFC 793 pour les spcifications TCP.
<br/>
RFC 1122 pour les ncessits TCP et une description
de l'algorithme Nagle.
<br/>
RFC1323 pour les options d'horodatage et la fentre TCP.
<br/>
RFC1644 pour une description des dangers
de TIME_WAIT.
<br/>
RFC2481 pour une description de la notification explicite
de congestion.
<br/>
RFC 2581 pour des algorithmes de contrle de congestion TCP.
<br/>
RFC2018 et RFC2883 pour SACK et ses extensions.
</div><br/><br /><h1 class="TitreSection0" id="L15">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2001-2003.<br/><br/>
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
