<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  This man page is Copyright (C) 1999 Andi Kleen &lt;ak@muc.de&gt;. -->
<!--  Permission is granted to distribute possibly modified copies -->
<!--  of this page provided the header is included verbatim, -->
<!--  and in case of nontrivial modification author and date -->
<!--  of the modification is added to the header. -->
<!--  $Id: udp.7,v 1.7 2000/01/22 01:55:05 freitag Exp $ -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt;  -->
<!--  08/06/2001 - LDP-man-pages-1.37 -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>UDP</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">format d'adresse</a>
<br /><a class="summaryIndent0" href="#L4">gestion d'erreur</a>
<br /><a class="summaryIndent0" href="#L5">ioctls</a>
<br /><a class="summaryIndent0" href="#L6">erreurs</a>
<br /><a class="summaryIndent0" href="#L7">versions</a>
<br /><a class="summaryIndent0" href="#L8">credits</a>
<br /><a class="summaryIndent0" href="#L9">voir aussi</a>
<br /><a class="summaryIndent0" href="#L10">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
udp - Protocole UDP pour IPv4
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;netinet/in.h&gt;</b> <b></b>  <br/>
<b>udp_socket</b> <b></b>  <b>=</b> <b></b>  <b>socket(PF_INET</b> <b></b> ,<b></b>  <b>SOCK_DGRAM</b> <b></b> ,<b></b>  <b>0);</b> <b></b>  <b></b>  </div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Il s'agit d'une implmentation de l'User Datagram Protocol dcrit dans la RFC 768. Elle
implmente un service de paquets datagrammes non-fiables, sans connexion.
Les paquets peuvent tre rordonnes ou dupliqus avant leur arrive.
UDP cr et vrifie des sommes de contrle pour dtecter les erreurs de transmission.<br/><br/>
Lorsqu'une socket UDP est cre, ses adresses locales et distantes sont indtermines.
Les datagrammes peuvent tre envoys immdiatement en utilisant
<b>sendto (2)</b>
ou
<b>sendmsg (2)</b>
avec une adresse de destination valide en argument. Lorsque 
<b>connect (2) </b>
est appel sur une socket, l'adresse de destination par dfaut est fixe, et les
datagrammes pourront tre envoys avec
<b>send (2)</b>
ou
<b>write (2)</b>
sans spcifier d'adresse de destination.
Il restera possible d'envoyer des donnes  d'autres destinations en passant l'adresse 
<b>sendto (2)</b>
ou
<b>sendmsg (2).</b>
Afin de recevoir les paquets, une socket doit tre attache  une adresse locale
en utilisant
<b>bind (2).</b>
Sinon la couche socket affectera automatiquement une port local libre, hors de
l'intervalle dfini par
<i>net.ipv4.ip_local_port_range</i> et attacher la socket  l'adresse
<i>INADDR_ANY .<br/><br/></i>
Les oprations de rception ne renvoie qu'un seul paquet  la fois. Si le paquet est plus
petit que le buffer transmis, il n'y aura pas plus de donnes renvoyes. S'il est plus grand
le paquet sera tronqu et le drapeau
<b>MSG_TRUNC</b> <b></b>  sera activ.
<i>MSG_WAITALL</i> n'est pas support.<br/><br/>
Les options IP peuvent tre fixes ou lues en utilisant les options des sockets dcrites dans
<b>ip (7).</b>
Elles ne sont traites par le noyau que lorsque le sysctl appropri est activ
(mais sont quand mme fournies  l'utilisateur quant il est inhib). Voir
<b>ip (7).<br/><br/></b>
Quand l'attribut
<b>MSG_DONTROUTE</b> <b></b>  est actif  l'mission, l'adresse de destination doit reprsenter une adresse d'interface
locale, et le paquet n'est envoy qu' cette interface.<br/><br/>
UDP fragmente un paquet quand sa longueur totale excde le MTU de l'interface
(Maximum Transmission Unit). Une alternative plus efficace pour le rseau est d'utiliser
la recherche du MTU du chemin, 
comme indiqu dans la section
<b>IP_PMTU_DISCOVER</b> <b></b>  <b></b>  de
<b>ip (7).<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L4">format d'adresse</h1>
<div class="paragraph">
UDP utilise le format d'adresse IPv4
<b>sockaddr_in</b> <b></b>  <b></b>  comme indiqu dans
<b>ip (7). <br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L5">gestion d'erreur</h1>
<div class="paragraph">
Toutes les erreurs fatales seront transmises  l'utilisateur comme un retour d'erreur mme
lorsque la socket n'est pas connecte. Ceci inclut les erreurs asynchrones reues du rseau.
Vous pouvez ainsi recevoir une erreur due  un paquet prcdemment
envoy sur la mme socket.
Ce comportement diffre de celui de nombreuses autres implmentations des sockets BSD, qui
ne transmettent pas d'erreur si la socket n'est pas connect.
Les comportement de Linux correspond  la
<b>RFC 1122</b> .<br/><br/></b>
Pour assurer la compatibilit avec du code ancien, on peut fixer l'option SOL_SOCKET
<b>SO_BSDCOMPAT</b> <b></b>  <b></b>  <b></b>  pour ne recevoir les erreurs distantes que si la socket a t
connecte (sauf pour
<b>EPROTO</b> <b></b>  et
<b>EMSGSIZE ).</b>
Il vaut mieux corriger le code pour
grer les erreurs proprement plutt que d'activer cette option.
Les erreurs locales sont toujours transmises.<br/><br/>
Lorsque l'option
<b>IP_RECVERR</b> <b></b>  est active, toutes les erreurs sont stockes dans la file d'erreur de la socket
et peuvent tre lues avec
<b>recvmsg (2)</b>
en activant son option
<b>MSG_ERRQUEUE .<br/><br/></b>
</div><br/><br /><h1 class="TitreSection0" id="L6">ioctls</h1>
<div class="paragraph">
Les ioctls sont accessible avec l'appel-systme
<b>ioctl (2).</b>
La syntaxe correcte est :<br/><br/>
.RS

int <b> value</b>;
error <i> = ioctl(</i> tcp_socket <b>, </b> ioctl_type <i>, &</i> value <b>);</b>



<br/><br/>

<b>SIOCINQ</b> <b></b>  Prend en argument un pointeur sur un entier. Y crit la taille en octets du prochain
datagramme en attente, ou 0 si aucun datagramme n'est disponible.
<br/><br/>

<b>SIOCOUTQ</b> <b></b>  Renvoie le nombre d'octets de donnes dans la file d'mission locale. Seulement sur
Linux 2.4 et ultrieurs.<br/><br/>
De plus, les ioctls document dans
<b>ip (7)</b>
et
<b>socket (7)</b>
sont supports.
</div><br/><br /><h1 class="TitreSection0" id="L7">erreurs</h1>
<div class="paragraph">
Toutes les erreurs documentes pour
<b>socket (7)</b>
ou
<b>ip (7)</b>
peuvent tre renvoyes lors d'une mission ou d'une rception sur une socket UDP.<br/><br/>
<b>ECONNREFUSED</b> <b></b>  Aucun correspondant sur l'adresse destination associe  la socket. Ceci peut tre
caus par l'mission antrieure d'un paquet sur la socket.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">versions</h1>
<div class="paragraph">
IP_RECVERR est une nouveaut de Linux 2.2.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L9">credits</h1>
<div class="paragraph">
Cette page de manuel a t crite par Andi Kleen.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L10">voir aussi</h1>
<div class="paragraph">
<b>ip (7),</b>
<b>socket (7),</b>
<b>raw (7).<br/><br/></b>
RFC 768 pour le protocole UDP
<br/>
RFC 1122 pour les ncessit de l'hte.
<br/>
RFC 1191 pour une description de la recherche du MTU par chemin.
</div><br/><br /><h1 class="TitreSection0" id="L11">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2001-2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
