<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Copyright (C) 2001 Andries Brouwer &lt;aeb@cwi.nl&gt; -->
<!--  -->
<!--  Permission is granted to make and distribute verbatim copies of this -->
<!--  manual provided the copyright notice and this permission notice are -->
<!--  preserved on all copies. -->
<!--  -->
<!--  Permission is granted to copy and distribute modified versions of this -->
<!--  manual under the conditions for verbatim copying, provided that the -->
<!--  entire resulting derived work is distributed under the terms of a -->
<!--  permission notice identical to this one -->
<!--   -->
<!--  Since the Linux kernel and libraries are constantly changing, this -->
<!--  manual page may be incorrect or out-of-date.  The author(s) assume no -->
<!--  responsibility for errors or omissions, or for damages resulting from -->
<!--  the use of the information contained herein.  The author(s) may not -->
<!--  have taken the same level of care in the production of this manual, -->
<!--  which is licensed free of charge, as they might when working -->
<!--  professionally. -->
<!--   -->
<!--  Formatted or processed versions of this manual, if unaccompanied by -->
<!--  the source, must acknowledge the copyright and authors of this work. -->
<!--  -->
<!--  Traduction Christophe Blaess, &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>UNITS</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">description</a>
<br /><a class="summaryIndent0" href="#L2">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
units, kilo, kibi, mega, mebi, giga, gibi - Prfixes dcimaux et binaires.
</div><br/><br /><h1 class="TitreSection0" id="L2">description</h1>
<div class="paragraph">
</div><br/><h2 class="TitreSection1" id="L4">Prfixes dcimaux</h2>
<div class="paragraph">
Le Systme International utilise des prfixes qui indiquent des puissances
de dix. Un kilomtre vaut 1000 mtres, et un mgawatt vaut 1000000 watt.
Voici les prfixes standards.<br/><br/>
.RS
.TS
l l l.
Prfixe	Nom	Valeur
y	yocto	10^-24 = 0.000000000000000000000001
z	zepto	10^-21 = 0.000000000000000000001
a	atto	10^-18 = 0.000000000000000001
f	femto	10^-15 = 0.000000000000001
p	pico	10^-12 = 0.000000000001
n	nano	10^-9  = 0.000000001
u	micro	10^-6  = 0.000001
m	milli	10^-3  = 0.001
c	centi	10^-2  = 0.01
d	deci	10^-1  = 0.1
da	deca	10^ 1  = 10
h	hecto	10^ 2  = 100
k	kilo	10^ 3  = 1000
M	mega	10^ 6  = 1000000
G	giga	10^ 9  = 1000000000
T	tera	10^12  = 1000000000000
P	peta	10^15  = 1000000000000000
E	exa	10^18  = 1000000000000000000
Z	zetta	10^21  = 1000000000000000000000
Y	yotta	10^24  = 1000000000000000000000000
.TE
<br/><br/>
Le symbole pour micro est la lettre grecque Mu, souvent crite u
dans un contexte Ascii o la lettre grecque n'est pas disponible.
Voir aussi
<br/><br/>

.RS
http://physics.nist.gov/cuu/Units/prefixes.html

</div><br/><h2 class="TitreSection1" id="L4">Prfixes binaires</h2>
<div class="paragraph">
Les prfixes binaires ressemblent aux dcimaux, mais ont un 'i'
supplmentaires (et 'Ki' commence par un 'K' majuscule). Les noms sont
forms en prenant la premire syllable du prfixe dcimal avec la
mme taille approximative et en ajoutant "bi" pour "binaire".<br/><br/>
.RS
.TS
l l l.
Prfixe	Nom	Valeur
Ki	kibi	2^10 = 1024
Mi	mebi	2^20 = 1048576
Gi	gibi	2^30 = 1073741824
Ti	tebi	2^40 = 1099511627776
Pi	pebi	2^50 = 1125899906842624
Ei	exbi	2^60 = 1152921504606846976
.TE
<br/><br/>
Voir aussi
<br/><br/>

.RS
http://physics.nist.gov/cuu/Units/binary.html

</div><br/><h2 class="TitreSection1" id="L4">Discussion</h2>
<div class="paragraph">
Avant l'introduction des prfixes binaires, il tait asez courant
d'utiliser k=1000 et K=1024.
Malheureusement le M est dj en majuscule, et ne peut pas
indiquer l'aspect binaire.<br/><br/>
Il y a queleques temps cela n'tait pas trop grave, car les modules mmoire et
les disques avaient toujours des tailles en puissance de deux, ainsi tout le
monde savait, dans ce contexte que "kilo-octet" et "mga-octet" signifiaent
1024 et 1048576 octets respectivement. Ce qui tait un abus de langage
 l'origine avec les prfixes "kilo" et "mga" a commenc  devenir
la pratique officielle dans le monde informatique.
Mais la technologie des disques a volu et leurs tailles sont devenues
arbitraires. Aprs une priode de flottement, tous les fabricants de
disques ont fix le standard k=1000, M=1000k, et G=1000M.<br/><br/>
La situation tait floue&nbsp;: pour un modem 14.4&nbsp;k, k=1000&nbsp;; pour une
<!--  also common: 14.4k modem -->
disquette 1.44&nbsp;M, M=1024000, etc. En 1998 l'IEC a approuv le standard
qui dfinit les prfixes binaires ci-dessus, permettant d'tre prcis
et sans ambigut.<br/><br/>
Ainsi aujourd'hui, MB = 1000000B et MiB = 1048576B.<br/><br/>
Dans le monde du logiciel libre, les programmes voluent peu  peu
pour tre conformes. Lorsque Linux boote, il dit<br/><br/>
.RS

hda: 120064896 sectors (61473 MB) w/2048KiB Cache


<br/><br/>
les MB sont des "megabytes" et les "KiB" des "kibibytes".
</div><br/><br /><h1 class="TitreSection0" id="L3">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
