<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  This man page is Copyright (C) 1999 Andi Kleen &lt;ak@muc.de&gt;. -->
<!--  Permission is granted to distribute possibly modified copies -->
<!--  of this page provided the header is included verbatim, -->
<!--  and in case of nontrivial modification author and date -->
<!--  of the modification is added to the header. -->
<!--  -->
<!--  Modified, 2 Dec 2002, Michael Kerrisk, mtk16@ext.canterbury.ac.nz -->
<!--  Traduction Christophe Blaess, &lt;cb@club-internet.fr&gt; -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>UNIX</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">format d'adresse</a>
<br /><a class="summaryIndent0" href="#L4">options des sockets</a>
<br /><a class="summaryIndent0" href="#L5">messages annexes</a>
<br /><a class="summaryIndent0" href="#L6">versions</a>
<br /><a class="summaryIndent0" href="#L7">notes</a>
<br /><a class="summaryIndent0" href="#L8">erreurs</a>
<br /><a class="summaryIndent0" href="#L9">voir aussi</a>
<br /><a class="summaryIndent0" href="#L10">auteur</a>
<br /><a class="summaryIndent0" href="#L11">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
unix, PF_UNIX, AF_UNIX, PF_LOCAL, AF_LOCAL - Sockets pour communications locales entre processus.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;sys/un.h&gt;<br/><br/></b> <b></b>  unix_socket <i> = socket(PF_UNIX, type, 0);</i>
<br/>
error <i> = socketpair(PF_UNIX, type, 0, int *</i> sv <b>);</b><br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
La famille de socket
<b>PF_UNIX</b> <b></b>  (aussi connue sous le nom
<b>PF_LOCAL )</b>
sert  communiquer efficacement entre processus sur la mme machine.
Une socket Unix peut tre soit anonyme (cre par
<b>socketpair (2))</b>
soit associe  un fichier de type socket.
Linux supporte aussi un espace de noms abstrait, indpendant du systme
de fichiers.<br/><br/>
Les types valides sont
<b>SOCK_STREAM</b> <b></b>  <b></b>  pour une socket oriente flux, et
<b>SOCK_DGRAM</b> <b></b>  pour une socket oriente datagramme, prservant les limites entre messages.
Les socket Unix sont toujours fiables et ne rordonnent pas les datagrammes.<br/><br/>
Les sockets Unix supportent la transmission de descripteurs de fichiers ou
d'identificateurs d'un processus  l'autre en utilisant des donnes annexes.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L4">format d'adresse</h1>
<div class="paragraph">
Une adresse Unix est dfinie comme un nom dans le systme de fichier ou une
chane unique dans l'espace de noms abstrait. Les sockets cres par
<b>socketpair (2)</b>
sont anonymes. Pour les sockets non-anonymes, l'adresse cible peut tre
indique en utilisant
<b>connect (2). </b>
L'adresse locale peut tre fixe avec
<b>bind (2). </b>
Quand une socket est connecte et qu'elle n'a pas encore d'adresse locale,
une adresse unique dans l'espace de noms abstrait lui est automatique founie.<br/><br/>
.RS

#define UNIX_PATH_MAX	108<br/><br/>
.ta 4n 17n 42n
struct sockaddr_un {
	sa_family_t	sun_family;	/* AF_UNIX */
	char	sun_path[UNIX_PATH_MAX];	/* chemin accs */
};


 <br/><br/>
<b>sun_family</b> <b></b>  <b></b>  contient toujours la valeur
<b>AF_UNIX .</b>
<b>sun_path</b> <b></b>  contient le chemin d'accs  la socket, termin par un zro, dans le systme
de fichiers. Si
<b>sun_path</b> <b></b>  commence par un octet nul, il se rfre  l'espace abstrait maintenu
par le module du protocole Unix.
L'adresse de la socket dans cet espace est donn par le reste des octets dans
<b>sun_path .</b>
Notez que les noms dans l'espace abstrait ne sont pas termins par un zro.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L5">options des sockets</h1>
<div class="paragraph">
Pour des raisons historiques, les options de ces sockets sont spcifies
avec un type SOL_SOCKET mme si elles sont spcifiques PF_UNIX.
On peut les fixer avec
<b>setsockopt (2)</b>
et les lire avec
<b>getsockopt (2)</b>
en spcifiant la famille SOL_SOCKET.
<br/><br/>

<b>SO_PASSCRED</b> <b></b>  Valide la rception des identifiants dans les messages annexes du processus
metteur. Lorsque cette option est active et la socket non encore connecte
un nom unique dans l'espace abstrait sera gnr automatiquement.
On attend un attribut boolen entier.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L6">messages annexes</h1>
<div class="paragraph">
Les donnes annexes sont envoyes et reues en utilisant
<b>sendmsg (2)</b>
et
<b>recvmsg (2).</b>
Pour des raisons historiques, les messages annexes lists ci-dessous
sont spcifis avec un type SOL_SOCKET mme s'ils sont spcifiques PF_UNIX.
Pour les envoyer, fixez le champ
<b>cmsg_level</b> <b></b>  de la structure 
<b>cmsghdr</b> <b></b>   SOL_SOCKET et le champ
<b>cmsg_type</b> <b></b>  <b></b>  avec le type du message. Pour plus de dtails, voir
<b>cmsg (3). <br/><br/></b>
<br/><br/>

<b>SCM_RIGHTS</b> <b></b>  Envoie ou reoit un jeu de descripteurs de fichiers ouverts par un autre
processus. La portion de donnes contient une table de descripteurs.
Les descripteurs passs se comportent comme s'ils avaient t crs avec
<b>dup (2).<br/><br/></b>
<br/><br/>

<b>SCM_CREDENTIALS</b> <b></b>  Envoyer ou recevoir les identifiants Unix. Ceci peut servir 
l'authentification. Les identifications sont passs en message annexe en
<b>struct ucred</b> .<br/><br/></b>
.RS

.ta 4n 11n 17n
struct ucred {
	pid_t	pid;	/* PID processus metteur */  
	uid_t	uid;	/* UID processus metteur */ 
	gid_t	gid;	/* GID processus metteur */ 
};


 <br/><br/>
Les identifiants que l'metteur envoie sont vrifis par le noyau.
Un processus avec un UID effectif nul est autoris  indiquer des valeurs
autres que les siennes.
L'metteur doit indiquer son propre PID (sauf s'il a la capacit
<b>CAP_SYS_ADMIN ),</b>
son UID rel, effectif ou sauv (sauf s'il a la capacit
<b>CAP_SETUID ),</b>
et son GID rel, effecif ou sauv (sauf s'il a la capacit
<b>CAP_SETGID ).</b>
Pour recevoir un message
<b>struct</b> <b></b>  <b>ucred</b> <b></b>  l'option
<b>SO_PASSCRED</b> <b></b>  <b></b>  doit tre valide sur la socket.<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L7">versions</h1>
<div class="paragraph">
<b>SCM_CREDENTIALS</b> <b></b>  et l'espace de noms abstrait ont t introduits avec Linux 2.2 et ne doivent
pas tre utiliss dans des programmes portables.
(Certains systmes drivs de BSD supportent aussi le passage d'identifiants,
mais les dtails d'implmentation diffrent).<br/><br/>
</div><br/><br /><h1 class="TitreSection0" id="L8">notes</h1>
<div class="paragraph">
Dans l'implmentation Linux, les sockets qui sont visibles dans le systme
de fichiers honorent les permissions du rpertoire o elles se trouvent.
Leur propritaire, groupe et autorisations peuvent tre changes.
La cration d'une nouvelle socket chouera si le processus n'a pas le droit
d'crire et de parcours (excution) dans le rpertoire o elle est cre.
La connexion sur une socket ncessite les permissions de lecture/criture.
Le comportement diffre de plusieurs systmes drivs de BSD qui ignorent
les permissions sur les sockets Unix. Les programmes portable ne doivent
pas s'appuyer sur ces fonctionnalits pour la scurit.<br/><br/>
Lier une socket avec un nom de fichier crer la socket dans le systme de
fichier, qu'il faudra dtruire lorsqu'elle n'est plus utile
(en appelant
<b>unlink (2)).</b>
La smantique habituelle Unix s'applique&nbsp;; la socket peut tre efface
 tout moment, et sera effectivement supprime lorsque sa dernire rfrence
sera ferme.<br/><br/>
Pour passer un descripteur ou des identifiants, il faut envoyer ou recevoir
au moins un octet de donne.<br/><br/>
Les sockets flux Unix ne supportent pas la notion de donnes hors-bande.
</div><br/><br /><h1 class="TitreSection0" id="L9">erreurs</h1>
<div class="paragraph">
<br/><br/>

<b>ENOMEM</b> <b></b>  Plus de mmoire.
<br/><br/>

<b>ECONNREFUSED</b> <b></b>  <b>connect (2)</b>
a t appel sur une socket qui n'est pas en coute. Ceci peut arriver si
la socket distante n'existe pas ou si le fichier n'est pas une socket.
<br/><br/>

<b>EINVAL</b> <b></b>  Argument invalide. Une cause habituelle est l'oubli de AF_UNIX dans le champ
sun_type de l'adresse passe ou lorsque la socket est dans un tat
invalide pour l'opration.
<br/><br/>

<b>EOPNOTSUPP</b> <b></b>  Opration de flux sur une socket non oriente flux, ou tentatice d'utiliser
des options de donnes hors-bande.
<br/><br/>

<b>EPROTONOSUPPORT</b> <b></b>  Le protocole pass n'est pas PF_UNIX.
<br/><br/>

<b>ESOCKTNOSUPPORT</b> <b></b>  Type de socket inconu.
<br/><br/>
 
<b>EPROTOTYPE</b> <b></b>  La socket distante ne correspond pas au type local (SOCK_DGRAM vs.
SOCK_STREAM)
<br/><br/>

<b>EADDRINUSE</b> <b></b>  L'adresse locale est dj prise ou l'objet existe dj dans le systme de
fichier.
<br/><br/>

<b>EISCONN</b> <b></b>  <b>connect (2)</b>
a t appele sur une socket dj connecte, ou l'adresse cible a t
indique sur une socket connecte.
<br/><br/>

<b>ENOTCONN</b> <b></b>  L'opration ncessite une adresse cible, mais la socket n'est pas connecte.
<br/><br/>

<b>ECONNRESET</b> <b></b>  La socket distante a t ferme de manire inattendue.
<br/><br/>

<b>EPIPE</b> <b></b>  La socket distante, de type flux,  a t ferme. Dans ce cas un signal
<b>SIGPIPE</b> <b></b>  <b></b>  est mis galement. Ceci peut tre vit en passant l'attribut
<b>MSG_NOSIGNAL</b> <b></b>  dans 
<b>sendmsg (2)</b>
ou
<b>recvmsg (2).</b>
<br/><br/>

<b>EFAULT</b> <b></b>  Adresse mmoire utilisateur invalide.
<br/><br/>

<b>EPERM</b> <b></b>  L'metteur a transmis des identifiants invalide dans la
<b>struct ucred</b> .<br/><br/></b>
D'autres erreurs peuvent tre dclenches par le niveau socket gnrique ou
par le systme de fichiers. Voir les pages de manuel correspondantes
pour plus de dtails.
</div><br/><br /><h1 class="TitreSection0" id="L10">voir aussi</h1>
<div class="paragraph">
<b>recvmsg (2),</b>
<b>sendmsg (2),</b>
<b>socket (2),</b>
<b>socketpair (2),</b>
<b>cmsg (3),</b>
<b>capabilities (7),</b>
<b>socket (7)</b>
</div><br/><br /><h1 class="TitreSection0" id="L11">auteur</h1>
<div class="paragraph">
Cette page de manuel a t crite par Andi Kleen.
</div><br/><br /><h1 class="TitreSection0" id="L12">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
