<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  This man page is Copyright (C) 1998 Heiner Eisen.  -->
<!--  Permission is granted to distribute possibly modified copies -->
<!--  of this page provided the header is included verbatim, -->
<!--  and in case of nontrivial modification author and date -->
<!--  of the modification is added to the header. -->
<!--  $Id: x25.7,v 1.4 1999/05/18 10:35:12 freitag Exp $ -->
<!--  Traduction Christophe Blaess &lt;ccb@club-internet.fr&gt; -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>X25</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">synopsis</a>
<br /><a class="summaryIndent0" href="#L2">description</a>
<br /><a class="summaryIndent0" href="#L3">adresse de socket</a>
<br /><a class="summaryIndent0" href="#L4">options des sockets</a>
<br /><a class="summaryIndent0" href="#L5">bogues</a>
<br /><a class="summaryIndent0" href="#L6">voir aussi</a>
<br /><a class="summaryIndent0" href="#L7">versions</a>
<br /><a class="summaryIndent0" href="#L8">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph">
x25, PF_X25 - Interface du protocole ITU-T X.25 / ISO-8208.
</div><br/><br /><h1 class="TitreSection0" id="L2">synopsis</h1>
<div class="paragraph">
<b>#include</b> <b></b>  <b>&lt;sys/socket.h&gt;</b> <b></b>  <br/>
<b>#include</b> <b></b>  <b>&lt;linux/x25.h&gt;</b> <b></b>  <br/><br/>

<b>x25_socket</b> <b></b>  <b>=</b> <b></b>  <b>socket(PF_X25</b> <b></b> ,<b></b>  <b>SOCK_SEQPACKET</b> <b></b> ,<b></b>  <b>0);</b> <b></b>  <b><br/><br/></b> <b></b>  </div><br/><br /><h1 class="TitreSection0" id="L3">description</h1>
<div class="paragraph">
Les sockets X25 fournissent une interface pour le protocole par paquets X.25.
Elles permettent aux application de communiquer sur un rseau X.25 public
standardis par la recommandation de l'International Telecommunication Union
(X.25 mode DTE-DCE). Les sockets X25 peuvent aussi servir  communiquer sans
rseau intermdiaire X.25 (X.25 mode DTE-DTE) dcrit par ISO-8208.<br/><br/>
Les frontires de message sont prserves - un
<b>read (2) </b>
sur la socket retrouvera le mme bloc de donne que celui du
<b>write(2) </b>
sur la socket correspondante. Si ncessaire, le noyau prend soin de
segmenter et rassembler les messages longs par le biais du bit M de
X.25. Il n'y a pas de limite maximale pour la taille du message, toutefois
le rassemblage d'un long message peut chouer si on manque temporairement
de ressource systme ou si d'autres contraintes (taille mmoire, limite
de buffer) entre en jeu. Si cela se produit, la connexion X.25 sera
rinitialise.
</div><br/><br /><h1 class="TitreSection0" id="L4">adresse de socket</h1>
<div class="paragraph">
L'adresse d'une socket de la famille
<b>AF_X25</b> <b></b>  <b></b>  utilise une
<b>struct</b> <b></b>  <b>sockaddr_x25</b> <b></b>  pour reprsenter les adresses rseau dfinies par la
recommandation X.121 de l'ITU-T.<br/><br/>
.RS

.ta 4n 18n 32n
struct sockaddr_x25 {
	sa_family_t	sx25_family;	/* doit tre AF_X25 */
	x25_address	sx25_addr;	/* adresse X.121    */
};
.ta


<br/><br/>
<i>sx25_addr</i> contient une table de caractres
<i>x25_addr[] </i>  interprter comme une chane termine par un caractre nul.
<i>sx25_addr.x25_addr[]</i> contient jusqu' 15 caractres Ascii (sans compter le zro final)
formant l'adress X.121.
Seuls les chiffres dcimaux de `0'  `9' sont autoriss.
</div><br/><br /><h1 class="TitreSection0" id="L5">options des sockets</h1>
<div class="paragraph">
Les options suivantes spcifiques aux sockets X.25 peuvent tre fixes avec
<b>setsockopt (2)</b>
et lue avec 
<b>getsockopt (2)</b>
en utilisant le paramtre niveau
<b>SOL_X25 .</b>
<br/><br/>

<b>X25_QBITINCL</b> <b></b>  Contle si le bit Q X.25 (Qualified Data Bit) est accessible par
l'utilisateur. Il attend un argument entier. S'il est nul (par dfaut),
le bit Q n'est jamais mis pour les paquets sortants et le bit Q des paquets
entrants est ignor. S'il vaut 1, un premier octet supplmentaire est accol
 chaque message lus ou crits sur la socket. Pour les donnes lues depuis
la socket, un premier octet nul indique que le bit Q des donnes
correspondantes n'tait pas actif. Un premier octet avec une valeur 1
indique que le bit Q tait valid.
Si le premier octet des donns crites sur la socket est 1, le bit Q
sera activ&nbsp;; si le premier octet est 0, le bit Q sera inhib.
</div><br/><br /><h1 class="TitreSection0" id="L6">bogues</h1>
<div class="paragraph">
Beaucoup, l'implmentation X.25 PLP est considre comme
<b>CONFIG_EXPERIMENTAL .<br/><br/></b>
Cette page de manuel est incomplte.<br/><br/>
Il n'y a pas encore de fichier d'en-tte ddi pour les applications, il
faut inclure l'en-tte du noyau
<b>&lt;linux/x25.h&gt; .</b>
<b>CONFIG_EXPERIMENTAL</b> <b></b>  <b></b>  implique aussi que les versions  venir seront
peut-tre incompatibles au niveau binaire.<br/><br/>
Les vnements N-Reset X.25 ne sont pas encore propags au processus
utilisateur. Ainsi si une rinitialisation se produit, des donnes peuvent
tre perdues sans avertissement.
</div><br/><br /><h1 class="TitreSection0" id="L7">voir aussi</h1>
<div class="paragraph">
<b>socket (7),</b>
<b>socket (2)<br/><br/></b>
Jonathan Simon Naylor: 
\(lqThe Re-Analysis and Re-Implementation of X.25.\(rq
The URL is
.RS
<i>ftp://ftp.pspt
/pub/ham/linux/ax25/x25doc.tgz</i> 
</div><br/><br /><h1 class="TitreSection0" id="L8">versions</h1>
<div class="paragraph">
La famille de protocole PF_X25 est une nouveaut avec Linux 2.2.
</div><br/><br /><h1 class="TitreSection0" id="L9">traduction</h1>
<div class="paragraph">
Christophe Blaess, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
