.\" This is in the public domain
.\" Traduction Christophe Blaess <ccb@club-internet.fr>
.\" MJ 25/07/2003 LDP-1.56
.TH ld<?php include ("../8 "25 juillet 2003" LDP "Manuel de l'administrateur Linux".php"); ?>.SH NOM
ld.so, ld-linux.so* \- Chargeur et diteur de liens dynamique.
.SH DESCRIPTION
Les programmes
.B ld.so
et
.B ld-linux.so*
trouvent et chargent les bibliothques partages ncessaires pour un
programme, prparent son dmarrage, et le lancent.
.LP
Les binaires Linux ncessitent une dition de liens dynamique (au dmarrage)
sauf si l'option
.B \-static
a t indique sur la ligne de commande de
.B ld
durant la compilation.
.LP
Le programme
.B ld.so
traite les binaires a.out, un format utilis il y a bien longtemps\ ;
.B ld-linux.so*
traitent les fichiers ELF (\fB/lib/ld-linux.so.1\fP for libc5, \fB/lib/ld-linux.so.2\fP pour GlibC2),
que tout le monde utilise depuis des annes. Autrement les deux programmes
ont le mme comportement et utilisent les fichiers et programmes
.BR ldd (1),
.BR ldconfig (8)
et
.IR /etc/ld.so.conf .
.LP
Les bibliothques partages ncessaire  un programme sont recherches dans
diffrents endroits\ :
.IP o
(ELF seul) En utilisant l'attribut de section dynamique DT_RPATH du fichier
binaire s'il est prsent, et l'attribut DT_RUNPATH sinon.
L'utilisation de DT_RPATH est dconseille.
.IP o
En utilisant la variable d'environnement
.BR LD_LIBRARY_PATH .
Sauf si l'excutable est un binaire Set-UID ou Set-GID auquel cas elle est
ignore.
.IP o
(ELF seul) En utilisant l'attribut de section dynamique DT_RUNPATH
du fichier binaire s'il est prsent.
.IP o
Depuis le fichier cache
.BR /etc/ld.so.cache
qui contient une liste compile de bibliothques prcdement trouves
dans des chemins pas dfaut. Si, toutefois, le fichier binaire
a t li avec l'option
.B -z nodeflib
de l'diteur de liens, les chemins par dfaut sont ignores.
.IP o
Dans le rpertoire par dfaut
.BR /lib ,
puis
.BR /usr/lib .
Si le binaire a t li avec l'option
.B -z nodeflib
de l'diteur de lien, cette tape est saute.
.SH SYNOPSIS
L'diteur de lien dynamique peut tre lan indirectement en dmarrant un
programme li dynamiquement ou une bibliothque (dans ce cas, aucune option
en ligne de commande ne peut tre transmise, et avec ELF, l'diteur
indiqu dans la section
.B .interp
du programme est excut), ou directement en lanant\ :
.P
.B /lib/ld-linux.so.*
[OPTIONS] [PROGRAMME [ARGUMENTS]]
.SH "OPTIONS EN LIGNE DE COMMANDE"
.TP
.B --list
Liste les dpendances et leurs rsolutions.
.TP
.B --verify
Vrifie que le programme est li dynamiquement et que l'diteur de liens
peut le traiter.
.TP
.B --library-path PATH
Surcharge la variable d'environnement
.B LD_LIBRARY_PATH
(voir plus bas).
.TP
.B --ignore-rpath LISTE
Ignorer les informations RPATH and RUNPATH dans les objets de la LISTE.
Cette oprtion a t supporte par la GlibC2 pendant environ une heure.
Puis elle a t renomme en\ :
.TP
.B --inhibit-rpath LISTE
.SH ENVIRONNEMENT
Il y a quatre variables d'environnement importantes.
.TP
.B LD_LIBRARY_PATH
Une liste de rpertoires spars par des points-virgules, dans lesquels
les bibliothques sont recherches au dmarrage.
Comme la variable
d'environnement
.BR PATH .
.TP
.B LD_PRELOAD
Une liste spare par des blancs de bibliothques ELF spcifiques 
l'utilisateur, a charger avant les autres bibliothques.
Ceci permet de surcharger slectivement les fonctions des autres
bibliothques partages. Pour les binaires ELF Set-UID, Set-GID, seules
les bibliothques Set-UID des rpertoires standards seront charges.
.TP
.B LD_BIND_NOW
(libC 5 ; GibC depuis 2.1.1)
Si la chane est non-vide, l'diteur de lien rsoudra tous les symboles 
au dmarrage du programme plutt que repousser la rsolution des noms
de fonctions au moment o elles sont rfrences en premier.
Ceci est utile dans un dbogueur.
.TP
.B LD_TRACE_LOADED_OBJECTS
(ELF seul)
Si la chaine est non-vide, le programme liste ses dpendances dynamiques
comme s'il tait lanc par
.BR ldd (1),
au lieu du lancement normal.
.LP
Il existe de nombreuses autres variables plus ou moins obscures,
certaines obsoltes, ou rseves pour un usage interne.
.TP
.B LD_WARN
(ELF seul)(GlibC depuis 2.1.3)
Si la chane est non-vide, avertir si un symbole n'est pas rsolu.
.TP
.B LD_NOWARN
(a.out seul)(libC5)
Supprimer les avertissement  propos des bibliothques a.out incompatibles
avec les versions antrieure
.TP
.B LD_BIND_NOT
(GlibC depuis 2.1.95)
Ne pas mettre  jour les tables GOT (global offset table) et PLT
(procedure linkage table) aprs rsolution d'un symbole.
.TP
.B LD_DEBUG
(GlibC depuis 2.1)
Afficher de nombreuses informations de dbogage de l'diteur dynamique.
Si elle contient
.B all
afficher tous les message d'information, si elle contient
.B help
afficher un message d'aide  propos des catgories de messages pour cette
variable d'environnement.
.TP
.B LD_DEBUG_OUTPUT
(GlibC depuis 2.1)
Fichier o la sortie de
.B LD_DEBUG
devrait tre envcoye. Par dfaut c'est la sortie standard.
LD_DEBUG_OUTPUT est ignore pour les binaires Set-UID / Set-GID.
.TP
.B LD_VERBOSE
(GlibC depuis 2.1)
S'il s'agit d'une chane non vide, afficher les informations sur la version
des objets sur on demande des informations sur le programme (si
.B LD_TRACE_LOADED_OBJECTS
a t configur, ou si les options
.B --list
ou
.B --verify
ont t donnes  l'diteur de liens dynamiques).
.TP
.B LD_PROFILE
(GlicC depuis 2.1)
Activer le suivi des objets partags.
.TP
.B LD_PROFILE_OUTPUT
(GlibC depuis 2.1)
Fichier o la sortie de
.B LD_PROFILE
est envoye. Par dfaut la sortie standard.
LD_DEBUG_OUTPUT est ignor pour les binaires Set-UID/Set-GID.
.TP
.B LD_AOUT_LIBRARY_PATH
(LibC5)
Version de LD_LIBRARY_PATH pour les binaire a.out seulement.
Les anciennes versions de ld-linux.so.1 supportent LD_ELF_LIBRARY_PATH.
.TP
.B LD_AOUT_PRELOAD
(LibC5)
Version de LD_PRELOAD pour les binaires a.out seulement.
Les anciennes versions de ld-linux.so.1 supportent LD_ELF_PRELOAD.
.TP
.B LD_SHOW_AUXV
(GlibC depuis 2.1)
Afficher les tables auxiliaires passes au noyau.
.TP
.B LD_HWCAP_MASK
(GlibC depuis 2.1)
Masque des capacits matrielles.
.TP
.B LD_ORIGIN_PATH
(GlibC depuis 2.1)
Chemin du fichier binaire (pour les programmes non Set-UID).
.TP
.B LD_DYNAMIC_WEAK
(GlibC depuis 2.1.91)
Autorise la surcharge des symboles faibles (retour  l'ancien comportement).
.TP
.B LD_KEEPDIR
(a.out seul)(LibC5)
Ne pas ignorer le rpertoire dans les noms de bibliothques a.out.
Cette option est trs dconseille.
.TP
.B LDD_ARGV0
(LibC5)
.IR argv [0]
 utiliser par
.BR ldd (1)
si aucun n'est prsent.
.SH FICHIERS
.PD 0
.TP
.B /lib/ld.so
le chargeur/diteur de lien a.out.
.TP
.BR /lib/ld-linux.so. { 1 , 2 }
Le chargeur/diteur de liens ELF.
.TP
.B /etc/ld.so.cache
Fichier contenant la liste compiles des rpertoires o des bibliothques
se trouvent.
.TP
.B /etc/ld.so.preload
Fichier contenant une liste de librairie ELF, spares par des espaces, 
charger avant de dmarrer le programme.
.TP
.B lib*.so*
Bibliothques partages.
.PD
.SH NOTES
Les fonctionnalits
.B ld.so
sont disponibles pour les excutables compils  partir de la LibC version
4.4.3 et ultrieures.
Les fonctionnalits ELF sont disponibles depuis 1.1.52 et la LibC5.
.SH "VOIR AUSSI"
.BR ldd (1),
.BR ldconfig (8)
.\" .SH AUTHORS
.\" ld.so: David Engel, Eric Youngdale, Peter MacDonald, Hongjiu Lu, Linus
.\"  Torvalds, Lars Wirzenius and Mitch D'Souza
.\" ld-linux.so: Roland McGrath, Ulrich Drepper and others.
.\"
.\" In the above, (libc5) stands for David Engel's ld.so/ld-linux.so.
.SH TRADUCTION
Christophe Blaess, 2003.
