.\" -*- nroff -*-
.\" Copyright 1999 SuSE GmbH Nuernberg, Germany
.\" Author: Thorsten Kukuk <kukuk@suse.de>
.\"
.\" This program is free software; you can redistribute it and/or
.\" modify it under the terms of the GNU General Public License as
.\" published by the Free Software Foundation; either version 2 of the
.\" License, or (at your option) any later version.
.\"
.\" This program is distributed in the hope that it will be useful,
.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
.\" General Public License for more details.
.\"
.\" You should have received a copy of the GNU General Public
.\" License along with this program; see the file COPYING.  If not,
.\" write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
.\" Boston, MA 02111-1307, USA.
.\"
.\" Modified, 6 May 2002, Michael Kerrisk, mtk16@ext.canterbury.ac.nz
.\"   Change listed order of /usr/lib and /lib
.\" Traduction Christophe Blaess, <ccb@club-internet.fr>
.\" MJ 25/07/2003 LDP-1.56
.TH LDCONFIG 8 "21 juillet 2003" LDP "Manuel de l'administrateur Linux"
.SH NOM
/sbin/ldconfig \- Configuration de l'diteur de liens dynamiques.
.SH SYNOPSIS
.B /sbin/ldconfig
[
.B \-nNvXV
]
[
.BR \-f\ configuration
]
[
.BR \-C\ cache
]
[
.BR \-r\ racine
]
.IR rpertoire \ ...
.PD 0
.PP
.PD
.BR /sbin/ldconfig
.B \-l
[
.B \-v
]
.IR bibliothque \ ...
.PD 0
.PP
.PD
.B /sbin/ldconfig
.B \-p
.SH DESCRIPTION
.B ldconfig
cre les liens ncessaires et met en cache les bibliothques partages les
plus rcentes trouves dans les rpertoires indiqus sur la ligne de
commande, dans le fichier
.IR /etc/ld.so.conf ,
et dans les rpertoires srs
.RI ( /lib
et
.IR /usr/lib ).
Le cache est utilis par le chargeur / diteur de liens
.IR ld.so
ou
.IR ld-linux<?php include ("../..php"); ?>.B ldconfig
vrifie les en-ttes et noms des fichiers des bibliothques qu'il trouve
pour dterminer les versions et mettre  jour les liens.
.PP
.B ldconfig
essaye de dduire le type bibliothque ELF (LibC5 ou LibC6/GlibC) en se
basant sur la bibliothque C utilise pour les liens de la bibliothque.
Ainsi, lorsqu'on cre une bibliothque dynamique, il est sage d'indiquer
explicitement la bibliothque C utilise (en employant l'option -lc).
.PP
Certaines bibliothques existantes ne contiennent pas assez d'information
pour dduire leur type. Ainsi, le format du fichier
.IR /etc/ld.so.conf
permet d'indiquer le type attendu. Cela ne doit servir
.B que
pour les bibliothques ELF qui ne fonctionnent pas sinon. Le format est
"dirname=TYPE", o TYPE peut tre libc4, libc5 ou libc6. (Cette syntaxe
marche aussi sur la ligne de commande). Les espaces ne sont
.B pas
autoriss. Voir aussi l'option
.BR -p .
Normalement
.B ldconfig
doit tre lanc par le Super-Utilisateur, car il peut avoir besoin de
l'autorisation d'criture sur certains fichiers appartenant  root.
.SH OPTIONS
.TP
.B \-v
Mode volubile.
Affiche le numro de version actuelle, le nom de chaque rpertoire au fur et
 mesure du parcours, et les liens qui sont crs.
Peut surcharger le mode silencieux.
.TP
.B \-n
Ne traiter que les rpertoires indiqus sur la ligne de commande.
Ne pas s'occuper des rpertoires srs
.RI ( /lib
et
.IR /usr/lib )
ni de ceux indiqus dans
.IR /etc/ld.so.conf .
Ncessit l'option
.BR \-N .
.TP
.B \-N
Ne pas reconstruire le cache.
Si l'option
.B \-X
n'est pas indique, les liens sont quand mme mis  jour.
.TP
.B \-X
Ne pas mettre  jour les liens.
Si l'option
.B \-N
n'est pas indique, le cache est quand mme reconstruit.
.TP
.B \-f configuration
Utiliser le fichier de
.B configuration
indiqu plutt que
.IR /etc/ld.so.conf .
.TP
.B \-C cache
Utiliser le
.B cache
indiqu plutt que
.IR /etc/ld.so.cache .
.TP
.B \-r racine
Se dplacer vers, et utiliser le rpertoire
.B racine
indiqu.
.TP
.B \-l
Mode bibliothque. Lier manuellement les bibliothques individuelles.
Destin seulement aux experts.
.TP
.B \-p
Afficher la liste des rpertoires et des bibliothques potentielles
enregistrs dans le cache actuel.

.SH FICHIERS
.PD 0
.TP 20
.B /lib/ld.so
chargeur/diteur de liens dynamiques
.TP 20
.B /etc/ld.so.conf
liste de rpertoires o chercher les bibliothques, spars par des blancs,
des virgules ou des deux-points.
.TP 20
.B /etc/ld.so.cache
liste ordonne des bibliothques trouves dans les rpertoires
indiqus dans
.BR /etc/ld.so.conf .
.PD
.SH TRADUCTION
Christophe Blaess, 2003.
