#! /usr/bin/perl -w

use strict;
use locale;

sub BI
{
  my ($text) = @_;
  my $ret = "";
  my $state = 0;

  for (my $i = 0; $i < length ($text); $i++)
  {
    my $c = substr ($text, $i, 1);
    if ($c eq '"')
    {
      if ($state == 0)
      {
        $ret = $ret."<b>";
        $state = 1;
      }
      elsif ($state == 1)
      {
        $ret = $ret."</b>";
        $state = 2;
      }
      elsif ($state == 2)
      {
        $ret = $ret."<i>";
        $state = 3;
      }
      elsif ($state == 3)
      {
        $ret = $ret."</i>";
        $state = 0;
      }
    }
    else
    {
      $ret = $ret.$c;
    }
  }
  return $ret;
}

sub IB
{
  my ($text) = @_;
  my $ret = "";
  my $state = 0;

  for (my $i = 0; $i < length ($text); $i++)
  {
    my $c = substr ($text, $i, 1);
    if ($c eq '"')
    {
      if ($state == 0)
      {
        $ret = $ret."<i>";
        $state = 1;
      }
      elsif ($state == 1)
      {
        $ret = $ret."</i>";
        $state = 2;
      }
      elsif ($state == 2)
      {
        $ret = $ret."<b>";
        $state = 3;
      }
      elsif ($state == 3)
      {
        $ret = $ret."</b>";
        $state = 0;
      }
    }
    else
    {
      $ret = $ret.$c;
    }
  }
  return $ret;
}

sub IR
{
  my ($text) = @_;
  my $ret = "";
  my $state = 0;

  $ret = $ret."<i>";
  for (my $i = 0; $i < length ($text); $i++)
  {
    my $c = substr ($text, $i, 1);
    if ($c eq '"')
    {
      if ($i != 0)
      {
        if ($state == 0)
        {
          $ret = $ret."</i>";
          $state = 1;
        }
        elsif ($state == 1)
        {
          $ret = $ret."<i>";
          $state = 0;
        }
      }
    }
    else
    {
      $ret = $ret.$c;
    }
  }
  $ret = $ret."</i>";
  return $ret;
}

sub RI
{
  my ($text) = @_;
  my $ret = "";
  my $state = 0;

  for (my $i = 0; $i < length ($text); $i++)
  {
    my $c = substr ($text, $i, 1);
    if ($c eq '"')
    {
      if ($state == 0)
      {
        $ret = $ret."<i>";
        $state = 1;
      }
      elsif ($state == 1)
      {
        $ret = $ret."</i>";
        $state = 0;
      }
    }
    else
    {
      $ret = $ret.$c;
    }
  }
  $ret = $ret."</i>";
  return $ret;
}

sub BR
{
  my ($text) = @_;
  my $ret = "";
  my $state = 0;

  $ret = $ret."<b>";
  for (my $i = 0; $i < length ($text); $i++)
  {
    my $c = substr ($text, $i, 1);
    if ($c eq '"')
    {
      if ($i != 0)
      {
        if ($state == 0)
        {
          $ret = $ret."</b>";
          $state = 1;
        }
        elsif ($state == 1)
        {
          $ret = $ret."<b>";
          $state = 0;
        }
      }
    }
    else
    {
      $ret = $ret.$c;
    }
  }
  $ret = $ret."</b>";
  return $ret;
}

sub RB
{
  my ($text) = @_;
  my $ret = "";
  my $state = 0;

  for (my $i = 0; $i < length ($text); $i++)
  {
    my $c = substr ($text, $i, 1);
    if ($c eq '"')
    {
      if ($state == 0)
      {
        $ret = $ret."<b>";
        $state = 1;
      }
      elsif ($state == 1)
      {
        $ret = $ret."</b>";
        $state = 0;
      }
    }
    else
    {
      $ret = $ret.$c;
    }
  }
  $ret = $ret."</b>";
  return $ret;
}

sub man2dvp
{
  my ($name, $entete, $pied) = @_;
  my $num = $name;
  my $file = "";


  $num =~ s#[\w\d\-_~\.]*\.([\d]{1})[\w]*#$1#;

  my $in = "./man-fr-1.58.1/man".$num."/".$name;
  open IN, "<".$in or die "Impossible d'ouvrir ".$in." : ".$!."\n";
  foreach (<IN>)
  {
    $file = $file.$_;
  }
  close IN;

# .so
  if ($file =~ s#\.so ([^\n]*)\n#<?php include (\"\.\./$1.php\"); ?>#g)
  {
    goto FIN;
  }

# <
  $file =~ s#<#&lt;#g;

# >
  $file =~ s#>#&gt;#g;

  my $head = "";
  open ENTETE, "<".$entete or die "Impossible d'ouvrir ".$entete." : ".$!."\n";
  foreach (<ENTETE>)
  {
    $head = $head.$_;
  }
  close ENTETE;
  $file = $head.$file;

# Commentaires
  $file =~ s#\.\\"([^\n]*)\n#<!-- $1 -->\n#g;

# .SH
  my $i = 1;
  my @sections;
  while ($file =~ m#\.SH [\"]?([^\"^\n]*)[\"]?\n#)
  {
    $sections[$i-1] = lc $1;
    if ($i == 1)
    {
      $file =~ s#\.SH [\"]?([^\"\n]*)[\"]?\n#<br /><h1 class="TitreSection0" id="L$i">$sections[$i-1]</h1>\n<div class="paragraph">\n#;
    }
    else
    {
      $file =~ s#\.SH [\"]?([^\"\n]*)[\"]?\n#</div><br/><br /><h1 class="TitreSection0" id="L$i">$sections[$i-1]</h1>\n<div class="paragraph">\n#;
    }
    $i++;
  }

# .SS
  $file =~ s#\.SS [\"]?([^\"\n]*)[\"]?\n#</div><br/><h2 class="TitreSection1" id="L$i">$1</h2>\n<div class="paragraph">\n#g;

# .IP
  $file =~ s#\.IP [\"]?([^\"\n]*)[\"]? [^\n]*\n#</div><div class="paragraph">$1<br/>\n#g;

# Saut de ligne
  $file =~ s#\n\n#<br/><br/>\n#g;

# Sommaire
  $i = 0;
  my $sommaire = "";
  foreach (@sections)
  {
    $sommaire = $sommaire."<br /><a class=\"summaryIndent0\" href=\"#L$i\">$sections[$i]</a>\n";
    $i++;
  }

# .TH
  $file =~ s#(\.TH ([^\n]*)\n)#$1\n$sommaire<br/><br/>#g;
  $file =~ s#\.TH ([^ ]*) [^\n]*\n#<br/><h1>$1</h1>#g;

# .IP
  $file =~ s#(\.TH ([^\n]*)\n)#$1\n$sommaire<br/><br/>#g;
  $file =~ s#\.TH ([^ ]*) [^\n]*\n#<br/><h1>$1</h1>#g;

# .PP
  $file =~ s#\n\.PP#<br/><br/>#g;
# .LP
  $file =~ s#\n\.LP#<br/><br/>#g;
# .P
  $file =~ s#\n\.P#<br/><br/>#g;

# .RE
  $file =~ s#\.RE##g;

# .BI
  while ($file =~ m#\.BI ([^\n]*)\n#)
  {
    my $text = BI ($1);
    $file =~ s#\.BI ([^\n]*)\n#$text\n#;
  }

# .IB
  while ($file =~ m#\.IB ([^\n]*)\n#)
  {
    my $text = IB ($1);
    $file =~ s#\.IB ([^\n]*)\n#$text\n#;
  }

# .RI
  while ($file =~ m#\.RI ([^\n]*)\n#)
  {
    my $text = RI ($1);
    $file =~ s#\.RI ([^\n]*)\n#$text\n#;
  }

# .IR
  while ($file =~ m#\.IR ([^\n]*)\n#)
  {
    my $text = IR ($1);
    $file =~ s#\.IR ([^\n]*)\n#$text\n#;
  }

# .BR
  while ($file =~ m#\.BR ([^\n]*)\n#)
  {
    my $text = BR ($1);
    $file =~ s#\.BR ([^\n]*)\n#$text\n#;
  }

# .RB
  while ($file =~ m#\.RB ([^\n]*)\n#)
  {
    my $text = RB ($1);
    $file =~ s#\.RB ([^\n]*)\n#$text\n#;
  }

# .B
  while ((my $l) = ($file =~ m#\.B ([^\n]*)\n#))
  {
    if ($name eq 'Index.'.$num)
    {
      $l =~ s#[\"]?([^ ^,]*)[\"]?#<a href=\"\./$1\.$num\.php\" class=\"lienArticle\">$1</a> #g;
    }
    else
    {
      $l =~ s#[\"]?([^ ^,]*)[\"]?#<b>$1</b> #g;
    }
    $file =~ s#\.B ([^\n]*)\n#$l #;
  }

# .I
  $file =~ s#\.I [\"]?([^\"\n]*)[\"]?\n#<i>$1</i> #g;

# \fI
  $file =~ s#\\fI([^\n]*?)\\f[\w]{1}#<i>$1</i>#g;

# \fB
  $file =~ s#\\fB([^\n]*?)\\f[\w]{1}#<b>$1</b>#g;

# .br
  $file =~ s#\.br#<br/>#g;

# \-
  $file =~ s#\\-#-#g;

# \&[
  $file =~ s#\\\&##g;

# .TP
  $file =~ s#\.TP#<br/><br/>\n#g;

# .sp
  $file =~ s#\.sp#<br/><br/>\n#g;

# .fi
  $file =~ s#\.fi#\n#g;

# .nf
  $file =~ s#\.nf##g;

# \s- \s+
  $file =~ s#\\s[-+]{1}[\d]?([^\n])\\s[-+]{1}[\d]?#$1#g;

# \ 
  $file =~ s#\\ #&nbsp;#g;

# Caracteres speciaux
  $file =~ s#é#&eacute;#g;
  $file =~ s#è#&egrave;#g;
  $file =~ s#à#&agrave;#g;

  open PIED, "<".$pied or die "Impossible d'ouvrir ".$pied." : ".$!."\n";
  foreach (<PIED>)
  {
    $file = $file.$_;
  }
  close PIED;

FIN :
  my $out = "";
  if ($name eq 'Index.'.$num)
  {
    $out = "./man/man".$num."/index.php";
  }
  else
  {
    $out = "./man/man".$num."/".$name.".php";
  }
  open OUT, ">".$out or die "Impossible de creer ".$out." : ".$!."\n";
  print OUT $file;
  close OUT;
}

sub man2php
{
  mkdir "./man";

  for (my $i = 1; $i <= 8; $i++)
  {
    my $rep = "./man-fr-1.58.1/man".$i."/";
  
    if (opendir DIR, $rep)
    {
      my $file;

      printf "man".$i."...\n";
      mkdir "./man/man".$i;
      while (defined ($file = readdir (DIR)))
      {
        if ($file ne '..' and $file ne '.')
        {
          man2dvp ($file, "./entete.php", "./pied.php");
        }
      }
      closedir DIR;
    }
    else
    {
      print "Impossible d'ouvrir $rep : $!\n";
    }
  }
}

man2php ();
print "Conversion terminee\n";
