<?php
	$rubrique = 18;
	$meta_description = "Man page de www.developpez.com";
	$meta_keywords = "Man, page, manuel, utilisateur, Linux";
	$titre_page = "Man page";
	$xhtml=true;
	$urlCss = "../article.css";
  
	include("$DOCUMENT_ROOT/template/entete.php");
?>
	<div style="text-align:center;">
		<table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
		  <tr>
				<td align="center" style="text-align:left">
<!--  Written by Oron Peled &lt;oron@actcom.co.il&gt;. -->
<!--  May be distributed subject to the GPL. -->
<!--  -->
<!--  I tried to be as much generic in the description as possible: -->
<!--  - General boot sequence is applicable to almost any -->
<!--  OS/Machine (DOS/PC, Linux/PC, Solaris/SPARC, CMS/S390) -->
<!--  - kernel and init(8) is applicable to almost any Unix/Linux -->
<!--  - boot scripts are applicable to SYSV-R4 based Unix/Linux -->
<!--  -->
<!--  - Traduction 20/06/2003 par Franois Micaux (fmicaux@actilis.net) -->
<!--  MJ 25/07/2003 LDP-1.56 -->
<br/><h1>BOOT</h1>
<br /><a class="summaryIndent0" href="#L0">nom</a>
<br /><a class="summaryIndent0" href="#L1">description</a>
<br /><a class="summaryIndent0" href="#L2">fichiers</a>
<br /><a class="summaryIndent0" href="#L3">voir aussi</a>
<br /><a class="summaryIndent0" href="#L4">traduction</a>
<br/><br/><br /><h1 class="TitreSection0" id="L1">nom</h1>
<div class="paragraph"><br/><br/>
boot-scripts - Description gnrale du dmarrage du systme.
</div><br/><br /><h1 class="TitreSection0" id="L2">description</h1>
<div class="paragraph"><br/><br/> 
La squence de dmarrage est variable en fonction du systme
mais peut globalement tre dcoupe selon les tapes suivantes&nbsp;:
(i) amorage matriel, (ii) chargeur de dmarrage,
(iii) dmarrage du noyau, (iv) <b>init</b> et <b>inittab</b>,
(v) scripts de dmarrage.
Nous allons dcrire chacune d'entre-elles plus en dtail ci-dessous.<br/><br/>
</div><br/><h2 class="TitreSection1" id="L6">Amorage matriel</h2>
<div class="paragraph">
Aprs la mise sous tension ou un reset matriel,
un programme stock en mmoire morte (souvent une PROM) prend le contrle.
Sur les PC, on appelle gnralement ce programme le
<b>BIOS</b>.<br/><br/>
Ce programme effectue normalement un auto-test de la machine
et accde  la mmoire non volatile pour y lire quelques paramtres.
Dans les PC, cette mmoire est maintenue par une batterie de type CMOS.
Ainsi la plupart des gens l'appellent <b>CMOS</b>, alors qu'en dehors
du monde des PC, elle
est gnralement appele <b>nvram</b>
(non-volatile ram).<br/><br/>
Les paramtres stocks dans la <b>nvram</b> varient d'un systme
 l'autre, mais au minimum, le programme d'amorage matriel
devrait savoir quel est le priphrique d'amorage, o  dfaut
quels priphriques il faut essayer pour amorcer le systme.<br/><br/>
Ensuite, la phase de dmarrage matriel accde au priphrique d'amorage,
charge le chargeur de dmarrage, qui est situ  une position
fixe sur le priphrique d'amorage, et lui passe contrle.<br/><br/>
<br/><br/>
 
Note&nbsp;:
Nous n'abordons pas ici le dmarrage  partir du rseau.
Ceux qui s'intressent  ce sujet devraient rechercher du ct de
DHCP, TFTP, PXE, Etherboot, et nous rejoindre au <b>dmarrage du noyau</b>.<br/><br/>
</div><br/><h2 class="TitreSection1" id="L6">Chargeur de dmarrage</h2>
<div class="paragraph">
Sur les PC, le chargeur de dmarrage est situ sur le premier
secteur du priphrique d'amorage - c'est le <b>MBR</b>
(Master Boot Record).<br/><br/>
Sur la plupart des systmes, ce chargeur initial est trs limit du fait de
diverses contraintes. Mme sur des systmes autres que le PC, il existe des
limitations concernant la taille et la complexit de ce chargeur, mais la taille
du MBR des PC  est limite - 512 octets y compris la table de partition (64 octets)
et un identifiant de disque (2 octets) ne laissent que 446 octets pour le code - et
rend quasiment impossible le stockage d'un chargeur de dmarrage complet.<br/><br/>
Ainsi, sur la plupart des systmes d'exploitation, le chargeur
initial appelle un chargeur de dmarrage secondaire situ sur
une partition du disque.<br/><br/>
Sous Linux, le chargeur de dmarrage est normalement
<b>lilo (8)</b>
ou
<b>grub (8).</b>
Chacun peut tre install soit en tant que chargeur secondaire
(si le MBR install par DOS pointe vers eux), soit
en tant que chargeur en deux parties, car ils fournissent un
MBR spcial contenant un code d'amorage pour charger
la seconde partie du chargeur  partir de la partition principale.<br/><br/>
Le rle principal du chargeur de dmarrage est de localiser le
noyau sur le disque, le charger et l'excuter.
La plupart des chargeurs de dmarrage sont interactifs, pour
permettre la spcification d'un noyau alternatif (par exemple
un noyau de sauvegarde dans le cas o la dernire version compile
ne fonctionne pas) et le passage de paramtres optionnels au noyau.<br/><br/>
</div><br/><h2 class="TitreSection1" id="L6">Dmarrage du noyau</h2>
<div class="paragraph">
Quand le noyau est charg, il initialise les priphriques (via leurs pilotes), 
dmarre le gestionnaire de swap (c'est un "processus noyau",
appel <b>kswapd</b> sur les noyaux Linux modernes), et monte le systme
de fichiers racine - appel <b>root filesystem</b> - (/).<br/><br/>
Quelques paramtres relatifs  cela peuvent tre passs au noyau
(par exemple : on peut spcifier un autre systme de fichiers racine
que celui par dfaut). Pour plus d'informations sur les paramtres
du noyau Linux, voir
<b>bootparam (7).<br/><br/></b>
C'est uniquement  cet instant que le noyau cre un premier
(en espace utilisateur) processus, qui porte le numro 1.
Ce processus excute le programme
<i>/sbin/init ,</i>
en lui passant tout paramtre qui n'est pas dj gr par le noyau.<br/><br/>
</div><br/><h2 class="TitreSection1" id="L6">init et inittab</h2>
<div class="paragraph">
Quand init dmarre, il lit
<i>/etc/inittab</i> pour y trouver ses instructions. Ce fichier dfinit ce qui doit s'excuter
dans les diffrents modes de fonctionnement (<i>run-levels</i>).<br/><br/>
Cela donne  l'administrateur systme une mthode simple de gestion dans laquelle
chaque run-level est associ  un ensemble de services (par exemple : <b>S</b>
correspond  un mode maintenance (<i>single-user</i>), en run-level <b>2</b>,
la plupart des services rseaux sont actifs, etc.). L'administrateur peut changer
le run-level courant par
<b>init (8)</b>
et connaitre le run-level courant par
<b>runlevel (8).<br/><br/></b>
Toutefois, comme il n'est pas pratique de grer les services
individuellement en ditant ce fichier, inittab se limite 
l'appel d'un ensemble de scripts qui dmarrent/arrtent les services.<br/><br/>
</div><br/><h2 class="TitreSection1" id="L6">Scripts de dmarrage</h2>
<div class="paragraph"><br/><br/>
<br/><br/>
 
Note&nbsp;:
La description suivante s'applique aux systmes bass sur SYSV-R4, qui couvre
actuellement la plupart des Unices commerciaux (Solaris, HPUX, Irix, Tru64) ainsi
que les distributions majeures de Linux (RedHat, Debian, Mandrake, Suse, Caldera).
Quelques systmes (Slackware Linux, Gentoo Linux, FreeBSD, OpenBSD) utilisent un
procd quelque peu diffrent pour les scripts de dmarrage.<br/><br/><br/><br/>
Pour chaque service gr (messagerie, nfs, cron, etc.) il y a un script de
dmarrage simple stock dans un rpertoire spcifique
( /etc/init.d</i>
dans la majorit des versions de Linux).
Chacun de ces scripts accepte en unique argument le mot 
'start' -- dont l'effet est le lancement du service, ou le mot
'stop' -- pour arrter le service. Le script peut ventuellement
accepter d'autres paramtres pratiques (par exemple : 'restart', enchaine un
'stop' suivi d'un 'start', 'status' donne l'tat du service). Un appel du script
sans argument permet d'afficher tous ceux possibles. <br/><br/>
</div><br/><h2 class="TitreSection1" id="L6">Rpertoires d'ordonnancement</h2>
<div class="paragraph">
Pour permettre aux scripts spcifiques de dmarrer/arrter un run-level
spcifique et dans un ordre particulier, il y a des \fBrpertoires
d'ordonnancement\fR. Ce sont gnralement <b>/etc/rc[0-6S].d</b>.
Dans chacun de ces rpertoires, il y a des liens (gnralement symboliques)
vers les scripts du rpertoire <b>/etc/init.d</b>.<br/><br/>
Un premier script (souvent <i>/etc/rc</i>) est appel par inittab(5) et appelle
lui-mme les scripts des services grce aux liens des rpertoires
d'ordonnancement.
Tous les liens dont le nom commence par 'S' sont appel avec l'argument 'start'
(et dmarrent le service concern). Tous les liens dont le nom commence par
'K' sont appels avec l'argument 'stop' (et arrtent le service concern).<br/><br/>
Pour introduire un ordonnancement au sein d'un run-level, les noms des liens
contiennent des numros d'ordre. Aussi, pour plus de clart, ils se terminent
par le nom du service qu'ils concernent. Exemple&nbsp;: Le lien
<i>/etc/rc2.d/S80sendmail</i> dmarre le service sendmail dans le run-level 2.
Cela est fait aprs l'excution de <i>/etc/rc2.d/S12syslog</i> mais avant celle
de <i>/etc/rc2.d/S90xfs</i>.<br/><br/>
<br/><br/>
 
Si l'on lit le script <i>/etc/rc</i>, on constate ce qui suit&nbsp;:
En premier lieu, les scripts K* sont excuts pour arrter les services
non concerns par le run-level, suivis des scripts S* pour dmarrer ceux
qui le deviennent.
L'ordre est exactement celui du caractre d'expansion '*', car l'appel
successif des diffrents scripts se fait par une boucle 'for'. Pour
schmatiser, <b>rc</b> excute 'for i in /etc/rc$runlevel.d/K*; do $i stop ; done'
puis ensuite 'for i in /etc/rc.$runlevel.d/S*; do $i start ; done'.<br/><br/><br/><br/>
Pour grer l'ordre de dmarrage et les run-levels, on doit grer ces liens.
Toutefois, sur beaucoup de versions de Linux, il existe des outils qui
facilitent cela. (exemple&nbsp;:
<b>chkconfig (8)).<br/><br/></b>
</div><br/><h2 class="TitreSection1" id="L6">Configuration de dmarrage</h2>
<div class="paragraph">
Habituellement, les daemons dmarrs peuvent ventuellement recevoir
des options et arguments sur leur ligne de commande. 
Pour permettre aux administrateurs systmes de changer ces paramtres 
sans diter le script, des fichiers de configuration sont utiliss.
Ils sont stocks dans un rpertoire spcifique (<i>/etc/sysconfig</i> sur les
systmes RedHat et Mandrake), et sont utiliss par les scripts de dmarrage.<br/><br/>
Sur les anciens Unices, ces fichiers contenaient les options de ligne de commande
pour les daemons, mais sur les systmes Linux modernes (et aussi sur HPUX), ces
fichiers contiennent uniquement des variables shell. Les scripts de dmarrage du
rpertoire <i>/etc/init.d</i> <b>sourcent</b> (par la commande interne '<b>.</b>' du
shell) les fichiers de configuration et utilisent ensuite les variables.
</div><br/><br /><h1 class="TitreSection0" id="L3">fichiers</h1>
<div class="paragraph"><br/><br/> 
<i>/etc/init.d/ ,</i>
<i>/etc/rc[S0-6].d/ .</i>
<i>/etc/sysconfig/<br/><br/></i> </div><br/><br /><h1 class="TitreSection0" id="L4">voir aussi</h1>
<div class="paragraph">
<b>inittab (5),</b>
<b>bootparam (7),</b>
<b>init (8),</b>
<b>runlevel (8),</b>
<b>shutdown (8)</b>
</div><br/><br /><h1 class="TitreSection0" id="L5">traduction</h1>
<div class="paragraph">
Franois Micaux, 2003.
								</td>
							</tr>
						</table></div>
<?php
	include("$DOCUMENT_ROOT/template/pied.php");
?>
